#include <bits/stdc++.h>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<double> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<double> pmax(n), pmin(n), smax(n), smin(n);
    pmax[0] = a[0];
    pmin[0] = a[0];
    for (int i = 1; i < n; i++) {
        pmax[i] = max(pmax[i - 1], a[i]);
        pmin[i] = min(pmin[i - 1], a[i]);
    }
    smin[n - 1] = a[n - 1];
    smax[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        smin[i] = min(smin[i + 1], a[i]);
        smax[i] = max(smax[i + 1], a[i]);
    }
    cout << fixed << setprecision(20) << 1.0 << ' ';
    for (int i = 1; i < n; i++) {
        if (pmax[i - 1] >= smax[i] && pmin[i - 1] >= smin[i]) {
            cout << fixed << setprecision(20) << 0.0 << ' ';
        } else if (pmin[i - 1] >= smax[i]) {
            cout << fixed << setprecision(20) << 0.0 << ' ';
        } else if (pmax[i - 1] <= smax[i] && pmin[i - 1] >= smin[i]) {
            double t1 = 1.0 - pmax[i - 1] / smax[i];
            double t2 = 1.0 - pmin[i - 1] / smin[i];
            auto check = [&](double t) ->double{
                double smx = smax[i] * (1.0 - t);
                double smn = smin[i] * (1.0 - t);
                return max({pmax[i-1], smx, smn}) - min({pmin[i-1], smn, smx});
            };
            if(t1 >= 0.0 && check(t1) - check(t2) < 1e-9) cout << fixed << setprecision(20) << t1 << ' ';
            else cout << fixed << setprecision(20) << t2 << ' ';
        } else if (pmax[i - 1] <= smin[i]) {
            double t1 = 1.0 - pmax[i - 1] / smax[i];
            double t2 = 1.0 - pmin[i - 1] / smin[i];
            auto check = [&](double t) ->double{
                double smx = smax[i] * (1.0 - t);
                double smn = smin[i] * (1.0 - t);
                return max({pmax[i-1], smx, smn}) - min({pmin[i-1], smn, smx});
            };
            if(t1 >= 0.0 && check(t1) - check(t2) < 1e-9) cout << fixed << setprecision(20) << t1 << ' ';
            else cout << fixed << setprecision(20) << t2 << ' ';
        } else if (pmax[i - 1] <= smax[i] && pmin[i - 1] <= smin[i]){
            double t1 = 1.0 - pmax[i - 1] / smax[i];
            double t2 = 1.0 - pmin[i - 1] / smin[i];
            auto check = [&](double t) ->double{
                double smx = smax[i] * (1.0 - t);
                double smn = smin[i] * (1.0 - t);
                return max({pmax[i-1], smx, smn}) - min({pmin[i-1], smn, smx});
            };
            if(t1 >= 0.0 && check(t1) - check(t2) < 1e-9) cout << fixed << setprecision(20) << t1 << ' ';
            else cout << fixed << setprecision(20) << t2 << ' ';
        } else {
            double t1 = 1.0 - pmax[i - 1] / smax[i];
            double t2 = 1.0 - pmin[i - 1] / smin[i];
            auto check = [&](double t) ->double{
                double smx = smax[i] * (1.0 - t);
                double smn = smin[i] * (1.0 - t);
                return max({pmax[i-1], smx, smn}) - min({pmin[i-1], smn, smx});
            };
            if(t1 >= 0.0 && check(t1) - check(t2) < 1e-9) cout << fixed << setprecision(20) << t1 << ' ';
            else cout << fixed << setprecision(20) << t2 << ' ';
        }
    }
    return 0;
}
