#include <bits/stdc++.h>

using namespace std;

const int mod = 1e9 + 7;

int main() {
	ios::sync_with_stdio(0); cin.tie(0);
	
	int l, n; cin>>l>>n;
	vector<int> pw(l + 1);
	pw[0] = 1;
	for(int i=1;i<=l;i++) pw[i] = pw[i-1] * 2 % mod;
	
	vector<vector<int>> hh(n, vector<int>(26));
	for(int i=0;i<n;i++){
		string s; cin>>s;
		for(int j=0;j<l;j++){
			hh[i][s[j] - 'a'] = (hh[i][s[j] - 'a'] + pw[j]) % mod;
		}
	}
	
	vector<vector<int>> cmp;
	cmp.push_back({});
	for(int i=0;i<n;i++) cmp.back().push_back(i);
	vector<int> is(n);
	for(int j=0;j<26;j++){
		vector<vector<int>> tmp;
		for(auto v : cmp){
			if((int)v.size() == 1){
				is[v[0]] = 1;
				continue;
			}
			
			int car = -1;
			for(int l=0;l<26;l++){
				bool ok = 1;
				for(auto x : v){
					if(hh[x][l] == 0) { ok = 0; break; }
				}
				
				if(!ok) continue;
				int last = hh[v[0]][l];
				for(auto x : v){
					if(last != hh[x][l]) ok = 0;
				}
				
				if(ok) continue;
				car = l; break;
			}
			
			if(car == -1){
				cout<<"NO\n";
				return 0;
			}
			
			map<int, vector<int>> mm;
			for(auto x : v){
				mm[hh[x][car]].push_back(x);
			}
			
			for(auto x : mm) tmp.push_back(x.second);
		}
		
		swap(cmp, tmp);
	}
	
	cout<<"YES\n";
}
