﻿#include <iostream>
#include <vector>
#include <set>
#include<map>
#include<deque>
#include <algorithm>

using namespace std;

typedef long long ll;

template<typename T> istream& operator>>(istream& in, vector<T>& a) { for (int i = 0; i < a.size(); ++i) in >> a[i]; return in; }
template<typename T> ostream& operator<<(ostream& out, vector<T>& a) { for (int i = 0; i < a.size(); ++i) out << a[i] << ' '; return out;}

template<typename T1, typename T2> istream& operator>>(istream& in, pair<T1, T2> &p){ in >> p.first >> p.second; return in; }
template<typename T1, typename T2> ostream& operator<<(ostream& out, pair<T1, T2> &p) { out << p.first << ' ' << p.second; return out; }



#define all(x) x.begin(),x.end()
#define range(i,n) for (int i=0;i<n;++i)
#define rrange(i,n) for (int i=n-1;i>=0;--i)


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    sort(all(a));
    reverse(all(a));
    ll ans = 0;
    range(i, n / 2) ans += a[i];
        cout << ans;
}
