﻿#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <map>
#include <set>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <numeric>
#include <climits>
#include <random>
#include <fstream>
#include <cstdlib>
#include <bitset>
#include <deque>
#include <iterator>

using namespace std;

template <typename T> inline T getint() {
	T val = 0;
	char c;
	bool neg = false;
	while ((c = getchar()) && !(c >= '0' && c <= '9')) {
		neg |= c == '-';
	}
	do {
		val = (val * 10) + c - '0';
	} while ((c = getchar()) && (c >= '0' && c <= '9'));
	return val * (neg ? -1 : 1);
}

#define int long long
#define x first
#define y second
typedef long long ll;
typedef long double ld;
const ll INF = LLONG_MAX;

ll gcd(ll a, ll b) {
	return b ? gcd(b, a % b) : a;
}

const ll maxn = 1e5;
const ld eps = 1e-10;



signed main() {
	std::ios::sync_with_stdio(false);
	std::ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n; cin >> n;
	vector<int> q(n);
	for (int i = 0; i < n; i++)
		cin >> q[i];
	vector<int> minp(n);
	vector<int> maxp(n);
	vector<int> mins(n);
	vector<int> maxs(n);
	minp[0] = q[0];
	maxp[0] = q[0];
	mins[n - 1] = q[n - 1];
	maxs[n - 1] = q[n - 1];
	for (int i = 1; i < n; i++)
	{
		minp[i] = min(q[i], minp[i - 1]);
		maxp[i] = max(q[i], maxp[i - 1]);
	}
	for (int i = n - 2; i >= 0; i--)
	{
		maxs[i] = max(q[i], maxs[i + 1]);
		mins[i] = min(q[i], mins[i + 1]);
	}
	cout.setf(ios::fixed);
	cout.precision(12);
	for (int i = 0; i < n; i++) {
		if (i == 0) {
			cout << (ld)1 << " ";
			continue;
		}
		ld a, b, c, d;
		a = maxp[i - 1];
		c = maxs[i];
		b = minp[i - 1];
		d = mins[i];
		/*if (c == 0 || a == 0)
		{
			cout << (ld)1 << " ";
			continue;
		}
		if (b == 0 && d == 0) {
			if (c > 0)
				cout << (ld)1 - a / c << " ";
				1

			else
				cout << (ld)1 << " ";
		}*/
		if (a >= c)
			if (d <= b) {
				cout << (ld)0 << " ";
			}
			else {//d>b
				ld t = (ld)1 - b / d;
				cout << (ld)t << " ";
			}
		else//a<c
			if (d >= b) {
				ld t1 = (ld)1 - b / d;
				ld t2 = (ld)1 - a / c;
				if (abs((a - min(b, d * ((ld)1 - t2))) - (max(a, c * ((ld)1 - t1)) - b)) < eps)
				{
					cout << max(t1, t2) << " ";
				}
				else
				if (a - min(b, d * ((ld)1 - t2)) > max(a, c * ((ld)1 - t1)) - b + eps)
					cout << t1 << " ";
				else
					cout << t2 << " ";
			}//d<b
			else {
				ld t = (ld)1 - a / c;
				cout << t << " ";
			}
	}
}