#include <algorithm>
#include <iostream>
#include <vector>
#include <numeric>
// #include <bits/stdc++.h>

using namespace std;
#define all(o) (o).begin(), (o).end()
#define rall(o) (o).rbegin(), (o).rend()
#define len(o) (int)((o).size())
#if LOCAL
#define dbg(o) cout << #o << " = " << o << "\n";
#else
#define dbg(o)
#endif

using ll = long long;
using ld = long double;

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (const T &e : a) {
        out << e << " ";
    }
    return out;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &e : a) {
        in >> e;
    }
    return in;
}

int main() {
    int n; cin >> n;
    vector<int> aa(n);
    vector<int> bb(n);
    cin >> aa >> bb;

    int l = 0, r = 2e6;
    while (r - l > 1) {
        int m = (l + r) / 2;
        vector<int> a = aa;
        vector<int> b = bb;
        int ptr = 0;
        for (int i = 0; i < n; ++i) {
            while (b[i] > 0 && ptr < i + m && ptr < n) {
                int k = min(a[ptr], b[i]);
                b[i] -= k;
                a[ptr] -= k;
                if (a[ptr] == 0) ptr++;
            }
        }
        if (ptr == n) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << (l > 1e6 ? -1 : l) << "\n";
}
