#include <algorithm>
#include <iostream>
#include <vector>
#include <numeric>
#include <bitset>
#include <iomanip>
// #include <bits/stdc++.h>

using namespace std;
#define all(o) (o).begin(), (o).end()
#define rall(o) (o).rbegin(), (o).rend()
#define len(o) (int)((o).size())
#if LOCAL
#define dbg(o) cout << #o << " = " << o << "\n";
#else
#define dbg(o)
#endif

using ll = long long;
using ld = long double;

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (const T &e : a) {
        out << e << " ";
    }
    return out;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &e : a) {
        in >> e;
    }
    return in;
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout << fixed << setprecision(16);
    vector<int> b(4);
    cin >> b;
    vector<pair<ld, int>> a;
    for(int i = 0; i < 4; ++i) a.push_back(make_pair(b[i], i + 1));
    sort(all(a));
    vector<pair<ld, int>> ans;
    ld mxx = 0;
    if (count(all(b), 1) >= 1) {
        cout << a[3].second << ' ' << a[2].second << ' ' <<  a[1].second << ' ' << a[0].second << endl;
        cout << a[3].first << ' ' << a[2].first << ' ' << 1 << ' ' << 1 << endl;
    } else {
        do {
            ld delta = ((a[0].first * a[3].first) + a[1].first + a[2].first) - ((a[1].first * a[2].first) + a[0].first + a[3].first);
            if (delta >= 0) {
                ld mx = max(a[0].first, a[3].first), mn = min(a[0].first, a[3].first);
                int mni = 0, mxi = 0;
                if (a[0].first < a[3].first) {
                    mni = 1;
                    mxi = 4;
                } else {
                    mni = 4;
                    mxi = 1;
                }
                ld nmn = mn - 1.0 * delta / (mx - 1);
                if (nmn >= 1) {
                    if (mxx < nmn * a[mxi - 1].first + a[1].first + a[2].first) {
                        ans = a;
                        ans[mni - 1].first = nmn;
                        mxx = nmn * a[mxi - 1].first + a[1].first + a[2].first;
                    }
                }
            }
        } while(next_permutation(all(a)));
        for(auto e : ans) cout << e.second << ' ';
        cout << endl;
        for(auto e : ans) cout << e.first << ' ';
    }
}
