#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

void solve() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.setf(ios::fixed);
    cout.precision(20);
    int n;
    cin >> n;
    vector<int> a(n);
    for(auto &i: a) cin >> i;
    vector<int> pmn = a, pmx = a;
    vector<int> smn = a, smx = a;
    for(int i=1;i<n;i++) {
        pmn[i] = min(pmn[i], pmn[i-1]);
        pmx[i] = max(pmx[i], pmx[i-1]);
    }
    for(int i=n-2;i>=0;i--) {
        smn[i] = min(smn[i], smn[i+1]);
        smx[i] = max(smx[i], smx[i+1]);
    }

    auto get = [&](ld mx, ld mn, ld x, ld y) {
        return max(mx, x) - min(mn, y);
    };
    ld eps = 1e-9;
    cout << (ld)1  << ' ';
    for(int i=1;i<n;i++) {
        ld amn = 1e18, at = -1;
        ld mx = pmx[i-1];
        ld mn = pmn[i-1];
        ld x = smx[i];
        ld y = smn[i];
        auto q = get(mx, mn, x, y);
        if(q < amn || (abs(amn - q) < eps && 0 > at)) {
            amn = q;
            at = 0;
        }
        q = get(mx, mn, 0, 0);
        if(q < amn || (abs(amn - q) < eps && 1 > at)) {
            amn = q;
            at = 1;
        }
        auto t = 1 - (min(x, mx) / x);
        auto qt = (min(x, mx) / x);
        q = get(mx, mn, x*qt, y*qt);
        if(q < amn || (abs(amn - q) < eps && t > at)) {
            amn = q;
            at = t;
        }
        t = 1 - (min(y, mn) / y);
        qt = (min(y, mn) / y);
        q = get(mx, mn, x*qt, y*qt);
        if(q < amn || (abs(amn - q) < eps && t > at)) {
            amn = q;
            at = t;
        }
        cout << at << ' ';
    }
}

signed main() {
    solve();
}