#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define all(t) (t).begin(), (t).end()

void solve() {
    cout << fixed << setprecision(20);
    int n = 4;
    vector<int> t(n);
    for (int &x : t) cin >> x;
    vector<int> ind(n);
    iota(all(ind), 0);
    sort(all(ind));
    vector<pair<int, ld>> best(4);
    ld bestAns = -1e9;
    do {
        for (int nm = 0; nm < n; ++nm) {
            vector<ld> ans(n);
            ld prod = 1;
            bool div0 = false, time0 = false;
            for (int i = 0; i < n; ++i) {
                if (i == nm) continue;
                if (i + nm == 3) (t[ind[i]] == 1 ? div0 = true : prod /= t[ind[i]] - 1);
                else
                    (t[ind[i]] == 1 ? time0 = true : prod *= t[ind[i]] - 1);
                ans[i] = t[ind[i]];
            }

            if (div0 && time0) ans[nm] = t[ind[nm]]; else ans[nm] = 1 + prod;
            if (ans[nm] > t[ind[nm]]) continue;
            ld cur = ans[0] * ans[3] + ans[2] + ans[1];
            if (cur > bestAns) {
                bestAns = cur;
                for (int i = 0; i < 4; ++i) {
                    best[i] = {ind[i], ans[i]};
                }
            }
        }
    } while (next_permutation(all(ind)));
    for (auto &[x, y] : best) cout << x + 1 << ' ';
    cout << '\n';
    for (auto &[x, y] : best) cout << y << ' ';
}

signed main() {
    solve();
}