#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>

#define ll long long
#define ld long double 

using namespace std;

vector<ld> prefx, sufx, prefn, sufn, a;
ld inf = 1e12;

ld mindb(ld a, ld b) {
	if (a > b) return b;
	return a;
}

ld maxdb(ld a, ld b) {
	if (a < b) return b;
	return a;
}

ld fun_s(ld a, ld b, ld c, ld d, ld s) {
	return maxdb(maxdb((a - d), (c - b) * s), maxdb(a - b * s, c * s - d));
}

int main() {
	cout.precision(30);
	ll n;
	cin >> n;
	a.resize(n);
	prefx.resize(n);
	sufx.resize(n);
	prefn.resize(n);
	sufn.resize(n);
	for (ll i = 0; i < n; i++) cin >> a[i];
	prefx[0] = a[0];
	sufx[0] = a[n - 1];
	prefn[0] = a[0];
	sufn[0] = a[n - 1];
	for (ll i = 1; i < n; i++) {
		prefn[i] = mindb(prefn[i - 1], a[i]);
		sufn[i] = mindb(sufn[i - 1], a[n - 1 - i]);
		prefx[i] = maxdb(prefx[i - 1], a[i]);
		sufx[i] = maxdb(sufx[i - 1], a[n - 1 - i]);
	}
	vector<ld> ans(n, inf);
	for (ll i = 0; i < n; i++) {
		if (i == 0) {
			ans[0] = 1;
		}
		else {
			ld aa = prefx[i - 1], bb = sufn[n - i - 1], cc = sufx[n - i - 1], dd = prefn[i - 1];
			ld sm, s1 = aa / cc, s2 = dd / bb, s3, s4 = (aa + bb) / (dd + bb);
			if (cc - bb == 0) {
				s3 = inf;
			}
			else {
				s3 = (aa - dd) / (cc - bb);
			}
			sm = inf;
			ld z1 = fun_s(aa, bb, cc, dd, s1), z2 = fun_s(aa, bb, cc, dd, s2), z3 = fun_s(aa, bb, cc, dd, s3), z4 = fun_s(aa, bb, cc, dd, s4);
			vector<pair<ld, ld>> z = { {z1, s1}, {z2, s2}, {z3, s3}, {z4, s4} };
			sort(z.begin(), z.end());
			ld zm = inf;
			for (ll j = 0; j < 4; j++) {
				if (z[j].second >= 0 && z[j].second <= 1) {
					if (zm >= z[j].first) {
						zm = mindb(zm, z[j].first);
						sm = mindb(sm, z[j].second);
					}
				}
			}
			ans[i] = maxdb(1 - sm, 0);
		}
	}
	for (ld i : ans) cout << i << " ";
}