#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<map>

#define ll long long
#define ld long double 

using namespace std;

int l, n;
vector<string> v;
vector<vector<bool>> b;

bool prover(vector<bool> useda, vector<int> s) {
	if ((int)s.size() == 1) return true;
	vector<bool> p(26, false);
	for (int g = 0; g < 26; ++g) {
		bool flag = true;
		for (int i = 0; i < (int)s.size(); ++i) {
			if (!b[s[i]][g]) flag = false;
		}
		p[g] = flag;
	}
	bool ans = true;
	int x = 0;
	for (int i = 0; i < 26; ++i) {
		if (p[i] && !useda[i]) {
			map<vector<bool>, vector<int>> maap;
			for (int dk = 0; dk < (int)s.size(); ++dk) {
				vector<bool> vk(l, false);
				for (int j = 0; j < l; ++j) {
					if (v[s[dk]][j] == char('a' + i)) vk[j] = true;
				}
				maap[vk].push_back(dk);
			}
			if ((int)maap.size() == 1) useda[i] = true;
			if ((int)maap.size() >= 2) {
				x = 7;
				useda[i] = true;
				for (auto h : maap) {
					ans = ans && prover(useda, h.second);
				}
			}
		}
	}
	if (x == 7) return ans;
	else return false;
}


int main() {
	cin >> l >> n;
	v.resize(n);
	b.resize(n, vector<bool>(26));
	for (int i = 0; i < n; ++i) cin >> v[i];
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < l; ++j) {
			b[i][v[i][j] - 'a'] = true;
		}
	}
	vector<int> s(n);
	for (int i = 0; i < n; ++i) s[i] = i;
	vector<bool> us(26, false);
	if (prover(us, s)) cout << "YES";
	else cout << "NO";
}