#include<iostream>
#include<vector>

#define ll long long

using namespace std;

ll mod = 998244353;

vector<ll> fact(200021, 1);

ll pow_mod(ll a, ll b) {
	if (b == 0) return 1;
	if (b == 1) return a;
	ll d = pow_mod(a, b / 2);
	d = (d * d) % mod;
	if (b % 2 == 1) d = (d * a) % mod;
	return d;
}

ll del_mod(ll a, ll b) {
	ll d = pow_mod(b, mod - 2) % mod;
	return (a * d) % mod;
}

int main() {
	for (ll i = 1; i < 200021; i++) fact[i] = (fact[i - 1] * i) % mod;
	ll n, m;
	cin >> n >> m;
	ll chisl = (fact[n + m - 1] * fact[n + m - 2]) % mod;
	ll znam = (fact[m - 1] * fact[m]) % mod;
	znam = (znam * fact[n]) % mod;
	znam = (znam * fact[n - 1]) % mod;
	ll ans = del_mod(chisl, znam);
	cout << ans;
}