#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")

#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define ll long long
#define ld long double

#define double ld
#define endl '\n'

using namespace std;

const int INF = 1e18;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> arr(n, vector<int>(3));
    for (int i = 0; i < n; ++i) {
        for (int k = 0; k < 3; ++k) {
            cin >> arr[i][k];
        }
    }

    sort(all(arr));

    double lb = -INF, ub = INF;

    for (int i = 0; i < n; ++i) {
        double a = arr[i][0], b = arr[i][1], c = arr[i][2];
        double vx = -b / (2 * a);
        double vy = a * vx * vx + b * vx + c;

        if (a > 0) {
            lb = max(lb, vy);
        } else if (a < 0) {
            ub = min(ub, vy);
        }
    }

    double l = -INF, r = INF;

    for (int i = 0; i < n; ++i) {
        double a = arr[i][0], b = arr[i][1], c = arr[i][2];

        if (a > 0) {
            double lin = (-b - sqrt(b * b - 4 * a * (c - ub))) / 2.0 / a;
            double rin = (-b + sqrt(b * b - 4 * a * (c - ub))) / 2.0 / a;
            l = max(l, lin);
            r = min(r, rin);
        }

        if (a < 0) {
            double rin = (-b - sqrt(b * b - 4 * a * (c - lb))) / 2.0 / a;
            double lin = (-b + sqrt(b * b - 4 * a * (c - lb))) / 2.0 / a;
            l = max(l, lin);
            r = min(r, rin);
        }
    }

    mt19937_64 rnd;

    uniform_real_distribution<double> dx(l, r);

    while (true) {
        double x = dx(rnd);

        double up = INF, down = -INF;

        bool ok = true;

        for (int i = 0; i < n; ++i) {
            double a = arr[i][0], b = arr[i][1], c = arr[i][2];
            double val = a * x * x + b * x + c;

            if (a > 0)
                down = max(down, val);
            if (a < 0)
                up = min(up, val);

        }

        if (down <= up or abs(down - up) < 1e-6) {
            cout << x << " " << (up + down) / 2.0 << endl;
            return;
        }
    }
}

signed main() {
#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL
    cout.precision(16);
    cout << fixed;
    solve();
}


