#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define pb push_back
#define eb emplace_back
#define f first
#define s second
#define deb(a) cerr << fixed << setprecision(20) << #a << " = " << a << '\n';
//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

typedef tree<
    pii,
    null_type,
    less<pii>,
    rb_tree_tag,
    tree_order_statistics_node_update>
ordered_set;

const int inf = 2e9;
const ll INF = 2e18;
const int MOD1 = 1e9 + 7;
const int MOD2 = 998244353;
const int P1 = 31;
const int P2 = 37;
const int dx[4] = {0, 0, -1, 1};
const int dy[4] = {-1, 1, 0, 0};
const ld Pi = acosl(-1);
const ld EPS = 1e-11;
const int N = 2e6;
int qqq = 1;


int n;
vector <ld> mn, mx;
vector <int> prefm, prefx, sufx, sufm;

inline ld check(ld &x, int &ind, bool f = 0){
    mn.clear(), mx.clear();
    if (ind != 0)
        mn.eb(prefm[ind - 1]);
    mn.eb(sufm[ind] * (1.0 - x));
    if (ind != 0)
        mx.eb(prefx[ind - 1]);
    mx.eb(sufx[ind] * (1.0 - x));
    ld ans = -inf;

    for (auto i: mn){
        for (auto j: mx){
            ans = max(ans, abs(i - j));
        }
    }

    return ans;
}

void solve() {

    cin >> n;
    vector <int> a(n);
    for (int &i: a)
        cin >> i;
    prefx.resize(n);
    prefm.resize(n);
    sufx.resize(n);
    sufm.resize(n);
    for (int i = 0; i < n; i++){
        prefx[i] = max(a[i], (i == 0 ? -inf : prefx[i - 1]));
        prefm[i] = min(a[i], (i == 0 ? inf : prefm[i - 1]));
    }

    for (int i = n - 1; i >= 0; i--){
        sufx[i] = max(a[i], (i == n - 1 ? -inf: sufx[i + 1]));
        sufm[i] = min(a[i], (i == n - 1 ? inf : sufm[i + 1]));
    }


    ld l = EPS, r = 1;
    for (int i = 0; i < n; i++){
        l = 0, r = 1;
        for (int lg = 0; lg < 55; lg++){
            ld m1 = l + (r - l) / 3.0;
            ld m2 = r - (r - l) / 3.0;
            if (check(m1, i) >= check(m2, i))
                l = m1;
            else
                r = m2;
        }
        //cout << fixed << setprecision(20) << check(r, i, sg, 1) << '\n';
        cout << fixed << setprecision(20) << r << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cin >> qqq;
    while (qqq--) {
        solve();
    }
    return 0;
}
