﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;
vector<int> a, b;
int n;

bool check(int m) {
    int free = 0;
    vector<int> a1 = a, b1 = b;

    for (int i = 0; i < n; i++) {
        free = max(free, i - m);
        while (free < n && i + m >= free && a1[i] > 0) {
            if (a1[i] <= b1[free]) {
                b1[free] -= a1[i];
                a1[i] = 0;
            }
            else {
                a1[i] -= b1[free];
                b1[free] = 0;
                free++;
            }
        }
    }
/*    cout << m << '\n';
    for (auto it : r) {
        cout << it << ' ';
    }
    cout << '\n';*/
    
    for (int i = 0; i < n; i++) {
        if (a1[i] > 0) return false;
    }
    return true;
}


signed main()
{   
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    a.resize(n);
    b.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    int l = 0, r = n;
    while (r - l > 1) {
        int m = (r + l) / 2;
        int j = 0;
        if (check(m)) {
            r = m;
        }
        else {
            l = m;
        }
    }
    int ans;
    if (check(l)) ans = l;
    else ans = r;
    if (check(ans)) {
        cout << ans;
    }
    else {
        cout << -1;
    }
}
