﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <iomanip>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
mt19937 rnd(228228227);
int n;

signed main()
{   
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(15);
    cin >> n;
    vector<int> v(n);
    vector<int> pmi(n, 1e9), pma(n, 0), smi(n, 1e9), sma(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        if (i > 0) {
            pmi[i] = pmi[i - 1];
            pma[i] = pma[i - 1];
        }
        pmi[i] = min(pmi[i], v[i]);
        pma[i] = max(pma[i], v[i]);
    }
    for (int i = n - 1; i >= 0; i--) {
        if (i + 1 < n) {
            smi[i] = smi[i + 1];
            sma[i] = sma[i + 1];
        }
        smi[i] = min(smi[i], v[i]);
        sma[i] = max(sma[i], v[i]);
    }
    cout << 1 << " ";
    for (int i = 1; i < n; i++) {
        ld lmin = pmi[i - 1], rmin = smi[i], lmax = pma[i - 1], rmax = sma[i];
        if (lmin >= rmin && lmax >= rmax) {
            cout << 0 << " ";
        }
        else if (lmin <= rmin && lmax >= rmax) {
            cout << 1 - lmin / rmin << " ";
        }
        else if (lmin >= rmin && rmax >= lmax) {
            cout << 1 - lmax / rmax << " ";
        }
        else {
            ld t = (1 - lmin / rmin);
            if (rmax * (1 - t) >= lmax) {
                t = (1 - lmax / rmax);
            }
            cout << t << " ";
        }
    }
}
