#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <list>
#include <queue>
#include <deque>
#include <ctime>
#include <chrono>
#include <random>
#include <bitset>
#include <stack>
#include <cstring>
#define fast cin.tie(0);cout.tie(0);cin.sync_with_stdio(0);cout.sync_with_stdio(0)
#define F first
#define S second
#define pq priority_queue
#define umap unordered_map
#define uset unordered_set
#define pb push_back
#define sqr(x) ((x)*(x))
#define fill(v,n) for(int qqq=0;qqq<n;qqq++)cin>>v[qqq]
#define seed (myclock::now() - beginning).count()
#define mod 998244353
#define eps 1e-7
#define eps1 1e-9
#define BIL 1000000000ll
#define INF sqr(2 * BIL)

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ull, ull> pull;
typedef long double ld;
typedef pair<ld, ld> pld;
typedef chrono::high_resolution_clock myclock;

ld a = -1, b = -1, c = -1, d = -1, best_ans = 0;
ld maxa, maxb, maxc, maxd;

struct ans {
	ld dif, sum, cur;

	bool operator<(ans other) {
		if (abs(dif - other.dif) > 5 * eps)
			return dif < other.dif;
		return sum > other.sum;
	}

	bool operator=(ans other) {
		return abs(dif - other.dif) < 5 * eps && abs(sum - other.sum) < 5 * eps;
	}
};

ld eval(ld a, ld b, ld c, ld d) {
	return a * d + b + c;
}

ans find_d(ld a, ld b, ld c) {
	if (a == 1) {
		if (a - b - c + b * c)
			return { BIL, 0, 0 };
		return { 0, eval(1, b, c, d), maxd };
	}
	ld d = (a - b - c + b * c) / (a - 1);
	if (d < 1 || d > maxd) return { BIL, 0, 0 };
	return { 0, eval(a, b, c, d), d };
}

ans find_c(ld a, ld b) {
	ld L = 1, R = maxc;
	while (R - L > eps1) {
		ld l = L + (R - L) / 3, r = R - (R - L) / 3;
		ans tl = find_d(a, b, l), tr = find_d(a, b, r);
		if (tl < tr)
			R = r;
		else L = l;
	}
	ans t = find_d(a, b, (L + R) / 2);
	return { t.dif, t.sum, (L + R) / 2 };
}

ans find_b(ld a) {
	ld L = 1, R = maxb;
	while (R - L > eps1) {
		ld l = L + (R - L) / 3, r = R - (R - L) / 3;
		ans tl = find_c(a, l), tr = find_c(a, r);
		if (tl < tr)
			R = r;
		else L = l;
	}
	ans t = find_c(a, (L + R) / 2);
	return { t.dif, t.sum, (L + R) / 2 };
}

ans find_a() {
	ld L = 1, R = maxa;
	while (R - L > eps1) {
		ld l = L + (R - L) / 3, r = R - (R - L) / 3;
		ans tl = find_b(l), tr = find_b(r);
		if (tl < tr)
			R = r;
		else L = l;
	}
	ans t = find_b((L + R) / 2);
	return { t.dif, t.sum, (L + R) / 2 };
}

void solve(int a1, int a2, int a3, int a4) {
	maxa = a1;
	maxb = a2;
	maxc = a3;
	maxd = a4;
	ans cur = find_a();
	if (cur.dif < 15 * eps && cur.sum > best_ans) {
		a = cur.cur;
		best_ans = cur.sum;
		b = find_b(a).cur;
		c = find_c(a, b).cur;
		d = find_d(a, b, c).cur;
	}
}

int main() {
	cout << fixed << setprecision(10);
	int k[4];
	fill(k, 4);
	solve(k[0], k[1], k[2], k[3]);
	solve(k[0], k[1], k[3], k[2]);
	solve(k[0], k[3], k[2], k[1]);
	int order[4] = { 1, 2, 3, 4 };
	ld ans[4] = { a, b, c, d };
	auto check = [&]() -> bool {
		for (int i = 0; i < 4; i++)
			if (ans[i] > k[order[i] - 1])
				return 0;
		return 1;
	};
	for (int i = 0; i < 24; i++) {
		if (check()) {
			for (int i : order) cout << i << " ";
			cout << "\n";
			for (ld i : ans) cout << i << " ";
			exit(0);
		}
		next_permutation(order, order + 4);
	}
}