#include <unordered_map>
#include <functional>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <bitset>
#include <random>
#include <cmath>
#include <deque>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>


#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")

#define all(x) (x).begin(), (x).end()
#define an cerr << "-->"; cerr.flush()

using namespace std;

typedef	int ii;
typedef long long ll;
typedef long double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = (ll)3e5 + 5;
const ll mod = (ll)1e9 + 7;
const ll maxlog = 20;

void operator delete(void* q);

void ex(ll exitCode = 0) {
#ifdef _DEBUG
    //system("pause");
#endif // _DEBUG
    exit(exitCode);
}

ll n;

vector<ll> vc;

bool used[cst];

vector<ll> s1, s2;

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> n;
    vc.resize(n);
    for (ll& i : vc) cin >> i;
    reverse(all(vc));
    for (ll i = 1; i <= n; i++) {
        while (!used[i]) {
            used[vc.back()] = 1;
            s1.push_back(vc.back());
            vc.pop_back();
            cout << 1 << "\n";
        }
        while (s1.back() != i) {
            used[s1.back()] = 0;
            s2.push_back(s1.back());
            s1.pop_back();
            cout << 12 << "\n";
        }
        cout << -1 << "\n";
        used[i] = 0;
        s1.pop_back();
        while (s2.size()) {
            cout << 21 << "\n";
            s1.push_back(s2.back());
            used[s2.back()] = 1;
            s2.pop_back();
        }
    }
    ex();
}