#include <vector>
#include <iostream>
#include <algorithm>
#include <iomanip>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<long long> A(n);
    for (int i = 0; i < n; ++i)
        cin >> A[i];
    vector<long long> mn_suff(n + 1);
    vector<long long> mx_suff(n + 1);
    mx_suff[n] = 0;
    mn_suff[n] = 1e9 + 7;
    for (int i = n - 1; i >= 0; --i) {
        mx_suff[i] = max(mx_suff[i + 1], A[i]);
        mn_suff[i] = min(mn_suff[i + 1], A[i]);
    }
    long long mn_pref = 1e9 + 7, mx_pref = 0;
    cout << fixed << setprecision(20);
    cout << 1 << ' ';
    for (int i = 0; i + 1 < n; ++i) {
        mn_pref = min(mn_pref, A[i]);
        mx_pref = max(mx_pref, A[i]);
        if (mx_suff[i + 1] <= mx_pref) {
            if (mn_suff[i + 1] >= mn_pref)
                cout << (1 - ((long double) mn_pref) / mn_suff[i + 1]) << ' ';
            else
                cout << 0 << ' ';
        } else {
            cout << (1 - min(((long double) mx_pref) / mx_suff[i + 1], ((long double) mn_pref) / mn_suff[i + 1])) << ' ';
        }
    }
    cout << '\n';
    return 0;
}