#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <cmath>
#include <assert.h>
#include <queue>
using namespace std;

signed main() {
    int n; cin >> n;
    vector <int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }

    int l = -1, r = n + 1;
    for (int bin = 0; bin < 20; bin++) {
        int k = (l + r) / 2;
        bool ok = true;
        queue <pair <int, int>> q;
        for (int i = 0; i < k; i++) {
            q.push({ i, a[i] });
        }
        for (int i = 0; i < n && ok; i++) {
            if (i + k < n)
                q.push({ i + k, a[i + k] });
            int zap = b[i];
            while (zap > 0 && !q.empty()) {
                int ind = q.front().first;
                int val = q.front().second;
                if (abs(ind - i) > k) {
                    ok = false;
                    break;
                }
                if (zap >= val) {
                    zap -= val;
                    q.pop();
                }
                else {
                    q.front() = { ind, val - zap };
                    zap = 0;
                }
            }
        }
        if (ok && q.empty())
            r = k;
        else
            l = k;
    }
    if (r == n + 1)
        r = -1;
    cout << r;

    return 0;
}