#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

// #pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

inline void prepare() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n;
int arr1[1000000];
int arr2[1000000];
int cpy[1000000];

inline bool check(int param) {
    for (int i = 0; i < n; i++) {
        cpy[i] = arr2[i];
    }

    int left = 0;
    int right = min(n - 1, param);

    for (int j = 0; j < n; j++) {
        if (j - param - 1 >= 0) {
            left = max(j - param, left);
        }

        int val = arr1[j];

        while (left <= right) {
            int take = min(val, cpy[left]);
            val -= take;
            cpy[left] -= take;

            if (cpy[left] == 0) {
                left++;
            }
            if (val == 0) {
                break;
            }
        }

        if (val != 0) {
            return false;
        }
        if (j + param + 1 < n) {
            right++;
        }
    }

    return true;
}

inline void solve() {
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> arr1[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> arr2[i];
    }

    int left = 0;
    int right = n + 1;

    while (right - left > 1) {
        int mid = (left + right) >> 1;

        if (check(mid)) {
            right = mid;
        } else {
            left = mid;
        }
    }

    if (check(left)) {
        cout << left;
    } else if (check(right)) {
        cout << right;
    } else {
        cout << -1;
    }
}

int main() {
    prepare();
    solve();
}
