#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

const ld eps = 1e-10;

bool check(vector<ll> a, vector<ll> b, int n, int x) {
  deque<pair<ll, int> > q;
  for (int i = 0; i <= x; ++i) {
      q.emplace_back(b[i], i);
  }
  for (int i = 0; i < n; ++i) {
    while (a[i] > 0 && !q.empty()) {
      if (q[0].first < 0)
        return 0;
      ll delta = min(a[i], q[0].first);
      a[i] -= delta;
      q[0].first -= delta;
      if (q[0].first == 0)
        q.pop_front();
    }
    if (q.empty() && a[i] > 0)
      return 0;
    if (!q.empty() && q[0].second == i - x) {
      q.pop_front();
    }
    if (i + 1 + x < n) {
      q.emplace_back(b[i + 1 + x], i + 1 + x);
    }
  }
  return 1;
}

signed main() {
  ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
  int n;
  cin >> n;
  vector<ll> a(n);
  vector<ll> b(n);
  for (ll &x : a)
    cin >> x;
  for (ll &x : b)
    cin >> x;
  ll sum = 0;
  for (ll x : a)
    sum += x;
  for (ll &x : b)
    sum -= x;
  if (sum > 0) {
    cout << -1;
    return 0;
  }
  bool flag0 = 1;
  for (int i = 0; i < n; ++i) {
    if (a[i] > b[i]) {
      flag0 = 0;
      break;
    }
  }
  if (flag0) {
    cout << 0;
    return 0;
  }
  ///cout << "r = 1: " << check(a, b, n, 1) << endl;
  int l = 0;
  int r = n;
  while (r - l > 1) {
    int m = (l + r) >> 1;
    ///cout << m << ": " << check(a, b, n, m) << endl;
    if (check(a, b, n, m))
      r = m;
    else
      l = m;
  }
  cout << r;
  return 0;
}
