#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(a) a.begin(), a.end()

using ll = long long;

signed main() {
  ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

  int n;
  cin >> n;
  vector <int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }
  vector <int> b(n);
  for (int i = 0; i < n; ++i) {
    cin >> b[i];
  }

  auto f = [&](int mid) {
    vector <int> a1 = a;
    vector <int> b1 = b;
    int it = 0;
    for (int i = 0; i < n; ++i) {
      while (it < i - mid) {
        ++it;
      }
      while (true) {
        while (it < n && a1[it] >= b1[it]) {
          ++it;
        }
        if (it >= n) {
          break;
        }
        if (it > i + mid) {
          break;
        }
        if (it < i) {
          int add = min(a1[i], b1[it] - a1[it]);
          a1[i] -= add;
          a1[it] += add;
        } else if (it > i && a1[i] > b1[i]) {
          int add = min(a1[i] - b1[i], b1[it] - a1[it]);
          a1[i] -= add;
          a1[it] += add;
        }
        if (it >= i && a1[i] <= b1[i]) {
          break;
        }
        if (a1[i] == 0) {
          break;
        }
      }
    }
    for (int i = 0; i < n; ++i) {
      if (a1[i] > b1[i]) {
        return false;
      }
    }
    return true;
  };

  auto f2 = [&](int mid) {
    vector <int> a1 = a;
    vector <int> b1 = b;
    reverse(all(a1));
    reverse(all(b1));
    int it = 0;
    for (int i = 0; i < n; ++i) {
      while (it < i - mid) {
        ++it;
      }
      while (true) {
        while (it < n && a1[it] >= b1[it]) {
          ++it;
        }
        if (it >= n) {
          break;
        }
        if (it > i + mid) {
          break;
        }
        if (it < i) {
          int add = min(a1[i], b1[it] - a1[it]);
          a1[i] -= add;
          a1[it] += add;
        } else if (it > i && a1[i] > b1[i]) {
          int add = min(a1[i] - b1[i], b1[it] - a1[it]);
          a1[i] -= add;
          a1[it] += add;
        }
        if (it >= i && a1[i] <= b1[i]) {
          break;
        }
        if (a1[i] == 0) {
          break;
        }
      }
    }
    for (int i = 0; i < n; ++i) {
      if (a1[i] > b1[i]) {
        return false;
      }
    }
    return true;
  };

  int l = -1, r = n - 1;
  while (r - l > 1) {
    int mid = l + r >> 1;
    if (f(mid) || f2(mid)) {
      r = mid;
    } else {
      l = mid;
    }
  }
  if (!f(r) && !f2(r)) {
    cout << -1;
  } else {
    cout << r;
  }
}
/*
5
1 2 3 4 5
5 4 3 2 1
*/

