#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) (a).begin(), (a).end()
#define len(a) int((a).size())

signed main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	#define int ll
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	for (auto &x : a)
		cin >> x;

	for (auto &x : b)
		cin >> x;

	vector<ll> pref_a(n + 1), pref_b(n + 1);
	for (int i = 0; i < n; i++) {
		pref_a[i + 1] = pref_a[i] + a[i];
		pref_b[i + 1] = pref_b[i] + b[i];
	}

	auto can = [&](int value) {
		ll mn = LLONG_MAX;
		for (int i = 0; i < n; i++) {
			int to = min(n - 1, i + value);
			if (pref_a[i + 1] > pref_b[to + 1])
				return false;

			if (i != 0 && pref_a[i + 1] - pref_b[to + 1] - mn > 0)
				return false;

			int from = max(-1ll, i - value);
			mn = min(mn, pref_a[i + 1] - pref_b[from + 1]);
		}

		return true;
	};

	int l = -1, r = n;
	while (r - l > 1) {
		int mid = (l + r) >> 1;
		(can(mid) ? r : l) = mid;
	}

	if (r == n)
		r = -1;

	cout <<  r << '\n';
}
