#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) (a).begin(), (a).end()
#define len(a) int((a).size())

signed main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);
	cout << fixed << setprecision(10);

	array<int, 4> values;
	for (int i = 0; i < 4; i++)
		cin >> values[i];

	vector<int> order{0, 1, 2, 3};
	sort(all(order), [&](const int i, const int j) {
		return values[i] < values[j];
	});

	sort(all(values));
	auto [a, b, c, d] = values;
	a--, b--, c--, d--;

	auto solve = [&](int prod, int a, int b) -> pair<ld, ld> {
		if (a > b)
			return {a, a == 0 ? a : ld(prod) / a};

		return {b == 0 ? 0 : ld(prod) / b, b};
	};

	ll first = (a + 1) * (c + 1) + a + c + 2;
	ld second;
	if (a * d > b * c) {
		auto [x, y] = solve(b * c, a, d);
		second = (b + 1) * (c + 1) + x + y + 2;
	} else {
		auto [x, y] = solve(a * d, b, c);
		second = (a + 1) * (d + 1) + x + y + 2;
	}

	if (first > second) {
		cout << order[0] + 1 << ' ' << order[1] + 1 << ' ' << order[3] + 1 << ' ' << order[2] + 1 << '\n';
		cout << a + 1 << ' ' << a + 1 << ' ' << c + 1 << ' ' << c + 1 << '\n';
	} else {
		for (int i = 0; i < 4; i++)
			cout << order[i] + 1 << " \n"[i == 3];

		if (a * d > b * c) {
			auto [aa, dd] = solve(b * c, a, d);
			cout << aa + 1 << ' ' << b + 1 << ' ' << c + 1 << ' ' << dd + 1 << '\n';
		} else {
			auto [bb, cc] = solve(a * d, b, c);
			cout << a + 1 << ' ' << bb + 1 << ' ' << cc + 1 << ' ' << d + 1 << '\n';
		}
	}
}
