#include<bits/stdc++.h>
#define plus plus1
#define minus minus1
#define INF 1e12
using namespace std;
typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;
const char nl = '\n';
vector<array<int, 3>> plus, minus;

ld apply(array<int, 3> a, ld x) {
	return x * x * a[0] + x * a[1] + a[2];
}

ld apply_plus(ld x) {
	bool was = false;
	ld ans = -1;
	for(int i = 0; i < plus.size(); i++) {
		ld here = apply(plus[i], x);
		if(!was) {
			was = true;
			ans = here;
		} else {
			ans = max(ans, here);
		}
	}
	return ans;
}


ld apply_minus(ld x) {
	bool was = false;
	ld ans = -1;
	for(int i = 0; i < minus.size(); i++) {
		ld here = apply(minus[i], x);
		if(!was) {
			was = true;
			ans = here;
		} else {
			ans = min(ans, here);
		}
	}
	return ans;
}

ld get_res(ld x) {
	return apply_plus(x) - apply_minus(x);
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef _FILE
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	int n;
	cin >> n;
	for(int i = 0; i < n; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		if(a > 0) {
			plus.push_back({a, b, c});
		} else {
			minus.push_back({a, b, c});
		}
	}
	if(plus.empty()) {
		cout << fixed << setprecision(17) << 0 << ' ' << apply_minus(0) - 1;
		return 0;
	} else if(minus.empty()){
		cout << fixed << setprecision(17) << 0 << ' ' << apply_plus(0) + 1;
		return 0;
	}
	ld l = -INF;
	ld r = INF;
	for(int i = 0; i < 200; i++) {
		ld mid1 = l + (r - l) / 3;
		ld mid2 = r - (r - l) / 3;
		ld r1 = get_res(mid1);
		ld r2 = get_res(mid2);
		if(r1 <= r2) {
			r = mid2;
		} else {
			l = mid1;
		}
	}
	cout << fixed << setprecision(17) << l << ' ' << (apply_minus(l) + apply_plus(l)) / 2;
}