#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;
const char nl = '\n';

const ll inf = 1e10;
const ll mod = 1e9+7;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef _FILE
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	

	int n, k;
	cin >> n >> k;

	vector<pair<ll, ll>> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i].first >> a[i].second;
	}

	vector<pair<ll, int>> dst(n);
	for (int i = 0; i < n; i++) {
		if (a[i].first % k == a[i].second % k) {
			dst[i].first = inf;
		} else {
			dst[i].first = abs(a[i].first - a[i].second);
		}
		dst[i].second = i;
	}
	sort(dst.begin(), dst.end());
	vector<ll> d(n);
	for (auto p: dst) {
		d[p.second] = p.first;
	}

	vector<ll> p(n + 1);
	for (int i = 0; i < n; i++) {
		p[i + 1] = p[i] + max(a[i].first, a[i].second);
	}

	ll ans = 0;
	int pv = -1;
	int pi = 0;

	map<ll, ll> mp;
	ll cs = 0;
	ll ptl = 0;
	vector<bool> used(n, false);
	for (auto tp: dst) {
		if (tp.first >= inf) break;
		int i = tp.second;
		if (tp.first != pv) {
			pi = -1;
			mp.clear();
			cs = 0;
			ptl = n;
		//	cout << "HI" << endl;
		}

		int tl = i, tr = i + 1;
		while (tl > pi + 1 && d[tl - 1] > d[i]) tl--;
		while (tr < n && d[tr] > d[i]) tr++;

		if (tl != pi + 1) {
			mp.clear();
			cs = 0;
			ptl = n;
		//	cout << "HI" << endl;
		}

		ptl = min(ptl, (ll)tl);
		for (int j = tl; j <= i; j++) {
			cs = (cs + p[j]) % mod;
		}
		for (int j = i + 1; j <= tr; j++) {
			ans = (ans + (i + 1 - ptl) * p[j] - cs + mod) % mod;
		}
		//cout << i << ' ' << tl << ' ' << tr << ' ' << pi << nl;
		//cout << "CS: " << cs << endl;

		for (int j = tl; j <= i; j++) {
			mp[p[j] % k]++;
		}
		for (int j = i + 1; j <= tr; j++) {
			ans = (mod + ans - tp.first * mp[p[j] % k] % mod) % mod;
		}

		pi = i;
		pv = tp.first;
		used[i] = true;
	}
	mp.clear();
	map<ll, ll> mp2;
	for (int i = 0; i < n; i++) {
		if (used[i]) continue;
		mp.clear();
		mp2.clear();
		int j = i;
		while (j < n && !used[j]) {
			used[j] = true;
			j++;
		}

		cs = 0;
		for (int ti = i; ti < j; ti++) {
			mp[p[ti] % k]++;
			mp2[p[ti] % k] = (mp2[p[ti] % k] + p[ti]) % mod;
			cs = (cs + p[ti]) % mod;
			ll le = (ti - i + 1 - mp[p[ti + 1] % k]);
			ans = (ans + mod + mod + p[ti + 1] * le - (cs - mp2[p[ti + 1] % k])) % mod;
		}
	}
	cout << ans << nl;
}