#include<bits/extc++.h>

#define int long long
//#define p pair<int, int>
#define pb push_back
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define endl '\n'
const int INF = 1000000001;

using namespace std;

const int MAXN = 1000500;
const int MAXM = 100500;
const int mod = (int) 1e9 + 7, x = 1791791791;
int pow_[MAXN];
int b[MAXM][26];

void sol(vector<int> inds, vector<int> &used) {
    if ((int) inds.size() <= 1) {
        return;
    }
    bool f1 = false;
    int c1 = -1;
    for (int c = 0; c < 26; c++) {
        if (!used[c]) {
            bool f2 = true;
            for (int i: inds) {
                if (b[i][c] == 0) {
                    f2 = false;
                } else {
                    f1 = true;
                }
            }
            if (f2) {
                c1 = c;
            }
        }
    }
    if (c1 == -1) {
        if (f1) {
            cout << "NO\n";
            exit(0);
        }
        return;
    }
    map<int, vector<int>> kek;
    for (int i: inds) {
        kek[b[i][c1]].push_back(i);
    }
    used[c1] = 1;
    for (auto &el: kek) {
        sol(el.second, used);
    }
    used[c1] = 0;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    pow_[0] = 1;
    for (int i = 1; i < MAXN; i++) {
        pow_[i] = pow_[i - 1] * x % mod;
    }
    int L, n;
    cin >> L >> n;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < L; j++) {
            b[i][s[j] - 'a'] += pow_[j];
            b[i][s[j] - 'a'] %= mod;
        }
    }
    vector<int> inds(n), used(26);
    iota(all(inds), 0);
    sol(inds, used);
    cout << "YES\n";
}
