#pragma GCC optimize("Ofast,unroll-all-loops")
#pragma GCC optimize("O3")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2")
//#pragma GCC target("popcnt")

#include "bits/stdc++.h"
#include <numeric>

using namespace std;

template<typename A, typename B>
string to_string(pair<A, B> p);

template<typename A, typename B, typename C>
string to_string(tuple<A, B, C> p);

template<typename A, typename B, typename C, typename D>
string to_string(tuple<A, B, C, D> p);

string to_string(const string &s) {
    return '"' + s + '"';
}

string to_string(const char *s) {
    return to_string((string) s);
}

string to_string(bool b) {
    return (b ? "true" : "false");
}

string to_string(vector<bool> v) {
    bool first = true;
    string res = "{";
    for (int i = 0; i < static_cast<int>(v.size()); i++) {
        if (!first) {
            res += ", ";
        }
        first = false;
        res += to_string(v[i]);
    }
    res += "}";
    return res;
}

template<size_t N>
string to_string(bitset<N> v) {
    string res = "";
    for (size_t i = 0; i < N; i++) {
        res += static_cast<char>('0' + v[i]);
    }
    return res;
}

template<typename A>
string to_string(A v) {
    bool first = true;
    string res = "{";
    for (const auto &x : v) {
        if (!first) {
            res += ", ";
        }
        first = false;
        res += to_string(x);
    }
    res += "}";
    return res;
}

template<typename A, typename B>
string to_string(pair<A, B> p) {
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template<typename A, typename B, typename C>
string to_string(tuple<A, B, C> p) {
    return "(" + to_string(get<0>(p)) + ", " +
           to_string(get<1>(p)) + ", " + to_string(get<2>(p)) + ")";
}

template<typename A, typename B, typename C, typename D>
string to_string(tuple<A, B, C, D> p) {
    return "(" + to_string(get<0>(p)) + ", " + to_string(get<1>(p)) +
           ", " + to_string(get<2>(p)) + ", " +
           to_string(get<3>(p)) + ")";
}

void debug_out() { cerr << endl; }

template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << " " << to_string(H);
    debug_out(T...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", \
                   debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

#define sz(a) (ll)((a).size())
#define all(v) (v).begin(), (v).end()
#define rall(v) v.rbegin(), v.rend()
#define pikachu push_back
#define mp make_pair
#define st first
#define nd second
#define i128 __int128
#define pt(s) (s)[sz((s)) - 2]
#define pll pair<ll, ll>
#define pii pair<int, int>

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<class t1, class t2>
inline bool cmin(t1 &a, const t2 &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<class t1, class t2>
inline bool cmax(t1 &a, const t2 &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

typedef long long ll;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef long double ld;
const ll INFL = 2e18l + 666;
const int INFI = 2e9 + 7;
inline ull bpow(ull a, ull b, ull mod = INFL) {
    ull res = 1;
    for (; b; b >>= 1) {
        if (b & 1) {
            res = ((ull) 1ll * res * a) % mod;
        }
        a = ((ull) 1ll * a * a) % mod;
    }
    return res;
}
#ifndef LOCAL
void UseFiles(const string &s) {
    freopen((s + ".in").c_str(), "r", stdin);
    freopen((s + ".out").c_str(), "w", stdout);
}
#else

void UseFiles(const string &) {}

#endif
void run();
signed main() {
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(10) << fixed;
    //UseFiles("triangles");
    run();
}
const ld EPS = 1e-6;
void run() {
    vector<ll> t(4);
    cin >> t[0] >> t[1] >> t[2] >> t[3];
    vector<ll> per = {0, 1, 2, 3};
    vector<ll> perAns;
    vector<ld> answer;
    ld ans = -2;
    do {
        vector<ld> a = {t[per[0]], t[per[1]], t[per[2]], t[per[3]]};
        ld val1 = (a[0] - 1) * (a[3] - 1);
        ld val2 = (a[1] - 1) * (a[2] - 1);
        vector<ld> cur;
        if (val1 < val2) {
            ld kek = val1 / (a[1] - 1) + 1;
            cur = {a[0], a[1], kek, a[3]};
            if (cmax(ans, val1)) perAns = per, answer = cur;
        } else if (val1 > val2) {
            ld kek = val2 / (a[3] - 1) + 1;
            cur = {kek, a[1], a[2], a[3]};
            if (cmax(ans, val2)) perAns = per, answer = cur;
        } else {
            cur = {a[0], a[1], a[2], a[3]};
            if (cmax(ans, val1)) perAns = per, answer = cur;
        }
    } while (next_permutation(all(per)));
    for (auto e : perAns) cout << e + 1 << ' ';
    cout << endl;
    for (auto e : answer) cout << e << ' ';
    for (ll i = 0; i < 4; ++i) {
        if (t[perAns[i]] < answer[i]) assert(false);
    }
    ld val1 = (answer[0] - 1) * (answer[3] - 1);
    ld val2 = (answer[1] - 1) * (answer[2] - 1);
    if (abs(val1 - val2) > EPS || abs(val1 - ans) > EPS) assert(false);
}