#include <bits/stdc++.h>

using namespace std;


struct node_t {
	array<map<char, pair<int, int>>, 20> next_bin;
	int cnt;
	int sum;

	node_t() {
		cnt = 0;
		sum = 0;
	}
};

vector<node_t> nodes;


void add_string(const string& s) {
	int node = 0;
	for(char c: s) {
		if(!nodes[node].next_bin[0].count(c)) {
			nodes[node].next_bin[0][c] = {nodes.size(), 0};
			nodes.emplace_back();
		}
		node = nodes[node].next_bin[0][c].first;
	}
	nodes[node].cnt++;
}


void dfs(int node) {
	int pref = nodes[node].cnt;
	for(auto [c, tup]: nodes[node].next_bin[0]) {
		int chld = tup.first;
		nodes[node].next_bin[0][c].second = pref;
		dfs(chld);
		pref += nodes[chld].sum;
	}
	nodes[node].sum = pref;

	for(int i = 1; i < 20; i++) {
		for(auto [c, tup]: nodes[node].next_bin[i - 1]) {
			auto [v, cnt] = tup;
			if(v != -1) {
				auto it = nodes[v].next_bin[i - 1].lower_bound(c);
				if(it == nodes[v].next_bin[i - 1].end()) {
					nodes[node].next_bin[i][c] = {-1, cnt + nodes[v].sum};
				} else {
					nodes[node].next_bin[i][c] = {
						it->first == c ? it->second.first : -1,
						cnt + it->second.second
					};
				}
			} else {
				nodes[node].next_bin[i][c] = {-1, cnt};
			}
		}
	}
}


signed main() {
	nodes.emplace_back();


	int n, q;
	cin >> n >> q;

	vector<tuple<int, char, int, int>> ss;
	string s;
	cin >> s;
	for(int i = 0; i < s.size(); i++) {
		ss.emplace_back(i, s[i], 1, -1);
	}

	for(int i = 0; i < n; i++) {
		string t;
		cin >> t;
		add_string(t);
	}

	dfs(0);


	int node = 0;
	int ans = 0;
	for(int i = 0; i < s.size(); i++) {
		get<3>(ss[i]) = node;
		if(node != -1) {
			char c = s[i];
			auto it = nodes[node].next_bin[0].lower_bound(c);
			if(it == nodes[node].next_bin[0].end()) {
				ans += nodes[node].sum;
				node = -1;
			} else {
				ans += it->second.second;
				node = it->first == c ? it->second.first : -1;
			}
		}
	}
	cout << ans << "\n";

	for(int i = 0; i < q; i++) {
		int k;
		char c;
		cin >> k >> c;
		k--;

		int exp;
		auto it = lower_bound(ss.begin(), ss.end(), make_tuple(k, 0, 0, 0));
		if(it != ss.begin()) {
			--it;

			auto& [i, c, n, node] = *it;

			assert(k == 0 || i < k);
			assert(i + n >= k);

			int node1 = node;
			for(int j = 19; j >= 0 && node1 != -1; j--) {
				if((n >> j) & 1) {
					auto it = nodes[node1].next_bin[j].lower_bound(c);
					if(it == nodes[node1].next_bin[j].end()) {
						ans -= nodes[node1].sum;
						node1 = -1;
					} else {
						ans -= it->second.second;
						node1 = it->first == c ? it->second.first : -1;
					}
				}
			}
			n = k - i;

			node1 = node;
			for(int j = 19; j >= 0 && node1 != -1; j--) {
				if((n >> j) & 1) {
					auto it = nodes[node1].next_bin[j].lower_bound(c);
					if(it == nodes[node1].next_bin[j].end()) {
						ans += nodes[node1].sum;
						node1 = -1;
					} else {
						ans += it->second.second;
						node1 = it->first == c ? it->second.first : -1;
					}
				}
			}

			exp = it - ss.begin() + 1;
		} else {
			exp = 0;
		}

		while(ss.size() > exp) {
			auto [i, c, n, node] = ss.back();
			for(int j = 19; j >= 0 && node != -1; j--) {
				if((n >> j) & 1) {
					auto it = nodes[node].next_bin[j].lower_bound(c);
					if(it == nodes[node].next_bin[j].end()) {
						ans -= nodes[node].sum;
						node = -1;
					} else {
						ans -= it->second.second;
						node = it->first == c ? it->second.first : -1;
					}
				}
			}
			ss.pop_back();
		}

		int node;
		if(ss.empty()) {
			node = 0;
		} else {
			int i, c, n;
			tie(i, c, n, node) = ss.back();
			for(int j = 19; j >= 0 && node != -1; j--) {
				if((n >> j) & 1) {
					auto it = nodes[node].next_bin[j].find(c);
					if(it != nodes[node].next_bin[j].end()) {
						node = it->second.first;
					} else {
						node = -1;
					}
				}
			}
		}

		int n = s.size() - k;
		ss.emplace_back(k, c, n, node);
		for(int j = 19; j >= 0 && node != -1; j--) {
			if((n >> j) & 1) {
				auto it = nodes[node].next_bin[j].lower_bound(c);
				if(it == nodes[node].next_bin[j].end()) {
					ans += nodes[node].sum;
					node = -1;
				} else {
					ans += it->second.second;
					node = it->first == c ? it->second.first : -1;
				}
			}
		}

		cout << ans << "\n";
	}

	return 0;
}
