#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define ld long double
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vi vector<int>
#define pii pair<int, int>
#define pb push_back
#define vpii vector<pair<int, int> >

const long double eps = 1e-10;
const int INF = (1ll << 31ll) - 1ll;
const long long INFL = (1ll << 63ll) - 1ll;

void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(15);

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
}

const size_t SIZE = 5e5 + 10;

inline bool check(vector<int> a, vector<int> b, int k) {
    int n = a.size();
    int j = 0;
    for (int i = 0; i < n; i++) {
        while (j < i) {
            if (i - j > k) {
                j++;
                continue;
            }
            int can = b[j] - a[j];
            if (a[i] >= can) {
                a[i] -= can;
                b[j] -= can;
                j++;
            } else {
                b[j] -= a[i];
                a[i] = 0;
                break;
            }
        }
        if (a[i] > b[i]) {
            j = i + 1;
            while (j < n && j - i <= k) {
                int need = a[i] - b[i];
                if (b[j] < need) {
                    a[i] -= b[j];
                    b[j] = 0;
                    j++;
                } else {
                    b[j] -= need;
                    a[i] -= need;
                    break;
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (a[i] > b[i])
            return false;
    }
    return true;
}

const int MAXN = 1e6 + 5;

int a1[MAXN], a[MAXN], b1[MAXN], b[MAXN];

signed main() {
    fastio();

    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> a1[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b1[i];
    }

    int l = -1, r = n;
    while (r - l > 1) {
        int k = (r + l) / 2;
        for (int i = 0; i < n; i++) {
            a[i] = a1[i];
            b[i] = b1[i];
        }
        bool ok = true;
        int j = 0;
        for (int i = 0; i < n; i++) {
            while (j < i) {
                if (i - j > k) {
                    j++;
                    continue;
                }
                int can = b[j] - a[j];
                if (a[i] >= can) {
                    a[i] -= can;
                    b[j] -= can;
                    j++;
                } else {
                    b[j] -= a[i];
                    a[i] = 0;
                    break;
                }
            }
            if (a[i] > b[i]) {
                j = i + 1;
                while (j < n && j - i <= k) {
                    int need = a[i] - b[i];
                    if (b[j] < need) {
                        a[i] -= b[j];
                        b[j] = 0;
                        j++;
                    } else {
                        b[j] -= need;
                        a[i] -= need;
                        break;
                    }
                }
            }
        }
        for (int i = 0; i < n; i++) {
            if (a[i] > b[i])
                ok = false;
        }
        if (ok) {
            r = k;
        } else {
            l = k;
        }
    }
    if (r == n) {
        cout << -1 << '\n';
        return 0;
    }
    cout << r << '\n';

    return 0;
}
/*

 */