#include <iostream>
#include <vector>
#include <algorithm>

#define int long long
using namespace std;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int n, s = 0;
    cin >> n;
    vector <int> a(n), b(n);
    for (auto &el: a) {
        cin >> el;
        s -= el;
    }
    for (auto &el: b) {
        cin >> el;
        s += el;
    }
    if (s < 0) {
        cout << -1;
        return 0;
    }
    int l = -1, r = n;
    while (r - l > 1) {
        int m = (l + r) / 2;
        vector <int> a1 = a, b1 = b;
        bool flag = true;
        int j = 0;
        for (int i = 0; i < n; i++) {
            j = max(j, i - m);
            while (a1[i] > 0 && j < i) {
                int inc = min(a1[i], max(0ll, b1[j] - a1[j]));
                a1[i] -= inc, b1[j] -= inc;
                if (a1[j] == b1[j])
                    j++;
            }
            if (a1[i] >= b1[i] && i == j)
                j++;
            while (a1[i] > b1[i] && j <= min(n - 1, i + m)) {
                int inc = min(a1[i] - b1[i], b1[j]);
                a1[i] -= inc, b1[j] -= inc;
                if (b1[j] == 0)
                    j++;
            }
            if (a1[i] > b1[i]) {
                flag = false;
                break;
            }
        }
        if (flag)
            r = m;
        else
            l = m;
    }
    cout << r << endl;

    return 0;
}
