#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <iomanip>

#define int long long
using namespace std;

const int INF = 1e9 + 179;
const long double EPS = 1e-9;

int a2 = 0;
int a1 = INF;
multiset<int> suff;

//long double f(long double t) {
//    auto temp_max = max((long double) pref_max, (1 - t) * (long double) (*(--suff.end())));
//    auto temp_min = min((long double) pref_min, (1 - t) * (long double) (*suff.begin()));
//
//    return temp_max - temp_min;
//}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;

    vector<int> a(n);
    for (auto &elem: a) {
        cin >> elem;
        suff.insert(elem);
    }


    cout << setprecision(10) << fixed;
    for (int i = 0; i < n; ++i) {
//        long double l = 0, r = 1;
//        while (r - l > EPS) {
//            auto m1 = l + (l + r) / 3;
//            auto m2 = l + 2 * (l + r) / 3;
//            if (f(m1) < f(m2)) {
//                l = m1;
//            } else {
//                r = m2;
//            }
//        }

//        cout << l << ' ';

        auto b1 = (long double) (*suff.begin());
        auto b2 = (long double) (*(--suff.end()));

        long double ans, k = 1;
        if (a2 < b2) {
            k = (long double) a2 / b2;
        }

        if (k * b1 > a1) {
            k = (long double) a1 / b1;
        }
        ans = max((long double) 0, 1 - k);

        cout << ans << ' ';

        a1 = min(a1, a[i]);
        a2 = max(a2, a[i]);
        suff.erase(suff.find(a[i]));
    }


    return 0;
}
