#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>

#define int long long
using namespace std;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cout << fixed << setprecision(10);

    vector <pair <int, int>> t(4);
    for (int i = 0; i < 4; i++) {
        cin >> t[i].first;
        t[i].second = i;
    }
    sort(t.begin(), t.end());

    vector <double> ans(4);
    for (int i = 0; i < 4; i++)
        ans[i] = t[i].first;
    double prod = min((t[0].first - 1) * (t[3].first - 1), (t[1].first - 1) * (t[2].first - 1));

    if (prod == (t[0].first - 1) * (t[3].first - 1)) {
        if (ans[2] == 1)
            ans[1] = 1;
        else
            ans[1] = prod / (ans[2] - 1) + 1;
    } else {
        if (ans[4] == 1)
            ans[0] = 1;
        else
            ans[0] = prod / (ans[4] - 1) + 1;
    }

    for (auto &[val, i]: t)
        cout << i + 1 << " ";
    cout << endl;
    for (auto &el: ans)
        cout << el << " ";
    cout << endl;


    return 0;
}
