#include <bits/stdc++.h>

using namespace std;
#define int long long
#define endl '\n'
#define double long double

int check(double m, vector<vector<int>> &par, int n) {
    vector<pair<double, pair<int, int>>> ans(n);
    for (int i = 0; i < n; i++) {
        ans[i].first = par[i][0] * m * m + par[i][1] * m + par[i][2];
        if (par[i][0] >= 0) {
            ans[i].second.first = 1;
        } else {
            ans[i].second.first = 0;
        }
        ans[i].second.second = i;
    }
    sort(ans.begin(), ans.end());
    int mini = 0, maxi = 0;
    int mmmin = 0, mmmax = 0;
    for (int i = 0; i < n; i++) {
        if (ans[i].second.first == 0) {
            mini = ans[i].second.second;
            mmmin = i;
            break;
        }
    }
    for (int i = n - 1; i > -1; i--) {
        if (ans[i].second.first == 1) {
            maxi = ans[i].second.second;
            mmmax = i;
            break;
        }
    }
    if (mmmax < mmmin) {
        return 3;
    }
    int a = par[mini][0] - par[maxi][0], b = par[mini][1] - par[maxi][1], c = par[mini][2] - par[maxi][2];
    double D = sqrt((double)(b * b - 4 * a * c));
    double x1 = (-b + D) / (2 * a);
    if (x1 > m) {
        return 1;
    } else {
        return 2;
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<vector<int>> par(n, vector<int>(3));
    for (int i = 0; i < n; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        par[i][0] = a;
        par[i][1] = b;
        par[i][2] = c;
    }
    double L = -1000000000, R = 1000000000;
    for (int i = 0; i < 80; i++) {
        double m = (L + R) / 2;
        int ch = check(m, par, n);
        if (ch == 3) {
            R = m;
            break;
        } else {
            if (ch == 2) {
                R = m;
            } else {
                L = m;
            }
        }
    }
    vector<pair<double, int>> ans(n);
    for (int i = 0; i < n; i++) {
        ans[i].first = par[i][0] * R * R + par[i][1] * R + par[i][2];
        if (par[i][0] >= 0) {
            ans[i].second = 1;
        } else {
            ans[i].second = 0;
        }
    }
    sort(ans.begin(), ans.end());
    int mini = 0;
    for (int i = 0; i < n; i++) {
        if (ans[i].second == 0) {
            mini = i;
            break;
        }
    }
    cout << setprecision(8) << R << " " << ans[mini].first << endl;
}
