#include <bits/stdc++.h>


using namespace std;
#define all(x) (x).begin, (x).end
typedef long long ll;


signed main(){
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    ll s1 = 0, s2 = 0;
    vector<int> a(n), b(n);
    for (int &i : a) {
        cin >> i;
        s1 += i;
    }
    for (int &i : b) {
        cin >> i;
        s2 += i;
    }
    if (s1 > s2) {
        cout << -1;
        return 0;
    }
    int l = -1, r = n - 1;
    while (l + 1 < r) {
        int m = (l + r + 1) / 2;
        queue<pair<int, int>> q1, q2;
        for (int i = 0; i < n; i++) {
            if (!q1.empty() && i - q1.front().second > m)
                break;
            if (!q2.empty() && i - q2.front().second > m)
                q2.pop();
            q1.push({a[i], i});
            q2.push({b[i], i});
            while (!q1.empty() && !q2.empty()) {
                if (q1.front().first < q2.front().first) {
                    q2.front().first -= q1.front().first;
                    q1.pop();
                } else if (q1.front().first > q2.front().first) {
                    q1.front().first -= q2.front().first;
                    q2.pop();
                } else {
                    q1.pop();
                    q2.pop();
                }
            }
        }
        if (q1.empty()) r = m;
        else l = m;
    }
    cout << r;
}
