#include <iostream>
#include "vector"
#include "algorithm"

using namespace std;
#define all(x) (x).begin(), (x).end()
typedef long long ll;
const int INF = 1e9 + 7;

vector<int> ingrp;
vector<vector<int>> grp(2);
void movefrom(int v) {
    cout << (v + 1) << (2 - v) << '\n';
    ingrp[grp[v].back()] = 1 - v;
    grp[1 - v].push_back(grp[v].back());
    grp[v].pop_back();
}
signed main(){
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    vector<pair<int, int>> b(n);
    ingrp.assign(n, {});
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        b[i] = {a[i], i};
        cout << 1 << '\n';
        grp[0].push_back(i);
    }
    sort(all(b));
    for (int i = 0; i < n; ++i) {
        int targ = b[i].second;
        while (grp[ingrp[targ]].back() != targ) {
            movefrom(ingrp[targ]);
        }
        grp[ingrp[targ]].pop_back();
        cout << "-" << ingrp[targ] + 1 << '\n';
    }
}
