#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <array>

using namespace std;
#define int long long
signed main() {
	if (1) {
		ios_base::sync_with_stdio(false);
		cin.tie(nullptr);
		cout.tie(nullptr);
	}
	int n;
	cin >> n;
	vector <int> a(n), b(n);
	for (int i = 0; i < n; ++i) cin >> a[i];
	for (int i = 0; i < n; ++i) cin >> b[i];
	vector <int> flex(n);
	int l = -1, r = n;
	while (r - l > 1) {
		for (int i = 0; i < n; ++i) flex[i] = 0;
		int m = (l + r) / 2;
		int now = 0;
		bool ok = true;
		for (int i = 0; i < n; ++i) {
			if (a[i] <= b[i]) continue;
			now = max(now, i - m);
			int me = a[i] - b[i];
			while (now < n && now <= i + m) {
				int here = b[now] - a[now] - flex[now];
				if (here <= 0) {
					++now;
					continue;
				}
				if (me > here) {
					flex[now] += here;
					me -= here;
					++now;
					continue;
				}
				flex[now] += me;
				me = 0;
				break;
			}
			if (me > 0) {
				ok = false;
				break;
			}
		}
		if (ok) r = m;
		else l = m;
	}
	if (r == n) cout << -1;
	else cout << r;
}