#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace __gnu_pbds;
template<typename T>
using ordset = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#endif

#define all(q) q.begin(), q.end()
#define Please return
#define AC 0
#define nl '\n'

using namespace std;
using ll = long long;
using ld = long double;
using cmpl = complex<long double>;

template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& x) {
	return in >> x.first >> x.second;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& out, const pair<T1, T2>& x) {
	return out << x.first << ' ' << x.second;
}

template<typename T>
istream& operator>>(istream& in, vector <T>& x) {
	for (auto& p : x)
		in >> p;
	return in;
}

template<typename T>
ostream& operator<<(ostream& out, const vector <T>& x) {
	for (auto& p : x)
		out << p << ' ';
	return out;
}

const ld eps = 1e-9;

int main(int argc, char* argv[]) {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	cout.precision(20);
	if (argc > 1) {
		freopen(argv[1], "r", stdin);
	}
	if (argc > 2) {
		freopen(argv[2], "w", stdout);
	}

	vector<ld> tVal(4);
	cin >> tVal;
	vector<int> ind = { 0, 1, 2, 3 };

	vector<int> bestPerm;
	vector<ld> bestA;
	ld bestAns = -1;

	do
	{
		vector<ld> t(4);
		for (int i = 0; i < 4; ++i)
			t[i] = tVal[ind[i]];

		for (int i = 0; i < 4; ++i)
		{
			ld a = t[3 - i];
			ld b = 0, c = 0;
			if (i == 0 || i == 3)
				b = t[1], c = t[2];
			else if (i == 1 || i == 2)
				b = t[0], c = t[3];

			if (abs(a - 1.0) > eps)
			{
				ld d = (b * c + a - b - c) / (a - 1);
				if (0 <= d && d <= t[i])
				{
					ld ans = b * c + a + d;
					if (ans > bestAns)
					{
						bestAns = ans;
						bestPerm = ind;
						bestA = t;
						bestA[i] = d;
					}
				}
			}
			else if (abs(b * c + a - b - c) < eps)
			{
				ld d = t[i];
				ld ans = b * c + a + d;
				if (ans > bestAns)
				{
					bestAns = ans;
					bestPerm = ind;
					bestA = t;
				}
			}
		}
	} while (next_permutation(all(ind)));

	for (auto x : bestPerm)
		cout << x + 1 << " ";
	cout << "\n";
	cout << bestA;

	Please AC;
}