#include <iostream>
#include <random>
#include <algorithm>
#include <deque>

#pragma warning(disable : 4996)

using namespace std;

//define int long long
#define double long double
#define max(a, b) a<b ? b : a
#define min(a, b) a<b ? a : b
mt19937 rnd;

using namespace std;

const int p = 239;
const int m = 1e9 + 1329;

inline int getint() {
	int res = 0;
	while (1) {
		char f = _getchar_nolock();
		if (f == ' ' || f == '\n') break;
		res = res * 10 + (f - '0');
	}
	return res;
}

const int MAXN = 1e6;
int a[MAXN];
int b[MAXN];
pair <int, int> c[MAXN];

signed main() {
	//ios_base::sync_with_stdio(); cin.tie(0); cout.tie(0);
	int n = getint(); 
	long long sa = 0, ba = 0;
	for (int i = 0; i < n; ++i) {
		a[i] = getint();
		sa += a[i];
	}
	for (int i = 0; i < n; ++i) {
		b[i] = getint();
		ba += b[i];
	}
	if (sa > ba) {
		cout << "-1\n";
		return 0;
	}
	int l = -1, r = n - 1;
	deque < pair <int, int> > q;
	while (r - l > 1) {
		int m = (r + l) / 2;
		bool yes = 1;
		q.clear();
		int sz = 0;
		for (int i = 0; i < n; ++i) {
			c[i] = { 0, n - 1 };
		}
		for (int i = n - 1; i >= 0; --i) {
			if (i - m >= 0) {
				c[i - m] = { a[i], min(n - 1, i + m) };
			}
			else {
				q.push_back({ a[i], min(n - 1, i + m) });
				sz++;
			}
		}
		for (int i = 0; i < n; ++i) {
			q.push_front(c[i]);
			sz++;
			int sum = 0;
			while (!q.empty()) {
				if (q.back().second < i) {
					yes = 0;
					break;
				}
				if (sum + q.back().first <= b[i]) {
					sum += q.back().first;
					q.pop_back();
					sz--;
				}
				else {
					q[sz - 1].first -= (b[i] - sum);
					break;
				}
			}
			if (!yes) {
				break;
			}
		}
		if (sz > 0) yes = 0;
		if (yes) {
			r = m;
		}
		else {
			l = m;
		}
	}
	cout << r << "\n";
}