#include <iostream>
#include <random>
#include <algorithm>

#pragma warning(disable : 4996)

using namespace std;

#define int long long
#define double long double
#define max(a, b) a<b ? b : a
#define min(a, b) a<b ? a : b
mt19937 rnd;

using namespace std;

const int p = 239;
const int m = 1e9 + 1329;

signed main() {
	ios_base::sync_with_stdio(); cin.tie(0); cout.tie(0);
	int l, n; cin >> l >> n;
	vector < vector <char> > a(n, vector <char>(l));
	vector < vector <bool> > is(n, vector <bool>(26, 0));
	for (int i = 0; i < n; ++i) {
		string s; cin >> s;
		for (int j = 0; j < l; ++j) {
			a[i][j] = s[j];
			is[i][s[j] - 'a'] = 1;
		}
	}
	vector <bool> in(26, 1);
	for (int i = 0; i < 26; ++i) {
		for (int j = 0; j < n; ++j) {
			in[i] = (in[i] & is[j][i]);
		}
	}
	vector <int> h(n);
	for (int i = 0; i < n; ++i) {
		h[i] = 0;
		for (int j = 0; j < l; ++j) {
			if (!in[a[i][j] - 'a']) {
				a[i][j] = '?';
			}
			h[i] = (h[i] * p + a[i][j]) % m;
		}
	}
	sort(h.begin(), h.end());
	for (int i = 1; i < n; ++i) {
		if (h[i] == h[i - 1]) {
			cout << "NO\n";
			return 0;
		}
	}
	cout << "YES\n";
}