#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <stack>
typedef long long ll;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll n;
    cin >> n;
    vector<ll> a(n, 0);
    vector<ll> b(n, 0);

    bool all_eq = true;
    ll sum = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sum += a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        all_eq &= a[i]<=b[i];
        sum -= b[i];
    }
    if (sum > 0){
        cout << -1;
        return 0;
    }
    if(all_eq){
        cout << 0;
        return 0;
    }
    ll max_l = 0;
    for (int i = 0; i < n; ++i){
        ll s = b[i];
        ll l = 0;
        while(s < a[i]){
            l++;
            if(i+l < n) s+=b[i+l];
            if(i-l >= 0) s+=b[i-l];
            if(i+l >= n && i-l < 0) break;
        }
        max_l = max(max_l, l);
    }
    cout << max_l;

    return 0;
}