#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <stack>
typedef long long ll;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll n;
    cin >> n;
    vector<ll> arr(n + 1);
    for (int i = 1; i <= n; i++) cin >> arr[i];
    if (n == 1){
        cout << 1;
        return 0;
    }
    vector<ll> s_max(n + 1);
    s_max[n] = arr[n];
    for (int i = n - 1; i >= 0; i--) s_max[i] = max(s_max[i + 1], arr[i]);
    vector<ll> p_max(n + 1);
    p_max[1] = 0;
    for (int i = 2; i <= n; i++) p_max[i] = max(p_max[i - 1], arr[i - 1]);
    vector<ll> p_min(n + 1);
    p_min[1] = arr[1];
    for (int i = 2; i <= n; i++) p_min[i] = min(p_min[i - 1], arr[i - 1]);
    vector<ll> s_min(n + 1);
    s_min[n] = arr[n];
    for (int i = n - 1; i >= 0; i--) s_min[i] = min(s_min[i + 1], arr[i]);
    vector<ll> pr(n + 1);
    pr[1] = arr[1];
    for (int i = 2; i <= n; i++) pr[i] = pr[i - 1] + arr[i];
    cout << "1 ";
    for (int k = 2; k <= n; k++){
        int a = p_max[k];
        int c = s_max[k];
        int b = p_min[k];
        int d = s_min[k];
        ld t1 = max(1 - ld(a)/c, 1 - ld(b)/d);
        t1 = max(t1, ld(0.0));
        ld n1 = a - (1 - t1)*d;
        bool is_t2 = false;
        ld t2 = 0;
        ld n2 = 0;
        if (b*c <= d*a){
            t2 = 1 - ld(b)/d;
            t2 = max(t2, ld(0.0));
            n2 = a - b;
            is_t2 = true;
        }
        bool is_t3 = false;
        ld t3 = 0;
        ld n3 = 0;
        if (b*c >= d*a) {
            t3 = 1 - ld(a) / c;
            t3 = max(t3, ld(0.0));
            n3 = (1 - t3) * (c - d);
            is_t3 = true;
        }
        ld t4 = min(1 - ld(a)/c, 1 - ld(b)/d);
        bool bad_t4 = true;
        if (t4 >= ld(0.0)) bad_t4 = false;
        ld n4 = (1 - t4) * c - b;
        vector<pair<ld, ld>> res;
        res.push_back({n1, -t1});
        if (is_t2) res.push_back({n2, -t2});
        if (is_t3) res.push_back({n3, -t3});
        if (!bad_t4) res.push_back({n4, -t4});
        sort(res.begin(), res.end());
        cout << fixed << setprecision(10) << -res[0].second << ' ';
    }
    return 0;
}
