#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <stack>
typedef long long ll;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll n;
    cin >> n;
    vector<ll> arr(n + 1);
    for (int i = 1; i <= n; i++) cin >> arr[i];
    if (n == 1){
        cout << 1;
        return 0;
    }
    vector<ll> s_max(n + 1);
    s_max[n] = arr[n];
    for (int i = n - 1; i >= 0; i--) s_max[i] = max(s_max[i + 1], arr[i]);
    vector<ll> p_max(n + 1);
    p_max[1] = 0;
    for (int i = 2; i <= n; i++) p_max[i] = max(p_max[i - 1], arr[i - 1]);
    vector<ll> p_min(n + 1);
    p_min[1] = arr[1];
    for (int i = 2; i <= n; i++) p_min[i] = min(p_min[i - 1], arr[i - 1]);
    vector<ll> s_min(n + 1);
    s_min[n] = arr[n];
    for (int i = n - 1; i >= 0; i--) s_min[i] = min(s_min[i + 1], arr[i]);
    cout << "1 ";

    for (int k = 2; k <= n; k++){
        int a = p_max[k];
        int c = s_max[k];
        int b = p_min[k];
        int d = s_min[k];
        ld t1 = 1 - ld(a)/c;
        ld t2 = 1 - ld(b)/d;

        cout << fixed << setprecision(18) << max(t1, max(t2, ld(0))) << ' ';
    }
    return 0;
}
