#include <iostream>
#include <vector>


using namespace std;

int main() {
    int INF = 1e9 + 1;
    int n; cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    vector<pair<int, int>> left_min_max(n + 1);
    vector<pair<int, int>> right_min_max(n + 1);
    double left_min, left_max, right_min, right_max;
    left_min_max[0] = {INF, 0};
    right_min_max[n] = {INF, 0};
    for (int i = 1; i <= n; ++i) {
        left_min_max[i] = {min(left_min_max[i - 1].first, a[i - 1]),
                           max(left_min_max[i - 1].second, a[i - 1])};
        right_min_max[n - i] = {min(right_min_max[n - i + 1].first, a[n - i]),
                           max(right_min_max[n - i + 1].second, a[n - i])};
    }
    for (int i = 0; i < n; ++i) {
        left_min = left_min_max[i].first;
        left_max = left_min_max[i].second;
        right_min = right_min_max[i].first;
        right_max = right_min_max[i].second;

        if (left_max <= right_max && left_min >= right_min)
            cout << 1 - left_max / right_max << " ";
        else if (left_max > right_max && left_min < right_min)
            cout << 1 - left_min / right_min << " ";
        else if (left_max > right_max && left_min > right_min)
            cout << 0 << " ";
        else {
            double t2 = 1 - left_max / right_max;
            double t1 = 1 - left_min / right_min;
            double a1 = right_max - min(right_min, (1 - t1) * left_min);
            double a2 = max(right_max, (1 - t2) * right_max) - left_min;
            if (a1 < a2)
                cout << t1 << " ";
            else if (a1 == a2)
                cout << max(t1, t2) << " ";
            else
                cout << t2 << " ";
        }
    }
    return 0;
}
