#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <climits>
#include <queue>
#include <algorithm>
#include <assert.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = INT_MAX;

vector<int> a, b;
vector<ll> pref_b;
int n;

bool check(int k)
{
    for (int i = 0; i < n; i++) {
        // cout << i << ' ' << pref_b[min(n, i + k + 1)] << ' ' << pref_b[max(0, i - k)] << '\n';
        if (pref_b[min(n, i + k + 1)] - pref_b[max(0, i - k)] < a[i]) {
            return false;
        }
    }
    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(18);
#ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
#endif

    cin >> n;

    a.resize(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    b.resize(n);
    pref_b.resize(n + 1);
    for (int i = 0; i < n; i++)
    {
        cin >> b[i];
        pref_b[i + 1] = pref_b[i] + b[i];
    }

    // cout << pref_b[2] - pref_b[0] << '\n';
    // check(1);
    // return 0;
    int l = -1, r = n;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (!check(m)) {
            l = m;
        }
        else {
            r = m;
        }
    }
    if (!check(r)) {
        cout << -1 << '\n';
    }
    else {
        cout << r << '\n';
    }
}