#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <climits>
#include <queue>
#include <algorithm>
#include <assert.h>
#include <stack>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = INT_MAX;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(18);
#ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
#endif

    int n;
    cin >> n;

    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    stack<int> s1, s2;

    int cur = 1;
    for (int i = 0; i < n; i++)
    {
        cout << "1" << '\n';
        if (a[i] == cur)
        {
            cout << "-1" << '\n';
            cur++;
        }
        else
        {
            s1.push(a[i]);
        }
    }

    bool infirst = true;
    while (cur <= n)
    {
        if (infirst)
        {
            while (!s1.empty())
            {
                if (s1.top() == cur)
                {
                    cout << "-1" << '\n';
                    cur++;
                }
                else
                {
                    cout << "12" << '\n';
                    s2.push(s1.top());
                }
                s1.pop();
            }
        }
        else
        {
            while (!s2.empty())
            {
                if (s2.top() == cur)
                {
                    cout << "-2" << '\n';
                    cur++;
                }
                else
                {
                    cout << "21" << '\n';
                    s1.push(s2.top());
                }
                s2.pop();
            }
        }
        infirst = !infirst;
    }
}