#include <iostream>
#include <iomanip>
#include <map>
#include <set>
#include <cmath>
#include <string>
#include <stack>
#include <algorithm>
#include <vector>
#include <bitset>

using itn = int;
using ll = long long;

const int INF = 1e9;

using namespace std;

int n, l;

vector <string> words;

vector <set <int>> exists;

vector <int> classes[2], for_sort;

char cur_r;

vector <int> r_of_class;

bool cmp(int i, int j) {
    for (int ind = 0; ind < l; ++ind) {
        if (words[i][ind] != words[j][ind] && (words[i][ind] == cur_r || words[j][ind] == cur_r))
            return words[j][ind] == cur_r;
    }
    return false;
}

int find_r(int l, int rgh) {
    for (int r = 0; r < 26; ++r) {
        bool exist = true;
        for (int i = l; i <= rgh; ++i) {
            if (exists[for_sort[i]].find(r) == exists[for_sort[i]].end()) {
                exist = false;
                break;
            }
        }
        if (exist)
            return r;
    }
    return -1;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    vector<double> t(4);
    cin >> t[0] >> t[1] >> t[2] >> t[3];
    vector<int> ind = { 0, 1, 2, 3 };
    vector<int> ans_ind;
    vector<double> ans_val;
    double cur = 0;
    for (int i = 0; i < 24; ++i) {
        vector<double> a = { t[ind[0]], t[ind[1]], t[ind[2]], t[ind[3]] };
        if ((a[0] - 1) * (a[3] - 1) > (a[1] - 1) * (a[2] - 1)) {
            double nxt = ((a[1] - 1) * (a[2] - 1)) / max(a[0] - 1, a[3] - 1);
            if (a[0] > a[3])
                a[3] = nxt + 1;
            else
                a[0] = nxt + 1;
        }
        else if ((a[0] - 1) * (a[3] - 1) < (a[1] - 1) * (a[2] - 1)) {
            double nxt = ((a[0] - 1) * (a[3] - 1)) / max(a[1] - 1, a[2] - 1);
            if (a[1] > a[2])
                a[2] = nxt + 1;
            else
                a[1] = nxt + 1;
        }
        double cur_val = a[0] * a[3] + a[1] + a[2];
        if (cur_val > cur) {
            cur = cur_val;
            ans_ind = ind;
            ans_val = a;
        }
        next_permutation(ind.begin(), ind.end());
    }
    cout << fixed << setprecision(12);
    for (auto i : ans_ind)
        cout << i + 1 << ' ';
    cout << '\n';
    for (auto v : ans_val)
        cout << v << ' ';
    cout << '\n';
}