#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<random>
#include <bitset>
#include<fstream>
#include<stack>
#include<cmath>
#include<iomanip>
#include <string>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef long double ld;

ll bin_pow(ll a, ll step)
{
	if (step == 0)
		return 1;
	if (step % 2 == 1)
		return a*bin_pow(a, step-1);
	ll now = bin_pow(a, step / 2);
	return now * now;
}

ld eps = 1e-12;

void solveG() {
	vector<int>p = { 0, 1, 2, 3 }, ans_p(4);
	vector<ld>arr(4), ans;
	for (auto&i : arr)
		cin >> i;
	ld best_ans = -1;
	do {
		ld l = 0, r = 1e9;
		for (int i = 0; i < 600; i++) {
			ld m = (l + r) / 2;
			ld a1 = arr[p[0]], a2, a3 = arr[p[2]], a4;
			if ((a1 == 1 || a3 == 1) && m > eps)
			{
				r = 0;
				continue;
			}
			if (a1 == 1)
				a2 = arr[p[1]];
			else
				a2 = m / (a1 - 1) + 1;
			if (a3 == 1)
				a4 = arr[p[3]];
			else
				a4 = m / (a3 - 1) + 1;
			if (a2 - arr[p[1]] <= eps && a4 - arr[p[3]] <= eps)
				l = m;
			else
				r = m;
		}
		for (int mask = 0; mask < 4; mask++) {
			ld a1, a2, a3, a4;
			if (mask & 1) { // a1
				a1 = arr[p[0]];
				if (a1 == 1)
					a4 = arr[p[1]];
				else
					a4 = l / (a1 - 1) + 1;
			}
			else { // a4
				a4 = arr[p[1]];
				if (a4 == 1)
					a1 = arr[p[0]];
				else
					a1 = l / (a4 - 1) + 1;
			}

			if (mask & 2) { // a2
				a2 = arr[p[2]];
				if (a2 == 1)
					a3 = arr[p[3]];
				else
					a3 = l / (a2 - 1) + 1;
			}
			else { // a3
				a3 = arr[p[3]];
				if (a3 == 1)
					a2 = arr[p[2]];
				else
					a2 = l / (a3 - 1) + 1;
			}
			if (a1 + a2 + a3 + a4 + l > best_ans) {
				ans_p[0] = p[0];
				ans_p[1] = p[2];
				ans_p[2] = p[3];
				ans_p[3] = p[1];
				best_ans = l + a1 + a2 + a3 + a4;
				ans = { a1, a2, a3, a4 };
			}
		}
	} while (next_permutation(p.begin(), p.end()));
	for (auto i : ans_p)
		cout << i + 1 << ' ';
	cout << '\n' << setprecision(60) << fixed;
	for (auto&i : ans)
		cout << i << ' ';
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	//cin>>t;
	while (t--) {
		solveG();
	}
	return 0;
}