#define _USE_MATH_DEFINES

#include <iostream>
#include <iomanip>

#include <cmath>
#include <algorithm>

#include <vector>
#include <string>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((ll)(x).size())

int main() {
    ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

    vector<int> t(4);
    cin >> t[0] >> t[1] >> t[2] >> t[3];
    vector<int> pos = { 0, 1, 2, 3 };
    long double ans = 0;
    vector<int> ans_p;
    vector<long double> ans_v;

    do {
        long double a1 = t[pos[0]], a2 = t[pos[1]], a3 = t[pos[2]], a4 = t[pos[3]];

        long double c_a4 = a4;
        if (a1 - 1 != 0) {
            c_a4 = (a2 - 1) * (a3 - 1) / (a1 - 1) + 1;
        }

        if (c_a4 <= a4) {
            long double cur_ans = a1 + c_a4 + a2 * a3;

            if (ans < cur_ans) {
                ans = cur_ans;
                ans_p = pos;
                ans_v = { a1, a2, a3, c_a4 };
            }
        }

        long double c_a1 = a1;
        if (a4 - 1 != 0) {
            c_a1 = (a2 - 1) * (a3 - 1) / (a4 - 1) + 1;
        }

        if (c_a1 <= a1) {
            long double cur_ans = c_a1 + a4 + a2 * a3;

            if (ans < cur_ans) {
                ans = cur_ans;
                ans_p = pos;
                ans_v = { c_a1, a2, a3, a4 };
            }
        }

        long double c_a2 = a2;
        if (a3 - 1 != 0) {
            c_a2 = (a1 - 1) * (a4 - 1) / (a3 - 1) + 1;
        }

        if (c_a2 <= a2) {
            long double cur_ans = a1 + a4 + c_a2 * a3;

            if (ans < cur_ans) {
                ans = cur_ans;
                ans_p = pos;
                ans_v = { a1, c_a2, a3, a4 };
            }
        }

        long double c_a3 = a3;
        if (a2 - 1 != 0) {
            c_a3 = (a1 - 1) * (a4 - 1) / (a2 - 1) + 1;
        }

        if (c_a3 <= a3) {
            long double cur_ans = a1 + a4 + a2 * c_a3;

            if (ans < cur_ans) {
                ans = cur_ans;
                ans_p = pos;
                ans_v = { a1, a2, c_a3, a4 };
            }
        }

    } while (next_permutation(all(pos)));

    for (auto c : ans_p) {
        cout << c + 1 << ' ';
    }
    cout << setprecision(6) << fixed << '\n';

    //cout << ans_v[0] + ans_v[3] + ans_v[1] * ans_v[2] << ' ' << ans_v[0] * ans_v[3] + ans_v[1] + ans_v[2] << '\n';

    for (auto c : ans_v) {
        cout << c << ' ';
    }
    return 0;
}