#define _USE_MATH_DEFINES

#include <iostream>
#include <iomanip>

#include <cmath>
#include <algorithm>

#include <vector>
#include <string>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((ll)(x).size())

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	vector<int> b; b.reserve(n + 1); b.push_back(0);
	vector<int> s1, s2; s1.reserve(n); s2.reserve(n);
	for (int i = 0; i < n; ++i) {
		while (!s1.empty() && a[i] > s1.back()) {
			if (b.back() + 1 == s1.back()) {
				cout << "-1\n";
				b.push_back(s1.back());
			}
			else {
				cout << "12\n";
				s2.push_back(s1.back());
			}
			s1.pop_back();
		}
		if (b.back() + 1 == a[i]) {
			cout << "1\n-1\n";
			b.push_back(a[i]);
		}
		else {
			cout << "1\n";
			s1.push_back(a[i]);
		}
		while (!s2.empty()) {
			if (b.back() + 1 == s2.back()) {
				cout << "-2\n";
				b.push_back(s2.back());
			}
			else {
				cout << "21\n";
				s1.push_back(s2.back());
			}
			s2.pop_back();
		}
	}
	while (!s1.empty() || !s2.empty()) {
		if (!s1.empty() && b.back() + 1 == s1.back()) {
			cout << "-1\n";
			s1.pop_back();
		}
		if (!s2.empty() && b.back() + 1 == s2.back()) {
			cout << "-2\n";
			s2.pop_back();
		}
	}

	return 0;
}