#include <iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include <iomanip>
typedef long long ll;
typedef long double ld;

using namespace std;

struct function_t {
	ld a, b, c;

	ld v() {
		return f(-b / (2 * a));
	}

	ld f(ld x) {
		return a * x * x + b * x + c;
	}
};


int main() {
	ll n;
	cin >> n;
	vector<function_t> f(n);
	for (auto& x : f) {
		cin >> x.a >> x.b >> x.c;
	}
	cout << setprecision(10) << fixed;
	sort(f.begin(), f.end(), [](function_t& x, function_t& y) {return x.v() < y.v(); });
	for (ll i = 0; i < n - 1; i++) {
		if (signbit(f[i].a) != signbit(f[i + 1].a)) {
			ld x = (-f[i].b / (2 * f[i].a) + -f[i + 1].b / (2 * f[i + 1].a)) / 2;
			cout << x << ' ' << (f[i].v() + f[i + 1].v()) / 2;
			return 0;
		}
	}
	if (f[0].a < 0) {
		cout << -f[0].b / (2 * f[0].a) << ' ' << f[0].v();
	}
	else {
		reverse(f.begin(), f.end());
		cout << -f[0].b / (2 * f[0].a) << ' ' << f[0].v();
	}
	return 0;
}