#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define pb push_back
#define ld long double

mt19937_64 rndll(239);

typedef unsigned long long key_t;

const int N = 1e5 + 7;
const int L = 1e6 + 10;

const int K = 26;

int l, n;
key_t key[L];
key_t hsh[N][K];

void go(vector<int> S, int have) {
    if (S.size() == 1) {
        return;
    }
    int d = -1;
    for (int c = 0; c < 26; ++c) {
        if ((have >> c) & 1) continue;
        bool good = true;
        for (int i : S) {
            good &= hsh[i][c] != 0;
        }
        if (good) {
            d = c;
        }
    }

    if (d == -1) {
        cout << "NO\n";
        exit(0);
    }

    sort(S.begin(), S.end(), [&](int i, int j) {
        return hsh[i][d] < hsh[j][d];
    });
    int last = 0;
    for (int i = 0; i < (int)S.size(); ++i) {
        if (i + 1 == (int) S.size() || hsh[S[i]][d] != hsh[S[i + 1]][d]) {
            vector<int> T;
            for (int j = last; j <= i; ++j) {
                T.push_back(S[j]);
            }
            go(T, have | (1 << d));
            last = i + 1;
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> l >> n;
    for (int i = 0; i < l; ++i) {
        key[i] = rndll();
    }
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < l; ++j) {
            hsh[i][s[j] - 'a'] ^= key[j];
        }
    }
    vector<int> S;
    for (int i = 0; i < n; ++i) {
        S.push_back(i);
    }
    go(S, 0);
    cout << "YES\n";
    return 0;
}
