#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
using namespace std;
#define int ll
#define f first
#define s second
#define vi vector<int>
#define pii pair<int, int>
#define pb push_back

void solve() {
    int l, n;
    cin >> l >> n;
    string a[n];
    for (auto &i : a)
        cin >> i;
    int m[n];
    for (int i = 0; i < n; ++i) {
        m[i] = 0;
        for (auto &j : a[i])
            m[i] |= (1 << j - 'a');
    }
    const int P = 2e5 + 13;
    const int mod = 1e9 + 7;
    int p[n + 5];
    p[0] = 1;
    for (int i = 1; i < n + 5; ++i) {
        p[i] = p[i - 1] * P % mod;
    }
    int sum[n][26];
    memset(sum, 0, sizeof(sum));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < a[i].size(); ++j) {
            sum[i][a[i][j] - 'a'] = (sum[i][a[i][j] - 'a'] + p[j]) % mod;
        }
    }
    vi v(n);
    iota(v.begin(), v.end(), 0);
    function<bool(vi, int)> rec = [&] (vi v, int can)-> bool {
        if (v.size() <= 1)
            return 1;
        int save = can;
        for (auto &i : v)
            can &= m[i];
        if (can == 0)
            return 0;
        int otv = 0;
        for (int i = 0; i < 27; ++i) {
            if ((1 << i) & can)
                otv = i;
        }
        save ^= (1 << otv);
        sort(v.begin(), v.end(), [&] (int l, int r) {
            return sum[l][otv] < sum[r][otv];
        });
        bool ok = 1;
        vi now;
        for (int i = 0; i < v.size() && ok; ++i) {
            now.pb(v[i]);
            if (i + 1 == v.size() || sum[v[i]][otv] != sum[v[i + 1]][otv]) {
                ok &= rec(now, save);
                now.clear();
            }
        }
        return ok;
    };
    int x = rec(v, (1 << 30) - 1);
    if (x)
        cout << "YES\n";
    else
        cout << "NO\n";
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(16);
    solve();
    return 0;
}
