#include <bits/stdc++.h>


using namespace std;
typedef long double ld;
#define int long long

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const ld EPS = 1e-9;

ld calc(ld a, ld b, ld c, ld d){
    ld l = 0, r = 1 + EPS;
    auto sum = [&](ld t){
        return max(a,c*t) - min(b,d*t);
    };
    while(r - l > EPS){
        ld m1 = (r - l)/3 + l;
        ld m2 = (r-l)*2/3 + l;
        if(sum(m1) > sum(m2)){
            l = m1;
        }else{
            r = m2;
        }
    }
    return l;
}

void solve(){
    int n;
    cin>>n;
    vector<int> arr(n);
    for(auto &i : arr)cin>>i;
    vector<ld> ans(n);
    vector<int> prefmx(n), prefmn(n);
    prefmn[0] = prefmx[0] = arr[0];
    for(int i = 1;i<n;i++){
        prefmn[i] = min(prefmn[i-1], arr[i]);
        prefmx[i] = max(prefmx[i-1], arr[i]);
    }


    for(int i = n-1, mn = arr[i], mx = arr[i];i>=0;i--){
        mn = min(mn, arr[i]);
        mx = max(mx, arr[i]);
        if(i == 0){
            ans[i] = 1;
            continue;
        }
        ans[i] = 1 - calc(prefmx[i-1], prefmn[i-1], mx,mn);
//        cout<<ans[i]<<'\n';
    }

    for(int i = 0;i<n;i++){
        cout<<fixed<<setprecision(9)<<ans[i]<<' ';
    }

}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin>>t
    while(t--){
        solve();
    }
    return 0;
}