#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vsi = vector<set<ll>>;
using vmsi = vector<multiset<ll>>;
using ld = long double;
using vs = vector<string>;
using vb = vector<bool>;


#ifndef DEBUG
#define endl '\n'
#endif


template<typename T, typename V>
istream &operator>>(istream &is, pair<T, V> &p) {
    is >> p.first >> p.second;
    return is;
}


template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &e: v) is >> e;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &e: v) os << e << ' ';
    return os;
}

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(30);
    cout.setf(ios::fixed);

    solve();
}

// ----------------

ll m, n;

bool calc(const vs &a) {
    vi let('z' - 'a' + 1, 2);

    for (const auto &s: a) {
        for (auto &e: let) e = max(0ll, e - 1);
        for (auto c: s) {
            if (let[c - 'a'] == 1) ++let[c - 'a'];
        }
    }

    set<char> lett;
    for (char c = 'a'; c <= 'z'; ++c) {
        if (let[c - 'a'] != 2) continue;
        lett.insert(c);
    }

    if (lett.empty()) return false;
    vs b = a;
    for (auto &s: b) {
        for (auto &c: s) {
            if (let[c - 'a'] != 2) {
                c = 0;
            }
        }
    }

    map<string, vi> c;
    for (int i = 0; i < b.size(); ++i) {
        c[b[i]].push_back(i);
    }

    for (auto[_, g]: c) {
        if (g.size() <= 1) continue;
        if (g.size() == a.size()) return false;
        vs q;
        for (auto i: g) q.push_back(a[i]);
        if (not calc(q)) return false;
    }

    return true;
}

void solve() {
    cin >> m >> n;
    vs a(n);
    cin >> a;

    cout << (calc(a) ? "YES" : "NO") << endl;
}
