#include <bits\stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>

using namespace std;
// using namespace __gnu_pbds;

// template<class S>
// using ordered_set = tree<S, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;

#define fastio() ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

const int N = 1e5 + 10;
const ll MOD = 1971971971;

mt19937 rnd(time(0));

int len, n, mas[N], cnt[128], cur[128];
ll h[10 * N];
bool used[128];
map<int, int> hs;
string s[N];

ll mul(ll a, ll b) {
    return (a * b) % MOD;
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("outut.txt", "w", stdout);
#endif
    fastio();

    cin >> len >> n;
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < len; ++i) {
        h[i] = rnd() % MOD + 1;
    }

    int us = 0;
    while (n && us < 26) {
        for (char ch = 'a'; ch <= 'z'; ++ch)
            cnt[ch] = 0;
        for (int i = 0; i < n; ++i) {
            for (char ch : s[i])
                cur[ch] = 1;
            for (char ch = 'a'; ch <= 'z'; ++ch) {
                cnt[ch] += cur[ch];
                cur[ch] = 0;
            }
        }

        bool ok = 0;
        char c;
        for (char ch = 'a'; ch <= 'z'; ++ch) {
            if (!used[ch] && cnt[ch] == n) {
                ok = 1;
                c = ch;
                break;
            }
        }

        if (!ok) break;

        hs.clear();
        for (int i = 0; i < n; ++i) {
            mas[i] = 1;
            for (int j = 0; j < len; ++j) {
                if (s[i][j] == c) {
                    mas[i] = mul(mas[i], h[j]);
                }
            }
            ++hs[mas[i]];
        }

        for (int i = 0; i < n; ++i) {
            if (hs[mas[i]] == 1) {
                swap(s[i], s[n - 1]);
                swap(mas[i], mas[n - 1]);
                --n;
                --i;
            }
        }
        ++us;
        used[c] = 1;
    }

    if (n) cout << "NO";
    else cout << "YES";
}
