#include <bits/stdc++.h>

using namespace std;

using ll = int_fast64_t;
using ull = uint_fast64_t;

#define int ll
#define len(a) (int)(a).size()
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()


const int INF = 1 << 29;
const ll INFll = 1ll << 62;
const int N = 2000001;
int a[N], b[N], aa[N], bb[N], c[N];

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &o: v)
        is >> o;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (T &o: v)
        os << o;
    return os;
}


int n;

bool tr(int m) {
    deque<int> d;

    for (int i = n - 1; i > - 1; --i) {
        int x = a[i];
        a[i + m] = x;
        a[i] = 0;
    }
//    for (int i = 0; i < 2 * n; ++i)
//        cout << a[i] << " ";
//    cout << endl;

    for (int i = 0; i < 2 * n; ++i) {
        while (a[i] > 0 && !d.empty()) {
            int j = d.front();
            if (i-j > 2 * m) {
                d.pop_front();
                continue;
            }
            if (b[j] - a[j] > a[i]) {
                a[j] += a[i];
                a[i] = 0;
                break;
            } else {
                a[i] -= b[j] - a[j];
                a[j] = b[j];
                d.pop_front();
            }
        }
        if (a[i] < b[i])
            d.push_back(i);
    }
    for (int i = 0; i < 2 * n; ++i) {
        if (a[i] > b[i])
            return false;
    }
    return true;
}

void solve() {
    cin >> n;
    int SSS = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        SSS += a[i];
        aa[i] = a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        SSS -= b[i];
        bb[i] = b[i];
    }
    if (SSS > 0) {
        cout << -1;
        return;
    }
    int l = -1, r = n;
    while (l + 1 < r) {
        int m = (l + r) >> 1;
        if (tr(m)) r = m;
        else l = m;
        for (int i = 0; i < 2 * n; ++i)
            a[i] = aa[i], b[i] = bb[i], c[i] = 0;
    }
    cout << r;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
