#include <bits/stdc++.h>

using namespace std;

using ll = int_fast64_t;
using ull = uint_fast64_t;

#define int ll
#define len(a) (int)(a).size()
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()


const int INF = 1 << 29;
const ll INFll = 1ll << 62;
const int N = 2e5 + 3;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &o: v)
        is >> o;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (T &o: v)
        os << o;
    return os;
}


void solve() {
    int n;
    cin >> n;
    vector<double> d(n + 2), A(n + 2), B(n + 2, 1e10),
            a(n + 2), b(n + 2, 1e10), sum(n + 2);
    for (int i = 1; i <= n; ++i) {
        cin >> d[i];
        A[i] = max(A[i - 1], d[i]);
        B[i] = min(B[i - 1], d[i]);
        sum[i] = sum[i - 1] + d[i];
    }
    vector<double> ans(n + 1);
    int i = n;
    auto get_a = [&](double t) {
        return sum[n] - t * (sum[n] - sum[i - 1]);
    };
    auto get_b = [&](double t) {
        return t * (sum[n] - sum[i - 1]);
    };
    for (; i >= 2; --i) {
        a[i] = max(d[i], a[i + 1]);
        b[i] = min(d[i], b[i + 1]);
        if (A[i - 1] <= a[i] && B[i - 1] <= b[i]) {
            double ta = A[i - 1] / a[i];
            double mn_f = b[i] * ta;
            double tb = B[i - 1] / b[i];
            double mx_s = a[i] * tb;
            double x = A[i - 1] - mn_f;
            double y = mx_s - B[i - 1];
            double zz = x - y;
            if (zz < 0) zz = -zz;
            if (zz <= 1e-10) {
                if (get_b(ta) > get_b(tb))
                    ans[i] = 1 - ta;
                else
                    ans[i] = 1 - tb;
            } else {
                if (A[i - 1] - mn_f > mx_s - B[i - 1]) {
                    ans[i] = 1 - tb;
                } else {
                    ans[i] = 1 - ta;
                }
            }
            continue;
        }
        if (A[i - 1] >= a[i] && B[i - 1] <= b[i]) {
            ans[i] = 1 - B[i - 1] / b[i];
            continue;
        }
        if (A[i - 1] <= a[i] && B[i - 1] >= b[i]) {
            ans[i] = 1 - A[i - 1] / a[i];
            continue;
        }
        if (A[i - 1] >= a[i] && B[i - 1] >= b[i]) {
            ans[i] = 0;
            continue;
        }
    }
    ans[1] = 1;
    for (int j = 1; j <= n; ++j)
        cout << setprecision(10) << fixed << ans[j] << " ";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
