#include <bits/stdc++.h>

using namespace std;

using ll = int_fast64_t;
using ull = uint_fast64_t;

#define int ll
#define len(a) (int)(a).size()
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()


const int INF = 1 << 29;
const ll INFll = 1ll << 62;
const int N = 2e5 + 3;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &o: v)
        is >> o;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (T &o: v)
        os << o;
    return os;
}


void solve() {
    int n;
    cin >> n;
    vector<double> d(n + 2), A(n + 2), B(n + 2, 1e10),
            a(n + 2), b(n + 2, 1e10), sum(n + 2);
    for (int i = 1; i <= n; ++i) {
        cin >> d[i];
        A[i] = max(A[i - 1], d[i]);
        B[i] = min(B[i - 1], d[i]);
        sum[i] = sum[i - 1] + d[i];
    }
    vector<double> ans(n + 1, 0);
    int i = n;
    for (; i >= 2; --i) {
        a[i] = max(d[i], a[i + 1]);
        b[i] = min(d[i], b[i + 1]);
        if (A[i - 1] <= a[i] && B[i - 1] <= b[i]) {
            double ta = A[i - 1] / a[i];
            double tb = B[i - 1] / b[i];
            double k = A[i - 1] * a[i] * b[i] - b[i] * A[i - 1] * b[i] -
                       a[i] * B[i - 1] * a[i] - B[i - 1] * a[i] * b[i];
            if (k == 0)
                ans[i] = max(1 - ta, 1 - tb);
            else if (k < 0)
                ans[i] = 1 - ta;
            else
                ans[i] = 1 - tb;
        }
        if (A[i - 1] >= a[i] && B[i - 1] <= b[i]) {
            ans[i] = max(ans[i], 1 - B[i - 1] / b[i]);
        }
        if (A[i - 1] <= a[i] && B[i - 1] >= b[i]) {
            ans[i] = max(ans[i], 1 - A[i - 1] / a[i]);
        }
        if (A[i - 1] >= a[i] && B[i - 1] >= b[i]) {
            ans[i] = max(ans[i], (double) 0);
        }
    }

    ans[1] = 1;
    for (int j = 1; j <= n; ++j)
        cout << setprecision(10) << fixed << ans[j] << " ";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
