#include <iostream>
#include <iomanip>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <queue>

using namespace std;

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n; cin >> n;
	vector<ll>a(n), b(n), p_a(n + 1, 0), p_b(n + 1, 0);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		if (i > 0)
			p_a[i + 1] = p_a[i] + a[i];
		else
			p_a[i + 1] = a[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
		if (i > 0)
			p_b[i + 1] = p_b[i] + b[i];
		else
			p_b[i + 1] = b[i];
	}
	if (p_b[n] < p_a[n]) {
		cout << -1;
		exit(0);
	}
	ll ans = 0;
	for (int i = 1; i <= n; i++) {
		ll l = 0, r = n / 2 + 1;
		//cout << i << ": " << endl;
		while (r - l > 1) {
			ll m = (r + l) / 2;
			ll x = p_a[max((ll)0, i - m)], y = p_b[max((ll)0, i - m)];
			//cout << m << " : " << x << " " << y << endl;
			//cout << p_a[min(n, i + m)] << " " << p_b[min(n, i + m)] << endl;
			if (p_a[min(n, i + m)] - x >= p_b[min(n, i + m)] - y)
				l = m;
			else
				r = m;
		}
		//cout << l << endl << endl;
		ans = max(ans, l);
	}
	cout << ans;
}