#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <unordered_map>
#include <map>
#include <queue>
#include <stack>
#include <set>
#include <iomanip>

using namespace std;

#define int long long

int n, a[1000005], b[1000005];

bool check(int k)
{
    vector < int > c(n);
    for(int i = 0; i < n; i++)
        c[i] = b[i];
    int j = 0;
    for(int i = 0; i < n; i++)
    {
        if(j < i - k)
            j++;
        int cur = a[i];
        while(j <= min(n - 1, i + k) && cur)
        {
            int mi = min(cur, c[j]);
            c[j] -= mi;
            cur -= mi;
            if(!c[j])
                j++;
        }
        if(cur)
            return false;
    }
    return true;
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    for(int i = 0 ; i < n; i ++)
        cin >> a[i];
    for(int i = 0; i < n; i ++)
        cin >> b[i];

    int sum1, sum2;
    sum1 = sum2 = 0;
    for(int i = 0; i < n; i ++)
    {
        sum1 += a[i];
        sum2 += b[i];
    }

    if(sum2 < sum1)
    {
        cout << -1;
        return 0;
    }
    int l = -1;
    int r = n;
    while(l < r - 1)
    {
        int m = (l + r) / 2;
        (check(m) ? r : l) = m;
    }
    cout << r;
    return 0;
}
