#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <unordered_map>
#include <map>
#include <queue>
#include <stack>
#include <set>
#include <iomanip>
#include <bitset>

#define int double

using namespace std;

const int e = 1e-11;
int a[200005], mi[200005], ma[200005], pmi, pma;

int f(int t, long long p)
{
    return max(pma, ma[p] * ((int)1 - t)) - min(pmi, mi[p] * ((int)1 - t));
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    long long n;
    cin >> n;
    for(long long i = 0; i < n; i++)
        cin >> a[i];
    mi[n - 1] = ma[n - 1] = a[n - 1];
    for(long long i = n - 2; i >= 0; i--)
    {
        mi[i] = min(mi[i + 1], a[i]);
        ma[i] = max(ma[i + 1], a[i]);
    }
    cout << fixed << setprecision(9) << 1 << " ";
    pmi = pma = a[0];
    for(long long i = 1; i < n; i++)
    {
        int l = 0;
        int r = 1;
        while(r - l > e)
        {
            int m1 = (l * (int)2 + r) / (int)3;
            int m2 = (l + r * (int)2) / (int)3;
            if(f(m1, i) < f(m2, i))
                r = m2;
            else
                l = m1;
        }
        cout << r << " ";
        pmi = min(pmi, a[i]);
        pma = max(pma, a[i]);
    }
    return 0;
}
