#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <unordered_map>
#include <map>
#include <queue>
#include <stack>
#include <set>
#include <iomanip>

#define int long long

using namespace std;

int pos[1005];
stack < int > st[5];

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for(int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        pos[x] = 0;
        st[3].push(x);
    }
    while(st[3].size())
    {
        st[0].push(st[3].top());
        st[3].pop();
    }
    for(int v = 1; v <= n; v++)
    {
        int from = pos[v];
        int to = 1 + (from == 1);
        while(st[from].top() != v)
        {
            int cur = st[from].top();
            st[from].pop();
            if(from)
                cout << from;
            cout << to << '\n';
            pos[cur] = to;
            st[to].push(cur);
        }
        st[from].pop();
        if(!from)
            cout << 1 << '\n' << -1 << '\n';
        else
            cout << -from << '\n';
    }
    return 0;
}
