﻿#include <iostream>
#include <stack>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <climits>
#include <numeric>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <deque>
#include <queue>

#define int long long

using namespace std;


int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cout.precision(20);

    int n;
    cin >> n;
    if (n == 1) {
        int a;
        cin >> a;
        cout << 1.0;
        return 0;
    }
    vector<int> a(n);
    vector<pair<int, int>> out_arr(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    out_arr[1] = { a[0], a[0] };
    for (int i = 2; i < n; i++) {
        out_arr[i] = { max(out_arr[i - 1].first, a[i - 1]),
                       min(out_arr[i - 1].second, a[i - 1]) };
    }
    vector<pair<int, int>> in_arr(n);
    in_arr[n - 1] = { a[n - 1], a[n - 1] };
    for (int i = n - 2; i > -1; i--) {
        in_arr[i] = { max(in_arr[i + 1].first, a[i]),
                      min(in_arr[i + 1].second, a[i]) };
    }
    cout << 1.0 << ' ';
    for (int i = 1; i < n; i++) {
        double max_out = out_arr[i].first;
        double max_in = in_arr[i].first;
        double min_out = out_arr[i].second;
        double min_in = in_arr[i].second;
        if (max_out >= max_in) {
            if (min_out >= min_in) {
                cout << 0.0 << ' ';
            }
            else {
                cout << 1 - min_out / min_in << ' ';
            }
        }
        else {
            if(min_out >= min_in){
                cout << 1 - max_out / max_in;
            }
            else {
                cout << 1 - min(max_out / max_in, min_out / min_in) << ' ';
            }
        }
    }



    return 0;
}