#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <utility>
#include <set>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <queue>
#include <cstring>

using namespace std;
using ll = long long;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	long long n;
	cin >> n;
	vector<long long> a(n);
	long long sumA = 0;
	for(long long i = 0; i < n; ++i) {
		cin >> a[i];
		sumA += a[i];
	}
	vector<long long> b(n);
	long long sumB = 0;
	for(long long i = 0; i < n; ++i) {
		cin >> b[i];
		sumB += b[i];
	}
	if(sumA > sumB) {
		cout << -1;
		return 0;
	}
	long long l = -1;
	long long r = n;
	long long ans = n - 1;
	while(l + 1 < r) {
		bool pos = true;
		long long k = (l + r) / 2;
		long long put = 0;
		vector<long long> cb = b;
		for(long long i = 0; i < n && put < n; ++i) {
			long long cur = a[i];
			while(cur > 0 && put <= i + k && put < n) {
				if(cur >= cb[put]) {
					cur -= cb[put];
					++put;
				} else {
					cb[put] -= cur;
					cur = 0;
				}
			}
			if(cur > 0) {
				pos = false;
				break;
			}
			put = max(put, i - k + 1);
		}
		if(pos) {
			ans = min(ans, k);
			r = k;
		} else {
			l = k;
		}
	}
	cout << ans;
    return 0;
}
