#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <utility>
#include <set>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <queue>
#include <cstring>
#include <stack>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	stack<int> st1;
	stack<int> st2;
	for (int i = 0; i < n; i++)
	{
		int a;
		cin >> a;
		if (i % 2 == n % 2)
		{
			while (!st1.empty() && st1.top() < a)
			{
				cout << 12 << '\n';
				st2.push(st1.top());
				st1.pop();
			}
			cout << 2 << '\n';
			st2.push(a);
			while (!st1.empty())
			{
				cout << 12 << '\n';
				st2.push(st1.top());
				st1.pop();
			}
		}
		else
		{
			while (!st2.empty() && st2.top() > a)
			{
				cout << 21 << '\n';
				st1.push(st2.top());
				st2.pop();
			}
			cout << 1 << '\n';
			st1.push(a);
			while (!st2.empty())
			{
				cout << 21 << '\n';
				st1.push(st2.top());
				st2.pop();
			}
		}
	}
	while (!st1.empty())
	{
		cout << -1 << '\n';
		st1.pop();
	}
    return 0;
}
