#include <cstdio>
#include <vector>

const int N = 1000005;
const int A = 26;
const int LG = 20;
int n, q, end[N], to[N][A], size = 1, straight[N], down[N], less[N], f[LG][N], up_c[N], up[N], dep[N], len, prev[N];
char s[N], t[N];

void add(char *s)
{
    int cur = 0;
    for (int i = 0; s[i]; ++i) {
        if (!to[cur][s[i] - 'a']) {
            up_c[size] = s[i] - 'a';
            dep[size] = dep[cur] + 1;
            f[0][size] = size;
            prev[size] = cur;
            to[cur][s[i] - 'a'] = size++;
        }
        cur = to[cur][s[i] - 'a'];
        ++down[cur];
    }
    ++end[cur];
}

void dfs(int v)
{
    int sum = end[v];
    for (int i = 0; i < A; ++i) {
        if (to[v][i]) {
            if (v && i == up_c[v]) up[to[v][i]] = up[v];
            else up[to[v][i]] = to[v][i];
            less[to[v][i]] = less[v] + sum;
            dfs(to[v][i]);
            if (!to[to[v][i]][i]) straight[to[v][i]] = to[v][i];
            else straight[to[v][i]] = straight[to[to[v][i]][i]];
            sum += down[to[v][i]];
        }
    }
}

void go(int &cur, int amt, int c)
{
    if (to[cur][c]) {
        if (dep[straight[to[cur][c]]] - dep[cur] <= amt) cur = straight[to[cur][c]];
        else for (int i =  LG - 1; i >= 0; --i) if (amt >> i & 1) cur = f[i][to[cur][c]];
    }
}

int eval(int cur, int miss)
{
    if (dep[cur] == len) return less[cur];
    int sum = less[cur] + end[cur];
    for (int i = 0; i < miss; ++i) sum += down[to[cur][i]];
    return sum;
}

int main()
{
    scanf("%d%d%s", &n, &q, s);
    for (int i = 0; i < n; ++i) {
        scanf("%s", t);
        add(t);
    }
    dfs(0);
    for (int j = 1; j < LG; ++j) for (int i = 1; i < size; ++i) {
        int k = f[j - 1][i];
        if (k == -1 || !to[k][up_c[i]]) f[j][i] = -1;
        else f[j][i] = f[j - 1][to[k][up_c[i]]];
    }
    std::vector<std::pair<int, int> > pos;
    int cur = 0, miss = -1;
    for (int i = 0; s[i];) {
        pos.push_back(std::make_pair(i, s[i] - 'a'));
        do {
            if (dep[cur] == i) {
                if (to[cur][s[i] - 'a']) {
                    cur = to[cur][s[i] - 'a'];
                } else miss = s[i] - 'a';
            }
            ++i;
        } while (s[i] == s[i - 1]);
        len = i;
    }
    printf("%d\n", eval(cur, miss));
    while (q--) {
        int k;
        char c;
        scanf("%d %c", &k, &c);
        --k;
        c -= 'a';
        while (!pos.empty() && pos.back().first >= k) {
            if (dep[cur] > pos.back().first) {
                cur = up[cur];
                cur = prev[cur];
            }
            pos.pop_back();
        }
        if (pos.empty()) {
            cur = 0;
            go(cur, len, c);
            if (dep[cur] == len) miss = -1;
            else miss = c;
        } else {
            if (dep[cur] > pos.back().first) {
                cur = up[cur];
                go(cur, k - pos.back().first, pos.back().second);
                if (dep[cur] == k) {
                    go(cur, len - k, c);
                    if (dep[cur] == len) miss = -1;
                    else miss = c;
                } else miss = pos.back().second;
            }
        }
        pos.push_back(std::make_pair(k, c));
        printf("%d\n", eval(cur, miss));
    }
    return 0;
}

/*
4 3
anatoly
boris
anatooo
anbbbbu
anba
5 o
3 b
7 x



5 5
abcde
buz
ababa
build
a
aba
1 b
3 z
2 u
4 z
1 a

*/
