#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
using namespace std;
long double func(long double A,long double B,long double C,long double D,long double t)
{
    return max(A,(1-t)*B)-min(C,(1-t)*D);
}
long double urk(long double A,long double B,long double C,long double D,long double t)
{
    return t*(B+D);
}
bool ok(long double t)
{
    if(t<0 || t>1) return false;
    return true;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin>>n;
    int a[n];
    for(int i=0;i<n;i++) cin >>a[i];
    int mpr[n];int Mpr[n];
    mpr[0]=a[0];Mpr[0]=a[0];
    for(int i=1;i<n;i++)
    {
        mpr[i]=min(mpr[i-1],a[i]);
        Mpr[i]=max(Mpr[i-1],a[i]);
    }
    int ms[n];int Ms[n];
    ms[n-1]=a[n-1];Ms[n-1]=a[n-1];
    for(int i=n-2;i>=0;i--)
    {
        ms[i]=min(a[i],ms[i+1]);
        Ms[i]=max(a[i],Ms[i+1]);
    }
    for(int i=0;i<n;i++)
    {
        long double A,B,C,D;
        if(i==0) {cout<<1<<' ';continue;}

        A=Mpr[i-1];
        C=mpr[i-1];
        B=Ms[i];
        D=ms[i];
      //  cout<<A<<' '<<B<<' '<<C<<' '<<D<<'\n';
        vector<pair<long double,long double> > q;
        q.push_back({func(A,B,C,D,0),0});
        q.push_back({func(A,B,C,D,1),-1});
        long double t1=1-C/(D*1.0);
        if(ok(t1)) q.push_back({func(A,B,C,D,t1),-t1});
        t1=1-A/(B*1.0);
        if(ok(t1)) q.push_back({func(A,B,C,D,t1),-t1});
        sort(q.begin(),q.end());
      //  cout<<"HI";for(int i=0;i<q.size();i++) cout<<q[i].second<<' ';
       // cout<<"HI";
        if(q[0].second!=0)q[0].second*=-1;
        cout<<setprecision(15)<<q[0].second;
        cout<<' ';
    }
    return 0;
}
