//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,lzcnt,popcnt,bmi,bmi2")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

struct par
{
    ll a, b, c;

    ld operator()(ld x)
    {
        return a * x * x + b * x + c;
    }
};

signed main()
{
    cin.tie(0)->sync_with_stdio(false);
    int n;
    cin >> n;
    vector<par> abc(n);
    for (auto &i : abc) cin >> i.a >> i.b >> i.c;
    ld minY = -1e9, maxY = 1e9;
    for (auto &i : abc)
    {
        if (i.a > 0)
        {
            minY = max(minY, i(-i.b/(2.0 * i.a)));
        }
        else
        {
            maxY = min(maxY, i(-i.b/(2.0 * i.a)));
        }
    }
    random_device rd;
    mt19937_64 gen(rd());
    uniform_real_distribution<> dist(minY, maxY);
    while (true)
    {
        ld y = dist(gen);
        ld minX = -1e9, maxX = 1e9;
        for (auto i : abc)
        {
            ld d = i.b * i.b - 4 * i.a * (i.c - y);
            if (i.a > 0) {
                minX = max(minX, (-i.b - sqrtl(d)) / (2.0 * i.a));
                maxX = min(maxX, (-i.b + sqrtl(d)) / (2.0 * i.a));
            }
            else
            {
                minX = max(minX, (-i.b + sqrtl(d)) / (2.0 * i.a));
                maxX = min(maxX, (-i.b - sqrtl(d)) / (2.0 * i.a));
            }
        }
        if (minX < maxX)
        {
            cout << setprecision(12) << fixed << (minX + maxX) / 2 << ' ' << y;
            return 0;
        }
    }
    return 0;
}