#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
constexpr ld EPS = 1e-9;

template<class T>
using V = vector<T>;
template<class T>
using VV = V<V<T>>;

using VLL = V<ll>;
using VVLL = VV<ll>;
using VB = V<char>;
using VI = V<int>;

#define FOR(i, n) for(ll i = 0; i < n; ++i)
#define ALL(a) begin(a), end(a)

constexpr ll len = 'z' - 'a' + 1;

bool DFS(V<string>& a)
{
    //for(auto i : a)
    //    cerr << i << " ";
    //cerr << "\n";
    if(a.size() <= 1)
        return true;

    ll l = a[0].size();
    VB was(len, 1);
    for(auto const& i : a)
    {
        VB d(len);
        for(auto j : i)
            d[j - 'a'] = 1;

        FOR(j, len)
            was[j] &= d[j];
    }

    if(accumulate(ALL(was), 0LL) == 0)
        return false;

    unordered_map<string, V<string>> x;
    for(auto& i : a)
    {
        string s(l, '_');
        FOR(j, l)
            if(was[i[j] - 'a'])
                s[j] = i[j];

        //cerr << i << " -> " << s << "\n";
        i.erase(remove_if(ALL(i), [&](char c) { return was[c - 'a']; }), end(i));

        x[s].push_back(i);
    }

    for(auto& i : x)
        if(!DFS(i.second))
            return false;
    return true;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll l, n;
    cin >> l >> n;

    V<string> a(n);
    for(auto& i : a)
        cin >> i;

    sort(ALL(a));
    a.erase(unique(ALL(a)), end(a));

    if(DFS(a))
        cout << "YES\n";
    else
        cout << "NO\n";
}
