#include <bits/stdc++.h>

using namespace std;

const int N = 1e6;
pair<string, string> a[N]; // {$$$, word}

void solve(int l, int r) {
    if (l > r) {
        return;
    }
    if (l == r) {
        return;
    }
    bool is[26] = {};
    for (int i = 0; i < 26; ++i) {
        is[i] = true;
    }
    for (int i = l; i <= r; ++i) {
        bool curr[26] = {};
        for (int j = 0; j < a[i].second.size(); ++j) {
            if (a[i].first[j] == '$')
                curr[a[i].second[j] - 'a'] = true;
        }
        for (int j = 0; j < 26; ++j) {
            if (!curr[j]) {
                is[j] = false;
            }
        }
    }
    int toDel = 0;
    while (toDel < 26 && !is[toDel]) {
        ++toDel;
    }
    if (toDel == 26) {
        cout << "NO\n";
        exit(0);
    }
    for (int i = l; i <= r; ++i) {
        for (int j = 0; j < a[i].first.size(); ++j) {
            if (a[i].second[j] == char(toDel + 'a')) {
                a[i].first[j] = char(toDel + 'a');
            }
        }
    }
    sort(a + l, a + r + 1);
    int from = l;
    for (int i = l + 1; i <= r; ++i) {
        if (a[i].first != a[i - 1].first) {
            solve(from, i - 1);
            from = i;
        }
    }
    solve(from, r);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int l, n;
    cin >> l >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second;
        a[i].first = string(a[i].second.size(), '$');
    }
    solve(0, n - 1);
    cout << "YES\n";
    return 0;
}
