#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

namespace x = __gnu_pbds;
template <typename T>
using ordered_set = x::tree<T, x::null_type, less<T>, x::rb_tree_tag, x::tree_order_statistics_node_update>;

template <typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T>>;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

const int N = 1e6 + 10;

ll a[N], b[N], bc[N], ac[N];

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int j = 0; j < n; ++j) {
		cin >> b[j];
	}
	int lef = -1, rig = n + 1;
	while (rig - lef > 1) {
	// {
		int mid = (lef + rig) / 2;
		// int mid = 2;
		for (int i = 0; i < n; ++i) {
			bc[i] = b[i];
			ac[i] = a[i];
		}
		int it = 0;
		bool flag = 1;
		for (int i = 0; i < n; ++i) {
			if (it < i - mid) {
				flag = 0;
				break;
			}
			while (it < n && it <= i + mid && bc[i]) {
				if (bc[i] >= ac[it]) {
					bc[i] -= ac[it];
					ac[it] = 0;
					++it;
					// cout << "here" << endl;
				} else {
					ac[it] -= bc[i];
					bc[i] = 0;
					break;
				}
			}
		}
		// cout << mid << " -> " << it << endl;
		if (it != n) {
			flag = 0;
		}
		if (flag) {
			rig = mid;
		} else {
			lef = mid;
		}
	}
	if (rig == n + 1) {
		cout << -1;
	} else {
		cout << rig;
	}
}