#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

namespace x = __gnu_pbds;
template <typename T>
using ordered_set = x::tree<T, x::null_type, less<T>, x::rb_tree_tag, x::tree_order_statistics_node_update>;

template <typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T>>;

#define int ll

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

const int N = 1 << 19, MOD = 1e9 + 7, INF = 0x3f3f3f3f;

int a[N], b[N];
ll pref[N];
vector<pair<int, int>> spref;
pair<int, int> dlta[2 * N];

pair<int, int> tget(int l, int r) {
	l += N;
	r += N;
	pair<int, int> res = {+INF + 1, -1};
	while (l <= r) {
		if (l & 1)	res = min(res, dlta[l]);
		if (!(r & 1))	res = min(res, dlta[r]);
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
	return res;
}

ll ans = 0;
ll prefpref[N];
vector<int> indexes;

void solve(int l, int r) {
	if (r - l < 2) {
		return;
	}
	// cout << "lr" << l << " " << r << endl;
	auto [value, opos] = tget(indexes[l], indexes[r - 1] - 1);
	// cout << "[" << indexes[l] << "; " << indexes[r - 1] - 1 << "]" << endl;
	int pos = (int) (lower_bound(all(indexes), opos + 1) - begin(indexes)) - 1;
	// cout << "found real pos " << value << " " << opos << " " << pos << endl;
	if (value == +INF) {
		// for (int i = 0; i < 5; ++i) {
		// 	cout << prefpref[i] << " ";
		// }
		// cout << "\n";
		// cout << (prefpref[r] - prefpref[pos + 1]) 	* (pos - l + 1) << " " << (prefpref[pos + 1] - prefpref[l]) * (r - pos - 1) << endl;
		(ans -= (prefpref[r] - prefpref[pos + 1]) * (pos - l + 1) - (prefpref[pos + 1] - prefpref[l]) * (r - pos - 1)) %= MOD;
	} else {
		(ans -= value * (pos - l + 1) % MOD * (r - pos - 1)) %= MOD;
	}
	solve(l, pos + 1);
	solve(pos + 1, r);
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int n, k;
	cin >> n >> k;
	for (int i = 0; i < n; ++i) {
		cin >> a[i] >> b[i];
		if (a[i] < b[i]) {
			swap(a[i], b[i]);
		}
		if (a[i] % k != b[i] % k) {
			dlta[N + i] = {a[i] - b[i], i};
		} else {
			dlta[N + i] = {+INF, i};
		}
		pref[i + 1] = (pref[i] + a[i]) % MOD;
	}
	for (int i = N; i--; ) {
		dlta[i] = min(dlta[2 * i], dlta[2 * i + 1]);
	}
	for (int i = 0; i <= n; ++i) {
		spref.push_back({pref[i] % k, i});
		(ans += pref[i] * (2 * i - n)) %= MOD;
	}
	// cout << ans << endl;
	sort(all(spref));
	for (int lef = 0; lef <= n; ) {
		int rig = lef;
		while (rig <= n && spref[rig].x == spref[lef].x) {
			++rig;
		}

		indexes.clear();
		// cout << lef << " " << rig << endl;
		for (int i = lef; i < rig; ++i) {
			indexes.push_back(spref[i].y);
			prefpref[i - lef + 1] = (prefpref[i - lef] + pref[indexes.back()]) % MOD;
			// cout << "write " << i - lef + 1 << endl;
		}
		// for (int i = 0; i <= rig - lef; ++i) {
		// 	cout << prefpref[i] << " ";
		// }
		// cout << "\n";
		solve(0, sz(indexes));
		lef = rig;
	}
	cout << (ans % MOD + MOD) % MOD << "\n";
}