#include "bits/stdc++.h"

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define int ll
#define ff first
#define ss second
typedef pair<int, int> pii;
#define _ << ' ' <<
#define vec vector
#ifndef HOME
#define cerr if(0) cerr
#endif

mt19937 gen(time(0));

const ld INF = 9e18;

const ld EPS = 1e-7;
const ld EPS1 = 1e-8;

struct par {
    ld a, b, c;

    ld operator()(ld x) {
        return a * x * x + b * x + c;
    }
    ld ver() {
        return -b / (2 * a);
    }
};

ld sqr(ld x) {
    ld l = 0, r = max(x, (ld)1);
    for (int i = 0; i < 70; ++i) {
        ld m = (r + l) / 2;
        if (m * m > x) {
            r = m;
        } else {
            l = m;
        }
    }
    return r;
}

pair<ld, ld> inter(par f, par s) {
    ld a = f.a - s.a;
    ld b = f.b - s.b;
    ld c = f.c - s.c;
    ld d = b * b - 4 * a * c;
    if (d < EPS) {
//        exit(-1);
        return {-INF, INF};
    }
    ld sq = sqr(d);
    return {min((-b - sq) / (2 * a), (-b + sq) / (2 * a)), max((-b - sq) / (2 * a), (-b + sq) / (2 * a))};
}

bool check(par p, ld x, ld y) {
    if (p.a < 0) return p(x) - y > -EPS1;
    return y - p(x) > -EPS1;
}

void solve() {
    int n;
    cin >> n;

    int a, b, c;
    vector<par> v1, v2;
    vector<pair<ld, int> > v11;
    vector<pair<ld, int> > v12;
    vector<pair<ld, int> > v13;
    vector<pair<ld, int> > v14;
    vector<pair<ld, int> > v21;
    vector<pair<ld, int> > v22;
    vector<pair<ld, int> > v23;
    vector<pair<ld, int> > v24;
    for (int i = 0; i < n; ++i) {
        cin >> a >> b >> c;
        par p = {(ld)a, (ld)b, (ld)c};

        if (a > 0) {
            v11.push_back({-a, v1.size()});
            v12.push_back({p.ver(), v1.size()});
            v13.push_back({-p.ver(), v1.size()});
            v14.push_back({-p(p.ver()), v1.size()});
            v1.push_back(p);
        }
        else {
            v21.push_back({a, v2.size()});
            v22.push_back({p.ver(), v2.size()});
            v23.push_back({-p.ver(), v2.size()});
            v24.push_back({p(p.ver()), v2.size()});
            v2.push_back(p);
        }
    }
    sort(all(v11));
    sort(all(v12));
    sort(all(v13));
    sort(all(v14));
    sort(all(v21));
    sort(all(v22));
    sort(all(v23));
    sort(all(v24));

    vector<par> t1, t2;
    for (int i = 0; i < min(1000ll, (int)v11.size()); ++i) {
        t1.push_back(v1[v11[i].ss]);
    }
    for (int i = 0; i < min(1000ll, (int)v12.size()); ++i) {
        t1.push_back(v1[v12[i].ss]);
    }
    for (int i = 0; i < min(1000ll, (int)v13.size()); ++i) {
        t1.push_back(v1[v13[i].ss]);
    }
    for (int i = 0; i < min(1000ll, (int)v14.size()); ++i) {
        t1.push_back(v1[v14[i].ss]);
    }
    for (int i = 0; i < min(1000ll, (int)v1.size()); ++i) {
        t1.push_back(v1[i]);
    }

    for (int i = 0; i < min(1000ll, (int)v21.size()); ++i) {
        t2.push_back(v2[v21[i].ss]);
    }
    for (int i = 0; i < min(1000ll, (int)v22.size()); ++i) {
        t2.push_back(v2[v22[i].ss]);
    }
    for (int i = 0; i < min(1000ll, (int)v23.size()); ++i) {
        t2.push_back(v2[v23[i].ss]);
    }
    for (int i = 0; i < min(1000ll, (int)v24.size()); ++i) {
        t2.push_back(v2[v24[i].ss]);
    }
    for (int i = 0; i < min(1000ll, (int)v2.size()); ++i) {
        t2.push_back(v2[i]);
    }

//    v1 = t1;
//    v2 = t2;

    cout << fixed << setprecision(9);
    if (v1.size() == 0) {
        ld mn = INF;
        for (auto it : v2) {
            mn = min(mn, it(0));
        }
        cout << 0 _ mn - 1;
//        assert(0);
        return;
    }
    if (v2.size() == 0) {
        ld mx = -INF;
        for (auto it : v1) {
            mx = max(mx, it(0));
        }
        cout << 0 _ mx + 1;
//        assert(0);
        return;
    }

    ld l = -INF, r = INF;
//    int posl = 0;
//    int posr = 0;
//    for (int i = 0; i < v2.size(); ++i) {
//        auto it = v2[i];
//        auto [l1, r1] = inter(it, v1[0]);
//
//        if (l < l1) {
//            posl = i;
//            l = l1;
//        }
//        if (r > r1) {
//            r = r1;
//            posr = i;
//        }
//    }
//    for (auto it : v1) {
//        {
//            auto [l1, r1] = inter(it, v2[posl]);
//            l = max(l, l1);
//            r = min(r, r1);
//        }
//        auto [l1, r1] = inter(it, v2[posr]);
//        l = max(l, l1);
//        r = min(r, r1);
//    }

    for (int i = 0; i < t1.size(); ++i) {
        if (i > 5000) break;
        auto p1 = t1[i];
        for (int j = 0; j < t2.size(); ++j) {
            if (j > 5000) break;
            auto p2 = t2[j];
            auto [l1, r1] = inter(p1, p2);
            l = max(l, l1);
            r = min(r, r1);
        }
    }


//    if (l > r) swap(l, r);
    cerr << l _ r << endl;
    l += EPS;
    r -= EPS;
    ld yl = -INF;
    ld yr = -INF;
    for (auto it : v1) {
        yl = max(yl, it(l));
        yr = max(yr, it(r));
    }
//    for (auto it : v2) {
//        yl = min(yl, it(l));
//        yr = min(yr, it(r));
//    }

    yl += EPS;
    yr += EPS;

    bool fl = 1;
    for (auto it : v1) {
        if (!check(it, l, yl)) {
            fl = 0;
            break;
        }
    }
    for (auto it : v2) {
        if (!check(it, l, yl)) {
            fl = 0;
            break;
        }
    }

    if (fl) {
        cout << l _ yl;
        return;
    }

    fl = 1;
    for (auto it : v1) {
        if (!check(it, r, yr)) {
            fl = 0;
            break;
        }
    }
    for (auto it : v2) {
        if (!check(it, r, yr)) {
            fl = 0;
            break;
        }
    }
    if (fl) {
        cout << r _ yr;
        return;
    }
    exit(-1);
}

signed main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
        cout << '\n';
    }
}