#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>

#define ll long long

using namespace std;


vector<long double> vec, max_suf, max_pref, min_suf, min_pref;
int L, n;
pair<string, string> s[100007];
vector<pair<int, int>> ind;

signed main() {

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> L >> n;
    ind.push_back({ 0, n });

    string _s;
    for (int i = 0; i < L; ++i)
    {
        _s += '*';
    }
    for (int i = 0; i < n; ++i)
    {
        cin >> s[i].second;
        s[i].first = _s;
    }

    bool play = true;
    while (play)
    {
        play = false;
        int sz = ind.size();
        for (int h = 0; h < sz; ++h)
        {
            if (ind[h].second - ind[h].first == 1)
                continue;

            bool good[26];
            for (int i = 0; i < 26; ++i)
            {
                good[i] = true;
            }

            for (int i = ind[h].first; i < ind[h].second; ++i)
            {
                bool _good[26];
                for (int i = 0; i < 26; ++i)
                {
                    _good[i] = false;
                }

                for (int j = 0; j < L; ++j)
                {
                    _good[s[i].second[j] - 'a'] = true;
                }

                for (int i = 0; i < 26; ++i)
                {
                    good[i] &= _good[i];
                }
            }

            bool is_p = false;
            for (int i = 0; i < 26; ++i)
            {
                is_p |= good[i];
            }

            for (int i = ind[h].first; i < ind[h].second; ++i)
            {
                for (int j = 0; j < L; ++j)
                {
                    if (good[s[i].second[j] - 'a'])
                        s[i].first[j] = s[i].second[j];
                }
            }

            sort(s + ind[h].first, s + ind[h].second);
            pair<int, int> pr = ind[h];
            for (int i = pr.first; i < pr.second;)
            {
                int ind1 = i;
                ++i;
                while (i < pr.second && s[i].first == s[i - 1].first)
                {
                    ++i;
                }
                int ind2 = i;
                if (ind2 - ind1 > 1)
                    play = true;

                if (ind1 == pr.first)
                {
                    if (ind2 == pr.second)
                    {
                        cout << "NO";
                        return 0;
                    }
                    ind[h] = make_pair(ind1, ind2);
                }
                else
                {
                    ind.push_back(make_pair(ind1, ind2));
                }
            }
        }
        
    }

    cout << "YES";
}