#include <bits/stdc++.h>
#define ld long double

using namespace std;

const ld inf = 9e18;
const int SZ = 100000;

struct par
{
    ld a, b, c;
    ld f(ld x)
    {
        return a * x * x + b * x + c;
    }
    ld d(ld x)
    {
        return b * b - 4 * a * (c - x);
    }
    ld x1(ld x)
    {
        return (-b - sqrt(d(x))) / 2 / a;
    }
    ld x2(ld x)
    {
        return (-b + sqrt(d(x))) / 2 / a;
    }
};

par p[SZ];
ld lx = -inf, ly = -inf, rx = inf, ry = inf;

int main()
{
    int n;
    cin >> n;
    ld a, b, c;
    for (int i = 0; i < n; i++)
    {
        cin >> a >> b >> c;
        p[i].a = a / 1e9;
        p[i].b = b / 1e9;
        p[i].c = c / 1e9;
        if (a > 0)
            ly = max(ly, p[i].f(-p[i].b / 2 / p[i].a));
        else
            ry = min(ry, p[i].f(-p[i].b / 2 / p[i].a));
    }
    for (int i = 0; i < n; i++)
    {
        if (p[i].a > 0)
        {
            lx = max(lx, p[i].x1(ly));
            lx = max(lx, p[i].x1(ry));
            rx = min(rx, p[i].x2(ly));
            rx = min(rx, p[i].x2(ry));
        }
        else
        {
            lx = max(lx, p[i].x2(ly));
            lx = max(lx, p[i].x2(ry));
            rx = min(rx, p[i].x1(ly));
            rx = min(rx, p[i].x1(ry));
        }
    }
    cout << fixed << setprecision(15) << (rx + lx) / 2 << ' ' << (ry + ly) / 2 * 1e9;
    return 0;
}
