#include <iostream>
#include <algorithm>
#include <string>
#include <stack>
#include <map>
#include <unordered_map>
#define fastio ios_base::sync_with_stdio(0); cin.tie(0);
#define lli long long int 
using namespace std;

const int N = 2e6 + 30;
const lli mod = 1e9 + 7;

int main()
{
	fastio;
	cout.precision(9);
	int n;
	cin >> n;
	vector<long double> a(n), sufmax(n), sufmin(n), prefmax(n), prefmin(n);
	int i;
	for (i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	prefmax[0] = a[0];
	prefmin[0] = a[0];
	for (i = 1; i < n; i++)
	{
		prefmax[i] = max(prefmax[i - 1], a[i]);
		prefmin[i] = min(prefmin[i - 1], a[i]);
	}
	sufmax[n - 1] = sufmin[n - 1] = a[n - 1];
	for (i = n - 2; i >= 0; i--)
	{
		sufmax[i] = max(sufmax[i + 1], a[i]);
		sufmin[i] = min(sufmin[i + 1], a[i]);
	}
	
	cout << 1.000000000<<" ";
	for (i = 1; i < n; i++)
	{
		if (prefmin[i - 1] >= sufmax[i] || prefmax[i - 1] >= sufmax[i] && prefmin[i - 1] >= sufmin[i])
		{
			cout << 0<<" ";
		}
		else if (sufmin[i]<=prefmin[i - 1] && sufmax[i]>=prefmax[i - 1])
		{
			cout <<  (sufmax[i] - prefmax[i - 1])/ sufmax[i]<<" ";
		}
		else if (prefmax[i - 1] >= sufmax[i] && prefmin[i - 1] <= sufmin[i])
		{
			cout <<  (sufmin[i] - prefmin[i - 1]) / sufmin[i]<<" " ;
		}
		else if (prefmax[i - 1]<=sufmin[i] || sufmax[i]>=prefmax[i - 1] && sufmin[i] >= prefmin[i - 1])
		{
			double t1 = (sufmin[i] - prefmin[i - 1])/ sufmin[i];
			double t2 = (sufmax[i] - prefmax[i - 1])/ sufmax[i];
			if (max(sufmax[i] * (1 - t1), prefmax[i - 1]) - prefmin[i - 1] < prefmax[i - 1] - min(sufmin[i] * (1 - t2), prefmin[i - 1]))
			{
				cout << t1 << " ";
			}
			else if (max(sufmax[i] * (1 - t1), prefmax[i - 1]) - prefmin[i - 1] > prefmax[i - 1] - min(sufmin[i] * (1 - t2), prefmin[i - 1]))
			{
				cout << t2 << " ";
			}
			else
			{
				cout << max(t1, t2)<<" ";
			}
		}
	}


}