#include <iostream>
#include <algorithm>
#include <stack>

using namespace std;

const int N = 1e6 + 3;

int n;
double a[N];
double pmx[N], smx[N], pmn[N], smn[N];

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	for (int i = 1; i <= n; i++)
	{
		cin >> a[i];
	}
	pmn[0] = 1e9 + 7;
	for (int i = 1; i <= n; i++)
	{
		pmx[i] = max(a[i], pmx[i - 1]);
		pmn[i] = min(a[i], pmn[i - 1]);
	}
	smn[n + 1] = 1e9 + 7;
	for (int i = n; i > 0; i--)
	{
		smx[i] = max(a[i], smx[i + 1]);
		smn[i] = min(a[i], smn[i + 1]);
	}
	for (int i = 1; i <= n; i++)
	{
		if (smx[i] == smx[1] && smn[i] == smn[1])
		{
			cout << 1 - (pmx[i - 1] / smx[i]) << ' ';
		}
		else if (smx[i] == smx[1])
		{
			cout << 1 - min(pmx[i - 1] / smx[i], pmn[i - 1] / smn[i]) << ' ';
		}
		else if (smn[i] == smn[1])
		{
			cout << 0 << ' ';
		}
		else
		{
			cout << 1 - (pmn[i - 1] / smn[i]) << ' ';
		}
	}
	system("pause");
	return 0;
}