#include <iostream>
#include <algorithm>
#include <stack>

using namespace std;

const int N = 1e6 + 3;

int n;
int a[N], b[N];
int ap[N], bp[N];

bool check(int k)
{
	for (int i = 0; i < n; i++)
	{
		ap[i] = a[i];
		bp[i] = b[i];
	}
	int to = 0;
	for (int i = 0; i < n;)
	{
		if (i - to > k)
			to = i - k;
		if (to - i > k)
			return false;
		if (to >= n && ap[i] != 0)
			return false;
		if (bp[to] <= ap[i])
		{
			ap[i] -= bp[to];
			bp[to] = 0;
			to++;
		}
		else
		{
			bp[to] -= ap[i];
			ap[i] = 0;
		}
		if (ap[i] == 0)
			i++;
	}
	return true;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	for (int i = 0; i < n; i++)
		cin >> a[i];
	for (int i = 0; i < n; i++)
		cin >> b[i];
	long long sum = 0;
	for (int i = 0; i < n; i++)
		sum += b[i] - a[i];
	if (sum < 0)
		cout << -1;
	else
	{
		int l = 0, r = n;
		while (l < r)
		{
			int m = (l + r) / 2;
			if (check(m))
				r = m;
			else
				l = m + 1;
		}
		cout << l;
	}
	system("pause");
	return 0;
}