//165 - OG
#include <bits/stdc++.h>

#define fi first
#define se second
#define pb push_back
#define all(x) x.begin(),x.end()
#define sz(x) ((ll)(x).size())
#define re return
#define be(x) x.begin()
#define en(x) x.end()
#define for0(i,n) for (int i=0;i<n;i++)
#define for1(i,n) for (int i=1;i<n;i++)
#define rep(i,a,n) for (int i=a;i<n;i++)
#define rs resize
using namespace std;

typedef string str;
typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef pair<ld,ld> pld;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<char> vc;
typedef vector<string> vs;
typedef vector<vector<int>> vvi;
typedef vector<pair<int,int>> vpii;
typedef vector<pair<ll,ll>> vpll;

const ld PI = 3.1415926535;
const ll INF = 1e18 + 7;

ll n;
ll a[2000001], b[2000001], a1[2000001], b1[2000001];

bool f(ll c) {

    ll i = 0, j = 0;
    while (i < n && j < n) {
        while (j - i > c) i++;
        while (i - j > c) j++;

        if (i >= n || j >= n) break;

        if (a1[i] < b1[j]) {
            b1[j] -= a1[i];
            a1[i] = 0;
            i++;
            continue;
        }

        if (a1[i] == b1[j]) {
            b1[j] = 0;
            a1[i] = 0;
            i++;
            j++;
            continue;
        }

        if (a1[i] > b1[j]) {
            a1[i] -= b1[j];
            b1[j] = 0;
            j++;
            continue;
        }
    }

    for (ll i = 0; i < n; i++)
        if (a1[i]) return false;
    return true;
}

void Solve() {
    ll sa = 0, sb = 0;
    cin >> n;
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        sa += a[i];
    }
    for (ll i = 0; i < n; i++) {
        cin >> b[i];
        sb += b[i];
    }
    if (sa > sb) {
        cout << -1;
        return;
    }

    ll l = -1, r = 2000001;
    while (r - l > 1) {
        ll c = (l + r) / 2;
        if (f(c))
            r = c;
        else
            l = c;
        for (ll i = 0; i < n; i++) {
            a1[i] = a[i];
            b1[i] = b[i];
        }
    }
    cout << r;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll test = 1;
    // cin >> test;
    while (test--)
        Solve();
    return 0;
}
