#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,sse4,popcnt")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <functional>
#include <unordered_map>
#include <complex>
#include <array>
#include <chrono>
#include <random>
#include <vector>
#include <string>
#include <sstream>
#include <cmath>
#include <cstring>
#include <bitset>
#include <list>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <cassert>

#define sq(x) ((x) * (x))
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errp(x) cerr << "["#x"]  {" << ((x).first) << ", " << ((x).second) << "}\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n"

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template <typename T1, typename T2> inline bool relax(T1& a, const T2& b) {
    return a > b ? a = b, true : false;
}

template <typename T1, typename T2> inline bool strain(T1& a, const T2& b) {
    return a < b ? a = b, true : false;
}

// :::::::::::::::::::::::::::::::

// rusfree8049
// edefegecafy

#define v vector

bool check(ll m, v<ll>& a, v<ll>& b) {
    ll pos = 0;
    v<ll> xxx(a.size());
    for(ll i = 0; i < a.size(); ++i) {
        while(i - pos > m) {
            ++pos;
        }
        ll c = a[i];
        while(c > 0 && pos < a.size() && pos <= i + m) {
            if(xxx[pos] == b[pos]) {
                ++pos;
            } else {
                ll ma = min(b[pos] - xxx[pos], c);
                c -= ma;
                xxx[pos] += ma;
            }
        }
        if(pos > i + m || pos >= a.size()) {
            return false;
        }
    }
//    err(pos);
    return true;
}

void solve() {
    ll n;
    cin >> n;
    v<ll> a(n), b(n);
    for(ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for(ll i = 0; i < n; ++i) {
        cin >> b[i];
    }
    ll L = 0, R = n + 1;
    ll Ans = -1;
    bool x = check(1, a, b);
//    err(x);
    while(L < R) {
        ll M = (L + R) >> 1;
        if(check(M, a, b)) {
            Ans = M;
            R = M;
        } else {
            L = M + 1;
        }
    }
    cout << Ans;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);
    
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    
    return 0;
}
