﻿#include <iostream>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <vector>
#include <queue>
#include <iomanip>
using namespace std;
const int N = 2e5;
int a[N], mns[N], mxs[N], mnp[N], mxp[N];
long double ans[N];
/*
#define int long long
const int q = 29;
const int Mod = 1e9 + 7;
vector <int> mac[N][q];

queue <pair <int, int>> qu;
int timer = 0;
int used[q];
vector <int> sames;
void find_same(int L,int R)
{
    for (int j = 0; j < 26; j++)
    {
        for (int i = L; i < R; i++)
        {
            if (mac[i][j].size() > 0)
            {
                used[j]++;
            }
        }
    }
    for (int i = 0; i < 26; i++)
    {
        if (used[i] == R - L)
        {
            sames.push_back(i);
        }
    }
    if (sames.size() == 0)
    {
        cout << "NO";
        exit(0);
    }
}

signed main()
{
    int a, b;
    cin >> a >> b;
    for (int i = 0; i < b; i++)
    {
        string s;
        cin >> s;
        for (int j = 0; j < a; j++)
        {
            mac[i][s[j]-'a'].push_back(j);
        }
    }
    qu.push({ 0, a });
    while (!qu.empty())
    {
        pair<int, int> x = qu.front();
        qu.pop();
        find_same(x.first,x.second);

    }
}*/
int main()
{
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    mxp[0] = mnp[0] = a[0];
    for (int i = 1; i < n; ++i)
    {
        mxp[i] = max(mxp[i - 1], a[i]);
        mnp[i] = min(mnp[i - 1], a[i]);
    }
    mxs[n - 1] = mns[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; --i)
    {
        mxs[i] = max(mxs[i + 1], a[i]);
        mns[i] = min(mns[i + 1], a[i]);
    }
    for (int i = 0; i < n; ++i)
    {
        if (i > 0)
        {
            if (mxp[i - 1] > mxs[i])
                if (mnp[i - 1] > mns[i])
                    ans[i] = 0;
                else
                {
                    ans[i] = mns[i] - mnp[i - 1];
                    ans[i] /= mns[i];
                }
            else
                if (mnp[i - 1] > mns[i])
                {
                    ans[i] = mxp[i - 1] - mnp[i - 1];
                    ans[i] /= mxs[i] - mns[i];
                }
                else
                {
                    ans[i] = mxs[i] - mnp[i - 1];
                    ans[i] /= mxs[i];
                }
        }
        else
            ans[i] = 1;
    }
    for (int i = 0; i < n; ++i)
        cout << fixed << setprecision(11) << ans[i] << " ";
}


