﻿#include <algorithm>
#include <iostream>
#include <cmath>
#include <math.h>
#include <vector>
#include <queue>
#include <iomanip>
using namespace std;

const int N = 2e5;
const long double eps = 1e-10;
long double a[N], mns[N], mxs[N], mnp[N], mxp[N];
long double ans[N];

int main()
{
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    mxp[0] = mnp[0] = a[0];
    for (int i = 1; i < n; ++i)
    {
        mxp[i] = max(mxp[i - 1], a[i]);
        mnp[i] = min(mnp[i - 1], a[i]);
    }
    mxs[n - 1] = mns[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; --i)
    {
        mxs[i] = max(mxs[i + 1], a[i]);
        mns[i] = min(mns[i + 1], a[i]);
    }
    for (int i = 0; i < n; ++i)
    {
        if (i > 0)
        {
            if (mxp[i - 1] > mxs[i] + eps)
                if (mnp[i - 1] > mns[i])
                    ans[i] = 0;
                else
                    ans[i] = (mns[i] - mnp[i - 1]) / mns[i];
            else
                if (mxp[i - 1] - mxs[i] < eps)
                    ans[i] = max((mns[i] - mnp[i - 1]) / mns[i], (mxs[i] - mxp[i - 1]) / mxs[i]);
                else
                    ans[i] = (mxs[i] - mxp[i - 1]) / mxs[i];
        }
        else
            ans[i] = 1;
    }
    for (int i = 0; i < n; ++i)
        cout << fixed << setprecision(18) << ans[i] << " ";
}