#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <complex>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
//typedef __int128_t int128;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef complex<long double> comp;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const long double EPS = 1e-9;
const long double PI = acos(-1);

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ld START_TIME, TIME;

ld last(ld a1, ld a2, ld a3, ld mx) {
    if (a1 - 1 == 0) {
        if (a2 * a3 - a2 - a3 + a1 != 0) return -1;
        return mx;
    }
    ld a4 = (a2 * a3 - a2 - a3 + a1) / (a1 - 1);
    return a4;
}

ld res(ld a1, ld a2, ld a3, ld mx) {
    ld a4 = last(a1, a2, a3, mx);
    if (a4 < 1 || a4 > mx) return -1;
    return (a1 * a4 + a2 + a3);
}

vector<ld> p(4);
vector<ld> p1(4);
vector<int> ord(4);
vector<bool> used(4);

ld ans;
vector<ld> pans;
vector<int> ordans;

void solve(int i) {
    if (i == 4) {
        if (res(p1[0], p1[1], p1[2], p1[3]) > ans) {
            ans = res(p1[0], p1[1], p1[2], p1[3]);
            ld t = p1[3];
            p1[3] = last(p1[0], p1[1], p1[2], p1[3]);
            pans = p1;
            ordans = ord;
            p1[3] = t;
        }
        return;
    }
    for (int _ = 0; _ < 4; _++) {
        if (used[_]) continue;
        p1[i] = p[_];
        used[_] = 1;
        ord[i] = _;
        solve(i + 1);
        used[_] = 0;
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    START_TIME = clock();
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    //solve();
#ifdef LOCAL
    TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    cerr << endl << TIME * 1000 << " ms." << endl;
#endif
    for (auto& i : p)
        cin >> i;
    solve(0);
    for (auto& it : ordans) cout << it + 1 << " ";
    cout << '\n';
    cout << fixed << setprecision(10);
    for (auto& it : pans) cout << it << " ";
    return 0;
}