#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <random>
using namespace std;
const int maxN = 1e5;
int id[maxN];
vector<int> inds[maxN];
unordered_map<char, int> cnt[maxN];
string s[maxN];
unordered_map<char, vector<int>> cinds[maxN];
int num[maxN * 10];
int hsh[maxN];
mt19937 rng(228);
int rand(int l, int r) {
	return uniform_int_distribution<int>(l, r)(rng);
}
const int inf = 1e9 + 9;
int main() {
	for (auto& i : num) i = rand(0, inf);
	int k, n; cin >> k >> n;
	if (n == 1) {
		cout << "YES\n";
		return 0;
	}
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
		for (int j = 0; j < k; ++j) {
			cinds[i][s[i][j]].push_back(j);
		}
		inds[0].push_back(i);
		for (auto& c : cinds[i]) {
			cnt[0][c.first] += 1;
		}
	}
	int cntgood = 0;
	int tot = 1;
	unordered_map<int, vector<int>> nuid;
	while (cntgood < n) {
		nuid.clear();
		int nu = 0;
		for (int cg = 0; cg < tot; ++cg) {
			string com;
			for (auto& c : cnt[cg]) {
				if (c.second == inds[cg].size()) {
					com.push_back(c.first);
				}
			}
			if (com.empty()) {
				cout << "NO\n";
				return 0;
			}
			for (auto& i : inds[cg]) {
				for (auto& c : com) {
					for (auto& ind : cinds[i][c]) {
						s[i][ind] = '_';
						hsh[i] ^= num[ind];
					}
					cinds[i].erase(c);
				}
				nuid[hsh[i]].push_back(i);
			}
		}
		int zz = 0;
		for (auto& i : nuid) {
			if (i.second.size() == 1) {
				++cntgood;
				continue;
			}
			inds[zz] = i.second;
			cnt[zz].clear();
			for (auto& j : inds[zz]) {
				for (auto& c : cinds[j]) {
					cnt[zz][c.first] += 1;
				}
			}
			++zz;
		}
		tot = zz;
	}
	cout << "YES\n";
	return 0;
}