#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <random>
#include <time.h>
#include <stack>


using namespace std;

#define ll long long
#define ve vector
const ll inf = 1e18 + 9;

mt19937_64 rng(time(NULL));

ll rand(ll l, ll r) {
	return uniform_int_distribution<ll>(l, r)(rng);
}


int main() {
	int n;
	cin >> n;
	ve<int> p(n);
	for (auto& it : p) {
		cin >> it;
		--it;
	}
	reverse(p.begin(), p.end());
	ve<int> nx[2];
	stack<int> t1, t2;
	nx[0].resize(n, 0);
	nx[1].resize(n, 0);
	for (int i = 0; i < n; ++i) {
		if (nx[0][i]) {
			while (t1.top() != i) {
				cout << "12\n";
				nx[0][t1.top()] = 0;
				nx[1][t1.top()] = 1;
				t2.push(t1.top());
				t1.pop();
			}
			nx[0][i] = 0;
			t1.pop();
			cout << "-1\n";
		}
		else if (nx[1][i]) {
			while (t2.top() != i) {
				cout << "21\n";
				nx[1][t2.top()] = 0;
				nx[0][t2.top()] = 1;
				t1.push(t2.top());
				t2.pop();
			}
			nx[1][i] = 1;
			t2.pop();
			cout << "-2\n";
		}
		else {
			while (p.back() != i) {
				cout << "1\n";
				nx[0][p.back()] = 1;
				t1.push(p.back());
				p.pop_back();
			}
			cout << "1\n-1\n";
			p.pop_back();
		}
	}
	return 0;
}