#pragma GCC target("avx,avx2")
#pragma GCC optimaze("Ofast")
#pragma GCC optimaze("unroll-loops")
#pragma GCC optimaze("fast-math")
#pragma GCC optimaze("no-stack-protector")
#pragma GCC optimaze("unswitch-loops")
#pragma GCC optimaze("rename-registers")

#include<bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define forn(i, n) for(int i = 0; i < int(n); i++)

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n;
    cin >> n;

    vector<ll> stud(n), arr(n);
    ll sum1 = 0, sum2 = 0;
    forn(i, n) {
        cin >> stud[i];
        sum1+=stud[i];
    }
    forn(i, n) {
        cin >> arr[i];
        sum2+=arr[i];
    }

    if (sum1 > sum2) {
        cout << -1;
        return;
    }

    int l = -1, r = n;
    while(r - l > 1) {
        int m = (r + l) / 2;

        vector<ll> tempar = arr, tempstud = stud;
//        cout << m << "\n";
//        for(auto i : tempar) {
//            cout << i << " ";
//        }
//        cout << "\n";
//        for(auto i : tempstud) {
//            cout << i << " ";
//        }
//        cout << "\n";

        int j = 0;
        bool is = true;
        forn(i, n) {
            while(tempstud[i] > 0 && is && abs(j-i) <= m) {
                ll delta = min(tempar[j], tempstud[i]);
                tempar[j] -= delta;
                tempstud[i] -= delta;

                if (tempstud[i] == 0 || j == n-1) {
                    break;
                }
                else {
                    j++;
                }
            }

            if (tempstud[i] > 0) {
                is = false;
                break;
            }
        }

//        for(auto i : tempar) {
//            cout << i << " ";
//        }
//        cout << "\n";
//        for(auto i : tempstud) {
//            cout << i << " ";
//        }
//        cout << "\n";

        if (is) {
            r = m;
        }
        else {
            l = m;
        }
    }

    cout << r;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(20);

//    #ifndef ONLINE_JUDGE
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//    freopen("error.txt", "w", stderr);
//    #endif // ONLINE_JUDGE

    solve();

    return 0;
}
