#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

typedef long long ll;
#define int long long 

int n;
int a[1000010];
int b[1000010];
int c[1000010];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n;
	for (int i = 1; i <= n; ++i) cin >> a[i];
	for (int i = 1; i <= n; ++i) cin >> b[i];

	int l = -1, r = n + 1;

	while (l + 1 < r)
	{
		int  m = (l + r) >> 1;

		bool ok = true;
		int p = 1;
		for (int i = 1; i <= n; ++i)
		{
			c[i] = a[i];
			while (true)
			{
				if (i == p) break;
				if (i - p > m)
				{
					++p;
					continue;
				}
				if (c[p] == b[p])
				{
					++p;
					continue;
				}

				if (c[p] > b[p])
				{
					int need = c[p] - b[p];
					int can = max(0ll, b[i] - c[i]);
					if (need <= can)
					{
						c[p] -= need;
						c[i] += need;
						++p;
						continue;
					}
					else
					{
						c[p] -= can;
						c[i] += can;
						break;
					}
				}
				else
				{
					int need = c[i];
					int can = b[p] - c[p];
					if (need <= can)
					{
						c[p] += need;
						c[i] -= need;
						break;
					}
					else
					{
						c[p] += can;
						c[i] -= can;
						++p;
						continue;
					}
				}
			}
			if (!ok) break;
		}
		for (int i = 1; i <= n; ++i) if (c[i] > b[i])
		{
			ok = false;
			break;
		}
		if (ok)
		{
			r = m;
		}
		else
		{
			l = m;
		}
	}

	cout << (r == n + 1 ? -1 : r);
	return 0;
}