#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <string>
#include <map>

using namespace std;

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;
	vector<int>a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	vector<pair<int, int>>pref(n + 1);
	pref[0].first = 1e9 + 7;
	pref[0].second = 0;
	for (int i = 0; i < n; ++i) {
		pref[i + 1].first = min(pref[i].first, a[i]);
		pref[i + 1].second = max(pref[i].second, a[i]);
	}
	vector<pair<int, int>>suf(n + 1);
	suf[n].first = 1e9 + 7;
	for (int i = 0; i < n; ++i) {
		suf[n - i - 1].first = min(suf[n - i].first, a[n - i - 1]);
		suf[n - i - 1].second = max(suf[n - i].second, a[n - 1 - i]);
	}
	cout << 1 << ' ';
	for (int i = 1; i < n; ++i) {
		if (suf[i].second > pref[i].second) {
			cout << fixed << setprecision(10) << double(1) - (double)pref[i].second / suf[i].second << ' ';
		}
		else if (suf[i].first > pref[i].first) {
			cout << fixed << setprecision(10) << double(1) - (double)pref[i].first / suf[i].first << ' ';
		}
		else cout << 0 << ' ';
	}
	return 0;
}