#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>

using namespace std;

#define int long long

vector<int> a, b, pref;

bool prov(int k) {
    int s = pref[k]; int n = b.size();
    for (int i = 0; i < n; i++){
        if (i + k < n){
            s += a[i + k];
        }
        s = max((int)0, s - b[i]);
        if (pref[min(n, i + k + 1)] - pref[max((int)0, i - k + 1)] < s) {
            return false;
        }
    }
    return s <= (int) 0;
}

int binp() {
    int l = -1, r = a.size();
    while (l + 1 != r){
        int m = (l + r) / 2;
        if (prov(m)){
            r = m;
        }
        else {
            l = m;
        }
    }
    return r;
}

void f(){
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
}

signed main() {
    f();
    int n;
    cin >> n;
    a.resize(n);
    int s1 = 0, s2 = 0;
    for (int& i : a){
        cin >> i;
        s1 += i;
    }
    b.resize(n);
    for (int& i : b){
        cin >> i;
        s2 += i;
    }
    pref.resize(n + 1);
    pref[0] = 0;
    for (int i = 1; i <= n; i++){
        pref[i] = pref[i - 1] + a[i - 1];
    }
    if (s1 > s2){
        cout << -1;
        return 0;
    }
    cout << binp();
}
