#include <bits/stdc++.h>
#define int long long
#define fir first
#define sec second
#define pb push_back
#define all(vc) vc.begin(), vc.end()
#define pii pair <int, int>
#define endl "\n"
#define un unsigned
#define INF 10000000009
#define double long double
#define sp system("pause")
#define F first
#define S second

#define EPS 0.000000001
using namespace std;
/*
const int N = 100009, R = 1 << 20, MOD = 1e9 + 7;

signed main()
{
ios_base::sync_with_stdio(0);
cin.tie(0);
cout.tie(0);
cout.precision(17);

int n;
cin >> n;

vector<int> A(n), B(n);
vector<int> a(n), b(n);

int s1 = 0;
int s2 = 0;

for (int i = 0; i < n; i++) {
cin >> A[i];
s1 += A[i];
}
for (int i = 0; i < n; i++) {
cin >> B[i];
s2 += B[i];
}

if (s1 > s2) {
cout << -1;
return 0;
}

int l = 0, r = n;
while (l + 1 < r) {
int m = (l + r) / 2;
int id = 0;
bool fl = 1;
int ib = 0;
int check = 0;

a = A;
b = B;

for (int i = 0; i < n; i++) {
id = max(max(id, 0LL), id);
ib = max(max(ib, 0LL), ib);
while (id < n and id <= i + m and ib < n and ib <= i + m) {
if (a[id] > b[ib]) {
a[id] -= b[ib];
check += b[ib];
b[ib] = 0;
ib++;
}
else if (a[id] < b[ib]) {
b[ib] -= a[id];
check += a[id];
a[id] = 0;
id++;
}
else {
a[id] = 0;
check += a[id];
b[ib] = 0;
id++;
ib++;
}
}
}

if (check == s1) {
r = m;
}
else {
l = m;
}
}

cout << l;

sp;
return 0;
}
*/


#define int long long
#define fir first
#define sec second
#define pb push_back
#define all(vc) vc.begin(), vc.end()
#define pii pair <int, int>
#define endl "\n"
#define un unsigned
#define INF 1000000000000009
#define double long double
#define sp system("pause")
#define F first
#define S second
using namespace std;

const int N = 100009, R = 1 << 20, MOD = 1e9 + 7;

double check(vector<double> &vc, vector<pii>& idx, vector<pii> &lol, int k, double m)
{
  double mx = max(vc[lol[k - 1].second], vc[idx[k].sec] * (1 - m));
  double mn = min(vc[lol[k - 1].fir], vc[idx[k].first] * (1 - m));

  return mx - mn;
}

double tern(vector<double> &vc, vector<pii> &idx, vector<pii> &lol, int k, double l, double r)
{
  double m1, m2;

  while (r - l >  EPS)
  {
    m1 = (r - l) / 3 + l;
    m2 = r - (r - l) / 3;

    if (check(vc, idx, lol, k, m1) >= check(vc, idx, lol, k, m2))
    {
      l = m1;
    }
    else
    {
      r = m2;
    }
  }

  double ans = l;

  if (l + EPS <= 1.000)
  {
    if (check(vc, idx, lol, k, l + EPS/2) <= check(vc, idx, lol, k, ans))
    {
      ans = l + EPS/2;
    }
  }

  if (check(vc, idx, lol, k, r) <= check(vc, idx, lol, k, ans))
  {
    ans = r;
  }

  return ans;
}

signed main()
{
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  cout.precision(17);

  int n;
  cin >> n;

  vector<double> vc(n);
  vector<pii> idx(n);
  vector<pii> lol(n);

  for (int i = 0; i < n; i++)
  {
    cin >> vc[i];
  }

  idx[n - 1] = { n - 1, n - 1 };

  for (int i = n - 2; i >= 0; i--)
  {
    idx[i] = idx[i + 1];

    if (vc[i] < vc[idx[i + 1].fir])
    {
      idx[i].first = i;
    }

    if (vc[i] > vc[idx[i + 1].sec])
    {
      idx[i].second = i;
    }
  }

  lol[0] = { 0,0 };

  for (int i = 1; i < n; i++)
  {
    lol[i] = lol[i - 1];

    if (vc[i] < vc[lol[i].first])
    {
      lol[i].first = i;
    }

    if (vc[i] > vc[lol[i].sec])
    {
      lol[i].second = i;
    }
  }

  cout << 1 << " ";
  for (int i = 1; i < n; i++)
  {
    cout << fixed << tern(vc, idx, lol, i, 0.0, 1.0 + EPS) << " ";
  }

  //sp;
  return 0;
}
