#include <bits/stdc++.h>
//#define int long long
#define fir first
#define sec second
#define pb push_back
#define all(vc) vc.begin(), vc.end()
#define pii pair <int, int>
#define endl "\n"
#define un unsigned
#define INF 10000000009
#define double long double
#define sp system("pause")
#define F first
#define S second

#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#pragma GCC optimize("O1")
#pragma GCC optimize("O2")

using namespace std;

const double EPS = 0.0000000001;

inline double check(vector<double> &vc, vector<pii>& idx, vector<pii> &lol, int k, double m)
{
  double mx = max(vc[lol[k - 1].second], vc[idx[k].sec] * (1 - m));
  double mn = min(vc[lol[k - 1].fir], vc[idx[k].first] * (1 - m));

  return mx - mn;
}

inline double tern(vector<double> &vc, vector<pii> &idx, vector<pii> &lol, int k, double l, double r)
{
  double m1, m2;

  for (int i = 0; i < 51; i++)
  {
    m1 = (r - l) / 3 + l;
    m2 = r - (r - l) / 3;

    double mx1 = max(vc[lol[k - 1].second], vc[idx[k].sec] * (1 - m1));
    double mn1 = min(vc[lol[k - 1].fir], vc[idx[k].first] * (1 - m1));

    double mx2 = max(vc[lol[k - 1].second], vc[idx[k].sec] * (1 - m2));
    double mn2 = min(vc[lol[k - 1].fir], vc[idx[k].first] * (1 - m2));

    if (mx1 - mn1 >= mx2 - mn2)
    {
      l = m1;
    }
    else
    {
      r = m2;
    }
  }

  double ans = l;

  if (l + EPS <= 1.000)
  {
    if (check(vc, idx, lol, k, l + EPS) <= check(vc, idx, lol, k, ans))
    {
      ans = l + EPS;
    }
  }

  if (check(vc, idx, lol, k, r) <= check(vc, idx, lol, k, ans))
  {
    ans = r;
  }

  return ans;
}

signed main()
{
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  cout.precision(10);

  int n;
  cin >> n;

  vector<double> vc(n);
  vector<pair<int,int> > idx(n);
  vector<pair<int,int> > lol(n);

  for (int i = 0; i < n; i++)
  {
    cin >> vc[i];
  }

  idx[n - 1] = { n - 1, n - 1 };

  for (int i = n - 2; i >= 0; i--)
  {
    idx[i] = idx[i + 1];

    if (vc[i] < vc[idx[i + 1].fir])
    {
      idx[i].first = i;
    }

    if (vc[i] > vc[idx[i + 1].sec])
    {
      idx[i].second = i;
    }
  }

  lol[0] = { 0,0 };

  for (int i = 1; i < n; i++)
  {
    lol[i] = lol[i - 1];

    if (vc[i] < vc[lol[i].first])
    {
      lol[i].first = i;
    }

    if (vc[i] > vc[lol[i].sec])
    {
      lol[i].second = i;
    }
  }

  cout << 1 << " ";
  double ans = 1;

  for (int i = 1; i < n; i++)
  {
      if (lol[i] == lol[i - 1] && idx[i] == idx[i - 1])
      {
          cout << ans << " ";

      }
      else{

    ans = tern(vc, idx, lol, i, 0.0, 1.0);
    cout << ans << " ";
     }
  }

  return 0;
}
