// VkoshpKostroma.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

//Kostroma

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <stack>
#include <map>

using namespace std;

const int mod = 1e9 + 7;
const int Inf = 1e9;

int per[5];

void next_per() {
	int ind = 4;
	for (int i = 3; i >= 0; --i) {
		if (per[i] < per[i + 1]) {
			ind = i;
			break;
		}
	}
	int r = 4;
	while (per[r] < per[ind]) {
		r--;
	}
	swap(per[r], per[ind]);
	r = 4;
	ind++;
	while (r > ind) {
		swap(per[r], per[ind]);
		r--;
		ind++;
	}
}

long double get_ans(long double a, long double b, long double c, long double d) {
	long double P = a * b - a - b;
	if (c == 1) {
		if (P == -1) {
			return d;
		}
		else {
			return -Inf;
		}
	}
	long double t = (P + 1) / (c - 1) + 1;
	//cout << a << ' ' << b << ' ' << c << ' ' << d << ' ' << t << endl;
	if (t > d) {
		return -Inf;
	}
	return t;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout << fixed << setprecision(12);
	int a, b, c, d;
	cin >> a;
	cin >> b;
	cin >> c;
	cin >> d;
	int data[4] = {a, b, c, d};
	for (int i = 0; i < 5; ++i) {
		per[i] = i;
	}
	int max_per[4];
	long double max_val[4];
	long double mmax = 0;
	while (per[0] == 0) {
		long double ans = get_ans(data[per[1] - 1], data[per[4] - 1], data[per[3] - 1], data[per[2] - 1]);
		//cout << ans << endl;
		if (mmax < data[per[1] - 1] * data[per[4] - 1] + data[per[3] - 1] + ans) {
			mmax = data[per[1] - 1] * data[per[4] - 1] + data[per[3] - 1] + ans;
			for (int i = 0; i < 4; ++i) {
				max_per[i] = per[i + 1];
				max_val[i] = data[i];
			}
			max_val[per[2] - 1] = ans;
		}
		next_per();
	}
	for (int i = 0; i < 4; ++i) {
		cout << max_per[i] << ' ';
	}
	cout << endl;
	for (int i = 0; i < 4; ++i) {
		cout << max_val[max_per[i] - 1] << ' ';
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file