#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#define all(x) x.begin(), x.end()
using namespace std;


bool does_it_suit(double m, int amin, int amax, int bmin, int bmax) {
	double tmax = min((double)m / (bmax - bmin), (double)(amin + m) / bmax);
	double tmin = (double)(amax - m) / bmin;
	if (tmax >= tmin)
		return 1;
	return 0;
}
double f(double m, int amin, int amax, int bmin, int bmax) {
	return (1 - (double)(amax - m) / bmin);
}

signed main() {
	cout.setf(ios::fixed);
	cout.precision(20);
	int n;
	cin >> n;
	vector<int>a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	vector<int>p_max(n);
	vector<int>s_max(n);
	vector<int>p_min(n);
	vector<int>s_min(n);
	p_max[0] = p_min[0] = a[0];
	s_max[n - 1] = s_min[n - 1] = a[n - 1];
	for (int i = 1; i < n; ++i) {
		p_max[i] = max(p_max[i - 1], a[i]);
		p_min[i] = min(p_min[i - 1], a[i]);
		s_max[n - 1 - i] = max(s_max[n - i], a[n - 1 - i]);
		s_min[n - 1 - i] = min(s_min[n - i], a[n - 1 - i]);
	}
	cout << (double)1 << " ";
	for (int i = 1; i < n; ++i) {
		double mq = p_max[i - 1] - p_min[i - 1], mr = 1e9 + 100;
		for (int j = 0; j < 113; ++j) {
			double m = (mq + mr) / 2;
			if (does_it_suit(m, p_min[i - 1], p_max[i - 1], s_min[i], s_max[i])) {
				mr = m;
			}
			else
				mq = m;
		}
		cout << f(mr, p_min[i - 1], p_max[i - 1], s_min[i], s_max[i]) << ' ';
	}

}


/*
bool does_it_suit(double m, int amin, int amax, int bmin, int bmax) {
	double tmax = max((double)m / (bmax - bmin), (double)(amax - m) / bmin);
	double tmin = (double)(amin + m) / bmax;
	if (tmax >= tmin)
		return 1;
	return 0;
}
double f(double m, int amin, int amax, int bmin, int bmax) {
	return (1 - (double)(amax - m) / bmin);
}

signed main() {
	cout.setf(ios::fixed);
	cout.precision(20);
	int n;
	cin >> n;
	vector<int>a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	vector<int>p_max(n);
	vector<int>s_max(n);
	vector<int>p_min(n);
	vector<int>s_min(n);
	p_max[0] = p_min[0] = a[0];
	s_max[n - 1] = s_min[n - 1] = a[n - 1];
	for (int i = 1; i < n; ++i) {
		p_max[i] = max(p_max[i - 1], a[i]);
		p_min[i] = min(p_min[i - 1], a[i]);
	    s_max[n - 1 - i] = max(s_max[n - i], a[n - 1 - i]);
		s_min[n - 1 - i] = min(s_min[n - i], a[n - 1 - i]);
	}
	cout << 1 << " ";
	for (int i = 1; i < n; ++i) {
		double mq = p_max[i - 1] - p_min[i - 1], mr = 6;
		for (int j = 0; j < 101; ++j) {
			double m = (mq + mr) / 2;
			if (does_it_suit(m,p_min[i - 1],p_max[i - 1],s_min[i], s_max[i])) {
				mr = m;
			}
			else
				mq = m;
		}
		cout << f(mr, p_min[i - 1], p_max[i - 1], s_min[i], s_max[i]) << ' ';
	}

}
*/
