#include <bits/stdc++.h>
#define fori for (int i = 0; i < n; ++i)

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

using namespace std;
#ifdef local
bool debug = true;
#else
bool debug = false;
#endif

ll n;
vector <ll> a(n), b(n);

bool f(ll k) {
	vector <ll> d = a;
	int l = 0;
	for (int i = 0; i < n; ++i) {
		if (d[i] > b[i]) {
			while (l < n && (i - l > k || d[l] >= b[l])) {
				++l;
			}
			ll r = d[i] - b[i];
			while (r > 0 && l - i <= k && l < n) {
				if (d[l] >= b[l]) {
					++l;
					continue;
				}
				ll r1 = b[l] - d[l];
				if (r1 >= r) {
					d[l] += r;
					d[i] -= r;
					r = 0;
				} else {
					d[l] += r1;
					d[i] -= r1;
					r -= r1;
				}
			}
			if (r > 0) {
				if(debug)cout << "R = " << r << endl;
				if(debug)cout << "I = " << i << endl;
				return false;
			}
		}
	}
	return true;
}

inline void solve() {
	cin >> n;
	a.resize(n);
	b.resize(n);
	fori cin >> a[i];
	fori cin >> b[i];
	ll s1 = 0, s2 = 0;
	fori {
		s1 += a[i];
		s2 += b[i];
	}
	if (s1 > s2) {
		cout << -1;
		return;
	}
	ll l = -1, r = n;
	while (r - l > 1) {
		ll m = (l + r) / 2;
		if(debug)cout << "M = " << m << endl;
		if (f(m)) {
			if(debug)cout << "TRUE" << endl;
			r = m;
		} else {
			if(debug)cout << "FALSE" << endl;
			l = m;
		}
	}
	cout << r;
}

signed main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	
	solve();
}