#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

//#define int long long
#define SZ(sp) int(sp.size())

template < typename T >
using orde = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update >;
template < typename T >
using order = tree < T, null_type, less_equal <>, rb_tree_tag, tree_order_statistics_node_update >;
// find_by_order() yk-l
// order_of_key() kol-vo

#define int long long

int n;
vector < int > a, b;

char func(int k) {
    int pos = 0;
    vector < int > bb = b;
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        if (abs(i - pos) > k) {
            if (i < pos) {
                if (sum + a[i] > 0) {
                    return false;
                }
                continue;
            }
            else {
                ++pos;
            }
        }
        sum += a[i];
        while (pos < n && sum > 0) {
            if (abs(i - pos) > k) {
                return false;
            }
            int x = min(sum, bb[pos]);
            sum -= x;
            bb[pos] -= x;
            if (bb[pos] == 0) {
                ++pos;
            }
        }
    }
    return sum == 0;
}


void solve(){
    cin >> n;
    a.resize(n);
    b.resize(n);
    for (auto &el: a) {
        cin >> el;
    }
    for (auto &el: b) {
        cin >> el;
    }
    int sum_a = 0, sum_b = 0;
    for (int i = 0; i < n; ++i) {
        sum_a += a[i];
        sum_b += b[i];
    }
    if (sum_a > sum_b) {
        cout << -1 << '\n';
        return;
    }
    int l = -1, r = n - 1;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (func(mid)) {
            r = mid;
        }
        else {
            l = mid;
        }
    }
    cout << r << "\n";
}

int32_t main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
}




