#include <bits/stdc++.h>
#define double long double
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);
    int n; cin >> n;
    vector<double> a(n);
    vector<double> pmx(n), smx(n), pmn(n), smn(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if(i > 0) {
            pmx[i] = max(pmx[i-1], a[i]);
            pmn[i] = min(pmn[i-1], a[i]);
        }
        else{
            pmx[0] = a[i];
            pmn[0] = a[i];
        }
    }
    smn[n-1] = a[n-1];
    smx[n-1] = a[n-1];
    for (int i = n-2; i >= 0; --i) {
        smn[i] = min(smn[i+1], a[i]);
        smx[i] = max(smx[i+1], a[i]);
    }
    cout << 1.00000 << ' ';
    for (int i = 1; i < n; ++i) {
        double l = 0, r = 1.0, m1, m2;
        while(r - l >= 0.0000000000001) {
            m1 = l + (r - l) / 3.0;
            m2 = r - (r - l) / 3.0;
            if(max(pmx[i-1], smx[i] * (1-m1)) - min(pmn[i-1], smn[i] * (1-m1)) < max(pmx[i-1], smx[i] * (1-m2)) - min(pmn[i-1], smn[i] * (1-m2))) {
                r = m2;
            }
            else
                l = m1;
        }
        cout <<fixed << setprecision(10) << r << ' ';
    }
    return 0;
}
