#include <iostream>
#include <vector>
#include <iomanip>
#include <set>
#include <cmath>
#include <algorithm>

#define ll long long
#define pii pair<int, int>
#define pll pair<ll, ll>

const int INF = 1009000999;
const int N = 200005;

using namespace std;

int arr[N];
bool comp(pll a, pll b) {
	return (a.first * b.second > b.first * a.second);
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n, mal, mar, mil, mir;
	cin >> n;

	multiset<int> right;

	for (int i = 0; i < n; i++)
	{
		cin >> arr[i];
		right.insert(arr[i]);
	}
	multiset<int> left;
	cout << fixed << setprecision(2) << 1.00 << " ";
	for (int i = 0; i < n - 1; i++)
	{
		right.erase(arr[i]);
		left.insert(arr[i]);
		mil = *left.begin();
		mir = *right.begin();
		mal = *left.rbegin();
		mar = *right.rbegin();
		pll k, k1;
		pll d, d1;
		if (mal > mar) {
			if (mil < mar) {
				k = { mar, mil };
				// cout << k.first << " " << k.second << endl;
				d = { k.first * mal - mir * k.second, k.first };
			}
			else
			{
				cout << setprecision(2) << 0.00 << " ";
				continue;
			}
		}
		else
		{
			k = { mar, mal };
			if (comp({ mil, 1 }, { mar * k.second, k.first })) {
				d = { mal * k.first - mar * k.second, k.first };
			}
			else d = { mal - mil, 1 };
		}
		if (mir > mil) {
			k1 = { mir, mil };
			if (comp({ mal, 1 }, { mar * k1.second, k1.first })) {
				d1 = { mal - mil, 1 };
			}
			else d1 = { (mar - mil) * k1.second, k.first };
			if (comp(d, d1)) {
				d = d1;
				k = k1;
			}
		}
		if (comp(d, { mal, 1 }))
			k = { 1, 1 };
		else if (comp(d, { max(mal, mar) - min(mil, mir), 1}))
			k = { 0, 1 };
		// cout << k.first << " " << k.second << endl;
		if (k.first == 0) cout << setprecision(2) << 1.00 << " ";
		else cout << fixed << setprecision(2) << (k.first - double(k.second)) / k.first << " ";
	}
	return 0;
}
