#include <bits/stdc++.h>

using namespace std;

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int n; cin >> n;
    vector<int> va(n), vb(n);

    for (int& x : va) cin >> x;
    for (int& x : vb) cin >> x;

    int l = 0, r = n+7;
    while (l < r) {
        int m = (l + r) / 2;

        bool check = true;

        auto a = va, b = vb;

        for (int i = 0, j = 0; i < n; ++i) {
            j = max(j, i - m);
            while (j <= i + m && j < n) {
                if (a[i] <= b[j]) {
                    b[j] -= a[i];
                    a[i] = 0;
                    break;
                } else {
                    a[i] -= b[j];
                    b[j] = 0;
                    j++;
                }
            }

            if (a[i] > 0) {
                check = false;
                break;
            }
        }

        if (check) r = m;
        else l = m + 1;
    }

    cout << (r == n+7 ? -1 : r) << endl;

}
