#include <bits/stdc++.h>

using namespace std;
using ld = long double;

const int N = 1e5+7;

const ld EPS = 1e-18;

int n, a[N], b[N], c[N];

ld value(ld x) {
    ld miny = -1e36;
    ld maxy = +1e36;

    for (int i = n; i--; ) {
        if (a[i] > 0) {
            miny = max(miny, a[i]*x*x + b[i]*x + c[i]);
        } else {
            maxy = min(maxy, a[i]*x*x + b[i]*x + c[i]);
        }
    }

    if (miny < maxy) {
        cout << fixed << setprecision(9);
        cout << x << ' ' << (abs(miny) < abs(maxy) ? miny : maxy) << endl;
        exit(0);
    }

    return maxy-miny;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i] >> c[i];
    }

    value(0);

    ld l = -1e18, r = 1e18;
    while (true) {
        ld m1 = l + (r-l)/3;
        ld m2 = r - (r-l)/3;

        if (value(m1) > value(m2)) {
            r = m2;
        } else {
            l = m1;
        }
    }
}
