#include <bits/stdc++.h>

using namespace std;

#define MP make_pair

typedef long long ll;

const int N = 1e6 + 3e2;

int n;
ll a[N], b[N];
ll c[N];

bool check(int k){
    for (int i = 1; i <= n; i++) c[i] = a[i];

    for (int i = 1; i <= n; i++){
        for (int j = max(1, i - k); j <= min(n, i + k); j++){
            if (c[j] < b[j]){
                ll x = min(c[i], b[j] - c[j]);
                c[i] -= x;
                c[j] += x;
            }
        }
    }

    for (int i = n; i >= 1; i--){
        for (int j = min(n, i + k); j >= max(1, i - k); j--){
            if (c[j] < b[j]){
                ll x = min(c[i], b[j] - c[j]);
                c[i] -= x;
                c[j] += x;
            }
        }
    }

    for (int i = 1; i <= n; i++){
        for (int j = max(1, i - k); j <= min(n, i + k); j++){
            if (c[j] < b[j]){
                ll x = min(c[i], b[j] - c[j]);
                c[i] -= x;
                c[j] += x;
            }
        }
    }

    bool ok = true;
    for (int i = 1; i <= n; i++){
        if (c[i] > b[i]) ok = false;
    }

    return ok;
}

void solve(){
    cin >> n;
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= n; i++) cin >> b[i];

    int ans = -1;

    int l = 0, r = n - 1;
    while (l <= r){
        int m = (l + r) >> 1;
        if (check(m)){
            ans = m;
            r = m - 1;
        } else l = m + 1;
    }

    cout << ans;

}

int main(){
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int tests = 1;
    //cin >> tests;

    for (int test = 1; test <= tests; test++){
        solve();
    }

    return 0;
}
