#include <bits/stdc++.h>

using namespace std;

#define MP make_pair

typedef long long ll;

const int N = 2e6 + 3e2;

int n;
int a[N], b[N];
ll pref[N];

bool check(int k){
    for (int i = 1; i <= n; i++){
        int l = max(1, i - k), r = min(n, i + k);
        if (pref[r] - pref[l - 1] < a[i]) return false;
    }

    return true;
}

void solve(){
    cin >> n;
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= n; i++){
        cin >> b[i];
        pref[i] = pref[i - 1] + b[i];
    }

    if (accumulate(a + 1, a + n + 1, 0ll) > pref[n]){
        cout << -1;
        return;
    }

    int ans = -1;

    int l = 0, r = n - 1;
    while (l <= r){
        int m = (l + r) >> 1;
        if (check(m)){
            ans = m;
            r = m - 1;
        } else l = m + 1;
    }

    cout << ans;

}

int main(){
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int tests = 1;
    //cin >> tests;

    for (int test = 1; test <= tests; test++){
        solve();
    }

    return 0;
}
