#include <bits/stdc++.h>

using namespace std;

#define MP make_pair

typedef long long ll;

const int N = 1e6 + 3e2;

int n;
ll a[N], b[N];
ll c[N];

bool check(int k){
    for (int i = 1; i <= n; i++) c[i] = b[i] - a[i];

    //cout << k << endl;
    deque<int> dq;

    for (int i = 1; i <= n; i++){
        if (c[i] > 0) dq.push_back(i);
    }

    for (int i = 1; i <= n; i++){
        while (!dq.empty()){
            if (c[i] >= 0) break;
            int j = dq.front();
         //   cout << i << ' ' << j << ' ' << c[j] << endl;
            if (j < i - k || c[j] <= 0){
                dq.pop_front();
                continue;
            }

            if (j <= i + k){
                ll x = min(-c[i], c[j]);
                c[j] -= x;
                c[i] += x;
                if (c[j] == 0) dq.pop_front();
            } else break;
        }
        if (c[i] < 0) return false;
    }

    return true;
}

void solve(){
    cin >> n;
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= n; i++) cin >> b[i];

    int ans = -1;

    int l = 0, r = n - 1;
    while (l <= r){
        int m = (l + r) >> 1;
        if (check(m)){
            ans = m;
            r = m - 1;
        } else l = m + 1;
    }

    cout << ans;

}

int main(){
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int tests = 1;
    //cin >> tests;

    for (int test = 1; test <= tests; test++){
        solve();
    }

    return 0;
}
