#include <bits/stdc++.h>

using namespace std;

#define MP make_pair

typedef long long ll;

const int N = 1e6 + 3e2;

int cnt[N];

bool rec(vector<string> s){
    int n = s.size();
    if (n == 1) return true;
    for (int i = 0; i < n; i++){
        bitset<26> b;
        for (char ch : s[i]){
            b[ch - 'a'] = true;
        }

        for (int i = 0; i < 26; i++){
            if (b[i]) cnt[i]++;
        }
    }

    map<string, vector<string>> mp;
    for (int i = 0; i < n; i++){
        string t = s[i];
        for (char &ch : t){
            if (cnt[ch - 'a'] != n) ch = '?';
        }
        mp[t].push_back(s[i]);
    }

    bool ok = true;
    for (auto now : mp){
        if (now.second.size() == n) return false;
        if (!rec(now.second)) ok = false;
    }

    return ok;
}

void solve(){
    int len, n;
    cin >> len >> n;

    vector<string> s(n);
    for (int i = 0; i < n; i++){
        cin >> s[i];
    }

    cout << (rec(s) ? "YES" : "NO");

}

int main(){
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int tests = 1;
    //cin >> tests;

    for (int test = 1; test <= tests; test++){
        solve();
    }

    return 0;
}
