#include <bits/stdc++.h>

using namespace std;


const int MAXN = 1e5 * 26 + 1;
vector <int> groups[MAXN];

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	int l, n;
	cin >> l >> n;
	vector <string> dict(n);
	for(auto &i : dict)
		cin >> i;

	for(int i = 0; i < n; i++)
		groups[0].push_back(i);

	int last = 1;

	bool istrue = true;

	for(int i = 0; groups[i].size(); i++){
		if(groups[i].size() == 1)
			continue;
		vector <int> cnt(26, 0);
		int eq = 0;
		for(int j : groups[i]){
			vector <bool> used(26, false);
			for(auto k : dict[j])
				used[k - 'a'] = true;
			for(int j = 0; j < 26; j++)
				cnt[j] += used[j];
		}
		unordered_map <string, int> newind;
		for(int j : groups[i]){
			string s = dict[j];
			for(auto &k : s){
				if(cnt[k - 'a'] != groups[i].size())
					k = '#';
			}
			if(!newind.count(s))
				newind[s] = last++;
			groups[newind[s]].push_back(j);
		}
		if(newind.size() == 1){
			istrue = false;
			break;
		}
	}

	if(!istrue)
		cout << "NO\n";
	else
		cout << "YES\n";

	return 0;
}
