#include <bits/stdc++.h>

#define ll long long
#define ull unsigned long long
#define ALL(c) (c).begin(), (c).end()
#define RALL(c) (c).rbegin(), (c).rend()
#define ios ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

using namespace std;

int n;
vector <int> a, b;

bool ok(int k) {
    int it_l = 0, it_r = 0;
    vector <int> tmp = a;
    for (int i = 0; i < n; ++i) {
        if (tmp[i] == 0) continue;
        while (it_l < i - k) it_l++;
        it_r = max(it_r, i + 1);
        while (it_r > i + k) it_r--;
        while (it_l < i) {
            if (tmp[it_l] < b[it_l]) {
                int d = min(b[it_l] - tmp[it_l], tmp[i]);
                tmp[it_l] += d;
                tmp[i] -= d;
                if (tmp[i] == 0) break;
            }
            it_l++;
        }
        if (tmp[i] == 0) continue;
        while (it_r < n && it_r <= i + k) {
            if (tmp[it_r] < b[it_r]) {
                int d = min(b[it_r] - tmp[it_r], tmp[i]);
                tmp[it_r] += d;
                tmp[i] -= d;
                if (tmp[i] == 0) break;
            }
            it_r++;
        }
    }
//    cout << k << ":\n";
//    for (int i = 0; i < n; ++i) {
//        cout << tmp[i] << " ";
//    }
//    cout << "\n\n";
    for (int i = 0; i < n; ++i) {
        if (tmp[i] > b[i]) return false;
    }
    return true;
}

signed main() {
    ios;
    cin >> n;
    a.resize(n);
    b.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    int l = -1, r = n + 1;
    while (l < r - 1) {
        int m = (l + r) / 2;
        if (ok(m)) r = m;
        else l = m;
    }
    if (l == n) cout << -1;
    else cout << r;
}
