#include <bits/stdc++.h>

#define ll long long
#define int long long
#define ull unsigned long long
#define ALL(c) (c).begin(), (c).end()
#define RALL(c) (c).rbegin(), (c).rend()
#define ios ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

using namespace std;

int n;
vector <int> a, b;

bool ok(int k) {
    vector <int> can = a, tmp = a;
    int i = 0, j = n - 1;
    int l_border = 0, r_border = n - 1;
    bool ok = true;
    while (i <= j && ok) {
        ok = false;
        while (i < n && i <= j) {
            if (tmp[i] == 0) {
                i++;
                continue;
            }
            if (l_border < i - k) l_border = i - k;
            int tmp_l = l_border;
            while (tmp_l < i && tmp[i] != 0) {
                if (tmp[tmp_l] < b[l_border]) {
                    int d = min(b[tmp_l] - tmp[tmp_l], min(can[i], tmp[i]));
                    tmp[tmp_l] += d;
                    can[i] -= d;
                    tmp[i] -= d;
                    if (d != 0) ok = true;
                    if (tmp[tmp_l] == b[tmp_l] && l_border < tmp_l + 1) l_border = tmp_l + 1;
                    if (tmp[i] == 0) break;
                }
                tmp_l++;
            }
            if (tmp[i] > b[i]) break;
            i++;
        }
        while (j >= 0 && j >= i) {
            if (tmp[j] == 0) {
                j--;
                continue;
            }
            if (r_border > j + k) r_border = j + k;
            int tmp_r = r_border;
            while (tmp_r > j && tmp[j] != 0) {
                if (tmp[tmp_r] < b[tmp_r]) {
                    int d = min(b[tmp_r] - tmp[tmp_r], min(can[j], tmp[j]));
                    tmp[tmp_r] += d;
                    can[j] -= d;
                    tmp[j] -= d;
                    if (d != 0) ok = true;
                    if (tmp[tmp_r] == b[tmp_r] && r_border > tmp_r - 1) r_border = tmp_r - 1;
                    if (tmp[j] == 0) break;
                }
                tmp_r--;
            }
            if (tmp[j] > b[j]) break;
            j--;
        }
    }
    for (int t = 0; t < n; ++t) {
        if (tmp[t] > b[t]) return false;
    }
    return true;
}

signed main() {
    ios;
    cin >> n;
    a.resize(n);
    b.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    int l = -1, r = n + 1;
    while (l < r - 1) {
        int m = (l + r) / 2;
        if (ok(m)) r = m;
        else l = m;
    }
    if (l == n) cout << -1;
    else cout << r;
}
