#include <bits/stdc++.h>

using namespace std;

#define double long double

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<double> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<double> pmax(n), pmin(n), smax(n), smin(n);
    pmax[0] = a[0];
    pmin[0] = a[0];
    for (int i = 1; i < n; i++) {
        pmax[i] = max(pmax[i - 1], a[i]);
        pmin[i] = min(pmin[i - 1], a[i]);
    }
    smin[n - 1] = a[n - 1];
    smax[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        smin[i] = min(smin[i + 1], a[i]);
        smax[i] = max(smax[i + 1], a[i]);
    }
    cout << fixed << setprecision(20) << 1.0 << ' ';
    for (int i = 1; i < n; i++) {
        auto check = [&](double t) ->double{
            double smx = smax[i] * (1.0 - t);
            double smn = smin[i] * (1.0 - t);
            return max({pmax[i-1], smx, smn, (smn+smx)/2.0*(1-t)}) - min({pmin[i-1], smn, smx, (smn+smx)/2.0*(1-t)});
        };
        vector<double> ts;
        ts.push_back(0.0);
        ts.push_back(1.0);
        ts.push_back(1.0 - pmax[i-1]/smax[i]);
        ts.push_back(1.0 - pmin[i-1]/smin[i]);
        ts.push_back(1.0 - pmax[i-1]/smin[i]);
        ts.push_back(1.0 - pmin[i-1]/smax[i]);
        sort(ts.begin(), ts.end(), [&](double a, double b) {
            if (check(a) <= check(b)) return true;
            return false;
        });
        for (double x : ts) {
            if (x >= 0) {
                cout << fixed << setprecision(9) << x << ' ';
                break;
            }
        }
    }
    return 0;
}
