﻿#include <iostream>
#include <vector>
#include <set>
#include<map>
#include<deque>
#include <algorithm>

using namespace std;

typedef long long ll;

template<typename T> istream& operator>>(istream& in, vector<T>& a) { for (int i = 0; i < a.size(); ++i) in >> a[i]; return in; }
template<typename T> ostream& operator<<(ostream& out, vector<T>& a) { for (int i = 0; i < a.size(); ++i) out << a[i] << ' '; return out;}

template<typename T1, typename T2> istream& operator>>(istream& in, pair<T1, T2> &p){ in >> p.first >> p.second; return in; }
template<typename T1, typename T2> ostream& operator<<(ostream& out, pair<T1, T2> &p) { out << p.first << ' ' << p.second; return out; }



#define all(x) x.begin(),x.end()
#define range(i,n) for (int i=0;i<n;++i)
#define rrange(i,n) for (int i=n-1;i>=0;--i)


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    cin >> a >> b;
    ll s1 = 0, s2 = 0;
    range(i, n) {
        s1 += a[i];
        s2 += b[i];
    }
    if (s1 > s2) {
        cout << -1;
        return 0;
    }
    auto ok = [&](int m,vector<int> a,vector<int> b) {
        deque <pair<int, ll>> que;
        deque < pair<int, ll>> st;
        // index cnt
        range(i, n) {
            if (st.size() && st.front().first + m < i) return 0;
            while (que.size() && que.front().first + m < i) que.pop_front();

                if (0 && m == 1) {
                    cout << "====\n";
                    for (auto i : que) cout << i << "   "; cout << '\n';
                    for (auto i : st) cout << i << "   "; cout << '\n';
                    cout << "===\n";
                }
            while (st.size() && que.size()) {
                if (st.front().second >= que.front().second) {
                    st.front().second -= que.front().second;
                    if (st.front().second == 0ll) st.pop_front();
                    que.pop_front();
                }
                else {
                    que.front().second -= st.front().second;
                    st.pop_front();
                }
            }

            while (a[i] && que.size()) {

                if (0 && m == 1) cout << "!!!\n";

                if (a[i] >= que.front().second) {
                    a[i] -= que.front().second;
                    que.pop_front();
                }
                else {
                    que.front().second -= a[i];
                    a[i] = 0;
                }
            }
            
            while (st.size() && b[i]) {
                if (st.front().second > b[i]) {
                    st.front().second -= b[i];
                    b[i] = 0;
                }
                else {
                    b[i] -= st.front().second;
                    st.pop_front();
                }
            }
            if (a[i] >= b[i]) {
                a[i] -= b[i];
                b[i] = 0;
                st.push_back({ i,a[i] });
            }
            else {
                b[i] -= a[i];
                a[i] = 0;
                que.push_back({ i,b[i] });
            }
            
        }
        //cout << "~! " << m << '\n';
        //cout << a << '\n';
        //cout << "===\n";
        //for (auto i : que) cout << i << "   "; cout << '\n';
        //for (auto i : st) cout << i << "   "; cout << '\n';
        //cout << "===\n";
        //for (auto i : st) cout << i << '\n';
        //cout << '\n';


        for (auto i:st) if (i.second) return 0;
        return 1;
    };
    //cout << "!!!!!! " << ok(1);
    //return 0;
    int l = -1, r = n + 1;
    while (r - l > 1) {
        //cout << l << ' ' << r << '\n';
        int m = (l + r) / 2;
        //cout << "! " << m << ' ' << ok(m) << '\n';
        if (!ok(m,a,b))
            l = m;
        else
            r = m;
    }
    cout << r;
}
