﻿#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <map>
#include <set>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <numeric>
#include <climits>
#include <random>
#include <fstream>
#include <cstdlib>
#include <bitset>
#include <deque>
#include <iterator>

using namespace std;

template <typename T> inline T getint() {
	T val = 0;
	char c;
	bool neg = false;
	while ((c = getchar()) && !(c >= '0' && c <= '9')) {
		neg |= c == '-';
	}
	do {
		val = (val * 10) + c - '0';
	} while ((c = getchar()) && (c >= '0' && c <= '9'));
	return val * (neg ? -1 : 1);
}

#define int long long
#define x first
#define y second
typedef long long ll;
typedef long double ld;
const ll INF = LLONG_MAX;

ll gcd(ll a, ll b) {
	return b ? gcd(b, a % b) : a;
}

const ll maxn = 1e5;
const ld eps = 1e-10;

signed main() {
	std::ios::sync_with_stdio(false);
	std::ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n; cin >> n;
	stack<ll> s1, s2;
	for (ll i = 0; i < n; i++)
	{
		ll k;
		cin >> k;
		s1.push(k);
		cout << "1\n";
	}
	for (ll now = 1; now < n + 1; now++)
	{
		while (s1.top() != now) {
			cout << "12\n";
			s2.push(s1.top());
			s1.pop();
		}
		cout << "-1\n";
		s1.pop();
		while (s2.size() != 0) {
			cout << "21\n";
			s1.push(s2.top());
			s2.pop();
		}
	}

}