#include <iostream>
#include <map>
#include <vector>
#include <cassert>
#include <algorithm>
#include <iomanip>
#include<bits/stdc++.h>
#include <cassert>
using namespace std;

#define ld long double
vector <vector <int>> a;
const ld eps = 1e-12;
ld calc1(int i, ld x) {
	return a[i][0] * x * x + a[i][1] * x + a[i][2];
}

pair <ld, ld> calc2(int i, ld y) {
	ld ans = (-a[i][1] - sqrt(a[i][1] * a[i][1] + 4 * (y - a[i][2]) * a[i][0])) / 2 / a[i][0];
	ld ans2 = (-a[i][1] + sqrt(a[i][1] * a[i][1] + 4 * (y - a[i][2]) * a[i][0])) / 2 / a[i][0];
	if (ans2 < ans) swap(ans, ans2);
	return { ans, ans2 };
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(12);
	int n; cin >> n;
	a.resize(n, vector <int>(3));
	for (auto& x : a)
		for (auto& y : x) cin >> y;

	ld L = -1e18, R = 1e18;
	for (int i = 0; i < n; ++i) {
		if (a[i][0] < 0)
			R = min(R, calc1(i, (ld)-a[i][1] / 2 / a[i][0]));
		else
			L = max(L, calc1(i, (ld)-a[i][1] / 2 / a[i][0]));
	}
	while (L + eps < R) {
		ld M1 = L + (R - L) / 3;
		ld M2 = M1 + (R - L) / 3;
		ld lx1 = -1e18, rx1 = +1e18, lx2 = -1e18, rx2 = 1e18;
		for (int i = 0; i < n; ++i) {
			auto get = calc2(i, M1);
			lx1 = max(lx1, get.first);
			rx1 = min(rx1, get.second);
			auto get2 = calc2(i, M2);
			lx2 = max(lx2, get2.first);
			rx2 = min(rx2, get2.second);
		}
		ld d1 = rx1 - lx1, d2 = rx2 - lx2;
		if (d1 > eps) {
			cout << lx1 + eps << ' ' << M1 << '\n';
			return 0;
		}
		if (d2 > 0) {
			cout << lx2 + eps << ' ' << M2 << '\n';
			return 0;
		}
		if (d1 < d2) L = M1;
		else R = M2;
	}
	return 0;

}