#include <iostream>
#include <map>
#include <vector>
#include <cassert>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;
#define all(t) (t).begin(), (t).end()
const ld eps = 1e-1;
const int MOD = 1e9 + 7;
#define int ll
#define debug(x) 

void mod(int& x) {
    x %= MOD;
    if (x < 0) x += MOD;
}
int slv(vector<int> a, vector<int> d) {
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {

        }
    }
    return 0;
}
struct minTree {
    int n;
    vector<int> mn; 
    minTree(int n) : n(n), mn(2 * n, 2e9) {}
    void set(int i, int x) {
        i += n;
        mn[i] = x;
        while (i > 0) {
            i /= 2;
            mn[i] = ::min(mn[2 * i], mn[2 * i + 1]);
        }
    }
    int get(int l, int r) {
        int res = 2e9;
        for (l += n, r += n; l < r; l /= 2, r /= 2) {
            if (l & 1) res = min(res, mn[l++]);
            if (r & 1) res = min(res, mn[--r]);
        }
        return res;
    }
};

struct sufStack {
    ll sum = 0;
    vector<pair<int, int>> stack;

    void minSuf(int i, int x) {
        while (!stack.empty() && stack.back().second >= x) {
            int sz = stack.size();
            sum -= stack[sz - 1].second * (stack[sz - 2].first - stack[sz - 1].first) % MOD;
            mod(sum);

            stack.pop_back();
        }
        stack.emplace_back(i, x);
        int sz = stack.size();
        sum += stack[sz - 1].second * (stack[sz - 2].first - stack[sz - 1].first) % MOD;
        mod(sum);
    }

    int firstExists() { return stack.empty() ? -1 : stack.back().first; }

    int sumExist() {
        return sum;
    }

    void init(int n) {
        stack.emplace_back(n - 1, -1);
    }
};

struct summator {
    vector<int> pref;

    summator() {}

    summator(vector<int> v) : pref(v.size() + 1, 0) {
        for (int i = 0; i < v.size(); ++i) pref[i + 1] = (pref[i] + v[i]) % MOD;
    }

    int get(int l, int r) {
        return (pref[r] - pref[l] + MOD) % MOD;
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n), delta(n);
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        a[i] = max(x, y);
        delta[i] = max(x, y) - min(x, y);
    }
    vector<int> pref(n + 1);
    for (int i = 0; i < n; ++i) pref[i + 1] = (pref[i] + a[i]) % MOD;
    vector<ll> hpref(n + 1);
    for (int i = 0; i < n; ++i) hpref[i + 1] = hpref[i] + a[i];
    map<int, vector<int>> indices;
    map<int, vector<int>> prefThis;
    map<int, summator> pts;
    for (int i = 0; i <= n; ++i) indices[hpref[i] % k].push_back(i);
    for (int i = 0; i <= n; ++i) prefThis[hpref[i] % k].push_back(pref[i]);
    for (auto& entry : indices) entry.second.push_back(n + 1);
    for (auto& entry : prefThis) pts[entry.first] = summator(entry.second);
    summator s(pref);
    map<int, sufStack> d;
    minTree mt(n+1);
    for (int i = 0; i < n; ++i) d[hpref[i] % k].init(indices[hpref[i] % k].size() - 1);
    int ans = 0;
    for (int i = n - 1; i >= 0; --i) {
        debug(ans)
            int rem = hpref[i] % k;
        int idx = lower_bound(indices[rem].begin(), indices[rem].end(), i) - indices[rem].begin();
        sufStack& stack = d[rem];
        if (delta[i] % k != 0) {
            mt.set(i, delta[i]);
        }
        int x = mt.get(i, indices[rem][idx + 1]); 
        if (x < 2e9) stack.minSuf(idx, x);
        debug(idx)
        debug(i)
        debug(indices[rem][idx + 1])
        debug(x)
        
        int j = stack.firstExists();
        if (j == -1) j = indices[rem].size() - 1;
        debug(j)
        ans += s.get(i + 1, n + 1);
        ans -= pts[rem].get(idx, j);
        ans %= MOD;
        ans -= pref[i] * (n - i - j + idx) % MOD;
        ans += MOD;
        ans %= MOD;
        ans -= stack.sumExist();
        debug(stack.sumExist())
        ans += MOD;
        ans %= MOD;
    }
    cout << ans << '\n';

}

signed main() {
    solve();
}