#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>

#define ll long long
#define ld long double

using namespace std;

vector<ld> max_parus(ld a1, ld a4, ld a2, ld a3) {
	if (a1 < a4) swap(a1, a4);
	if (a2 < a3) swap(a2, a3);
	if ((a1 - 1) * (a4 - 1) == (a2 - 1) * (a3 - 1)) {
		ld pr = a1 * a4 + a2 + a3;
		return { a1, a2, a3, a4, pr };
	}
	else if ((a1 - 1) * (a4 - 1) > (a2 - 1) * (a3 - 1)) {
		ld b = (a2 - 1) * (a3 - 1) / (a1 - 1) + 1;
		a4 = b;
		ld pr = a1 * a4 + a2 + a3;
		return { a1, a2, a3, a4, pr };
		/*if (b < a4) {
			ld k = sqrt((a2 - 1) * (a3 - 1)) + 1;
			a1 = k;
			a4 = k;
			ld pr = a1 * a4 + a2 + a3;
			return { a1, a2, a3, a4, pr };
		}
		else {
			a4 = b;
			ld pr = a1 * a4 + a2 + a3;
			return { a1, a2, a3, a4, pr };
		}*/
	}
	else if ((a1 - 1) * (a4 - 1) < (a2 - 1) * (a3 - 1)) {
		swap(a1, a2);
		swap(a4, a3);
		ld b = (a2 - 1) * (a3 - 1) / (a1 - 1) + 1;
		a4 = b;
		ld pr = a1 * a4 + a2 + a3;
		return { a1, a2, a3, a4, pr };
		/*if (b < a1) {
			ld k = sqrt((a2 - 1) * (a3 - 1)) + 1;
			a1 = k;
			a4 = k;
			ld pr = a1 * a4 + a2 + a3;
			return { a1, a2, a3, a4, pr };
		}
		else {
			a4 = b;
			ld pr = a1 * a4 + a2 + a3;
			return { a1, a2, a3, a4, pr };
		}*/
	}
}

int main() {
	cout.precision(10);
	ld a1, a2, a3, a4;
	vector<ld> ans = { -1, -1 , -1, -1, -1 };
	vector<ld> t;
	cin >> a1 >> a2 >> a3 >> a4;
	vector<ld> a = { a1, a2, a3, a4 };
	t = max_parus(a1, a2, a3, a4);
	if (t[4] > ans[4]) ans = t;
	t = max_parus(a1, a3, a2, a4);
	if (t[4] > ans[4]) ans = t;
	t = max_parus(a1, a4, a3, a2);
	if (t[4] > ans[4]) ans = t;
	vector<bool> use(4, true);
	vector<ll> res(4, -1);
	for (ll i = 0; i < 4; i++) {
		for (ll j = 0; j < 4; j++) {
			if (use[j] && a[i] == ans[j]) {
				res[i] = j + 1;
				use[j] = false;
				j = 5;
			}
		}
	}
	ll z = -1;
	ll y = -1;
	for (ll i = 0; i < 4; i++) {
		if (use[i]) z = i + 1;
		if (res[i] == -1) y = i;
	}
	if (z > 0) {
		res[y] = z;
	}
	for (ll i = 0; i < 4; i++) cout << res[i] << " ";
	cout << endl;
	for (ll i = 0; i < 4; i++) cout << ans[i] << " ";
}