#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>

#define ll long long
#define ld long double

using namespace std;

vector<ld> max_parus(ld a1, ld a4, ld a2, ld a3) {
	if (a1 < a4) swap(a1, a4);
	if (a2 < a3) swap(a2, a3);
	if ((a1 - 1) * (a4 - 1) == (a2 - 1) * (a3 - 1)) {
		ld pr = a1 * a4 + a2 + a3;
		return { a1, a2, a3, a4, pr };
	}
	else if ((a1 - 1) * (a4 - 1) > (a2 - 1) * (a3 - 1)) {
		ld b = (a2 - 1) * (a3 - 1) / (a1 - 1) + 1;
		a4 = b;
		ld pr = a1 * a4 + a2 + a3;
		return { a1, a2, a3, a4, pr };
		/*if (b < a4) {
			ld k = sqrt((a2 - 1) * (a3 - 1)) + 1;
			a1 = k;
			a4 = k;
			ld pr = a1 * a4 + a2 + a3;
			return { a1, a2, a3, a4, pr };
		}
		else {
			a4 = b;
			ld pr = a1 * a4 + a2 + a3;
			return { a1, a2, a3, a4, pr };
		}*/
	}
	else if ((a1 - 1) * (a4 - 1) < (a2 - 1) * (a3 - 1)) {
		swap(a1, a2);
		swap(a4, a3);
		ld b = (a2 - 1) * (a3 - 1) / (a1 - 1) + 1;
		a4 = b;
		ld pr = a1 * a4 + a2 + a3;
		return { a3, a4, a1, a2, pr };
		/*if (b < a1) {
			ld k = sqrt((a2 - 1) * (a3 - 1)) + 1;
			a1 = k;
			a4 = k;
			ld pr = a1 * a4 + a2 + a3;
			return { a1, a2, a3, a4, pr };
		}
		else {
			a4 = b;
			ld pr = a1 * a4 + a2 + a3;
			return { a1, a2, a3, a4, pr };
		}*/
	}
}

int main() {
	cout.precision(10);
	ld a1, a2, a3, a4;
	vector<ld> ans = { -1, -1 , -1, -1, -1 };
	vector<ld> t;
	cin >> a1 >> a2 >> a3 >> a4;
	vector<ld> a = { a1, a2, a3, a4 };
	t = max_parus(a1, a2, a3, a4);
	if (t[4] > ans[4]) ans = t;
	t = max_parus(a1, a3, a2, a4);
	if (t[4] > ans[4]) ans = t;
	t = max_parus(a1, a4, a3, a2);
	if (t[4] > ans[4]) ans = t;
	vector<int> used(4, -1), g(4, -1);
	int ituz = -1;
	for (int i = 0; i < 4; ++i) {
		for (int j = 0; j < 4; ++j) {
			if (a[i] == ans[j] && used[i] == -1 && g[j] == -1) {
				used[i] = j;
				g[j] = i;
			}
		}
		if (used[i] == -1) ituz = i;
	}
	if (ituz != -1) {
		for (int j = 0; j < 4; ++j) {
			if (used[ituz] == -1 && g[j] == -1) {
				used[ituz] = j;
				g[j] = ituz;
			}
		}
	}
	for (int i = 0; i < 4; ++i) cout << g[i] + 1 << " ";
	cout << endl;
	for (ll i = 0; i < 4; i++) cout << ans[i] << " ";
}