#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,popcnt")

#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define ll long long
#define ld long double

#define double ld
#define endl '\n'

using namespace std;

const ll p = 239;
const ll mod = 1e9 + 7;

const int maxl = 1e6;

ll pr[maxl] ;

void precalc() {
    pr[0] = 1;
    for (int i = 1; i < maxl; ++i) {
        pr[i] = (pr[i - 1] * p) % mod;
    }
}

deque<vector<int>> gr(1);
deque<bitset<26>> ban(1);

void solve() {
    int l, n;
    cin >> l >> n;
    vector<string> arr(n);
    for (auto & e : arr)
        cin >> e;

    for (int i = 0; i < n; ++i)
        gr.back().push_back(i);

    map<ll, vector<int>> new_groups;

    while (gr.size()) {
        if (gr.front().size() <= 1) {
            gr.pop_front();
            ban.pop_front();
            continue;
        }

        bitset<26> aval = ~ban.back();

        for (int i : gr.front()) {
            bitset<26> has;
            for (char ch : arr[i])
                has[ch - 'a'] = true;
            aval = aval & has;
        }

        if (aval.count() == 0) {
            cout << "NO" << endl;
            return;
        }

        int u = -1;
        for (int c = 0; c < 26; ++c)
            if (aval[c])
                u = c;

        new_groups.clear();

        for (int i : gr.front()) {
            ll poses = 0;
            for (char x = 0; x < l; ++x)
                if (arr[i][x] - 'a' == u)
                    poses = (poses + pr[x]) % mod;
            new_groups[poses].push_back(i);
        }

        bitset<26> tmpp = ban.front();
        tmpp[u] = true;

        gr.pop_front();
        ban.pop_front();

        for (auto e : new_groups) {
            if (e.y.size() > 1) {
                gr.push_back(e.y);
                ban.push_back(tmpp);
            }
        }

    }

    cout << "YES" << endl;
}

signed main() {
#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL
    precalc();
    solve();
}


