#include <iostream>
#include <cmath>
#include <ctime>
#include <fstream>
#include <vector>
#include <iomanip>

using namespace std;

/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")*/

typedef long long ll;
typedef double ld;
using vll = vector<ll>;

#define pb push_back
#define eb emplace_back
#define ff first
#define ss second
#define show(x) cerr << (#x) << "=" << x << '\n'
#define ptree_node tree_node*
#define sqr(a) ((a) * (a))
#define all(x) (x).begin(), (x).end()

const int INF = 1e9;
const ld EPS = 1e-8;
const ld PI = atan2(0.0, -1.0);
const int M = 1e9;
const int MAXN = 2 * 1e5;


#define fast(){ \
    ios_base::sync_with_stdio(0); \
    cin.tie(0); \
}

ll n, x;
vector<ld> v, vmn, vmx, pr;


int main() {
	#ifdef _LOCAL
        clock_t Tsart = clock();
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
	fast();

	cin >> n;
	for (int i = 0; i < n; i++){
		cin >> x;
		v.pb(x);
	}
	vmn.resize(n);
	vmx.resize(n);
	vmn[n - 1] = vmx[n - 1] = v[n - 1];
	for (int i = n - 2; i >= 0; i--){
		vmn[i] = min(vmn[i + 1], v[i]);
		vmx[i] = max(vmx[i + 1], v[i]);
	}
	ld mn, mx;
	mn = mx = v[0];
	cout << 1 << ' ';
	for (int i = 1; i < n; i++){
		ld t1 = min((ld)1, mx / vmx[i]), t2 = min((ld) 1, mn / vmn[i]), t3 = min((ld) 1, mn / vmx[i]), t4 = 0, t5 = 1, ans = -1;
		ld k = min(max(mx, vmx[i] * t1) - min(mn, vmn[i] * t1), min(max(mx, vmx[i] * t2) - min(mn, vmn[i] * t2), min(max(mx, vmx[i] * t3) - min(mn, vmn[i] * t3),
			min(max(mx, vmx[i] * t4) - min(mn, vmn[i] * t4), max(mx, vmx[i] * t5) - min(mn, vmn[i] * t5)))));
		//cout << '\n' << k << '\n';
		if (max(mx, vmx[i] * t1) - min(mn, vmn[i] * t1) == k)
			ans = max(1 - t1, ans);
		if (max(mx, vmx[i] * t2) - min(mn, vmn[i] * t2) == k)
			ans = max(1 - t2, ans);
		if (max(mx, vmx[i] * t3) - min(mn, vmn[i] * t3) == k)
			ans = max(1 - t3, ans);
		if (max(mx, vmx[i] * t4) - min(mn, vmn[i] * t4) == k)
			ans = max(1 - t4, ans);
		if (max(mx, vmx[i] * t5) - min(mn, vmn[i] * t5) == k)
			ans = max(1 - t5, ans);
		mn = min(mn, v[i]);
		mx = max(mx, v[i]);
		cout << fixed << setprecision(9) << ans << ' ';
	}

	#ifdef _LOCAL
    	cerr << "Runtime: " << (ld)(clock() - Tsart) / CLOCKS_PER_SEC << '\n';
	#endif
	return 0;
}