#include <iostream>
#include <cmath>
#include <ctime>
#include <fstream>
#include <vector>
#include <iomanip>
#include <algorithm>
 
using namespace std;
 
/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")*/
 
typedef long long ll;
typedef double ld;
using vll = vector<ll>;
 
#define pb push_back
#define eb emplace_back
#define ff first
#define ss second
#define show(x) cerr << (#x) << "=" << x << '\n'
#define ptree_node tree_node*
#define sqr(a) ((a) * (a))
#define all(x) (x).begin(), (x).end()
#define int long long
const int INF = 1e9;
const ld EPS = 1e-8;
const ld PI = atan2(0.0, -1.0);
const int M = 1e9;
const int MAXN = 2 * 1e5;
 
 
#define fast(){ \
    ios_base::sync_with_stdio(0); \
    cin.tie(0); \
}
 
 
vector<pair<string, array<int, 26>>> s;
int B;
array<int, 26> used1;
 
 
bool _comp(pair<string, array<int, 26>> a, pair<string, array<int, 26>> b) {
    return a.second[B] < b.second[B];
}
 
 
int find_sym(int l, int r) {
    array<bool, 26> ch;
    for (int i = 0; i < 26; i++)
        ch[i] = true;
    for (int i = l; i < r; i++) {
        for (int j = 0; j < 26; j++) {
            ch[j] &= (s[i].second[j] > 0 ? 1 : 0);
        }
    }
    for (int i = 0; i < 26; i++) {
        if (ch[i] && !used1[i]) {
            return i;
        }
    }
    return -1;
}
 
 
 
bool check(int l, int r, array<int, 26> used) {
    //`cout << l << ' ' << r << '\n';
    if (r - l == 1)
        return true;
    used1 = used;
    int b = find_sym(l, r);
    if (b == -1)
        return false;
    used[b] = 1;
    B = b;
    // cout << char(b + 'a') << '\n';
    sort(s.begin() + l, s.begin() + r, _comp);
    // cout << "-- " << s[l].second[b] << ' ' << s[l + 1].second[b] << '\n';
    int nl, nr;
    nl = l;
    nr = l;
    for (; nr <= r; nr++) {
        if (nr == r || s[nl].second[b] != s[nr].second[b]) {
            if (check(nl, nr, used) == false)
                return false;
            nl = nr;
        }
    }
 
    return true;
}
 
 
 
signed main() {
    #ifdef _LOCAL
        clock_t Tsart = clock();
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    fast();
 
    int L, N;
    cin >> L >> N;
    s.resize(N);
    for (int i = 0; i < N; i++)
        cin >> s[i].first;
    for (int i = 0; i < N; i++) {
        for (auto b = 'a'; b <= 'z'; b++) {
            int c = 0;
            for (int j = 0; j < s[i].first.size(); j++) {
                if (s[i].first[j] == b) {
                    s[i].second[b - 'a'] += c * (L + 1) + (j + 1);
                    c++; 
                }
            }
        }
    }
    cout << (check(0, N, used1) ? "YES\n" : "NO\n");
 
    #ifdef _LOCAL
        cerr << "Runtime: " << (ld)(clock() - Tsart) / CLOCKS_PER_SEC << '\n';
    #endif
    return 0;
}