//package VKOSHP;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.StringTokenizer;

public class I2 {
    private static String[] arr;
    private static char[] alf;
    private static int l, n;
    private static long p, check;
    private static boolean res;
    private static long[] pow;

    private static void dfs(ArrayList<Integer> indexes, int depth) {
        if (depth==26) {
            if (indexes.size()>1) {
                res = false;
            }
            return;
        }
        HashMap<Long, ArrayList<Integer>> map = new HashMap<>();
        char currElem = alf[depth];
        for (int ind:indexes) {
            long hash = 0;
            for (int i=0; i<l; i++) {
                if (arr[ind].charAt(i)==currElem) hash+=(2 * pow[i]);
                else hash+=pow[i];
            }
            //if (currElem=='l') System.out.println("1 "+bin);
            map.putIfAbsent(hash, new ArrayList<>());
            ArrayList<Integer> list = map.get(hash);
            list.add(ind);
            map.replace(hash, list);
        }
        if (map.containsKey(check)) dfs(indexes, depth+1);
        else {
            for (long key:map.keySet()) {
                dfs(map.get(key), depth+1);
            }
        }
    }

    public static void main(String[] args) {
        Reader myReader = new Reader();
        l = myReader.nextInt(); n = myReader.nextInt();
        arr = new String[n];
        for (int i=0; i<n; i++) {
            arr[i] = myReader.nextToken();
        }
        alf = new char[]{'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z'};
        ArrayList<Integer> start = new ArrayList<>();
        for (int i=0; i<n; i++) start.add(i);
        res = true;
        pow = new long[l];
        pow[0] = 1;
        p = 31;
        for (int i=1; i<l; i++) {
            pow[i] = pow[i-1] * p;
        }
        for (int i=0; i<l; i++) check+=pow[i];
        dfs(start, 0);
        if (res) System.out.println("YES");
        else System.out.println("NO");
    }

    static class Reader {
        BufferedReader reader;
        StringTokenizer st;

        Reader() {
            reader = new BufferedReader(new InputStreamReader(System.in));
        }

        String nextToken() {
            try {
                if (st==null || !st.hasMoreElements()) st = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                e.printStackTrace();
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(nextToken());
        }
    }
}