﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;
vector<int> a, b, r;
int n;

bool check(int m) {
    int free = 0;
    for (int i = 0; i < n; i++) {
        r[i] = b[i] - a[i];
    }
    for (int i = 0; i < n; i++) {
        if (r[i] >= 0) continue;
        int cur = -r[i];
        free = max(free, i - m);
        while (free < n && i + m >= free && cur > 0) {
            if (r[free] > 0) {
                if (cur <= r[free]) {
                    r[free] -= cur;
                    cur = 0;
                }
                else {
                    cur -= r[free];
                    r[free] = 0;
                    free++;
                }
            }
            else {
                free++;
            }
        }
        r[i] = -cur;
    }
/*    cout << m << '\n';
    for (auto it : r) {
        cout << it << ' ';
    }
    cout << '\n';*/
    for (int i = 0; i < n; i++) {
        if (r[i] < 0) return false;
    }
    return true;
}


int main()
{
    cin >> n;
    r.resize(n);
    a.resize(n);
    b.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    int l = 0, r = n;
    while (r - l > 1) {
        int m = (r + l) / 2;
        int j = 0;
        if (check(m)) {
            r = m;
        }
        else {
            l = m;
        }
    }
    int ans;
    if (check(l)) ans = l;
    else ans = r;
    if (check(ans)) {
        cout << ans;
    }
    else {
        cout << -1;
    }
}
