﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <random>
using namespace std;
typedef long long ll;
int n, l;
mt19937 rnd(228228227);
vector<pair<string, int>> v;
vector<char> ans;
vector<vector<ll>> p;
vector<bool> used(26, false);
void solve(int l, int r) {
    if (r - l <= 1) {
        return;
    }
    for (int j = 0; j < 26; j++) {
        if (used[j]) {
            continue;
        }
        bool f = true;
        for (int i = l; i < r; i++) {
            if (p[v[i].second][j] == 0) {
                f = false;
                break;
            }
        }
        if (f) {
            sort(v.begin() + l, v.begin() + r, 
                [&](pair<string, int>& a, pair<string, int>& b) {
                    return p[a.second][j] < p[b.second][j];
                });
            used[j] = true;
            for (int i = l; i < r; ) {
                int k = i;
                while (k < r && p[v[i].second][j] == p[v[k].second][j]) {
                    k++;
                }
                solve(i, k);
                i = k;
            }
            used[j] = false;
            return;
        }
    }
    cout << "NO";
    exit(0);
}
signed main()
{   
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> l >> n;
    v.resize(n);
    p.resize(n, vector<ll>(26, 0));
    for (int i = 0; i < n; i++) {
        cin >> v[i].first;
        v[i].second = i;
    }
    int MOD = 228228227;
    vector<int> q(l);
    for (int i = 0; i < l; i++) {
        q[i] = rnd() % MOD + 1;
    }
    for (int i = 0; i < n; i++) {
        for (int k = 0; k < l; k++) {
            p[i][v[i].first[k] - 'a'] += q[k];
        }
    }
    for (int i = 0; i < 26; i++) {
        ans.push_back('a' + i);
    }
    solve(0, n);
    cout << "YES";
}
