#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <list>
#include <queue>
#include <deque>
#include <ctime>
#include <chrono>
#include <random>
#include <bitset>
#include <stack>
#include <cstring>
#define fast cin.tie(0);cout.tie(0);cin.sync_with_stdio(0);cout.sync_with_stdio(0)
#define F first
#define S second
#define pq priority_queue
#define umap unordered_map
#define uset unordered_set
#define pb push_back
#define sqr(x) ((x)*(x))
#define fill(v,n) for(int qqq=0;qqq<n;qqq++)cin>>v[qqq]
#define seed (myclock::now() - beginning).count()
#define mod 998244353
#define eps 1e-7
#define BIL 1000000000ll
#define INF sqr(2 * BIL)

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ull, ull> pull;
typedef long double ld;
typedef pair<ld, ld> pld;
typedef chrono::high_resolution_clock myclock;

int main() {
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	fill(a, n);
	fill(b, n);
	int l = 0, r = n - 1;
	auto check = [&](int k) -> bool {
		vector<int> A = a, B = b;
		int pos = 0; // where to push
		for (int i = 0; i < n; i++) {
			pos = max(pos, i - k);
			while (A[i]) {
				if (pos == n) return 0;
				if (A[i] <= B[pos]) {
					B[pos] -= A[i];
					A[i] = 0;
				}
				else {
					A[i] -= B[pos];
					B[pos] = 0;
					pos++;
				}
			}
			if (pos > i + k) return 0;
		}
		return 1;
	};
	if (!check(n - 1)) {
		cout << -1;
		exit(0);
	}
	if (check(0)) {
		cout << 0;
		exit(0);
	}
	while (l < r - 1) {
		int mid = (l + r) / 2;
		if (check(mid))
			r = mid;
		else l = mid;
	}
	if (check(l)) r = l;
	cout << r;
}