#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <list>
#include <queue>
#include <deque>
#include <ctime>
#include <chrono>
#include <random>
#include <bitset>
#include <stack>
#include <cstring>
#define fast cin.tie(0);cout.tie(0);cin.sync_with_stdio(0);cout.sync_with_stdio(0)
#define F first
#define S second
#define pq priority_queue
#define umap unordered_map
#define uset unordered_set
#define pb push_back
#define sqr(x) ((x)*(x))
#define fill(v,n) for(int qqq=0;qqq<n;qqq++)cin>>v[qqq]
#define seed (myclock::now() - beginning).count()
#define mod 998244353
#define eps 1e-10
#define BIL 1000000000ll
#define INF sqr(2 * BIL)

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ull, ull> pull;
typedef long double ld;
typedef pair<ld, ld> pld;
typedef chrono::high_resolution_clock myclock;

struct window {
	deque<int> min, max;

	void push(int val) {
		while (max.size() && val > max.back())
			max.pop_back();
		max.push_back(val);
		while (min.size() && val < min.back())
			min.pop_back();
		min.push_back(val);
	}

	void pop(int val) {
		if (max[0] == val)
			max.pop_front();
		if (min[0] == val)
			min.pop_front();
	}

	int get_max() {
		return max[0];
	}

	int get_min() {
		return min[0];
	}
};

ld count(ld pref_max, ld pref_min, ld suf_max, ld suf_min, ld k) {
	ld mx = max(pref_max, suf_max * (1 - k));
	ld mn = min(pref_min, suf_min * (1 - k));
	return mx - mn;
}

int main() {
	int n;
	cin >> n;
	vector<int> v(n);
	fill(v, n);
	window w;
	for (int i : v)
		w.push(i);
	cout << fixed << setprecision(12) << "1 ";
	int mn = v[0], mx = v[0];
	for (int i = 1; i < n; i++) {
		w.pop(v[i - 1]);
		int sufmax = w.get_max(), sufmin = w.get_min();
		ld L = 0, R = 1;
		while (R - L > eps) {
			ld l = L + (R - L) / 3, r = R - (R - L) / 3;
			if (count(mx, mn, sufmax, sufmin, l) - count(mx, mn, sufmax, sufmin, r) > -eps)
				L = l;
			else R = r;
		}
		cout << R << " ";
		mn = min(mn, v[i]);
		mx = max(mx, v[i]);
	}
}