#include <bits/stdc++.h>
#include <bits/extc++.h>

//#define int long long

using namespace std;
using namespace __gnu_pbds;

#define all(x) begin(x), end(x)
#define sz(x) int(size(x))
#define rep(i, a, b) for (int (i) = (a); (i) < (b); ++(i))
#define pb push_back

typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long long ll;

template<class T>
using Tree = tree<T, null_type, less<T>, rb_tree_tag,
        tree_order_statistics_node_update>;

void fastio() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
}

signed main() {
    fastio();
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &x: a) cin >> x;
    vector<int> b(n);
    for (auto &x: b) cin >> x;

    ll c1 = 0, c2 = 0;
    for (auto x: a) c1 += x;
    for (auto x: b) c2 += x;

    if (c1 > c2) {
        cout << -1;
        return 0;
    }
    int l = -1, r = n;
    while (r - l > 1) {
        vector<int> ca(a);
        vector<int> cb(b);
        int m = (l + r) / 2;
        int pt2 = 0;
        bool ok = true;
        for (int i = 0; i < n; ++i) {
            pt2 = max(pt2, i - m);
            while (ca[i] != 0 && pt2 <= i + m) {
                int x = min(ca[i], cb[pt2]);
                ca[i] -= x;
                cb[pt2] -= x;
                if (ca[i] != 0) pt2++;
            }
        }
        for (int x : ca) if (x > 0) ok = false;
        if (ok) r = m;
        else l = m;
    }
    cout << r;
    return 0;
}