#include <iostream>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <numeric>
#include <chrono>
#include <cassert>
#include <cmath>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define int long long
using ll = long long;
using ld = long double;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n;
    std::cin >> n;
    std::vector<int> st1, st2;
    int ops = 0;
    for (int i = 0; i < n; i++) {
        int c;
        std::cin >> c;
        st1.push_back(c);
        std::cout << 1 << '\n';
        ops++;
    }

    while (!st1.empty() || !st2.empty()) {
        if (st2.empty()) {
            int mini = *min_element(all(st1));
            while (!st1.empty()) {
                int val = st1.back();
                st1.pop_back();
                if (val == mini) {
                    std::cout << -1 << '\n';
                    ops++;
                } else {
                    st2.push_back(val);
                    std::cout << 12 << '\n';
                    ops++;
                }
            }
        } else {
            int mini = *min_element(all(st2));
            while (!st2.empty()) {
                int val = st2.back();
                st2.pop_back();
                if (val == mini) {
                    std::cout << -2 << '\n';
                    ops++;
                } else {
                    st1.push_back(val);
                    std::cout << 21 << '\n';
                    ops++;
                }
            }
        }
    }
    std::cerr << ops << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
//    int t; cin >> t; while(t--) solve();
}
