//
// Created by olymp on 12.12.2021.
//
#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <iomanip>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define ar array
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;

using namespace std;
const ll INF = 2e18;

int tp[17];

vector<int> get2(vector<int> &v, int d) {
    vector<int> res;
    rep(i, v.size()) {
        if (i % 2 == 0) {
            res.push_back(v[i]);
            res.push_back(v[i] | d);
        } else {
            res.push_back(v[i] | d);
            res.push_back(v[i]);
        }
    }
    return res;
}

vector<int> get1(vector<int> &v, int d) {
    vector<int> res;
    rep(i, v.size()) {
        res.push_back(v[i]);
    }
    for(int i = (int)v.size() - 1; i >= 0; --i) {
        res.push_back(v[i] | d);
    }
    return res;
}


vector<int> get3(vector<int> &v, int d) {
    vector<int> res;
    rep(i, v.size()) {
        if (i % 2 == 1) {
            res.push_back(v[i]);
            res.push_back(v[i] | d);
        } else {
            res.push_back(v[i] | d);
            res.push_back(v[i]);
        }
    }
    return res;
}

int check(int n, vector<int> &v) {
    int mn = 1e9;
    int mx = -1e9;
    rep(j, n) {
        int cnt = 0;
        for(int i = 1; i < (int)v.size(); ++i) {
            int x = v[i] ^ v[i - 1];
            if (x & (1 << j)) cnt++;
        }
        if ((v[0] ^ v.back()) & (1 << j)) cnt++;
        mn = min(mn, cnt);
        mx = max(mx, cnt);
    }
    return mx - mn;
}

vector<int> gen(int n) {
    if (n == 1) return {0, 1};
    auto v = gen(n - 1);
    int d = 1 << (n - 1);
    auto v1 = get1(v, d);
    auto v2 = get2(v, d);
    auto v3 = get3(v, d);
    int r1 = check(n, v1);
    int r2 = check(n, v2);
    int r3 = check(n, v3);
    int mn = min({r1, r2, r3});
    assert(mn <= 2);
    if (mn == r1) {
        return v1;
    }
    if (mn == r2) {
        return v2;
    }
    return v3;
}

void solve() {
    gen(4);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout << setprecision(15) << fixed;
    int t = 1;
    rep(_, t) {
        solve();
    }
    return 0;
}