#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define int ll
#define pb push_back
#define pob pop_back
#define F first
#define S second

using pii = pair<int, int>;
using pld = pair<ld, ld>;
using vint = vector<int>;
using vpii = vector<pii>;
using ar3=array<int, 3>;
using ar4=array<int, 4>;
using va3=vector<ar3>;
using va4=vector<ar4>;
const int N = 1e5 + 5;
const int Inf = 4e18+7;

#define all(x) (x).begin(), (x).end()
#define range(i, n) for (int i = 0; i < n; ++i)
#define sz(a) int(a.size())

int n;
int a[N], b[N], c[N];
// const ld eps = 1e-18;
ld get_vtx(int i) {
	return ld(-b[i]) / (2 * a[i]);
}

ld get_f(int i, ld x) {
	return a[i] * x * x + b[i] * x + c[i];
}

pld get_seg(int i, ld h) {
	ld D = b[i] * b[i] - 4 * a[i] * (c[i] - h);
	// cerr << i << ' ' << h << ' ' <<  D << endl;
	// assert(D > 0);
	D = max(D, (ld)0); 
	ld x1 = (-b[i] - sqrt(D)) / (2 * a[i]);
	ld x2 = (-b[i] + sqrt(D)) / (2 * a[i]);
	if (x1 > x2) {
		swap(x2, x1);
	}
	return {x1, x2};
}

pld gs(vint &v, ld m) {
	ld lmr = Inf, rml = -Inf;
	for (int j: v) {
		// cerr << "j: " << j << ' ' << s.F << ' ' << 
		pld s = get_seg(j, m);
		lmr = min(lmr, s.S);
		rml = max(rml, s.F);
	}
	return {rml, lmr};
}

ld get_r(pld p1, pld p2) {
	return min(p1.S - p2.F, p2.S - p1.F);
}

void solve() {
	cin >> n;
	range(i, n) {
		cin >> a[i] >> b[i] >> c[i];
	}
	vint neg, pos;
	range(i, n) {
		if (a[i] > 0) {
			pos.pb(i);
		} else {
			neg.pb(i);
		}
	}
	vint amogus(n);
	iota(all(amogus), 0);
	if (sz(neg) == 0) {
		// pld seg = gs(amogus, Inf);
		// ld x = (seg.F + seg.S) / 2;
		cout << 0 << ' ' << "10000000000000000000000000000000000000000000000000000000000000000000000" << '\n';
		return;
	}
	if (sz(pos) == 0) {
		// pld seg = gs(amogus, -Inf);
		// ld x = (seg.F + seg.S) / 2;
		cout << 0 << ' ' << "-10000000000000000000000000000000000000000000000000000000000000000000000" << '\n';
		return;
	}
	ld y = -Inf;
	// range(i, n) {
	// 	cout << get_vtx(i) << ' ' << get_f(i, get_vtx(i)) << '\n';
	// }
	for (int i: pos) {
		y = max(y, get_f(i, get_vtx(i)));
	}
	ld yy = Inf;
	for (int i: neg) {
		yy = min(yy, get_f(i, get_vtx(i)));
	}
	ld lb = y, rb = yy;
	// while (rb - lb > eps) {
	range(i, 100) {
		ld m = (lb + rb) / 2;
		pld sus = gs(pos, m);
		ld rml = sus.F, lmr = sus.S;
		if (rml < lmr) {
			rb = m;
		} else {
			lb = m;
		}
	}
	ld pos_h = rb;
	lb = y, rb = yy;
	range(i, 100) {
	// while (rb - lb > eps) {
		ld m = (lb + rb) / 2;
		pld sus = gs(neg, m);
		ld rml = sus.F, lmr = sus.S;
		if (rml < lmr) {
			lb = m;
		} else {
			rb = m;
		}
	}
	ld neg_h = lb;
	lb = pos_h, rb = neg_h;
	range(i, 100) {
	// while (rb - lb > eps) {
		ld m1 = lb + (rb - lb) / 3;
		ld m2 = lb + (rb - lb) * 2 / 3;

		ld r1 = get_r(gs(pos, m1), gs(neg, m1));
		ld r2 = get_r(gs(pos, m2), gs(neg, m2));
		if (r1 < r2) {
			lb = m1;
		} else {
			rb = m2;
		}
	}
	pld seg = gs(amogus, (lb + rb) / 2);
	// cerr << seg.F << ' ' << seg.S << '\n';
	ld x = (seg.F + seg.S) / 2;
	cout << x << ' ' << rb << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(NULL);
	cout << setprecision(20) << fixed;
	solve();
}