#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

typedef long double dbl;
#define all(x) x.begin(), x.end()

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

// #pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

inline void prepare() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

inline void solve() {
    int n;
    cin >> n;
    vector<dbl> a(n);
    cout << setprecision(15);
    multiset<int> b;
    dbl ma = 0;
    dbl mi = 0;
    for(int i = 0; i < n; ++i){
        cin >> a[i];
        b.insert(a[i]);
    }
    for(int i = 0; i < n; ++i){
        dbl minnow = *b.begin();
        dbl maxnow = *b.rbegin();

        dbl t[5];

        t[1] = mi / minnow;
        t[2] = mi / maxnow;
        t[3] = ma / minnow;
        t[4] = ma / maxnow;

        pair<dbl, dbl> a1[4];
        for (int k = 0; k < 4; k++) {
            a1[k].first = 100000000000;
            a1[k].second = t[k + 1];
        }

        if(t[1] <= 1){
            a1[0].first = max(maxnow * t[1], ma) - min(mi, minnow * t[1]);
        }
        if(t[2] <= 1){
            a1[1].first = max(maxnow * t[2], ma) - min(mi, minnow * t[2]);
        }
        if(t[3] <= 1){
            a1[2].first = max(maxnow * t[3], ma) - min(mi, minnow * t[3]);
        }
        if(t[4] <= 1){
            a1[3].first = max(maxnow * t[4], ma) - min(mi, minnow * t[4]);
        }

        sort(a1, a1 + 4);

        dbl ans2 = 1;
        dbl ans1 = 100000000000;
        for(int i = 0; i < 4; ++i){
            if(a1[i].first <= ans1){
                ans1 = a1[i].first;
                ans2 = min(ans2, 1 - a1[i].second);
            }
        }

        if(i == 0){
            ma = a[i];
            mi = a[i];
        }
        else{
            ma = max(a[i], ma);
            mi = min(a[i], mi);
        }
        b.erase(b.find(a[i]));
        cout << fixed << max(0.0l, ans2) << ' ';
    }
}

int main() {
    prepare();
    solve();
}
