#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

// #pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

inline void prepare() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int arr[200000];

inline void solve() {
    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }

    cout << setprecision(18);

    cout << fixed;
    cout << 1.0l << ' ';

    multiset<int> right;
    int mnLeft = arr[0];
    int mxLeft = arr[0];

    for (int i = 1; i < n; i++) {
        right.insert(arr[i]);
    }

    for (int i = 1; i < n; i++) {
        int mnRight = *right.begin();
        int mxRight = *right.rbegin();

        ld t = 0;

        if (mnRight > mnLeft) {
            t = 1.0l - ((ld) mnLeft) / mnRight;
            if (mxRight * (1 - t) > mxLeft) {
                t = 1.0l - ((ld) mxLeft) / mxRight;
            }
        } else {
            if (mxRight > mxLeft) {
                t = 1.0l - ((ld) mxLeft) / mxRight;
            }
        }

        cout << fixed;
        cout << t << ' ';

        right.erase(right.find(arr[i]));
        if (arr[i] < mnLeft) {
            mnLeft = arr[i];
        }
        if (arr[i] > mxLeft) {
            mxLeft = arr[i];
        }
    }
}

int main() {
    prepare();
    solve();
}
