#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) (a).begin(), (a).end()
#define len(a) int((a).size())

signed main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	vector<int> a(n);
	for (auto &x : a)
		cin >> x;

	vector<int> suf_max(n), suf_min(n);
	suf_max[n - 1] = suf_min[n - 1] = a[n - 1];
	for (int i = n - 2; i >= 0; i--) {
		suf_max[i] = max(suf_max[i + 1], a[i]);
		suf_min[i] = min(suf_min[i + 1], a[i]);
	}

	cout << "1.000 ";
	int pref_max = a[0], pref_min = a[0];
	for (int i = 1; i < n; i++) {
		if (suf_max[i] > pref_max) {
			ld take = max(ld(pref_max) / suf_max[i], ld(pref_min) / suf_min[i]);
			cout << 1 - take << ' ';
		} else if (suf_min[i] > pref_min) {
			cout << 1 - ld(pref_min) / suf_min[i] << ' ';
		} else {
			cout << "0 ";
		}

		pref_max = max(pref_max, a[i]);
		pref_min = min(pref_min, a[i]);
	}
	cout << '\n';
}
