#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;
const char nl = '\n';
vi a, b;
int n;

bool calc(int mid) {
	vi a1(n + mid, 0);
	for(int i = 0; i < n; i++) {
		a1[i + mid] = a[i];
	}
	int pt = 0;
	for(int i = 0; i < n; i++) {
		pt = max(pt, i + 1);
		if(b[i] < a1[i]) {
			return false;
		}
		while(pt < n + mid && b[i] != a1[i] && i + mid * 2 >= pt) {
			int can = min(b[i] - a1[i], a1[pt]);
			a1[i] += can;
			a1[pt] -= can;
			if(a1[pt] == 0) {
				++pt;
			}
		}
	}
	for(int i = 0; i < n; i++) {
		if(a1[i] > b[i]) {
			return false;
		}
	}
	for(int i = n; i < n + mid; i++) {
		if(a1[i] > 0) {
			return false;
		}
	}
	return true;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef _FILE
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	cin >> n;
	a.resize(n);
	b.resize(n);
	ll sum1 = 0;
	ll sum2 = 0;
	for(int i = 0; i < n; i++) {
		cin >> a[i];
		sum1 += a[i];
	}
	for(int i = 0; i < n; i++) {
		cin >> b[i];
		sum2 += b[i];
	}
	if(sum1 > sum2) {
		cout << -1;
		return 0;
	}
	int l = -1;
	int r = n;
	while(r - l > 1) {
		int mid = (l + r) / 2;
		if(calc(mid)) {
			r = mid;
		} else {
			l = mid;
		}
	}
	//cout << calc(1) << endl;
	if(r == n) {
		cout << -1;
	} else {
		cout << r;
	}
}