#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;
const char nl = '\n';

const int maxn = 1e5, K = 26;

int group[maxn][K];
vector<bool> good[maxn];

const ll mod1 = 1e9+7, mod2 = 1e9+9;

ll hsh(string &s, char c) {
	ll p1 = 1, p2 = 1;
	ll res1 = 0, res2 = 0;
	for (int i = 0; i < (int)s.size(); i++) {
		if (s[i] == c) {
			res1 = (res1 + p1) % mod1;
			res2 = (res2 + p2) % mod2;
		}
		p2 = p2 * 2 % mod2;
		p1 = p1 * 2 % mod1;
	}
	return res1 + res2 * mod1;
}

bool ans = true;
void solve(vector<int> &a, int mask = 0) {
	if (!ans) return;
	for (int i = 0; i < K; i++) {
		if ((mask >> i) & 1) continue;
		bool tgood = true;
		for (int x: a) {
			if (good[x][i]) {
				tgood = false;
				break;
			}
		}
		if (tgood) {
			mask = mask | (1 << i);
		}
	}

	if (__builtin_popcount(mask) == K) return;

	for (int i = 0; i < K; i++) {
		if ((mask >> i) & 1) continue;

		bool tgood = true;
		for (int x: a) {
			if (!good[x][i]) {
				tgood = false;
				break;
			}
		}
		if (tgood) {
			mask = mask | (1 << i);
			map<int, vector<int>> mp;
			for (int x: a) {
				mp[group[x][i]].push_back(x);
			}
			for (auto p: mp) {
				solve(p.second, mask);
			}

			return;
		}
	}
	ans = false;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef _FILE
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	
	int l, n;
	cin >> l >> n;

	vector<vector<ll>> a(n);
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		for (char c = 'a'; c <= 'z'; c++) {
			a[i].push_back(hsh(s, c));
			if (count(s.begin(), s.end(), c)) {
				good[i].push_back(true);
			} else {
				good[i].push_back(false);
			}
		}
	
	}

	for (int i = 0; i < 26; i++) {
		set<ll> ts;
		for (int j = 0; j < n; j++) {
			ts.insert(a[j][i]);
		}
		map<ll, ll> mp;
		int ti = 0;
		for (auto x: ts) {
			mp[x] = ti++;
		}
		for (int j = 0; j < n; j++) {
			group[j][i] = mp[a[j][i]];
		}
	}

	vector<int> ta(n);
	for (int i = 0; i < n; i++) {
		ta[i] = i;
	}
	solve(ta, 0);
	if (ans) {
		cout << "YES" << nl;
	} else {
		cout << "NO" << nl;
	}
}