#include<bits/extc++.h>

#define int long long
//#define p pair<int, int>
#define pb push_back
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define endl '\n'
const int INF = 1000000001;

using namespace std;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> A(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> A[i];
    }
    vector<int> pmin(n + 2, (int) 2e9), pmax(n + 2), smin(n + 2, (int) 2e9), smax(n + 2);
    for (int i = 1; i <= n; i++) {
        pmin[i] = min(pmin[i - 1], A[i]);
        pmax[i] = max(pmax[i - 1], A[i]);
    }
    for (int i = n; i >= 1; i--) {
        smin[i] = min(smin[i + 1], A[i]);
        smax[i] = max(smax[i + 1], A[i]);
    }
    cout << fixed << setprecision(25);
    cout << 1 << ' ';
    for (int k = 1; k < n; k++) {
        int min1 = pmin[k], max1 = pmax[k], min2 = smin[k + 1], max2 = smax[k + 1];
        if (max1 >= max2) {
            if (min2 <= min1) {
                cout << 0 << ' ';
            } else {
                cout << 1.0 * (ld) min1 / (ld) min2 << ' ';
            }
        } else {
            ld t = 1.0 * (ld) max1 / 1.0 / (ld) max2;
            if (min2 * max1 <= min1 * max2) {
                cout << 1 - t << ' ';
            } else {
                t = (ld) min1 / (ld) min2;
                cout << 1 - t << ' ';
            }
        }
    }
    cout << '\n';
    return 0;
}