#include <bits/stdc++.h>

using namespace std;


struct node_t {
	map<char, int> children;
	map<char, pair<int, int>> next;
	int cnt_less;
	int cnt;
	int depth;
	int sum;

	node_t(int depth): cnt_less(0), cnt(0), depth(depth), sum(0) {
	}
};

vector<node_t> nodes;


void add_string(const string& s) {
	int node = 0;
	for(char c: s) {
		if(!nodes[node].children.count(c)) {
			nodes[node].children[c] = nodes.size();
			nodes.emplace_back(nodes[node].depth + 1);
		}
		node = nodes[node].children[c];
	}
	nodes[node].cnt++;
}


void dfs(int node, int in_cnt_less) {
	nodes[node].cnt_less = in_cnt_less;
	nodes[node].sum = nodes[node].cnt;
	for(auto [c, chld]: nodes[node].children) {
		dfs(chld, nodes[node].cnt_less + nodes[node].sum);
		nodes[node].sum += nodes[chld].sum;
		if(!nodes[chld].next.count(c) || !nodes[nodes[chld].next[c].first].next.count(c) || nodes[chld].next[c].second != nodes[nodes[chld].next[c].first].next[c].second) {
			nodes[node].next[c] = {chld, 1};
		} else {
			nodes[node].next[c] = {nodes[nodes[chld].next[c].first].next[c].first, nodes[chld].next[c].second * 2 + 1};
		}
		// cerr << node <<
	}
}


void down(int& node, char c, int n, bool& complete) {
	while(n > 0 && complete) {
		auto it = nodes[node].next.find(c);
		if(it == nodes[node].next.end()) {
			complete = false;
			return;
		}
		if(it->second.second <= n) {
			node = it->second.first;
			n -= it->second.second;
		} else {
			node = nodes[node].children[c];
			n--;
		}
	}
}


int count_node(char c, int n, int node, bool complete) {
	if(!complete) {
		return 0;
	}

	int mod = nodes[node].cnt_less;

	down(node, c, n, complete);

	int ans = nodes[node].cnt_less;
	if(!complete) {
		auto it = nodes[node].children.lower_bound(c);
		ans += nodes[node].cnt;
		while(it != nodes[node].children.begin()) {
			ans += nodes[(--it)->second].sum;
		}
	}

	return ans - mod;
}


signed main() {
	nodes.emplace_back(0);


	int n, q;
	cin >> n >> q;

	vector<tuple<int, char, int, int, bool>> ss;
	string s;
	cin >> s;
	for(int i = 0; i < s.size(); i++) {
		ss.emplace_back(i, s[i], 1, -1, true);
	}

	for(int i = 0; i < n; i++) {
		string t;
		cin >> t;
		add_string(t);
	}

	dfs(0, 0);


	int ans = 0;
	int node = 0;
	bool complete = true;
	for(int i = 0; i < s.size(); i++) {
		get<3>(ss[i]) = node;
		get<4>(ss[i]) = complete;
		if(complete) {
			auto it = nodes[node].children.lower_bound(s[i]);
			if(it != nodes[node].children.end() && it->first == s[i]) {
				complete = true;
				node = it->second;
			} else {
				complete = false;
				ans += nodes[node].cnt;
				while(it != nodes[node].children.begin()) {
					ans += nodes[(--it)->second].sum;
				}
			}
		}
	}
	ans += nodes[node].cnt_less;
	cout << ans << "\n";

	for(int i = 0; i < q; i++) {
		int k;
		char c;
		cin >> k >> c;
		k--;

		int exp;
		auto it = lower_bound(ss.begin(), ss.end(), make_tuple(k, 0, 0, 0, false));
		if(it != ss.begin()) {
			--it;

			auto& [i, c, n, node, complete] = *it;

			assert(k == 0 || i < k);
			assert(i + n >= k);

			ans -= count_node(c, n, node, complete);
			n = k - i;
			ans += count_node(c, n, node, complete);

			exp = it - ss.begin() + 1;
		} else {
			exp = 0;
		}

		while(ss.size() > exp) {
			auto [i, c, n, node, complete] = ss.back();
			ans -= count_node(c, n, node, complete);
			ss.pop_back();
		}

		int node;
		bool complete;
		if(ss.empty()) {
			node = 0;
			complete = true;
		} else {
			int i, c, n;
			tie(i, c, n, node, complete) = ss.back();
			down(node, c, n, complete);
		}

		int n = s.size() - k;
		ss.emplace_back(k, c, n, node, complete);
		ans += count_node(c, n, node, complete);

		cout << ans << "\n";
	}

	return 0;
}
