#include <bits/stdc++.h>

using namespace std;

using ldbl_t = long double;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	std::cin >> n;
	std::vector<ldbl_t> a(n);
	for (auto &x : a)
		std::cin >> x;
	std::vector<ldbl_t> gans(n);
	gans[0] = 0.0;
	ldbl_t sum = 0;
	for (auto &x : a)
		sum += x;
	std::vector<ldbl_t> pmin(n, 1e9), pmax(n, -1e9), smin(n, 1e9), smax(n, -1e9);
	pmin[0] = pmax[0] = a[0];
	for (int i = 1; i < n; ++i) {
		pmin[i] = std::min(pmin[i - 1], a[i]);
		pmax[i] = std::max(pmax[i - 1], a[i]);
	}
	smin[n-  1] = smax[n - 1] = a[n - 1];

	for (int i = n - 2; i >= 0; --i) {
		smin[i] = std::min(smin[i + 1], a[i]);
		smax[i] = std::max(smax[i + 1], a[i]);
	}

	ldbl_t psum = 0;
	for (int i = 1; i < n; ++i) {
		psum += a[i - 1];
		ldbl_t l = pmin[i - 1], r = pmax[i - 1], x = smin[i], y = smax[i];
		std::pair<ldbl_t, ldbl_t> ans = {std::max({l, r, x, y}) - std::min({l, r, x, y}), 1.0};
		ldbl_t t = l / x;
		if (t <= 1.0) {
			ans = std::min(ans,
			 std::pair<ldbl_t, ldbl_t>{
			 	std::max({l, r, x * t, y * t}) - std::min({l, r, x * t, y * t}),
			 	t});
		}
		t = r / y;
		if (t <= 1.0) {
			ans = std::min(ans,
			 std::pair<ldbl_t, ldbl_t>{
			 	std::max({l, r, x * t, y * t}) - std::min({l, r, x * t, y * t}),
			 	t});
		}
		t = 0.0;
		if (t <= 1.0) {
			ans = std::min(ans,
			 std::pair<ldbl_t, ldbl_t>{
			 	std::max({l, r, x * t, y * t}) - std::min({l, r, x * t, y * t}),
			 	t});
		}
		// std::cerr << ans.first << " ";
		gans[i] = ans.second;
	}
	for (auto &x : gans)
		std::cout << std::setprecision(10) << std::fixed << 1.0 - x << " ";
	std::cout << "\n";
	return 0;
}
