#include <iostream>
#include "vector"
#include "algorithm"
#include "map"
using namespace std;
#define all(x) (x).begin(), (x).end()
typedef long long ll;
const int INF = 1e9 + 7;
#define int long long
int mod = 1791791791;
int p = 31;
bool solve(vector<string> a) {
    int n = a.size();
    if (n == 1)
        return 1;
    vector<int> inall(26);
    for (int i = 0; i < n; ++i) {
        vector<int> ina(26);
        for (auto j : a[i])
            ina[j-'a'] = 1;
        for (int j = 0; j < 26; ++j) {
            inall[j] += ina[j];
        }
    }
    int res = 0;
    for (int i = 0; i < 26; ++i) {
        inall[i] = (inall[i] == n);
        res += inall[i];
    }
    if (res == 0)
        return 0;
    map<int, vector<string>> mp;
    for (int i = 0; i < n; ++i) {
        int hsh = 0;
        int pp = 1;
        string s2;
        for (int j = 0; j < a[i].size(); ++j) {
            if (inall[a[i][j] - 'a'])
                hsh += pp * (a[i][j] - 'a' + 1);
            else
                s2.push_back(a[i][j]);
            pp *= p;
            pp %= mod;
            hsh %= mod;
        }
        mp[hsh].push_back(s2);
    }
    for (auto i : mp) {
        if (solve(i.second) == 0)
            return 0;
    }
    return 1;
}
signed main(){
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int stepa, n;
    cin >> stepa >> n;
    vector<string> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (solve(a))
        cout << "YES\n";
    else
        cout << "NO\n";
}
