#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <array>



using namespace std;


#define ll long long
#define ld long double
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

int32_t main() {
	int n;
	cin >> n;
	vector <int> a(n);
	for (int i = 0; i < n; ++i) cin >> a[i];
	vector <int> pref_min(n), suf_min(n), pref_max(n), suf_max(n);
	pref_min[0] = a[0];
	pref_max[0] = a[0];
	suf_min[n - 1] = a[n - 1];
	suf_max[n - 1] = a[n - 1];
	for (int i = 1; i < n; ++i) {
		pref_min[i] = min(pref_min[i - 1], a[i]);
		pref_max[i] = max(pref_max[i - 1], a[i]);
	}
	for (int i = n - 2; i >= 0; --i) {
		suf_min[i] = min(suf_min[i + 1], a[i]);
		suf_max[i] = max(suf_max[i + 1], a[i]);
	}
	cout << 1 << " ";
	for (int i = 1; i < n; ++i) {
		double t1;
		if (suf_min[i] <= pref_min[i - 1]) t1 = 1;
		else t1 = (double)pref_min[i - 1] / (double)suf_min[i];
		double t2;
		if (suf_max[i] <= pref_max[i - 1]) t2 = 1;
		else t2 = (double)pref_max[i - 1] / (double)suf_max[i];
		cout << fixed << setprecision(10) << 1 - min(t1, t2) << " ";
	}
		return 0;
}