#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <array>



using namespace std;



#define ll long long
#define ld long double
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


const int INF = 1e9 + 1;
const int mod = 1e9 + 7;

const flt inf = 1e18;
int n = 4;
vector<ll> t;


flt f(vector<flt>& a) {
	return a[0] * a[3] + a[1] + a[2];
}


flt slv(vector<int> &p, vector<flt> &a) {
	a.assign(n, 0);
	vector<ll> x(n);
	for (int i = 0; i < n; ++i) {
		x[i] = t[p[i]] - 1;
		a[i] = t[p[i]];
	}
	if (x[0] * x[3] == x[1] * x[2]) {

	}
	else if (x[0] * x[3] >= x[1] * x[2]) {
		if (x[0] < x[3]) {
			a[0] = ((flt)(x[1]) * x[2]) / x[3] + 1;
		}
		else {
			a[3] = ((flt)(x[1]) * x[2]) / x[0] + 1;
		}
	}
	else {
		if (x[1] < x[2]) {
			a[1] = ((flt)(x[0]) * x[3]) / x[2] + 1;
		}
		else {
			a[2] = ((flt)(x[0]) * x[3]) / x[1] + 1;
		}
	}
	return f(a);
}


int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	t.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> t[i];
	}
	vector<int> p(n);
	for (int i = 0; i < n; ++i) {
		p[i] = i;
	}
	flt mx = -inf;
	vector<flt> mxa;
	vector<int> mxp;
	while (1) {
		vector<flt> a;
		flt w = slv(p, a);
		if (w > mx) {
			mx = w;
			mxa = a;
			mxp = p;
		}
		if (!next_permutation(all(p))) {
			break;
		}
	}
	for (int i = 0; i < n; ++i) {
		cout << mxp[i] + 1 << " ";
	}
	cout << "\n";
	for (int i = 0; i < n; ++i) {
		cout << fixed << setprecision(10) << mxa[i] << " ";
	}
	cout << "\n";
	return 0;
}