#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <complex>
#include <deque>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int& i : a) {
        cin >> i;
    }
    vector<int> b(n);
    for (int& i : b) {
        cin >> i;
    }
    int l = -1, r = 1e6 + 1;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        deque<pair<int, int>> da;
        deque<pair<int, int>> db;
        bool ok = true;
        for (int i = 0; i < n; ++i) {
            int x = b[i];
            int q = a[i];
            if (da.front().first < i - m) {
                ok = false;
            }
            while (!da.empty() && x) {
                int can = min(x, da.front().second);
                x -= can;
                da.front().second -= can;
                if (da.front().second == 0) da.pop_front();
            }
            if (x) {
                db.push_back({i, x});
            }
            while (!db.empty() && db.front().first < i - m) db.pop_front();
            while (!db.empty() && q) {
                int can = min(q, db.front().second);
                q -= can;
                db.front().second -= can;
                if (db.front().second == 0) db.pop_front();
            }
            if (q) {
                da.push_back({ i, q });
            }
        }
        if (!da.empty()) {
            ok = false;
        }
        if (ok) {
            r = m;
        } else {
            l = m;
        }
    }
    if (r == 1e6 + 1) {
        cout << -1;
    } else {
        cout << r;
    }
}