#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <unordered_set>
#include <set>
#include <complex>
#include <iomanip>
#include <deque>
#include <numeric>

using namespace std;

#define all(x) x.begin(), x.end()

long double count(int mx1, int mn1, int mx2, int mn2, long double t) {
    return max((long double)mx1, (long double)mx2 * t) -  min((long double)mn1, (long double)mn2 * t);
}

vector<vector<int>> poses[26];
int n, l;
bool cann(vector<int> msk, vector<int> &used) {
    if (msk.size() == 1) {
        return true;
    }
    int can = -1;
    for (int i = 0; i < 26; i++) {
        if (used[i]) {
            continue;
        }
        bool fl = true;
        for (int j = 0; j < msk.size(); j++) {
            fl &= !poses[i][msk[j]].empty();
        }
        if (fl) {
            can = i;
            break;
        }
    }
    if (can == -1) {
        return false;
    }
    map<vector<int>, vector<int>> mp;
    for (int i = 0; i < msk.size(); i++) {
        mp[poses[can][msk[i]]].push_back(msk[i]);
    }
    bool fl = true;
    used[can] = 1;
    for (auto &[k, v] : mp) {
        fl &= cann(v, used);
    }
    used[can] = 0;
    return fl;

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> l;
    cin >> n;
    for (int i = 0; i < 26; i++) {
        poses[i].resize(n);
    }
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < l; j++) {
            poses[s[j] - 'a'][i].push_back(j);
        }
    }
    vector<int> p(n);
    iota(p.begin(), p.end(), 0);
    vector<int> used(26);
    if (cann(p, used)) {
        cout << "YES";
    } else {
        cout << "NO";
    }
}