#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace __gnu_pbds;
template<typename T>
using ordset = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#endif

#define all(q) q.begin(), q.end()
#define Please return
#define AC 0
#define nl '\n'

using namespace std;
using ll = long long;
using ld = long double;
using cmpl = complex<long double>;

template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& x) {
	return in >> x.first >> x.second;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& out, const pair<T1, T2>& x) {
	return out << x.first << ' ' << x.second;
}

template<typename T>
istream& operator>>(istream& in, vector <T>& x) {
	for (auto& p : x)
		in >> p;
	return in;
}

template<typename T>
ostream& operator<<(ostream& out, const vector <T>& x) {
	for (auto& p : x)
		out << p << ' ';
	return out;
}

pair <ld, ld> insec(pair <int, int> l1, pair <int, int> l2)
{
	ld x = ((ld)l2.second - (ld)l1.second) / ((ld)l1.first - (ld)l2.first);
	ld y = ((ld)l1.first * (ld)l2.second - (ld)l2.first * (ld)l1.second) / ((ld)l1.first - (ld)l2.first);

	return { x, y };
}

int main(int argc, char* argv[]) {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	cout.precision(20);
	if (argc > 1) {
		freopen(argv[1], "r", stdin);
	}
	if (argc > 2) {
		freopen(argv[2], "w", stdout);
	}

	int n;
	cin >> n;
	
	vector <int> a(n);
	cin >> a;

	vector <int> minl(n), minr(n), maxl(n), maxr(n);
	int mnl = a[0], mxl = a[0], mnr = a[n - 1], mxr = a[n - 1];
	for (int i = 0; i < n; i++)
	{
		mnl = min(mnl, a[i]);
		mxl = max(mxl, a[i]);
		minl[i] = mnl;
		maxl[i] = mxl;
	}
	for (int i = n - 1; i >= 0; i--)
	{
		mnr = min(mnr, a[i]);
		mxr = max(mxr, a[i]);
		minr[i] = mnr;
		maxr[i] = mxr;
	}

	vector <ld> ans(1, 1);
	for (int i = 1; i < n; i++)
	{
		vector <pair <int, int>> l(4);
		l[0] = { 0, maxl[i - 1] - minl[i] };
		l[1] = { minr[i] - maxr[i], maxr[i] - minr[i] };
		l[2] = { minr[i], maxl[i - 1] - minr[i] };
		l[3] = { -maxr[i], maxr[i] - minl[i - 1] };

		pair <ld, ld> t = { 1e9, 1e9 };
		for (int j = 0; j < 4; j++)
		{
			for (int k = j + 1; k < 4; k++)
			{
				if (l[j].first == l[k].first)
					continue;

				auto is = insec(l[j], l[k]);
				if (0 <= is.first && is.first <= 1)
				{
					ld num = -1e18;
					for (int x = 0; x < 4; x++)
						num = max(num, l[x].first * is.first + l[x].second);

					if (abs(num - t.second) < 1e-9)
						t = { max(is.first, t.first), num };
					else if (num < t.second)
						t = { is.first, num };
				}
			}
		}

		ld num = -1e18;
		for (int x = 0; x < 4; x++)
			num = max(num, l[x].second);

		if (abs(num - t.second) < 1e-9)
			t = { max(0, t.first), num };
		else if (num < t.second)
			t = { 0, num };

		num = -1e18;
		for (int x = 0; x < 4; x++)
			num = max(num, l[x].first + l[x].second);
		if (abs(num - t.second) < 1e-9)
			t = { max(1, t.first), num };
		else if (num < t.second)
			t = { 1, num };

		ans.push_back(t.first);
	}

	cout << ans << nl;

	Please AC;
}