#include <iostream>
#include <random>
#include <algorithm>
#include <deque>
#include <iomanip>
#include <unordered_map>

#pragma warning(disable : 4996)

using namespace std;

#define int long long
#define double long double
#define max(a, b) a<b ? b : a
#define min(a, b) a<b ? a : b
mt19937 rnd;

using namespace std;

inline int getint() {
	int res = 0;
	int l = 1;
	while (1) {
		char f = _getchar_nolock();
		if (f == ' ' || f == '\n') break;
		if (f == '-') {
			l *= -1;
			continue;
		}
		res = res * 10 + (f - '0');
	}
	return res * l;
}

const double eps = 1e-7;
vector < pair<pair<double, double>, double>> a;

double f(double x) {
	double mx = -1e9 - 1;
	double mn = 1e9 + 1;
	for (int i = 0; i < a.size(); i++) {
		if (a[i].first.first > 0) {
			mx = max(mx, a[i].first.first * x * x + a[i].first.second * x + a[i].second);
		}
		else {
			mn = min(mn, a[i].first.first * x * x + a[i].first.second * x + a[i].second);
		}
	}
	return mx - mn;
}

double fp(double x) {
	return (f(x + eps) - f(x)) / eps;
}

signed main() {
	//ios_base::sync_with_stdio(); cin.tie(0); cout.tie(0);
	cout << setprecision(22) << fixed;
	int n = getint();
	a.resize(n);
	int fl1 = 0;
	int fl2 = 0;
	for (int i = 0; i < n; i++) {
		a[i].first.first = getint();
		a[i].first.second = getint();
		a[i].second = getint();
		if (a[i].first.first > 0) fl1 = 1;
		else fl2 = 1;
	}
	if (!fl1) {
		cout << 0 << ' ' << -1e9 -1;
		return 0;
	}
	else if (!fl2) {
		cout << 0 << ' ' << 1e9 + 1;
		return 0;
	}
	double x = 0;
	for (int i = 0; i < 1500; i++) {
		x -= f(x) / fp(x);
	}
	double y = (a[0].first.first * x * x + a[0].first.second * x + a[0].second);
	for (int i = 0; i < a.size(); i++) {
		if (a[i].first.first > 0) {
			y = max(y, a[i].first.first * x * x + a[i].first.second * x + a[i].second);
		}
	}
	cout << x << ' ' << y;
}