#include <iostream>
#include <random>
#include <algorithm>
#include <deque>
#include <iomanip>
#include <map>
#include <set>

#pragma warning(disable : 4996)

using namespace std;

#define int long long
#define double long double
#define max(a, b) a<b ? b : a
#define min(a, b) a<b ? a : b
mt19937 rnd;

using namespace std;

inline int getint() {
	int res = 0;
	while (1) {
		char f = _getchar_nolock();
		if (f == ' ' || f == '\n') break;
		res = res * 10 + (f - '0');
	}
	return res;
}

const int MAXN = 1e5;
const int p = 1303;
const int mod = 1e9 + 1329;

int pp[MAXN];
string a[MAXN];
int u[MAXN];
int u2[MAXN];
int hsh[MAXN][26];
set <int> s = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25};

bool solve(int l, int r) {
	if (l >= r) return 1;
	for (int j = 0; j < 26; j ++) {
		if (s.find(j) == s.end()) continue;
		int fl = 1;
		for (int i = l; i <= r; i++) {
			if (hsh[u[i]][j] == 0) fl = 0;
		}
		if (fl) {
			map <int, vector <int>> y;
			for (int i = l; i <= r; i++) {
				auto jik = y[hsh[u[i]][j]];
				y[hsh[u[i]][j]].push_back(i);
			}
			int o = l;
			vector <int> p;
			for (auto& q : y) {
				p.push_back(o);
				for (int m : q.second) {
					u2[o++] = u[m];
				}
			}
			for (int i = l; i <= r; i++) {
				u[i] = u2[i];
			}
			s.erase(j);
			for (int i = 0; i < p.size() - 1; i++) {
				if (1 - solve(p[i], p[i + 1] - 1)) return 0;
			}
			if (1 - solve(p.back(), r)) return 0;
			s.insert(j);
			return 1;
			break;
		}
	}
	return 0;
}

signed main() {
	ios_base::sync_with_stdio(); cin.tie(0); cout.tie(0);
	pp[0] = 1;
	u[0] = 0;
	for (int i = 1; i < MAXN; i++) {
		u[i] = i;
		pp[i] = (pp[i - 1] * p) % mod;
	}
	int l, n; cin >> l >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < l; j++) {
			hsh[i][a[i][j] - 'a'] = (hsh[i][a[i][j] - 'a'] + pp[j]) % mod;
		}
	}
	if (solve(0, n - 1)) cout << "YES";
	else cout << "NO";
}