﻿#define _CRT_SECURE_NO_WARNINGS

#include <bitset>
#include <iostream>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <cmath>
#include <utility>
#include <cassert>
#include <vector>

#ifdef ONLINE_JUDGE
#define cerr if (false) cerr
#endif

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define int ll
#define sz(x) int(x.size())
#define dbg(x) cerr << #x << " = " << x << '\n';

using namespace std;

void solve() {
  int n;
  cin >> n;
  vector<int> A(n), B(n);

  ll sa = 0, sb = 0;
  for (int i = 0; i < n; ++i) cin >> A[i], sa += A[i];
  for (int i = 0; i < n; ++i) cin >> B[i], sb += B[i];

  if (sa > sb) {
    cout << -1;
  } else {
    int left = -1, right = n - 1;
    while (right - left > 1) {
      int mid = (left + right) / 2;
      vector<int> a = A, b = B;
      bool kok = true;
      int j = 0;
      for (int i = 0; i < n; ++i) {
        j = max(j, i - mid);
        while (j <= min(n - 1, i + mid) && a[i]) {
          int ms = min(a[i], b[j]);
          a[i] -= ms;
          b[j] -= ms;
          if (!b[j]) ++j;
        }
        kok &= !a[i];
      }
      (kok ? right : left) = mid;
    }
    cout << right;
  }
}

signed main() {
  cin.tie(nullptr)->ios::sync_with_stdio(false);

  int tests = 1;
  //cin >> tests
  for (int test = 1; test <= tests; ++test) {
    cerr << "_______Test # " << test << "_______:\n";
    solve();
  }
}