#include <iostream>
#include <algorithm>
#include <vector>
#include <fstream>
//#include <string>
//#include <map>
//#include <set>
//#include <queue>
//#include <cmath>

using namespace std;

int n;
vector<int> s, u;

bool check(int k) {
    int j = 0, x = s[0], y;
    for (int i = 0; i < n; ++i) {
        if (i - j > k) return false;
        y = u[i];
        while (y > 0 and j - i <= k) {
            if (x <= y) {
                y -= x;
                j += 1;
                if (j == n)
                    return true;
                x = s[j];
            } else {
                x -= y;
                y = 0;
            }
        }
    }
    return false;
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    s.resize(n); u.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> s[i];
    for (int i = 0; i < n; ++i)
        cin >> u[i];
    int l = -1, r = n;
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (check(m)) r = m;
        else l = m;
    }
    if (r == n)
        cout << -1;
    else
        cout << r;
    return 0;
}