#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <array>
#include <deque>
#include <iomanip>

#define rep(i, n) for (ll i = 0; i < ll(n); ++i)
#define ar array
#define j1 gdfk
using namespace std;
typedef long long ll;
const int N = 1e6;

void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	vector<int> minn(n), maxx(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		if (i) {
			minn[i] = min(minn[i - 1], a[i]);
			maxx[i] = max(maxx[i - 1], a[i]);
		}
		else
			minn[i] = maxx[i] = a[i];
	}
	vector<long double> ans(n);
	ans[0] = 1;
	int nminn = 2e9, nmaxx = 0;
	for (int i = n - 1; i > 0; --i) {
		nminn = min(nminn, a[i]);
		nmaxx = max(nmaxx, a[i]);
		int ominn = minn[i - 1], omaxx = maxx[i - 1];
		if (ominn <= nminn && nmaxx <= omaxx) {
			ans[i] = 1 - (long double)ominn / nminn;
		}
		else if (ominn >= nminn && omaxx <= nmaxx) {
			ans[i] = 1 - (long double)omaxx / nmaxx;
		}
		else if (ominn <= nminn && omaxx <= nmaxx) {
			long double f1 = (long double)ominn / nminn;
			long double f2 = (long double)omaxx / nmaxx;
			ans[i] = 1 - min(f1, f2);
		}
		else {
			ans[i] = 0;
		}
	}
	cout << fixed << setprecision(20);
	for (auto i : ans)
		cout << i << ' ';
}
signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	solve();
	cout << "\n";
}
