#include <iostream>
#include <iomanip>
#include <map>
#include <set>
#include <cmath>
#include <string>
#include <stack>
#include <algorithm>
#include <vector>

using itn = int;
using ll = long long;

const int INF = 1e9;

using namespace std;

int n;

vector <int> a, b;

bool check(int m) {
	vector<int> c(n);
	for (int i = 0; i < n; ++i)
		c[i] = b[i] - a[i];
	int i = 0, j = 0;
	while (i < n && c[i] >= 0)
		++i;
	while (j < n && (c[j] <= 0 || abs(j - i) > m))
		++j;
	while (i < n && j < n && abs(j - i) <= m) {
		if (abs(c[i]) <= c[j]) {
			c[j] -= abs(c[i]);
			c[i] = 0;
		}
		else {
			c[i] += c[j];
			c[j] = 0;
		}
		while (i < n && c[i] >= 0)
			++i;
		while (j < n && (c[j] <= 0 || abs(j - i) > m))
			++j;
	}
	int good = 1;
	for (int i = 0; i < n; ++i)
		if (c[i] < 0) good = 0;
	return good;
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin >> n;
	a.resize(n);
	b.resize(n);
	for (auto& x : a)
		cin >> x;
	for (auto& x : b)
		cin >> x;
	int l = -1, r = n;
	while (l + 1 < r) {
		int m = (l + r) / 2;
		if (check(m)) r = m;	
		else l = m;
	}
	if (r == n)
		cout << -1;
	else cout << r;
}