#include <iostream>
#include <iomanip>
#include <map>
#include <set>
#include <cmath>
#include <string>
#include <stack>
#include <algorithm>
#include <vector>

using itn = int;
using ll = long long;

const int INF = 1e9;

using namespace std;

int n;

vector <long long> c, a, b;

bool check(int k) {
	vector <ll> c(n), na = a;
	int ind2 = 0;
	for (int i = 0; i < n; ++i) {
		if (b[ind2] - c[ind2] >= na[i]) {
			c[i] += na[i];
			na[i] = 0;
		}
		else {
			na[i] -= b[ind2] - c[ind2];
			c[ind2] = b[ind2];
			++ind2;
			while (ind2 < n && abs(ind2 - i) > k) {
				++ind2;
			}
			if (ind2 == n)
				break;
			--i;
		}
	}
	for (int i = 0; i < n; ++i)
		if (na[i] > 0)
			return false;
	return true;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin >> n;
	a.resize(n);
	b.resize(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	ll sumall = 0;
	for (itn i = 0; i < n; ++i) {
		cin >> b[i];
		sumall += a[i] - b[i];
	}
	if (sumall < 0) {
		cout << -1;
		return 0;
	}
	int lft = -1, rgh = n, mid;
	while (rgh - lft > 1) {
		mid = (lft + rgh) / 2;
		if (check(mid) || check2(mid))
			rgh = mid;
		else
			lft = mid;
	}
	cout << rgh;
}