#include <iostream>
#include <iomanip>
#include <map>
#include <set>
#include <cmath>
#include <string>
#include <stack>
#include <algorithm>
#include <vector>

using itn = int;
using ll = long long;

const int INF = 1e9;

using namespace std;

int n;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& x : a) {
        cin >> x;
        --x;
    }
    reverse(a.begin(), a.end());
    vector<int> c, b;
    int cur = 0;
    vector<int> used(n, 0);
    while (cur < n) {
        if (used[cur] == 0) {
            while (a.back() != cur) {
                cout << 1 << '\n';
                b.push_back(a.back());
                used[a.back()] = 1;
                a.pop_back();
            }
            a.pop_back();
            cout << 1 << '\n';
            cout << -1 << '\n';
            used[cur] = -1;
        }
        else if (used[cur] == 1) {
            while (b.back() != cur) {
                cout << 12 << '\n';
                c.push_back(b.back());
                used[b.back()] = 2;
                b.pop_back();
            }
            b.pop_back();
            cout << -1 << '\n';
            used[cur] = -1;
        }
        else {
            while (c.back() != cur) {
                cout << 21 << '\n';
                b.push_back(c.back());
                used[c.back()] = 2;
                c.pop_back();
            }
            c.pop_back();
            cout << -2 << '\n';
            used[cur] = -1;
        }
        ++cur;
    }
}