#include <bits/stdc++.h>

using namespace std;

#define int long long

const long double EPS = 1e-9;
const int MAXN = 2e5 + 1000;

int a[MAXN];
int pmx[MAXN];
int pmn[MAXN];
int smx[MAXN];
int smn[MAXN];

long double f(long double t, int k){
    if (k == 0)
        return (t * smx[k]) - (t * smn[k]);
    else
        return max(t * smx[k], (long double)pmx[k - 1]) - min(t * smn[k], (long double)pmn[k - 1]);
}

signed main()
{
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (i == 0)
            pmx[i] = a[i], pmn[i] = a[i];
        else
            pmx[i] = max(pmx[i - 1], a[i]), pmn[i] = min(pmn[i - 1], a[i]);
    }
    for (int i = n - 1; i >= 0; i--) {
        if (i == n - 1)
            smx[i] = a[i], smn[i] = a[i];
        else
            smx[i] = max(smx[i + 1], a[i]), smn[i] = min(smn[i + 1], a[i]);
    }
    for (int i = 0; i < n; i++) {
        long double l = 0, r = 1;
        while (r - l > EPS) {
            long double m1 = l + (l + r) / 3;
            long double m2 = r - (l + r) / 3;
            if (f(m1, i) <= f(m2, i))
                r = m2;
            else
                l = m1;
        }
        cout << fixed << setprecision(9) << l << '\n';
    }
    return 0;
}
