#include <bits/stdc++.h>

#define ll long long

using namespace std;

void quickstart(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
}

const double eps = 1e-12;

int main()
{
    int n; cin >> n;
    vector<double> v(n);
    for(int i = 0; i < n; ++i)
        cin >> v[i];
    vector<double> ans(n, 0);
    vector<pair<int, int> > w(n, {n - 1, n - 1});
    for(int i = n - 2; i >= 0; --i){
        w[i] = w[i + 1];
        if(v[i] < v[w[i + 1].first])
            w[i].first = i;
        if(v[i] > v[w[i + 1].second])
            w[i].second = i;
    }
    cout << fixed << ' ' << setprecision(10) << '\n';
    ans[0] = 1;
    int mxi = 0, mni = 0;
    for(int i = 1; i < n; ++i){
        int mn = w[i].first, mx = w[i].second;
        double l = 0, r = 1;
        while((r - l) > eps){
            double m1 = (l + ((r - l) / 3.0));
            double m2 = (r - ((r - l) / 3.0));
            double mn1 = v[mn] * (1.0 - m1);
            double mx1 = v[mx] * (1.0 - m1);
            double mn2 = v[mn] * (1.0 - m2);
            double mx2 = v[mx] * (1.0 - m2);
            if(max(mx1, v[mxi]) - min(mn1, v[mni]) < max(mx2, v[mxi]) - min(mn2, v[mni]))
                r = m2;
            else
                l = m1;
        }
        ans[i] = (l + r) / 2.0;
        if(v[i] > v[mxi]) mxi = i;
        if(v[i] < v[mni]) mni = i;
    }
    for(int i = 0; i < n; ++i)
        cout << fixed << setprecision(11) << ans[i] << ' ';
    cout << '\n';
    return 0;
}
