#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<random>
#include<fstream>
#include<cmath>
#include<iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;

ll bin_pow(ll a, ll step)
{
	if (step == 0)
		return 1;
	if (step % 2 == 1)
		return a*bin_pow(a, step-1);
	ll now = bin_pow(a, step / 2);
	return now * now;
}

bool check(vector<ll>a, vector<ll>b, int k) {
	int bi = 0;
	for (int i = 0; i < a.size(); i++) {
		while (i - bi > k)
			bi++;
		while (a[i] != 0 && bi < b.size() && bi - i <= k) {
			int d = min(a[i], b[bi]);
			a[i] -= d;
			b[bi] -= d;
			if (b[bi] == 0)
				bi++;
		}
		if (a[i] != 0)
			return 0;
	}
	return 1;
}

void solveE() {
	/*int n; cin >> n;
	vector<ll>arr(n);
	multiset<ll>
	for (auto&i : arr) {
		cin >> i;
	}*/
	int n; 
	cin >> n;
	vector<ll>a(n), b(n);
	for (auto&i : a)
		cin >> i;
	for (auto&i : b)
		cin >> i;
	int l = -1, r = n;
	while (l + 1 != r) {
		int m = (l + r) / 2;
		if (check(a, b, m))
			r = m;
		else
			l = m;
	}
	if (r == n)
		cout << -1;
	else
		cout<<r;
}

int main() {
	int t = 1;
	//cin>>t;
	while (t--) {
		solveE();
	}
	return 0;
}