import math

inf = 1e5

if __name__ == '__main__':
    n = int(input())

    a, b, c = [0] * n, [0] * n, [0] * n
    for i in range(n):
        a[i], b[i], c[i] = map(int, input().split())

    min_y, max_y = inf, -inf

    for i in range(n):
        x0 = -b[i] / (2 * a[i])
        y0 = a[i] * x0 * x0 + b[i] * x0 + c[i]

        if a[i] > 0:
            max_y = max(max_y, y0)
        else:
            min_y = min(min_y, y0)

    Y = (min_y + max_y) / 100
    for k in range(1, 101):
        ans_y = Y * k

        l, r = -inf, inf

        for i in range(n):
            d = b[i] * b[i] - 4 * a[i] * (c[i] - ans_y)
            if d < 0:
                l, r = inf, -inf
                break

            sd = math.sqrt(d)

            x1 = (-b[i] - sd) / (2 * a[i])
            x2 = (-b[i] + sd) / (2 * a[i])

            x1_ = min(x1, x2)
            x2_ = max(x1, x2)

            l = max(l, x1_)
            r = min(r, x2_)

        if l < r:
            print(f'{(l + r) / 2:.{6}f} {ans_y:.{6}f}')
            exit(0)