import math

inf = 1e20

if __name__ == '__main__':
    n = int(input())

    a, b, c = [0] * n, [0] * n, [0] * n
    for i in range(n):
        a[i], b[i], c[i] = map(int, input().split())

    min_y, max_y = inf, -inf
    cur_min, cur_max = -1, -1
    mean_x = 0

    for i in range(n):
        x0 = -b[i] / (2 * a[i])
        y0 = a[i] * x0 * x0 + b[i] * x0 + c[i]

        mean_x += x0

        if a[i] > 0:
            max_y = max(max_y, y0)
            cur_max = i
        else:
            min_y = min(min_y, y0)
            cur_min = i

    cur = -1
    Y = 0
    if cur_min == -1:
        print(f'{mean_x:.{8}f} {inf:.{8}f}')
        exit(0)
    if cur_max == -1:
        print(f'{mean_x:.{8}f} {-inf:.{8}f}')
        exit(0)

    Y = max_y
    cur = cur_max


    X = (-b[cur]) / (2 * a[cur])

    if Y == max_y:
        Y = Y - (5*1e-6)
    else:
        Y = Y + (5*1e-6)

    print(f'{X:.{8}f} {Y:.{8}f}')