#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <stack>
#include <map>
#include <iomanip>
#include <set>
typedef long long ll;
typedef long double ld;

using namespace std;


bool f(ll k, vector<ll> a, vector<ll> b, ll n) {
    set<pair<ll, ll>> free;
    for (ll i = 0; i <= k; i++) {
        if (b[i] > a[i]) {
            free.insert({ i, b[i] - a[i] });
        }
    }
    for (ll i = 0; i < n; i++) {
        if (i + k < n && b[i + k] > a[i + k])
        {
            free.insert({ i + k, b[i + k] - a[i + k] });
        }
        while (!free.empty() && free.begin()->first < i - k) {
            free.erase(free.begin());
        }
        if (b[i] >= a[i]) {
            if (!free.empty() && free.begin()->first == i - k) {
                pair<ll, ll> g = *free.begin();
                ll x = min(g.second, b[i] - a[i]);
                a[g.first] += x;
                a[i] -= x;
            }
            if (b[i] != a[i]) {
                free.insert({ i, b[i] - a[i] });
            }
        }
        else if (b[i] < a[i]) {
            while (!free.empty()) {
                pair<ll, ll> g = *free.begin();
                ll d = a[i] - b[i];
                if (d >= g.second) {
                    a[i] -= g.second;
                    a[g.first] += g.second;
                    free.erase(free.begin());
                }
                else {
                    a[i] = b[i];
                    a[g.first] += d;
                    free.erase(free.begin());
                    free.insert({ g.first, b[g.first] - a[g.first] });
                    break;
                }
            }
        }
        continue;
    }
    bool f = 1;
    for (ll i = 0; i < n; i++) {
        f &= a[i] <= b[i];
    }
    return f;
}


int main() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    vector<ll> b(n);
    for (auto& x : a) {
        cin >> x;
    }
    for (auto& x : b) {
        cin >> x;
    }
    ll l = -1;
    ll r = n;
    while (l + 1 != r) {
        ll mid = (l + r) / 2;
        bool h = 0;
        h |= f(mid, a, b, n);
        reverse(a.begin(), a.end());
        reverse(b.begin(), b.end());
        h |= f(mid, a, b, n);
        if (f(mid, a, b, n)) {
            r = mid;
        }
        else {
            l = mid;
        }
    }
    cout << (r == n ? -1 : r);
    return 0;
}