#include <bits/stdc++.h>
#define int int64_t
#define F first
#define S second

using namespace std;

const long long mxn = 2e5 + 2;
const double inf = 1e18;
const double eps = 1e-11;

int n;
double a[mxn];
double suff[mxn], prefmx[mxn], prefmn[mxn], suffmx[mxn], suffmn[mxn];

pair <double, double> f(double t, int k) {
    double mx1 = prefmx[k - 1], mn1 = prefmn[k - 1];
    double mx2 = (1 - t) * suffmx[k], mn2 = (1 - t) * suffmn[k];

    double mx = max(max(mx1, mx2), max(mn1, mn2)), mn = min(min(mx1, mx2), min(mn1, mn2));
    return make_pair(mx - mn, suff[k] * t);
}


signed main () {

    cin >> n;
    for(int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    suffmx[n + 1] = -inf, suffmn[n + 1] = inf;
    for(int i = n; i >= 1; i--) {
        suff[i] = suff[i + 1] + a[i];
        suffmx[i] = max(suffmx[i + 1], a[i]);
        suffmn[i] = min(suffmn[i + 1], a[i]);
    } prefmx[0] = -inf, prefmn[0] = inf;
    for(int i = 1; i <= n; i++) {
        prefmx[i] = max(prefmx[i - 1], a[i]);
        prefmn[i] = min(prefmn[i - 1], a[i]);
    }
    for(int i = 1; i <= n; i++) {
        double l = 0, r = 1;
        for(int j = 1; j <= 105; j++) {
            double m1 = l + (r - l) / 3;
            double m2 = r - (r - l) / 3;
            if(f(m1, i).F < f(m2, i).F) r = m2;
            else l = m1;
        }
        cout << fixed << setprecision(10) << l << endl;
    }
    return 0;
}
