#include <bits/stdc++.h>
#define ll long long

using namespace std;

const ll maxn = (ll)(1e6) + 13;
ll n, a[maxn], b[maxn], pa[maxn], pb[maxn];
ll a1[maxn], b1[maxn];

ll sum_a(ll st, ll fn) {
	return (pa[fn] - pa[st - 1]);
}

ll sum_b(ll st, ll fn) {
	return (pb[fn] - pb[st - 1]);
}

bool check(ll k) {
/*
	cout << K << ": "<< endl;
	for (ll i = 1; i <= n; i++) {
		ll lo = max(1ll, i - K);
		ll hi = min(n, i + K);
		cout << i << " " << lo << " " << hi << "\n";
		cout << sum_a(lo, hi) << " " << sum_b(lo, hi) << "\n\n";
		if (sum_a(lo, hi) > sum_b(lo, hi))
			return false;
	}	
	return true;           */

	/*queue <pair <ll, ll> > q;
	queue <pair <ll, ll> > st;
	for (ll i = 1; i <= n; ++i) {
		cout << q.size() << ' ' << st.size() << '\n';
		if (!q.empty() && i-q.front().second > k)
			return 0;
		while (!st.empty() && i-st.front().second > k)
			st.pop();
		if (a[i] == b[i])
			continue;
		if (a[i] > b[i]) {
			q.push(make_pair(a[i]-b[i], i));
		}
		if (a[i] < b[i]) {
			st.push(make_pair(b[i]-a[i], i));
		}
		while (!q.empty() && !st.empty()) {
			if (q.front().first <= st.front().first) {
				st.front().first -= q.front().first;
				q.pop();
			} else {
				q.front().second -= st.front().second;
				st.pop();
			}
        }
	}
	if (!q.empty())
		return 0;
	return 1;*/

	for (ll i = 1; i <= n; i++) 
		a1[i] = a[i];

	deque <ll> q;
	for (ll i = 1; i <= min(n, i + k); i++)
		q.push_back(b[i]);
	for (ll i = 1; i <= n; i++) {
		while (!q.empty() && a1[i] > 0) {
			if (q.front() <= a1[i]) {
				a1[i] -= q.front();
				q.pop_front();
			}
			else {
				q.front() -= a1[i];
				a1[i] = 0;
			}
		}
		if (a1[i] > 0ll) return false;
		if (i + k + 1ll <= n)
			q.push_back(b[i + k + 1ll]);
		if ((ll)(q.size()) > 2ll * k + 1ll) q.pop_front();
	}
	return true;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);

	cin >> n;
	for (ll i = 1; i <= n; i++)
		cin >> a[i];
	for (ll i = 1; i <= n; i++) 
		cin >> b[i];

	for (ll i = 1; i <= n; i++) {
		pa[i] = pa[i - 1] + a[i];
		pb[i] = pb[i - 1] + b[i];
	}

	ll L = 0ll, R = n;
	ll ans = -1ll;
	while (L <= R) {
		ll mid = (L + R) / 2ll;
		if (check(mid)) {
			ans = mid;
			R = mid - 1;
		}
		else L = mid + 1;
	}

	cout << ans;

	return 0;
}