#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define clr clear
#define pb push_back
#define INF (ll)2e9
 
using namespace std;
 
int n;
 
const ll MAXN = (ll)2e5 + 20;
const ld zer = (ld)0.0;
const ld on = (ld)1.0;
const ld eps = (ld)1e-9;
 
ld a[MAXN], mn1[MAXN], mx1[MAXN], mn2[MAXN], mx2[MAXN];
bool used[5];
 
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
 
    cout << setprecision(10) << fixed;
 
    cin >> n;
 
    for (int i = 1; i <= n; ++i)
        cin >> a[i];
     
    mx1[1] = mn1[1] = a[1];
    for (int i = 2; i <= n; ++i)
    {
        mx1[i] = max(mx1[i - 1], a[i]);
        mn1[i] = min(mn1[i - 1], a[i]);
    }
 
    mx2[n] = mn2[n] = a[n];
    for (int i = n - 1; i > 0; --i)
    {
        mx2[i] = max(mx2[i + 1], a[i]);
        mn2[i] = min(mn2[i + 1], a[i]);
    }
 
    cout << 1;
    for (int k = 2; k <= n; ++k)
    {
        ld ans = INF;
 
        ld val1 = on - mn1[k - 1] / mn2[k], val2 = on - mx1[k - 1] / mx2[k];
 
        if (val1 >= max(val2, zer))
        {
            ans = mx1[k - 1] - mn1[k - 1];
            used[1] = true;
        }
 
        ld t2 = max(val1, max(val2, zer));
        ld ans2 = mx1[k - 1] - (on - t2) * mn2[k];
 
        if (fabs(ans2 - ans) < eps)
            used[2] = true;
        else if (ans2 < ans)
        {
            used[1] = false;
            used[2] = true;
            ans = ans2;
        }
 
        if (val2 >= 0.0 && val1 <= val2)
        {
            ld t3 = val2;
            ld ans3 = (on - t3) * (mx2[k] - mn2[k]);
            if (fabs(ans3 - ans) < eps)
                used[3] = true;
            else if (ans3 < ans)
            {
                used[1] = used[2] = false;
                used[3] = true;
                ans = ans3;
            }
        }
 
        if (min(val1, val2) >= zer)
        {
            ld t4 = min(val1, val2);
            ld ans4 = (on - t4) * mx2[k] - mn1[k - 1];
 
            if (fabs(ans4 - ans) < eps)
                used[4] = true;
            else if (ans4 < ans)
            {
                used[1] = used[2] = used[3] = false;
                used[4] = true;
                ans = ans4;
            }
        }
 
        ld t = zer;
 
        for (int i = 1; i < 5; ++i)
        {
            if (used[1])
                t = max(t, val1);
            else if (used[2])
                t = max(t, max(val1, max(val2, zer)));
            else if (used[3])
                t = max(t, val2);
            else
                t = max(t, min(val1, val2));
        }
 
        cout << ' ' << t;
    }
 
    return 0;
}