#include <bits/stdc++.h>

#define pb push_back
#define pp pop_back
#define pii pair<int, int>
#define ll long long
#define F first
#define S second
#define all(s) s.begin(), s.end()
#define int ll

using namespace std;

const int MAXN = 1e6 + 11;
int n, a[MAXN], b[MAXN];

bool ch(int x){
    int cur[n + 11];
    for(int i = 1; i <= n; i++){
        cur[i] = b[i];
    }

    int save = 0;
    queue<int> pos;
    for(int i = 1; i <= n; i++){
        if(cur[i])
            pos.push(i);

        int j = i - x;
        while(!pos.empty() and pos.front() < j){
            pos.pop();
        }
        //cout << 1 << endl;

        int num = a[i];
        while(num > 0 and !pos.empty()){
            int id = pos.front();
            if(cur[id] > num){
                cur[id] -= num;
                num = 0;
            }
            else{
                num -= cur[id];
                pos.pop();
            }
        }
        //cout << 2 << endl;

        j = max(save, i + 1);
        while(num > 0){
            if(j > i + x or j > n){
                return 0;
            }

            if(cur[j] > num){
                cur[j] -= num;
                num = 0;
            }
            else{
                num -= cur[j];
                cur[j] = 0;
                save = j;
            }
            j++;
        }
        //cout << i << endl;
    }
    return 1;
}

void solve(){
    cin >> n;
    for(int i = 1; i <= n; i++){
        cin >> a[i];
    }
    for(int i = 1; i <= n; i++){
        cin >> b[i];
    }

    ll tot = 0;
    for(int i = 1; i <= n; i++){
        tot += a[i];
        tot -= b[i];
    }
    if(tot > 0){
        cout << -1;
        return;
    }

    int l = 0, r = n - 1, res = n;
    while(l <= r){
        int mid = (l + r) / 2;
        if(ch(mid)){
            //cout << mid << endl;

            res = min(res, mid);
            r = mid - 1;
        }
        else{
            l = mid + 1;
        }
    }

    cout << res;
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

    int tt = 1;
    for(int i = 1; i <= tt; i++){
        solve();
    }

    return 0;
}
