#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 3e6;

int n, a[N], b[N], dup[N];

bool ok(int k) {
    for (int i = 1; i <= n; i++) {
        dup[i] = a[i];
    }
    int cur = 1;
    for (int i = 1; i <= n && cur <= n; i++) {
        int cap = b[i];
        if (cur < i - k) return 0;
        while (cur <= min(n, i + k) && cap >= dup[cur]) {
            cap -= dup[cur];
            dup[cur] = 0;
            cur++;
        }
        if (cur <= min(n, i + k))
            dup[cur] -= cap;
    }
    for (int i = 1; i <= n; i++) if (dup[i] > 0) return 0;
    return 1;
}

int get() {
    int l = -1, r = n;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (ok(m)) r = m;
        else l = m;
    }
    return r;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin >> n;
    long long s = 0;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        s += a[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> b[i];
        s -= b[i];
    }
    if (s > 0) cout << "-1", exit(false);
    cout << get();
    return 0;
}
