#include <bits/stdc++.h>

using namespace std;

const int N = 1e6 + 123;
int n, l;
string s[N];

int has[N][27];

void solve(vector<int> &pos, int j) {
    if(pos.size() <= 1) return;
    if (j >= l) {
        cout << "NO";
        exit(0);
    }
    int n = pos.size();
    for(int c = 'a'; c <= 'z'; c ++) {
        int cnt = 0, ok = 1;
        for (int i : pos) {
            ok &= has[i][c - 'a'];
            cnt += (s[i][j] == c);
        }
        if (!ok) continue;
        if (cnt == n || cnt == 0) continue;
        vector<int>t1, t2;
        for (int i : pos) {
            if (s[i][j] == c) t1.emplace_back(i);
            else t2.emplace_back(i);
        }
        solve(t1, 0);
        solve(t2, 0);
        return;
    }
    solve(pos , j + 1);
}

/*
void solve(vector<int> &pos) {
    if(pos.size() <= 1) return;
    int n = pos.size();
    for(int c = 'a'; c <= 'z'; c ++) {
        vector <pair <ll, int> > v;
        bool ok = 1, y = 0;
        for (auto i: pos) {
            ll v1 = 1 , ok = 0;
            for (int j = 0; j < l; ++j) {
                if (s[i][j] == c)
                    v1 = (v1*P%mod + j) % mod , ok = 1;
            }
            if (ok)
                v.push_back({v1, i});
        }
        if (v.size() != n) continue;
        sort(v.begin(), v.end());
        for (int i = 0; i < v.size(); ++i) {
            int j = i;
            vector <pair <int, int> > vec;
            while (v[i].first == v[j].first && j < (int)v.size()) {
                vec.push_back({p[v[j].second], v[j].second});
                ++j;
            }
            sort(vec.begin(), vec.end());
            for (int k = 0; k < vec.size(); ++k) {
                int h = k;
                ++sz;
                while (h < (int)vec.size() && vec[k].first == vec[h].first) {
                    p[vec[h].second] = sz;
                    ++h;
                }
                k = h - 1;
            }
            i = j - 1;
        }
    }
    vector<pair<int,int>> np;
    for (auto i: pos) {
        np.push_back({p[i] , i});
    }
    sort(np.begin() , np.end());
    for(int i = 0; i < np.size(); i ++) {
        int j = i;
        vector<int> t1;
        while(np[i].first == np[j].first && j < np.size()) {
            t1.push_back(np[j].second);
            j ++;
        }
        if(t1.size() != pos.size())
            solve(t1);
        i = j-1;
    }
}
*/

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    cin >> l >> n;
    vector<int> pos;
    for (int i = 1; i <= n; ++i) pos.push_back(i);
    for (int i = 1; i <= n; ++i) cin >> s[i];
    for (int j = 1 ; j <= n ; ++ j) {
        for (int k = 0 ; k < l ; ++ k) {
            has[j][s[j][k] - 'a'] = 1;
        }
    }
    solve(pos, 0);
    cout << "YES";
}
