#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define ld long double

mt19937_64 rndll(239);

const ld INF = 2e9, eps = 1e-9;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<ld> a(n + 2), mnl(n + 2, INF), mnr(n + 2, INF), mxl(n + 2, -INF), mxr(n + 2, -INF), sum(n + 2);
    for (int i = 1; i <= n; i++){
        int val;
        cin >> val;
        a[i] = val;
    }
    for (int i = 1; i <= n; i++){
        mnl[i] = min(mnl[i - 1], a[i]);
        mxl[i] = max(mxl[i - 1], a[i]);
    }
    for (int i = n; i >= 1; i--){
        mnr[i] = min(mnr[i + 1], a[i]);
        mxr[i] = max(mxr[i + 1], a[i]);
        sum[i] = sum[i + 1] + a[i];
    }
    for (int i = 1; i <= n; i++){
        vector<ld> u{1, 0};
        pair<ld, ld> ans = {INF, -INF};
        ld t_ans = 0;
        if (mnr[i] > mnl[i - 1] && i > 1){
            u.pb(1.0 - mnl[i - 1] / mnr[i]);
        }
        if (mxr[i] > mxl[i - 1] && i > 1){
            u.pb(1.0 - mxl[i - 1] / mxr[i]);
        }
        for (auto t : u){
            ld new_mn = min(mnl[i - 1], (1.0 - t) * mnr[i]), new_mx = max(mxl[i - 1], (1.0 - t) * mxr[i]);
            if (new_mx - new_mn < ans.first - eps){
                ans = {new_mx - new_mn, sum[i] * t};
                t_ans = t;
            }
            else if (abs((new_mx - new_mn) - ans.first) < eps && sum[i] * t > ans.second + eps){
                ans = {new_mx - new_mn, sum[i] * t};
                t_ans = t;
            }
        }
        cout <<  setprecision(10) << fixed << t_ans << ' ';
    }
    return 0;
}
