#include <bits\stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<class S>
using ordered_set = tree<S, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;

int n;

bool f(int x, vector<int> a, vector<int> b) {
    int p = 0;
    for (int i = 0; i < n; ++i) {
        p = max(p, i - x);
        int mx = min(a[i], b[i]);
        a[i] -= mx;
        b[i] -= mx;

        while (a[i] && p < min(n, i + x)) {
            mx = min(a[i], b[p]);
            a[i] -= mx;
            b[p] -= mx;
            if (!b[p]) ++p;
        }
        if (a[i]) return 0;
    }
    return 1;
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("outut.txt", "w", stdout);
#endif

    ll A = 0, B = 0;
    cin >> n;
    vector<int> a(n), b(n);
    for (int &i: a) {
        cin >> i;
        A += i;
    }
    for (int &i: b) {
        cin >> i;
        B += i;
    }

    if (B < A) {
        cout << -1;
        exit(0);
    }

    int l = -1, r = n - 1;
    while (r - l > 1) {
        int m = (l + r) >> 1;
        (f(m, a, b) ? r : l) = m;
    }

    cout << r;
}
