#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = int_fast64_t;
using ull = uint_fast64_t;

#define int ll
#define len(a) (int)(a).size()
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()


const int INF = 1 << 29;
const ll INFll = 1ll << 62;
const int N = 2e5 + 3;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &o: v)
        is >> o;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (T &o: v)
        os << o;
    return os;
}


int n;
vector<int> a, b;

bool check(int k){
    vector<int> acpy = a;
    int pos = 0;
    for (int i = 0; i < n; ++i) {
        if(pos < i - k)
            return false;
        int t = b[i];
        while(t && pos < n && pos <= i + k){
            if(t < acpy[pos]){
                acpy[pos] -= t;
                t = 0;
            }else{
                t -= acpy[pos];
                ++pos;
            }
        }
    }
    return pos == n;
}

void solve() {
    cin >> n;
    a.resize(n);
    b.resize(n);
    cin >> a >> b;
    if(accumulate(all(a), 0ll) > accumulate(all(b), 0ll)) {
        cout << -1;
        return;
    }
    int l = -1, r = n - 1;
    while(l + 1 < r){
        int m = (l + r) / 2;
        if(check(m))
            r = m;
        else
            l = m;
    }
    cout << r;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
