#include <iostream>
#include <iomanip>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <queue>

using namespace std;

typedef long long ll;

typedef unsigned long long ull;

bool com(pair<ll, ll> &a, pair <ll, ll> &b) {
	return a.first <= b.first;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n;
	cin >> n;
	vector<pair<ll, ll>> wagons(n);
	queue<ll> mainFlow;
	map<ll, ll> trecker;
	for (int i = 0; i < n; i++) {
		pair<ll, ll> wagon;
		cin >> wagon.first;
		wagon.second = i;
		wagons[i] = wagon;
		mainFlow.push(wagon.first);
		trecker[i] = -1;
	}
	sort(wagons.begin(), wagons.end(), com);
	stack <ll> first, second;
	for (int i = 0; i < n; i++) {
		if (trecker[wagons[i].first] == -1) {
			while (mainFlow.front() != wagons[i].first) {
				pair<ll, ll> wagon;
				wagon.first = mainFlow.front();
				mainFlow.pop();

				first.push(wagon.first);
				trecker[wagon.first] = 1;
				cout << 1 << endl;
			}

			pair<ll, ll> wagon;
			wagon.first = mainFlow.front();
			mainFlow.pop();
			cout << 1 << endl;
			cout << -1 << endl;
		}
		else {
			if (trecker[wagons[i].first] == 1) {
				while (first.top() != wagons[i].first) {
					pair<ll, ll> wagon;
					wagon.first = first.top();
					first.pop();

					second.push(wagon.first);
					trecker[wagon.first] = 2;
					cout << 12 << endl;
				}
				pair<ll, ll> wagon;
				wagon.first = first.top();
				first.pop();
				cout << -1 << endl;
			}
			else {
				while (second.top() != wagons[i].first) {
					pair<ll, ll> wagon;
					wagon.first = second.top();
					second.pop();

					first.push(wagon.first);
					trecker[wagon.first] = 1;
					cout << 21 << endl;
				}
				pair<ll, ll> wagon;
				wagon.first = second.top();
				second.pop();
				cout << -2 << endl;
			}
		}
	}
}