
#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

ll ok = 1;
vector<vector<vector<ll>>> inds;
vector<string> ss;

vector<ll> getsame(vector<ll> &is) {
    vector<vector<ll>> cnt(is.size(), vector<ll>(26));
    for (ll i = 0; i < is.size(); i++) {
        for (ll j = 0; j < ss[is[i]].size(); j++) {
            cnt[i][ss[is[i]][j] - 'a'] = 1;
        }
    }
    vector<ll> res(26);
    for (ll i = 0; i < 26; i++) {
        ll sum = 0;
        for (ll j = 0; j < is.size(); j++) {
            sum += cnt[j][i];
        }
        if (sum == is.size()) res[i] = 1;
    }
    return res;
}

void gen(ll c, vector<ll> &used, vector<ll> &cur) {
    if (!ok) return;
    if (c == 26) {
        if (cur.size() > 1) {
            ok = 0;
        }
        return;
    }
    used[c] = 1;
    map<vector<ll>, vector<ll>> pos;
    for (ll i: cur) {
        if (!inds[i][c].empty()) {
            pos[inds[i][c]].push_back(i);
        }
    }
    for (auto &p: pos) {
        if (p.second.size() >= 2) {
            vector<ll> same = getsame(p.second);
            ll s = -1;
            for (ll j = 0; j < 26; j++) {
                if (!used[j] && same[j]) {
                    s = j;
                    break;
                }
            }
            if (s == -1) {
                ok = 0;
                return;
            }
            gen(s, used, p.second);
        }
    }
    used[c] = 0;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, l;
    cin >> l >> n;
    inds.resize(n, vector<vector<ll>>(26));
    vector<ll> all, cur;
    for (ll i = 0; i < n; i++) {
        all.push_back(i);
        string s;
        cin >> s;
        ss.push_back(s);
        for (ll j = 0; j < l; j++) {
            inds[i][s[j] - 'a'].push_back(j);
        }
    }
    vector<ll> st = getsame(all);
    ll same = -1;
    for (ll j = 0; j < 26; j++) {
        if (st[j]) {
            same = j;
            break;
        }
    }
    if (same == -1) {
        cout << "NO\n";
        return 0;
    }
    vector<ll> used(26);
    gen(same, used, all);
    if (ok) {
        cout << "YES";
    } else {
        cout << "NO";
    }
    return 0;
}
