#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int N = 5e5 + 20;
const ll mod = 1e9 + 7;

int n, k;
vector<int> a, b;
ll result, pref[N];

int t[4 * N];

void build(int v, int tl, int tr){
      if(tl == tr){
            t[v] = tl;
            return;
      }
      int tm = (tl + tr) / 2;
      build(v * 2, tl, tm);
      build(v * 2 + 1, tm + 1, tr);
      int x = t[v * 2], y = t[v * 2 + 1];
      if(a[y] % k == b[y] % k)
            t[v] = x;
      else if(a[x] % k == b[x] % k)
            t[v] = y;
      else if(a[x] - b[x] > a[y] - b[y])
            t[v] = y;
      else
            t[v] = x;
}

int get(int v, int tl, int tr, int l, int r){
      if(l > r)
            return -1;
      if(tl == l && tr == r)
            return t[v];
      int tm = (tl + tr) / 2;
      int x = get(v * 2, tl, tm, l, min(r, tm));
      int y = get(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r);
      if(x == -1)
            return y;
      if(y == -1)
            return x;
      if(a[y] % k == b[y] % k)
            return x;
      if(a[x] % k == b[x] % k)
            return y;
      if(a[x] - b[x] > a[y] - b[y])
            return y;
      return x;
}

//unordered_map<int, int> qc[4 * N], wc[4 * N];
//unordered_map<int, ll> qs[4 * N], wsm[4 * N];
//
//void build2(int v, int tl, int tr){ // right
//      for(int i = tl; i <= tr; i ++){
//            qc[v][pref[i] % k] ++;
//            (qs[v][pref[i] % k] += pref[i]) %= mod;
//      }
//      if(tl == tr)
//            return;
//      int tm = (tl + tr) / 2;
//      build2(v * 2, tl, tm);
//      build2(v * 2 + 1, tm + 1, tr);
//}
//
//pair<ll, int> get2(int v, int tl, int tr, int l, int r, int x){
//      if(l > r)
//            return make_pair(0, 0);
//      if(tl == l && tr == r)
//            return {qs[v][x], qc[v][x]};
//      int tm = (tl + tr) / 2;
//      auto A = get2(v * 2, tl, tm, l, min(r, tm), x);
//      auto B = get2(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r, x);
//      return make_pair((A.first + B.first) % mod, A.second + B.second);
//}
//
//void build3(int v, int tl, int tr){ // left
//      for(int i = tl; i <= tr; i ++){
//            wc[v][(i == 0 ? 0 : pref[i - 1]) % k] ++;
//            (wsm[v][(i == 0 ? 0 : pref[i - 1]) % k] += (i == 0 ? 0 : pref[i - 1])) %= mod;
//      }
//      if(tl == tr)
//            return;
//      int tm = (tl + tr) / 2;
//      build3(v * 2, tl, tm);
//      build3(v * 2 + 1, tm + 1, tr);
//}
//
//pair<ll, int> get3(int v, int tl, int tr, int l, int r, int x){
//      if(l > r)
//            return make_pair(0, 0);
//      if(tl == l && tr == r)
//            return {wsm[v][x], wc[v][x]};
//      int tm = (tl + tr) / 2;
//      auto A = get3(v * 2, tl, tm, l, min(r, tm), x);
//      auto B = get3(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r, x);
//      return make_pair((A.first + B.first) % mod, A.second + B.second);
//}

vector<tuple<int, int, int, int, ll>> ask2, ask3;


void solve(int l, int r){
      if(l > r)
            return;
      // segments [l...p, p...r]
      int p = get(1, 0, n - 1, l, r);
      if(a[p] % k == b[p] % k)
            return;
      if(p - l <= r - p){
            for(int i = l; i <= p; i ++){
                  ask2.emplace_back(p, r, i, (i == 0 ? 0 : pref[i - 1] % k), (i == 0 ? 0 : pref[i - 1] % mod));
//                  auto w = get2(1, 0, n - 1, p, r, (i == 0 ? 0 : pref[i - 1] % k)); // pair (sum, cnt)
//                  result = (result + (w.first - (i == 0 ? 0 : pref[i - 1] % mod) * w.second % mod + mod) % mod + (w.second % mod * (b[p] % mod - a[p] % mod) % mod) + mod) % mod;
//                  result %= mod;
            }
      }else{
            for(int i = p; i <= r; i ++){
                  ask3.emplace_back(l, p, i, pref[i] % k, pref[i] % mod);
//                  auto w = get3(1, 0, n - 1, l, p, pref[i] % k); // pair (sum, cnt)
//                  result = (result + ((pref[i] % mod) * (w.second % mod)) % mod - w.first % mod + mod + (w.second % mod * (b[p] % mod - a[p] % mod) % mod) + mod) % mod;
//                  result %= mod;
            }
      }
      solve(l, p - 1);
      solve(p + 1, r);
}

//void brute(){
//      for(int l = 0; k <
//}

//3 3
//1 3 6 7 2 2

const int B = 700;

bool cmp(const tuple<int, int, int, int, ll>& x, const tuple<int, int, int, int, ll>& y){
      if(get<0>(x) / B == get<0>(y) / B)
            return get<1>(x) < get<1>(y);
      return get<0>(x) / B < get<0>(y) / B;
}

int main(){
      ios_base :: sync_with_stdio(0);
      cin.tie(0); cout.tie(0);
      cin >> n >> k;
      a.resize(n), b.resize(n);
      for(int i = 0; i < n; i ++){
            cin >> a[i] >> b[i];
            if(a[i] < b[i])
                  swap(a[i], b[i]);
      }
      ll all_p = 0;
      map<int, pair<int, ll>> sum;
//      vector<pair<int, ll>> sum(k);
      sum[0] = {1, 0};
      for(int i = 0; i < n; i ++){ // sum all segments without inverting with % k != 0
            pref[i] = (i > 0 ? pref[i - 1] : 0) + a[i];
            result = (result + (pref[i] % mod) * (i + 1) % mod) % mod;
            result = (result - all_p % mod + mod) % mod;
//            result -= all_p % mod;
            result = (result - ((pref[i] % mod) * sum[pref[i] % k].first % mod - sum[pref[i] % k].second % mod + mod) % mod + mod) % mod;
//            result -= ((pref[i] % mod) * sum[pref[i] % k].first % mod - sum[pref[i] % k].second) % mod;
//            while(result < 0)
//                  result += mod;
//            result %= mod;
            sum[pref[i] % k].first ++;
            sum[pref[i] % k].second += pref[i];
            all_p += pref[i];
//            result %= mod;
      }
//      cout << result << endl;
      build(1, 0, n - 1);
//      build2(1, 0, n - 1);
//      build3(1, 0, n - 1);
      solve(0, n - 1);
//      result %= mod;
//      while(result < 0)
//            result += mod;
//      cout << result;
      map<int, int> cnt;
      map<int, ll> sm;
      {
            sm.clear();
            cnt.clear();
            int L = 0, R = -1;
            sort(ask2.begin(), ask2.end(), cmp);
            for(auto [p, r, i, x, prf] : ask2){
                  while(R < r){
                        ++ R;
                        cnt[pref[R]%k] ++;
                        (sm[pref[R]%k] += pref[R] % mod) %= mod;
                  }
                  while(R > r){
                        sm[pref[R]%k] -= pref[R] %= mod;
                        (sm[pref[R]%k] += mod) %= mod;
                        cnt[pref[R]%k] --;
                        -- R;
                  }
                  while(L < p){
                        sm[pref[L]%k] -= pref[L] %= mod;
                        (sm[pref[L]%k] += mod) %= mod;
                        cnt[pref[L]%k] --;
                        ++ L;
                  }
                  while(L > p){
                        -- L;
                        (sm[pref[L]%k] += pref[L] % mod) %= mod;
                        cnt[pref[L]%k] ++;
                  }
                  auto w = make_pair(sm[x], cnt[x]);
                  result = (result + (w.first - prf * w.second % mod + mod) % mod + (w.second % mod * (b[p] % mod - a[p] % mod) % mod) + mod) % mod;
            }
      }
      {
            sm.clear();
            cnt.clear();
            int L = 0, R = -1;
            sort(ask3.begin(), ask3.end(), cmp);
            for(auto [p, r, i, x, prf] : ask3){
                  while(R < r){
                        ++ R;
                        cnt[(R==0?0:pref[R-1]%k)] ++;
                        (sm[(R==0?0:pref[R-1]%k)] += (R==0?0:pref[R-1])) %= mod;
                  }
                  while(R > r){
                        sm[(R==0?0:pref[R-1]%k)] -= (R==0?0:pref[R-1]) %= mod;
                        (sm[(R==0?0:pref[R-1]%k)] += mod) %= mod;
                        cnt[(R==0?0:pref[R-1]%k)] --;
                        -- R;
                  }
                  while(L < p){
                        sm[(L==0?0:pref[L-1]%k)] -= (L==0?0:pref[L-1]) %= mod;
                        (sm[(L==0?0:pref[L-1]%k)] += mod) %= mod;
                        cnt[(L==0?0:pref[L-1]%k)] --;
                        ++ L;
                  }
                  while(L > p){
                        -- L;
                        (sm[(L==0?0:pref[L-1]%k)] += (L==0?0:pref[L-1]) % mod) %= mod;
                        cnt[(L==0?0:pref[L-1]%k)] ++;
                  }
                  auto w = make_pair(sm[x], cnt[x]);
                  result = (result + ((prf % mod) * (w.second % mod)) % mod - w.first % mod + mod + (w.second % mod * (b[p] % mod - a[p] % mod) % mod) + mod) % mod;
            }
      }
      cout << result;
}
