#include <bits/stdc++.h>
#define pb push_back


using namespace std;
typedef long long ll;
typedef long double ld;
#define int int64_t
#define endl '\n'
const int N = 1e3+10;
const ld eps = 1e-11;

void solve()
{
    int n;
    cin >> n;
    ld a[n];
    ld pmn[n], pmx[n], smn[n], smx[n];
    for (int i=0;i<n;++i) {
        int x;
        cin >> x;
        a[i] = x;
    }
    pmn[0] = a[0];
    pmx[0] = a[0];
    for(int i=1;i<n;++i) {
        pmn[i] = min(pmn[i-1], a[i]);
        pmx[i] = max(pmx[i-1], a[i]);
    }
    smn[n-1] = a[n-1];
    smx[n-1] = a[n-1];
    for(int i=n-2;i>=0;--i) {
        smn[i] = min(smn[i+1], a[i]);
        smx[i] = max(smx[i+1], a[i]);
    }
    cout << "1.000 ";
    for (int k=1;k<n;++k) {
        ld cr1, cr2;
        if (pmx[k-1] > smx[k]) cr1 = 1;
        else {
            ld l = 0, r = 1;
            while (r - l > eps) {
                ld mid = (l+r)/2.0;
                if (pmx[k-1] > smx[k] * mid)
                    l = mid;
                else
                    r = mid;
            }
            cr1 = l;
        }
        if (pmn[k-1] > smn[k]) cr2 = 1;
        else {
            ld l = 0, r = 1;
            while (r - l > eps) {
                ld mid = (l+r)/2.0;
                if (pmn[k-1] < smn[k] * mid)
                    r = mid;
                else
                    l = mid;
            }
            cr2 = l;
        }
        ld s1 = max(pmx[k-1], smx[k] * cr1) - min(pmn[k-1], smn[k] * cr1);
        ld s2 = max(pmx[k-1], smx[k] * cr2) - min(pmn[k-1], smn[k] * cr2);
        ld s3 = max(pmx[k-1], smx[k] * 0) - min(pmn[k-1], smn[k] * 0);
        if (s3 < min(s1, s2) || abs(s3 - min(s1, s2)) < eps) {cr1 = 0;cr2 = 0;}
        if (abs(s1-s2) < eps) {
            if (s1 < s2) {
                cout << fixed << setprecision(12) << 1.0-cr1;
            }
            else {
                cout << fixed << setprecision(12) << 1.0-cr2;
            }
        }
        else {
            cout << fixed << setprecision(12) << 1.0-min(cr1, cr2);
        }
        cout << ' ';
    }
}

int32_t main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

   #ifdef LOCAL
   freopen("input.txt","r",stdin);
   freopen("output.txt","w",stdout);
   #else


   #endif // LOCAL

   solve();
   return 0;

}
