#include <bits/stdc++.h>

using namespace std;

typedef long double ld;

#define vec vector
#define all(x) (x).begin(), (x).end()

mt19937 gen(time(0));

void INPUT(bool F = 0) {

    iostream::sync_with_stdio(false);
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);


}

const ld eps = 1e-12;
ld calc(vec<int>& id, vec<ld>& t) {


    ld l = 0, r = 1e9 + 10;

    while(r - l > eps) {
        ld m = (l + r) / 2.0;
        bool ok = 1;
        if(ld(1.0) * (t[id[0]] - 1.0) * (t[id[3]] - 1.0) < m) ok = 0;
        if(ld(1.0) * (t[id[2]] - 1.0) * (t[id[1]] - 1.0) < m) ok = 0;
        if(ok) l = m;
        else r = m;
    }
    bool ok = 1;
    if(ld(1.0) * (t[id[0]] - 1.0) * (t[id[3]] - 1.0) < r) ok = 0;
    if(ld(1.0) * (t[id[2]] - 1.0) * (t[id[1]] - 1.0) < r) ok = 0;
    if(ok) return r;
    return l;
}


void solve() {




    vec<ld> a(4);
    for(int i = 0; i < 4; i++) cin >> a[i];
    vec<int> id(4, 0);
    iota(all(id), 0);
    ld mxAns = -2e9;
    vec<int> ansId;
    do {


        if(calc(id, a) >  mxAns) {
            mxAns = calc(id, a);
            ansId = id;
        }

    }while(next_permutation(all(id)));



    for(int i: ansId) {
        cout << i + 1 << ' ';
    }
    cout << '\n';

    if(abs(a[ansId[0]] - 1) > eps) a[ansId[3]] = mxAns / (a[ansId[0]] - 1.0) + ld(1.0);

    if(abs(a[ansId[2]] - 1) > eps) a[ansId[1]] = mxAns / (a[ansId[2]] - 1.0) + ld(1.0);
    cout << fixed << setprecision(10);
    for(ld i: ansId) cout << a[i] << ' ';

}



signed main() {
    INPUT();


    solve();



    return 0;
}
