#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

#define fi first
#define se second
#define all(m) (m).begin(), (m).end()
#define rall(m) (m).rbegin(), (m).rend()
#define mp make_pair
#define vec vector
#define pb push_back
#define eb emplace_back
#define sz(x) (x).size()
#define double long double

typedef pair <int, int> pii;
typedef long long ll;
typedef unsigned long long ull;


const int SIZE = 1e5 + 42;

mt19937_64 rng((uint64_t) new char);

int l, n;
ll rands[SIZE];
string s[SIZE];


bool rec(const vec<int> &v) {
    if(v.size() == 1) {
        return 1;
    }

    int cur = (1 << 26) - 1;
    for(auto i : v) {
        int ccur = 0;
        for(auto j : s[i]) {
            if(j == '#') continue;
            ccur |= 1 << int(j - 'a');
        }
        cur &= ccur;
    }


    if(cur == 0) {
        return 0;
    }

    vec<int> nxt, cntused(v.size(), 0);

    for(int i = 0; i < l; i++) {
        vec<int> cnxt;
        vec<char> curused(v.size(), 0);

        for(int j = 0; j < v.size(); j++) {
            if(s[v[j]][i] == '#') {
                cntused[j]++;
            }
            else if(cur & (1 << int(s[v[j]][i] - 'a'))) {
                s[v[j]][i] = '#';
                cntused[j]++;
                if(cntused[j] != l) {
                    cnxt.push_back(v[j]);
                }
                curused[j] = 1;
            }
        }

        for(int j = 0; j < v.size(); j++) {
            if(!curused[j]) {
                cnxt.push_back(v[j]);
            }
        }
        nxt = cnxt;
    }

    if(nxt.empty()) {
        return 1;
    }

    for(int i = 0; i < nxt.size();) {
        auto check = [&](string &a, string &b) {
            for(int j = 0; j < l; j++) {
                if(a[j] == '#' && b[j] != '#' || b[j] == '#' && a[j] != '#') {
                    return false;
                }
            }
            return true;
        };


        int j = i;
        while(j < nxt.size() && check(s[nxt[i]], s[nxt[j]])) {
            j++;
        }

        if(i == 0 && j == v.size()) {
            return false;
        }

        if(!rec(vec<int>(nxt.begin() + i, nxt.begin() + j))) {
            return false;
        }

        i = j;
    }

//    if(ht.size() == 0) return 1;
//    if(ht.size() == 1 && sum == v.size()) return 0;

    return true;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cin >> l >> n;

    for(int i = 0; i < l; i++) {
        rands[i] = rng();
    }

    for(int i = 0; i < n; i++) {
        cin >> s[i];
    }



    vec<int> v;
    for(int i = 0; i < n; i++) v.push_back(i);

    if(rec(v)) {
        cout << "YES";
    }
    else {
        cout << "NO";
    }


    return 0;
}
