#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <utility>
#include <set>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <queue>
#include <cstring>

using namespace std;
using ll = long long;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	long long n;
	cin >> n;
	vector<long long> a(n);
	long long sumA = 0;
	for(long long i = 0; i < n; ++i) {
		cin >> a[i];
		sumA += a[i];
	}
	vector<long long> b(n);
	long long sumB = 0;
	for(long long i = 0; i < n; ++i) {
		cin >> b[i];
		sumB += b[i];
	}
	if(sumA > sumB) {
		cout << -1;
		return 0;
	}
	bool can0 = true;
	for (ll i = 0 ; i < n ; i++){
		if (a[i] > b[i]){
			can0 = false;
		}
	}
	if (can0){
		cout << 0;
		return 0;
	}
	ll l = 0; ///  
	ll r = n-1; /// 
	ll mid;
	long long amSt = 0;
	while (r - l > 1){
		mid = (l+r) / 2;
		ll cur = 0;
		for (ll i = 0 ; i <= mid ; i++){
			cur += b[i];
		}
		bool can = true;
		for (ll i = 0 ; i < n; i++){
			if (a[i] > cur){
				can = false;
			}
			cur -= a[i];

			if (i + mid + 1 < n){
				cur += b[i+mid + 1];
			}
			if (i - mid >= 0){
				if(a[i] > b[i - mid]) {
					amSt += a[i] - b[i - mid];
				} else {
					cur -= b[i-mid] - a[i];
				}
			}
		}
		if (can){
			r = mid;
		}else{
			l = mid;
		}
	}
	cout << r;
	/*
	long long l = 0, r = n + 1;
	long long ans = n;
	while(l + 1 < r) {
		long long k = (l + r) / 2;
		long long av = 0;
		for(long long i = 0; i <= k; ++i) {
			av += b[i];
		}
		bool pos = true;
		for(long long i = 0; i < n; ++i) {
			if(a[i] > av) {
				pos = false;
				break;
			}
			av -= a[i];
			if(i > k) {
				av -= b[i - k - 1];
			}
			if(i + k < n) {
				av += b[i + k];
			}
		}
		if(pos) {
			ans = min(ans, k);
			l = k;
		} else {
			r = k;
		}
	}
	cout << ans;
    */
    return 0;
}
