#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int long long

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<int> a(n);
	int suma = 0;
	vector<int> b(n);
	int sumb = 0;
	for(int i = 0; i < n; i++){
		cin >> a[i];
		suma += a[i];
	}
	for(int i = 0; i < n; i++){
		cin >> b[i];
		sumb += b[i];
	}
	if(suma > sumb){
		cout << -1;
		return 0;
	}
	int l = -1;
	int r = n - 1;
	while(r - l > 1){
		int mid = (l + r) / 2;
		vector<int> bb = b;
		vector<int> aa = a;
		int last = 0;
		bool good = true;
		for(int i = 0; i < n; i++){
			last = max(last, i - mid);
			while(aa[i] > 0 && last < n && last <= i + mid){
				if(aa[i] >= bb[last]){
					aa[i] -= bb[last];
					bb[last] = 0;
					last++;
				}else{
					bb[last] -= aa[i];
					aa[i] = 0;
				}
			}
			if(aa[i] != 0){
				good = false;
				break;
			}
		}
		if(good){
			r = mid;
		}else{
			l = mid;
		}
	}
	cout << r;

    return 0;
}
