#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define ll long long
#define pii pair<int, int>

ll binpow(ll n, int p) {
	ll ans = n;
	int pos = 1;
	while (pos < p) {
		if (pos * 2 <= p) {
			pos *= 2;
			ans *= ans;
		}
		else {
			pos++;
			ans *= n;
		}
	}
	return ans;
}

const int INF = 1e9 + 7;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout << fixed;
	cout.precision(20);
	//freopen("input.txt", "r", stdin);
	int n;
	cin >> n;
	vector<int> a(n);
	for (auto& i: a) {
		cin >> i;
	}
	vector<int> lmax(n), lmin(n), rmax(n), rmin(n);
	int mn = INF, mx = 0;
	for (int i = 0; i < n; ++i) {
		if (mn > a[i]) {
			mn = a[i];
		}
		if (mx < a[i]) {
			mx = a[i];
		}
		lmax[i] = mx;
		lmin[i] = mn;
	}
	mn = INF, mx = 0;
	for (int i = n - 1; i >= 0; --i) {
		if (mn > a[i]) {
			mn = a[i];
		}
		if (mx < a[i]) {
			mx = a[i];
		}
		rmax[i] = mx;
		rmin[i] = mn;
	}
	cout << 1.0 << ' ';
	for (int i = 1; i < n; ++i) {
		int a = lmax[i - 1] - lmin[i - 1],
		b = rmax[i] - rmin[i],
		c = lmax[i - 1] - rmin[i],
		d = rmax[i] - lmin[i - 1];
		if (a > b && a > c && a > d) {
			cout << 0.0 << ' ';
		}
		else if (b > a && b > c && b > d) {
			cout << 1.0 << ' ';
		}
		else if (c > b && c > a && c > d) {
			cout << 0.0 << ' ';
		}
		else {
			cout << 1.0 - 1.0 * lmin[i - 1] / rmax[i] << ' ';
		}
	}
	return 0;
}
