#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define endl '\n'
#define gi(x) int(x-'a')
#define all(var) var.begin(),var.end()
#define mp make_pair
const int base = 26;
struct node{
    vector<int> links;
    int cnt,depth,ed;
    node(){
        links.resize(base+7,-1);
        cnt = 0;
        ed = 0;
    }
};
const int SZ = 1e6+7;
node T[SZ];
int ptr = 1;
int par[SZ];
int add(int v,int depth,string &s){
    if (v==-1){
        T[++ptr] = node();
        v = ptr;
    }
    T[v].depth = depth;
    T[v].cnt++;
    if (depth>=s.size()) {
        T[v].ed++;
        return v;

    }
    T[v].links[gi(s[depth])] = add(T[v].links[gi(s[depth])],depth+1,s);
    par[T[v].links[gi(s[depth])]] = v;
    return v;
}
const int LOG = 21;
int dp[SZ],P[SZ][LOG],pr[SZ][LOG],clk[SZ];
int total = 0;
void calc(int v,int depth,int len,int par,int rp){
    if (v==-1)
        return;
    pr[v][0] = rp;
    clk[v] = total;
    total+=T[v].ed;
    for(int i = 1;i<LOG;++i)
        pr[v][i] = pr[pr[v][i-1]][i-1];
    if (depth<=len){
        dp[v] = 0;
        for(int i = 0;i<par;++i){
            if (T[v].links[i]==-1)
                continue;
            dp[v]+=T[T[v].links[i]].cnt;
        }
    }
    for (int i = 0;i<base;++i) {
        int to = T[v].links[i];
        if (to == -1)
            continue;
        calc(to, depth + 1, len, i,v);
        if (v!=0){
            if (i==par)
                dp[v]+=dp[to];
            if (i<par) dp[v]+=T[to].cnt;
        }
    }
    int to = T[v].links[par];
    P[v][0] = to;
    for(int i = 1;i<LOG;++i){
        if (P[v][i-1]!=-1) P[v][i] = P[P[v][i-1]][i-1];
        else P[v][i] = -1;
    }

}

int calc_v(int v,int symb){
    if (v==-1)
        return 0;
    int ret = 0;
    if (symb!=-1)
        ret+=T[v].ed;
    for(int i = 0;i<symb;++i)
        if (T[v].links[i]!=-1)
            ret+=T[T[v].links[i]].cnt;

    return ret;
}
int getpos(int v,int depth,string &s){
    if (v==-1){
        return v;
    }
    T[v].cnt++;
    if (depth>s.size())
        return v;

    return max(v,getpos(T[v].links[gi(s[depth])],depth+1,s));
}
int getans(int v,int last){
    int ret = 0;
    if (last!=-1 && T[v].links[last]!=-1)
        ret+=dp[T[v].links[last]];
    return calc_v(v,last)+clk[v]+ret;
}
void solve(){
    int n,q;
    cin>>n>>q;
    string S;
    cin>>S;
    T[0] = node();
    for(int i = 1;i<=n;++i){
        string s;
        cin>>s;
        add(0,0,s);
    }

    int len = S.length();
    calc(0,0,len,0,0);
    int v = getpos(0,0,S);
    int last = -1;
    if (T[v].depth!=len)
        last = gi(S[T[v].depth]);
    cout<<getans(v,last)<<endl;
    vector<pair<int,int> > V;
    int ptr = 0;
    for(char to:S)
        V.push_back({++ptr,gi(to)});
    while(q--){
        int pos;
        char symb;
        cin>>pos>>symb;
        for(int lg = LOG-1;lg>=0;--lg)
            if (T[pr[v][lg]].depth>=pos)
                v = pr[v][lg];
        if (T[v].depth>=pos)
            v = pr[v][0];
        if (pos==T[v].depth+1){
            int need = len-pos;
            if (T[v].links[gi(symb)]!=-1) {
                int to = T[v].links[gi(symb)];
                for (int lg = LOG - 1; lg >= 0; --lg)
                    if ((1<<lg)<=need && P[to][lg]!=-1){
                        to = P[to][lg];
                        need-=(1<<lg);
                    }
                v = to;
            }
        }
        while(!V.empty() && V.back().first>=pos)
            V.pop_back();
        V.push_back({pos,gi(symb)});
        int ps = T[v].depth;
        if (ps==len)
            last = -1;
        else{
            int pos = lower_bound(all(V),mp(ps,-1))-V.begin();
            last = V[pos].second;
        }

        cout<<getans(v,last)<<endl;
    }
}
int main()
{
    ios_base::sync_with_stdio(); cin.tie();
    int t = 1;
    while(t--)
        solve();
    return 0;
}
