#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define endl '\n'
const int N = 2e5+7;
const int INF = 2e9+7;
const ld eps = 1e-9;
int A[N];
pair<int,int> pref[N],suf[N];
ld F(pair<int,int> p2,pair<int,int> p1){
    int a = p1.first,b = p1.second, c = p2.first,d = p2.second;
    pair<ld,ld> res = {INF,0};
    //// ak<=c
    {
        ld lbnd = 0, rbnd = min(ld(1),ld(c) / a);
        // bk<=d
        {
            rbnd = min(rbnd, ld(d) / b);
            if (lbnd<=rbnd || abs(lbnd-rbnd)<eps)
                res = min(res, {d - a * rbnd, rbnd});
        }
        // bk>=d
        {
            lbnd = max(lbnd,ld(d)/b);
            if (lbnd<=rbnd || abs(lbnd-rbnd)<eps){
                res = min(res,{ld(b-a)*lbnd,lbnd});
            }
        }
    }
    // ak>=c
    {
        ld lbnd = ld(c) / a, rbnd = 1;
        // bk<=d
        {
            rbnd = min(rbnd, ld(d) / b);
            if (lbnd<=rbnd || abs(lbnd-rbnd)<eps){
                res = min(res,{d-c,lbnd});
            }
        }
        // bk>=d
        {
            lbnd = max(lbnd,ld(d)/b);
            if (lbnd<=rbnd || abs(lbnd-rbnd)<eps){
                res = min(res,{b*lbnd-c,lbnd});
            }
        }
    }
    return ld(1)-res.second;
}
void solve(){
    int n;
    cin>>n;
    for(int i = 1;i<=n;++i){
        cin>>A[i];
    }
    pref[0] = {INF,-INF};
    for(int i = 1;i<=n;++i){
        pref[i].first = min(pref[i-1].first,A[i]);
        pref[i].second = max(pref[i-1].second,A[i]);
    }
    suf[n+1] = {INF,-INF};
    for(int i = n;i>=1;--i){
        suf[i].first = min(suf[i+1].first,A[i]);
        suf[i].second = max(suf[i+1].second,A[i]);
    }
    for(int i = 1;i<=n;++i){
        if (i==1)
            cout<<1<<' ';
        else
            cout<<fixed<<setprecision(10)<<F(pref[i-1],suf[i])<<' ';
    }
}
int main()
{
    ios_base::sync_with_stdio(); cin.tie();
    int t = 1;
    while(t--)
        solve();
    return 0;
}
