#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define endl '\n'
const int N = 2e5+7;
const int INF = 2e9+7;
const ld eps = 1e-18;
int A[N];
pair<int,int> pref[N],suf[N];
struct drib{
    ll a,b;
    drib(ll _a,ll _b){
        a = _a;
        b = _b;
    }
};
void nr(drib &a){
   // ll g = __gcd(a.a,a.b);
    //a.a/=g;
   // a.b/=g;
}
void norm(drib &a,drib &b){
    nr(a);
    nr(b);
}
const drib operator + (drib a,drib b){
    norm(a,b);
    ll g = a.b/__gcd(a.b,b.b)*b.b;
    a.a*=g/a.b;
    b.a*=g/b.b;
    a.a+=b.a;
    return a;
}
const drib operator - (drib a,drib b){
    norm(a,b);
    ll g = a.b/__gcd(a.b,b.b)*b.b;
    a.a*=g/a.b;
    b.a*=g/b.b;
    a.a-=b.a;
    return a;
}
const drib operator * (drib a,drib b){
    norm(a,b);
    a.a*=b.a;
    a.b*=b.b;
    return a;
}
const bool operator < (drib a,drib b) {
    norm(a,b);
    return a.a*b.b<a.b*b.a;
}
const bool operator == (drib a,drib b) {
    norm(a,b);
    return a.a*b.b==a.b*b.a;
}
const bool operator <= (drib a,drib b) {
    norm(a,b);
    return a.a*b.b<=a.b*b.a;
}

ld F(pair<int,int> p2,pair<int,int> p1){
    int a = p1.first,b = p1.second, c = p2.first,d = p2.second;
    pair<drib,drib> res = {{INF,1},{0,1}};
    //// ak<=c
    {
        drib lbnd = {0,1}, rbnd = min(drib(1,1),drib(c,a));
        // bk<=d
        {
            rbnd = min(rbnd, drib(d,b));
            if (lbnd<=rbnd)
                res = min(res, {drib(d,1) - drib(a,1) * rbnd, rbnd});
        }
        // bk>=d
        {
            lbnd = max(lbnd,drib(d,b));
            if (lbnd<=rbnd){
                res = min(res,{drib(b-a,1)*lbnd,lbnd});
            }
        }
    }
    // ak>=c
    {
        drib lbnd = drib(c, a), rbnd = drib(1,1);
        // bk<=d
        {
            rbnd = min(rbnd, drib(d,b));
            if (lbnd<=rbnd){
                res = min(res,{drib(d-c,1),lbnd});
            }
        }
        // bk>=d
        {
            lbnd = max(lbnd,drib(d,b));
            if (lbnd<=rbnd){
                res = min(res,{drib(b,1)*lbnd-drib(c,1),lbnd});
            }
        }
    }
    return ld(1)-ld(res.second.a)/res.second.b;
}
void solve(){
    int n;
    cin>>n;
    for(int i = 1;i<=n;++i){
        cin>>A[i];
    }
    pref[0] = {INF,-INF};
    for(int i = 1;i<=n;++i){
        pref[i].first = min(pref[i-1].first,A[i]);
        pref[i].second = max(pref[i-1].second,A[i]);
    }
    suf[n+1] = {INF,-INF};
    for(int i = n;i>=1;--i){
        suf[i].first = min(suf[i+1].first,A[i]);
        suf[i].second = max(suf[i+1].second,A[i]);
    }
    for(int i = 1;i<=n;++i){
        if (i==1)
            cout<<"1 ";
        else
            cout<<fixed<<setprecision(10)<<F(pref[i-1],suf[i])<<' ';
    }
}
int main()
{
    ios_base::sync_with_stdio(); cin.tie();
    int t = 1;
    while(t--)
        solve();
    return 0;
}
