//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,lzcnt,popcnt,bmi,bmi2")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll MOD = 1e9 + 7;

signed main()
{
    cin.tie(0)->sync_with_stdio(false);
    int n, k;
    cin >> n >> k;
    vector<ll> a(n), b(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i] >> b[i];
        if (a[i] < b[i]) swap(a[i], b[i]);
    }
    vector<ll> pref(n + 1);
    pref[0] = 0;
    for (int i = 1; i <= n; ++i)
    {
        pref[i] = pref[i - 1] + a[i - 1];
        pref[i] %= k;
    }
    map<ll, int> help;
    help[0] = -1;
    vector<int> nearest(n, -2);
    for (int i = 0; i < n; ++i)
    {
        if (help.find(pref[i + 1]) != help.end()) nearest[i] = help[pref[i + 1]];
        help[pref[i + 1]] = i;
    }
    //build st
    stack<int> help2;
    vector<int> nL(n, -1), nR(n, n);
    for (int i = 0; i < n; ++i)
    {
        if (a[i] % k == b[i] % k) continue;
        while (!help2.empty() && a[help2.top()] - b[help2.top()] > a[i] - b[i]) help2.pop();
        if (!help2.empty()) nL[i] = help2.top();
        help2.push(i);
    }
    while (!help2.empty()) help2.pop();
    for (int i = n - 1; i >= 0; --i)
    {
        if (a[i] % k == b[i] % k) continue;
        while (!help2.empty() && a[help2.top()] - b[help2.top()] >= a[i] - b[i]) help2.pop();
        if (!help2.empty()) nR[i] = help2.top();
        help2.push(i);
    }
    ll res = 0;
    for (int i = 0; i < n; ++i)
    {
        res += (a[i] * (i + 1) * (n - i)) % MOD;
        if (res >= MOD) res -= MOD;
    }
    for (int i = 0; i < n; ++i)
    {
        ll counter1 = 0, counter2 = 0;
        for (int j = nL[i] + 1; j < nR[i]; ++j)
        {
            if (nearest[j] >= nL[i] && nearest[j]) ++counter;
        }
        ++counter;
        ll delt = (b[i] - a[i]) * ((counter * (counter - 1)) / 2);
        delt = (delt % MOD + MOD) % MOD;
        res += delt;
        if (res >= MOD) res -= MOD;
    }
    cout << res;
    return 0;
}
//3 3 1 2 2 3 3 1
//5 5 4 1 4 2 2 3 2 4 1 5