#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct node {
    vector<int> p;
    vector<long double> vals;

    long double calc() {
        return vals[0] * vals[3] + vals[1] + vals[2];
    }
};

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    vector<pair<int, int>> t(4); // {index, val}
    for (int i = 0; i < 4; ++i) {
        t[i].first = i;
        cin >> t[i].second;
    }
    node res;
    res.p = {0, 1, 2, 3};
    res.vals = {0, 0, 0, 0};
    const long double EPS = 0.00000001;
    while (true) {
        vector<long double> a;
        vector<int> indexes;
        for (auto [ind, val] : t) {
            a.push_back(val);
            indexes.push_back(ind);
        }
        long double left = a[0] * a[3] - a[0] - a[3];
        long double right = a[1] * a[2] - a[1] - a[2];
        if (abs(left - right) < EPS) {
            node first;
            first.p = indexes;
            first.vals = a;
            if (first.calc() > res.calc()) {
                res = first;
            }
        } else if (left > right) {
            node first;
            first.p = indexes;
            first.vals = {(a[1] - 1) * (a[2] - 1) / (a[3] - 1) + 1, a[1], a[2], a[3]};
            if (first.calc() > res.calc()) {
                res = first;
            }
            node second;
            second.p = indexes;
            second.vals = {a[0], a[1], a[2], (a[1] - 1) * (a[2] - 1) / (a[0] - 1) + 1};
            if (second.calc() > res.calc()) {
                res = second;
            }
        } else {
            node first;
            first.p = indexes;
            first.vals = {a[0], (a[0] - 1) * (a[3] - 1) / (a[2] - 1) + 1, a[2], a[3]};
            if (first.calc() > res.calc()) {
                res = first;
            }
            node second;
            second.p = indexes;
            second.vals = {a[0], a[1], (a[0] - 1) * (a[3] - 1) / (a[1] - 1) + 1, a[3]};
            if (second.calc() > res.calc()) {
                res = second;
            }
        }
        if (!next_permutation(t.begin(), t.end())) {
            break;
        }
    }
    while (true) {
        vector<long double> a;
        vector<int> indexes;
        for (auto [ind, val] : t) {
            a.push_back(val);
            indexes.push_back(ind);
        }
        long double left = a[0] * a[3] - a[0] - a[3];
        long double right = a[1] * a[2] - a[1] - a[2];
        if (abs(left - right) < EPS) {
            node first;
            first.p = indexes;
            first.vals = a;
            if (first.calc() > res.calc()) {
                res = first;
            }
        } else if (left > right) {
            node first;
            first.p = indexes;
            first.vals = {(a[1] - 1) * (a[2] - 1) / (a[3] - 1) + 1, a[1], a[2], a[3]};
            if (first.calc() > res.calc()) {
                res = first;
            }
            node second;
            second.p = indexes;
            second.vals = {a[0], a[1], a[2], (a[1] - 1) * (a[2] - 1) / (a[0] - 1) + 1};
            if (second.calc() > res.calc()) {
                res = second;
            }
        } else {
            node first;
            first.p = indexes;
            first.vals = {a[0], (a[0] - 1) * (a[3] - 1) / (a[2] - 1) + 1, a[2], a[3]};
            if (first.calc() > res.calc()) {
                res = first;
            }
            node second;
            second.p = indexes;
            second.vals = {a[0], a[1], (a[0] - 1) * (a[3] - 1) / (a[1] - 1) + 1, a[3]};
            if (second.calc() > res.calc()) {
                res = second;
            }
        }
        if (!next_permutation(t.begin(), t.end())) {
            break;
        }
    }
    for (int i : res.p) {
        cout << i + 1 << ' ';
    }
    cout << '\n';
    cout << fixed << setprecision(7);
    for (auto i : res.vals) {
        cout << i << ' ';
    }
    return 0;
}
