#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const ll MOD = int( 1e9 + 7 );
const ll p = 31;

struct stp
{
    ll h;
    string s;
    array<int,30> sym;
};
ll ppower[int(2e6)];

int l, n;

bool rec ( vector<stp> a )
{
    if ( a.size() <= 1 )
        return true;

    bool f = false;

    for ( int i=0; i<a.size(); i++ )
    for ( int j=0; j<30; j++ )
    if ( a[i].sym[j] > 0 )
        f = true;

    if ( !f )
        return true;

    bool fnddd = false;
    vector<int> dels(30, 0);

    for ( int i=0; i<30; i++ )
    {
        bool g = true;
        for ( int j=0; j<a.size(); j++ )
        if ( a[j].sym[i] == 0 )
        {
            g = false;
            break;
        }

        if ( g )
        {
            dels[i] = true;
            fnddd = true;
        }
    }

    if ( !fnddd )
        return false;

    for ( int i=0; i<a.size(); i++ )
    for ( int j=0; j<a[i].s.size(); j++ )
    if ( dels[ a[i].s[j] -'a' ] )
    {
        a[i].sym[ a[i].s[j] -'a'] = 0;
        a[i].h += ( a[i].s[j]-'a'+1 ) * ppower[j];
        a[i].h %= MOD;
    }

    sort( a.begin(), a.end(), []( stp a, stp b )
         {
             return a.h < b.h;
         } );

    vector<stp> cur;
    cur.push_back( a[0] );

    for ( int i=1; i<a.size(); i++ )
    {
        if ( a[i-1].h == a[i].h )
            cur.push_back( a[i] );

        else
        {
            if ( !rec(cur) )
                return false;

            cur.clear();

            cur.push_back( a[i] );
        }
    }

    if ( cur.size() == a.size() )
        return false;

    if ( !rec( cur ) )
        return false;

    return true;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ppower[0] = 1;
    for ( int i=1; i<2e6; i++ )
        ppower[i] = ( ppower[i-1]*p ) % MOD;

    cin >> l >> n;

    vector<stp> a(n);

    for ( int i=0; i<n; i++ )
    {
        a[i].h = 0;
        cin >> a[i].s;
        for ( auto& el : a[i].s )
            a[i].sym[ el-'a' ] ++;

    }

    bool ans = rec( a );

    cout << ( ans ? "YES" : "NO" );

    return 0;
}
