#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <iomanip>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const ull hash_num = 1000000007;

ll n, l;
vector <string> s;
vector <vector<ull>> uv;

ull Hash(string s, char c){
    ull rez = 0, k = hash_num;
    for (int i = 0; i < s.size(); i++){
        if (s[i] == c) {rez += k;}
        k *= hash_num;
    }
    return rez;
}

ll formula(int a, int b){
    for (int i = 0; i < 26; i++){
        if (uv[a][i] != uv[b][i] && uv[b][i] != 0 && uv[a][i] != 0) {return 1;}
    }
    return 0;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> l >> n;
    s.resize(n);
    uv.resize(n);

    for (int i = 0; i < n; i++){
        uv[i].resize(26);
        cin >> s[i];
        for (char j = 'a'; j <= 'z'; j++){
            uv[i][int(j)-97] = Hash(s[i], j);
        }
    }

    for (int i = 0; i < n; i++){
        for (int j = i+1; j < n; j++){
            if (formula(i, j) == 0) {
                cout << "NO";
                return 0;
            }
        }
    }
    cout << "YES";
    return 0;

}
/*
4 4
idea
play
game
warm

*/
