#include <bits/stdc++.h>

using namespace std;

bool try_with_k(int k, int n, vector<int> mas1, vector<int> mas2){
    int i = 0, j = 0;
    while(i < n && j < n){
        if(i + k < j)
            return 0;
        else if(j + k < i)
            ++j;
        if(mas1[i] <= mas2[j])
            mas2[j] -= mas1[i],
            mas1[i] = 0,
            ++i;
        else
            mas1[i] -= mas2[j],
            mas2[j] = 0,
            ++j;
    }
    return mas1[n - 1] == 0;
}

int main()
{
    ios_base:: sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long n, s1 = 0, s2 = 0;
    cin >> n;

    vector<int> mas1(n), mas2(n);
    for(int i = 0; i < n; i++)
    {
        cin >> mas1[i];
        s1 += mas1[i];
    }

    for(int i = 0; i < n; i++)
    {
        cin >> mas2[i];
        s2 += mas2[i];
    }

    if(s1 > s2)
    {
        cout << -1 << '\n';
        return 0;
    }
    //cout << "zr check: " << try_with_k(0, n, mas1, mas2) << '\n';
    int l = -1, r = n, m;
    while(l + 1 != r){
        m = (l + r) / 2;
        if(try_with_k(m, n, mas1, mas2))
            r = m;
        else
            l = m;
    }
    cout << r;
    return 0;
}
