#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>

using namespace std;
typedef long long ll;
typedef long double ld;


int n;
vector<int> a;
vector<int> b;
vector<int> c;
ld L = 4e18, R = -4e18, tk;

ld f(ld x) {
    L = -4e18, R = 4e18, tk = 0;
    for (int i = 0; i < n; i++) {
        tk = a[i] * x * x + b[i] * x + c[i];
        if (a[i] > 0) {
            L = max(L, tk);
        } else {
            R = min(R, tk);
        }
    }
    return L - R;
}

int main() {
    cin >> n;
    a.resize(n);
    b.resize(n);
    c.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i] >> c[i];
    }
    ld mama = 1000000000;
    ld l = -mama;
    ld r = mama;
    while (r - l > 0.000000001) {
        ld m1 = (r - l) / 3 + l;
        ld m2 = 2 * (r - l) / 3 + l;
        if (f(m1) < f(m2)) {
            r = m2;
        } else {
            l = m1;
        }
    }
    ld ans_x = l;
    cout.precision(20);
    f(ans_x);
    cout << ans_x << ' ' << (R + L) / 2;
}


/*
int n;
vector<int> a, b;

bool check(int c) {
    int per = 0, cnt = 0, summ = 0;
    vector <int> a1, b1;
    a1 = a;
    b1 = b;
    for(int i = 0; i < n; i++){
        for(int i1 = max(0, i - c); i1 < min(i + c + 1, n); i1++){
            if(b1[i1] >= a1[i]){
                b1[i1] -= a1[i];
                a1[i] = 0;
                cnt++;
                break;
            }
            else{
                a1[i] -= b1[i1];
                b1[i1] = 0;
            }
        }
    }
    if(cnt == n){
        return true;
    }
    else{
        return false;
    }
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    cin >> n;
    int sum1 = 0, sum2 = 0;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        sum1 += k;
        a.push_back(k);
    }
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        sum2 += k;
        b.push_back(k);
    }
    if (sum1 > sum2) {
        cout << -1;
        return 0;
    }
    int l = -1, r = n;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (check(m)) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << r << endl;
    return 0;
}*/