#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
using ld = long double;
using pld = pair<ld, ld>;

const int ALPHABET_SIZE = 26, MAXLEN = 1e6;

/*struct Node {
    int go[ALPHABET_SIZE] = {0};
    bool is_end = false;
};

Node trie[MAXLEN];
int trie_size = 1;

bool can_go(int v, char ch) {
    return trie[v].go[ch - 'a'] != 0;
}

int go(int v, char ch) {
    return trie[v].go[ch - 'a'];
}

void create(int v, char ch) {
    trie[v].go
}*/
const int MAXN = 2 * 1e5 + 20;
const ll INF = 1e18 + 1e17;
const ld EPS = 1e-9;
const ll MOD = 1e9 + 7;
bool found[26];
bool tried[26];
int cnt[26];
ll pows[int(1e6) + 1];
int n, l;

void check(vector <string> &a) {
    if (a.size() == 1) {
        return;
    }
    for (int i = 0; i < 26; i++) {
        cnt[i] = 0;
    }
    vector <string> cur;
    map <int, vector <int> > pos;
    int chosen = -1;
    for (string &i: a) {
        for (int j = 0; j < 26; j++) {
            found[j] = false;
        }
        for (char j: i) {
            if (!found[j - 'a']) {
                found[j - 'a'] = true;
                cnt[j - 'a']++;
            }
        }
    }
    for (int i = 0; i < 26; i++) {
        if (cnt[i] == a.size() && !tried[i]) {
            chosen = i;
        }
    }
    if (chosen == -1) {
        cout << "NO";
        exit(0);
    }
    tried[chosen] = true;
    ll cur_num = 0;
    for (int i = 0; i < a.size(); i++) {
        cur_num = 0;
        for (int j = 0; j < a[i].size(); j++) {
            if (a[i][j] - 'a' == chosen) {
                cur_num = (cur_num + pows[j]) % MOD;
            }
        }
        if (pos.find(cur_num) == pos.end()) {
            pos[cur_num] = vector <int>();
        }
        pos[cur_num].push_back(i);
    }
    for (auto i: pos) {
        cur.clear();
        for (int j: i.second) {
            cur.push_back(a[j]);
        }
        check(cur);
    }
    tried[chosen] = false;
}

void solve() {
    cin >> l >> n;
    ll num;
    bool ok;
    for (num = l + 1; ; num++) {
        ok = true;
        for (int j = 2; j * j <= num; j++) {
            if (num % j == 0) {
                ok = false;
                break;
            }
        }
        if (ok) {
            break;
        }
    }
    pows[0] = 1;
    for (int i = 1; i <= l; i++) {
        pows[i] = (pows[i - 1] * num) % MOD;
    }
    vector <string> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    check(a);
    cout << "YES";
}

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}