#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
using ld = long double;
using pld = pair<ld, ld>;
const ll MOD = 1e9 + 7;
const int SIZE = 20 * 1e5 + 100;

ll tree[SIZE];
void build(int v, int l, int r, vector<ll>& a) {
    if (r - l == 1) {
        tree[v] = a[l];
        return;
    }
    build(2 * v, l, (l + r) / 2, a);
    build(2 * v + 1, (l + r) / 2, r, a);
    tree[v] = min(tree[2 * v], tree[2 * v + 1]);
}

ll get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (l >= qr || r <= ql) {
        return 1e18 + 1e17;
    }
    return min(get(2 * v, l, (l + r) / 2, ql, qr), get(2 * v + 1, (l + r) / 2, r, ql, qr));
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector <ll> difs(n);
    vector <ll> a(n);
    int fir, sec;
    for (int i = 0; i < n; i++) {
        cin >> fir >> sec;
        a[i] = max(fir, sec);
        difs[i] = abs(fir - sec);
        if (difs[i] % k == 0) {
            difs[i] = 1e18;
        }
    }

    build(1, 0, n, difs);

    ll ans = 0;
    vector <ll> pref(n + 1, 0);
    for (int i = 0; i < n; i++) {
        ans = (ans + (((i + 1) * (n - i)) % MOD * a[i]) % MOD) % MOD;
        pref[i + 1] = pref[i] + a[i];
    }
    map <ll, ll> sum;
    map <ll, vector <ll> > poses;
    map <ll, vector <pair <ll, ll> > > mins;
    map <ll, vector <char> > flag;
    ll ind;
    sum[0] = 0;
    poses[0] = vector <ll> ();
    poses[0].push_back(-1);
    mins[0] = vector <pair <ll, ll> > ();
    flag[0] = vector <char> ();
    ll cur_min;
    ll cnt;
    for (ll i = 0; i < n; i++) {
        ind = pref[i + 1] % k;
        if (mins.find(ind) == mins.end()) {
            mins[ind] = vector <pair <ll, ll> > ();
            sum[ind] = 0;
            poses[ind] = vector <ll> ();
            poses[ind].push_back(i);
            flag[ind] = vector <char> ();
            continue;
        }
        cur_min = get(1, 0, n, poses[ind].back() + 1, i + 1);
        cnt = 1;
        if (cur_min == 1e18) {
            cur_min = (pref[i + 1] - pref[poses[ind].back() + 1]) % MOD;
            mins[ind].push_back({cur_min, cnt});
            flag[ind].push_back(true);
            poses[ind].push_back(i);
            for (int j = 1;; j++) {
                if (!flag[ind][mins[ind].size() - j] || j > mins[ind].size()) {
                    break;
                }
                ans = (ans - pref[i + 1] + pref[poses[ind][poses[ind].size() - j]] + MOD) % MOD;
            }
            ans = (ans - sum[ind] + MOD) % MOD;
            continue;
        }
        while (mins[ind].size() && (mins[ind].back().first >= cur_min || flag[ind].back())) {
            cnt += mins[ind].back().second;
            sum[ind] = (sum[ind] - (mins[ind].back().first * mins[ind].back().second) % MOD + MOD) % MOD;
            mins[ind].pop_back();
            flag[ind].pop_back();
        }
        sum[ind] = (sum[ind] + (cnt * cur_min) % MOD) % MOD;
        mins[ind].push_back({cur_min, cnt});
        flag[ind].push_back(false);
        poses[ind].push_back(i);
        ans = (ans - sum[ind] + MOD) % MOD;
    }
    cout << ans;
}

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}