#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <stdlib.h>
#include <math.h>
#include <cmath>
#include <map>
#include <queue>
#include <iomanip>
#include <stack>

typedef long long ll;

using namespace std;

void IO()
{
    cin.tie(0);
    cout.tie(0);
    cout.sync_with_stdio(0);
}

int main() {
    IO();
    ll n, l;
    cin >> l >> n;
    vector<string> p(n + 1);
    for (int i = 0; i < n; ++i) {
        string c = "";
        for (int j = 0; j < l; ++j) {
            char x;
            cin >> x;
            c += x;
        }
        p[i] = c;
    }

    set<char> s;
    vector<map<char, vector<ll>>> m(n + 1);
    vector<char> h;
    for (int i = 0; i < 26; ++i) {
        bool t = true;
        for (int j = 0; j < n; ++j) {
            bool f = false;
            for (int k = 0; k < l; ++k) {
                if (p[j][k] == 'a' + i) {
                    f = true;
                    m[j]['a' + i].push_back(k);
                }
            }
            if (!f) {
                t = false;
            }
        }
        if (t) {
            s.insert('a' + i);
            h.push_back('a' + i);
        }
    }

    vector<map<vector<ll>, ll>> v(h.size() + 1);
    int x = 0;
    for (auto i : h) {
        for (int j = 0; j < n; ++j) {
            v[x][m[j][i]]++;
        }
        //cout << i << '\n';
        for (auto j : v[x]) {

            if (j.second == 1) {
                cout << "YES";
                return 0;
            }
            //cout << '\n';
        }
        //cout << '\n';
        x++;
    }
    cout << "NO";
}
