#include <bits/stdc++.h>

using namespace std;

vector<int> a(200000), pmn(200000), pmx(200000), smn(200000), smx(200000);

long double d(int i, long double k){
    return max(smx[i] * k, (long double)pmx[i]) - min(smn[i] * k, (long double)pmn[i]);
}

long double eps = 1e-6;

int main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (i == 0) {
            pmn[i] = a[i];
            pmx[i] = a[i];
        } else {
            pmn[i] = min(pmn[i - 1], a[i]);
            pmx[i] = max(pmx[i - 1], a[i]);
        }
    }
    smn[n - 1] = a[n - 1];
    smx[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        smn[i] = min(smn[i + 1], a[i]);
        smx[i] = max(smx[i + 1], a[i]);
    }
    cout << fixed << setprecision(31) << 1.0 << " ";
    for (int i = 0; i < n - 1; i++) {
        long double k_l = 1;
        long double k1 = ((long double)pmn[i] / smn[i]);
        long double k2 = ((long double)pmx[i] / smx[i]);
        //cout << d(i, k1) << ' ' << d(i, k2) << ' ' << d(i, k1) << endl;
        if(k1 < 1 && (d(i, k_l) > d(i, k1) || (abs(d(i, k_l) - d(i, k1)) < eps && k_l > k1))){
           k_l = k1;
        }
        if(k2 < 1 && (d(i, k_l) > d(i, k2) || (abs(d(i, k_l) - d(i, k2)) < eps && k_l > k2))){
           k_l = k2;
        }
        cout << 1 - k_l << ' ';
    }
}
