#define __GLIBCXX_DEBUG 1
#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#define int long long
#define ff first
#define ss second
#define _ << ' ' <<
#define __ << ' '
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int) a.size()

using namespace std;
using namespace __gnu_pbds;

const int MAXN = 5e5 + 10, inf = 1e15, mod = 1e9 + 7;
int n, k, sm = 0;
pair<int, int> tr[MAXN * 4];
pair<int, int> ar[MAXN];
int pr[MAXN];

void build(int v, int l, int r) {
    if (r - l == 1) {
        tr[v] = {inf, inf};
        if ((ar[l].ss - ar[l].ff) % k) {
            tr[v] = {ar[l].ss - ar[l].ff, l};
        }
        return;
    }
    int m = (r + l) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tr[v] = min(tr[2 * v + 1], tr[2 * v + 2]);
    return;
}

pair<int, int> get(int v, int l, int r, int ql, int qr) {
    if (l >= qr || ql >= r) {
        return make_pair(inf, inf);
    }
    if (ql <= l && r <= qr) {
        return tr[v];
    }
    int m = (r + l) / 2;
    return min(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
}

void f(vector<int> &a, int l, int r) {
    if (r <= l) return;
    pair<int, int> tmp;
    tmp = get(0, 0, n, a[l], a[r]);
    if (tmp.ss == inf) {
        int m = r - l;
        for (int i = 0; i < m; i++) {
            sm -= ar[a[l]].ss * (m - i) * (i + 1);
            //cout << '!' << endl;
            sm = (sm % mod + mod) % mod;
        }
    }
    int l1 = l, r1 = r, m1;
    while (r1 - l1 > 1) {
        m1 = (r1 + l1) / 2;
        if (a[m1] <= tmp.ss) {
            l1 = m1;
        }
        else {
            r1 = m1;
        }
    }
    if (a[l1] == tmp.ss) {
        sm -= (ar[a[l1]].ss - ar[a[l1]].ff) * (r - l1 - 1) * (l1 - l + 1);
        //cout << r _ l _ l1 _ (ar[a[l1]].ss - ar[a[l1]].ff) << endl;
        sm = (sm % mod + mod) % mod;
        f(a, l, l1 - 1);
        f(a, l1 + 1, r);
    }
    else {
        sm -= (ar[tmp.ss].ss - ar[tmp.ss].ff) * (r - l1) * (l1 - l + 1);
        //cout << '!' << endl;
        sm = (sm % mod + mod) % mod;
        f(a, l, l1);
        f(a, l1 + 1, r);
    }
}

void solve() {
    cin >> n >> k;
    int a, b;
    for (int i = 0; i < n; i++) {
        cin >> a >> b;
        if (a > b) {
            swap(a, b);
        }
        ar[i] = {a, b};
    }
    for (int i = 0; i < n; i++) {
        pr[i + 1] = pr[i] + ar[i].ss;
    }
    for (int i = 0; i < n; i++) {
        sm += ar[i].ss * (n - i) * (i + 1);
        if (ar[i].ss % k == 0) {
            if (ar[i].ss % k != ar[i].ff % k) {
                sm -= (ar[i].ss - ar[i].ff);
            }
            else {
                sm -= ar[i].ss;
            }
        }
    }
    gp_hash_table<int, vector<int> > mp;
    for (int i = 0; i <= n; i++) {
        if (mp.find(pr[i] % k) == mp.end()) {
            mp[pr[i] % k] = {};
        }
        mp[pr[i] % k].push_back(i);
    }
    //cout << sm << endl;
    build(0, 0, n);
    //cout << sm << endl;
    for (auto &x : mp) {
        f(x.ss, 0, sz(x.ss) - 1);
    }
    cout << sm;
    return;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int ttt = 1;
    //cin >> ttt;
    while(ttt--){
        solve();
    }
    return 0;
}


