#include<bits/stdc++.h>

//#define int ll

#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define _ << " " <<
#define mp make_pair

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;

const int MXN = 5e5 + 111;
const int MXT = 8e7;
const int L = 0;
const int R = 1e9 + 111;
const int MXLOG = 20;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;

int cnt[MXT];
ll sm[MXT];
bool rst[MXT];
int lt[MXT];
int rt[MXT];
ll prf[MXN];

int nxt = 2;

void push(int i) {
    if (rst[i]) {
        rst[i] = 0;
        rst[lt[i]] = 1;
        cnt[lt[i]] = 0;
        sm[lt[i]] = 0;
        rst[rt[i]] = 1;
        cnt[rt[i]] = 0;
        sm[rt[i]] = 0;
    }
}

void reset(int i, int l, int r, int q_l, int q_r) {
    if (q_l <= l && r <= q_r) {
        cnt[i] = 0;
        sm[i] = 0;
        rst[i] = 1;
        return;
    }
    if (q_r <= l || r <= q_l) {
        return;
    }
    int m = (l + r) / 2;
    if (lt[i] == 0) lt[i] = nxt++;
    if (rt[i] == 0) rt[i] = nxt++;
    push(i);
    reset(lt[i], l, m, q_l, q_r);
    reset(rt[i], m, r, q_l, q_r);
    cnt[i] = cnt[lt[i]] + cnt[rt[i]];
    sm[i] = sm[lt[i]] + sm[rt[i]];
}

void add(int i, int l, int r, int ind, int x) {
    if (ind < l || r <= ind) return;
    //cout << "add" _ i _ l _ r _ ind _ x << endl;
    if (l + 1 == r) {
        cnt[i] += x;
        sm[i] += l * x;
        //cout << ")-(" << endl;
        //cout << "cnt[" << i << "]=" << cnt[i] << endl;
        //cout << "sm[" << i << "]=" << sm[i] << endl;
        //cout << ")-(" << endl;
        return;
    }
    int m = (l + r) / 2;
    if (lt[i] == 0) lt[i] = nxt++;
    if (rt[i] == 0) rt[i] = nxt++;
    push(i);
    add(lt[i], l, m, ind, x);
    add(rt[i], m, r, ind, x);
    cnt[i] = cnt[lt[i]] + cnt[rt[i]];
    sm[i] = sm[lt[i]] + sm[rt[i]];
    //cout << "cnt[" << i << "]=" << cnt[i] << endl;
    //cout << "sm[" << i << "]=" << sm[i] << endl;
}

pii get(int i, int l, int r, int q_l, int q_r) {
    if (q_l <= l && r <= q_r) {
        return make_pair(cnt[i], sm[i]);
    }
    if (q_r <= l || r <= q_l) {
        return make_pair(0, 0);
    }
    int m = (l + r) / 2;
    if (lt[i] == 0) lt[i] = nxt++;
    if (rt[i] == 0) rt[i] = nxt++;
    push(i);
    pii p_lt = get(lt[i], l, m, q_l, q_r);
    pii p_rt = get(rt[i], m, r, q_l, q_r);
    return make_pair(p_lt.ff + p_rt.ff, (p_lt.ss + p_rt.ss) % MOD);
}


int a[MXN];
int dlt[MXN];


ll sp[MXLOG][MXN];
int K[MXN];

int n, k;

int get_min(int l, int r) {
    int res = min(sp[K[r - l + 1]][l],sp[K[r - l + 1]][r - (1 << K[r - l + 1]) + 1]);
    //cout << "get_min(" << l _ r << ")=" << res << endl;
    return res;
}

ll get_sum_a(int l, int r) {
    return prf[r + 1] - prf[l];
}

bool check(int l, int r) {
    for (int i = l; i <= r; ++i) {
        if (dlt[i] % k != 0) return false;
    }
    return true;
}

ll answer = 0;

map<int, int> mp_do;
map<int, int> lst;

map<int, int> sm_of;
map<int, int> cnt_of;

void solve() {
    cin >> n >> k;
    int x, y;
    for (int i = 0; i < n; ++i) {
        cin >> x >> y;
        a[i] = max(x, y);
        dlt[i] = max(x, y) - min(x, y);
    }
    if (k == 1) {
        cout << 0; exit(0);
    }
    prf[0] = 0;
    for (int i = 0; i < n; ++i) {
        prf[i + 1] = prf[i] + a[i];
    }
    /*for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            if ((get_sum_a(i, j) % k == 0) && check(i, j)) {
                answer -= get_sum_a(i, j) % MOD;
                answer %= MOD; answer += MOD; answer %= MOD;
            }
        }
    }*/
    sm_of.clear();
    cnt_of.clear();
    cnt_of[0] = 1;
    sm_of[0] = 0;
    for (int i = 0; i < n; ++i) {
        //cout << "i=" << i << endl;
        if (dlt[i] % k != 0) {
            //cout << "A" << endl;
            sm_of.clear();
            cnt_of.clear();
            cnt_of[prf[i + 1] % k] = 1;
            sm_of[prf[i + 1] % k] = prf[i + 1];
            continue;
        }
        //cout << "B" << endl;
        //cout << "i=" << i _ "prf[i+1]=" << prf[i+1] << endl;
        answer -= (cnt_of[prf[i + 1] % k] * prf[i + 1] - sm_of[prf[i + 1] % k]) % MOD;
        //cout << "!" _ prf[i + 1] _ prf[i + 1] % k _ cnt_of[prf[i + 1] % k] _ sm_of[prf[i + 1] % k] << endl;
        //cout << "answer-=" << (cnt_of[prf[i + 1] % k] * prf[i + 1] - sm_of[prf[i + 1] % k]) % MOD << endl;
        answer %= MOD; answer += MOD; answer %= MOD;
        ++cnt_of[prf[i + 1] % k];
        sm_of[prf[i + 1] % k] += prf[i + 1];
    }
    /*cout << "a:   ";
    for (int i = 0; i < n; ++i) {
        cout << a[i] << " ";
    } cout << endl;
    cout << "dlt: ";
    for (int i = 0; i < n; ++i) {
        cout << dlt[i] << " ";
    } cout << endl;//*/

    for (int i = 0; i < n; ++i) {
        sp[0][i] = dlt[i];
        if (dlt[i] % k == 0) {
            sp[0][i] = INF;
        }
    }
    for (int j = 1; j < MXLOG; ++j) {
        for (int i = 0; i < n; ++i) {
            sp[j][i] = sp[j - 1][i];
            if (i + (1 << (j - 1)) < MXN && sp[j][i] > sp[j - 1][i + (1 << (j - 1))]) {
                sp[j][i] = sp[j - 1][i + (1 << (j - 1))];
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        answer += ((ll)(i + 1) * (n - i) * a[i]) % MOD;
        answer %= MOD;
    }
    //cout << "answer=" << answer << endl;
    lst[0] = -1;
    mp_do[0] = nxt++;
    add(mp_do[0], L, R, INF, 1);
    int sm_k = 0;
    for (int i = 0; i < n; ++i) {
        //cout << "------" << endl;
        //cout << "i=" << i << endl;
        sm_k += a[i];
        sm_k %= k;
        //cout << "sm_k=" << sm_k << endl;
        if (!lst.count(sm_k)) {
            //cout << "A" << endl;
            lst[sm_k] = i;
            mp_do[sm_k] = nxt++;
            add(mp_do[sm_k], L, R, INF, 1);
            //cout << "!" _ "add" _ "mp_do[" << sm_k << "]" _ INF _ 1 << endl;
        } else {
            pii p_do;
            //cout << "B" << endl;
            int x = get_min(lst[sm_k] + 1, i);
            //cout << "---" << endl;
            //cout << "mp_do[" << sm_k << "]=" << mp_do[sm_k] << endl;
            //for (int j = 0; j < 10; ++j) {
            //    p_do = get(mp_do[sm_k], L, R, j, j + 1);
            //    cout << "cnt[" << j << "]=" << p_do.ff << endl;
            //    cout << "sm[" << j << "]=" << p_do.ss << endl;
            //    cout << endl;
            //}
            p_do = get(mp_do[sm_k], L, R, INF, INF + 1);
            //cout << "cnt[" << INF << "]=" << p_do.ff << endl;
            //cout << "sm[" << INF << "]=" << p_do.ss << endl;
            //cout << endl;
            //cout << "---" << endl;
            //cout << "x=" << x _ "from" _ "[" << lst[sm_k] + 1 << ";" << i + 1 << "]" << endl;
            p_do = get(mp_do[sm_k], L, R, x + 1, R); ///cnt sm
            //cout << "!" _ p_do.ff _ p_do.ss << endl;
            reset(mp_do[sm_k], L, R, x + 1, R);
            add(mp_do[sm_k], L, R, x, p_do.ff);
            //cout << "!" _ "add" _ "mp_do[" << sm_k << "]" _ x _ p_do.ff << endl;
            p_do = get(mp_do[sm_k], L, R, L, R); ///cnt sm
            //cout << "!" _ p_do.ff _ p_do.ss << endl;
            answer -= p_do.ss;
            answer %= MOD;
            answer += MOD;
            answer %= MOD;
            //cout << "answer -= " << p_do.ss << endl;
            add(mp_do[sm_k], L, R, INF, 1);
        }
        lst[sm_k] = i;
        //cout << endl;
        //cout << endl;
        //cout << endl;
    }
    cout << answer << endl;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    for (int i = 1; i < MXN; ++i) {
        K[i] = K[i - 1];
        while ((1 << (K[i] + 1)) <= i) {
            ++K[i];
        }
    }
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}

