#include <bits/stdc++.h>

using namespace std;

#define ll long long

const ll inf = 1e18;
ll n;
vector<ll> sa;
vector<ll> sb;

bool f(ll k)
{
    for (int i = 1; i <= n; ++i)
    {
        if (sa[min(n, i + k)] - sa[max(0ll, i - k - 1)] > sb[min(n, i + 2 * k)] - sb[max(0ll, i - 2 * k - 1)])
        {
            return false;
        }
    }
    return true;
}


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    sa.resize(n + 1, 0);
    sb.resize(n + 1, 0);
    sa[0] = 0; sb[0] = 0;
    for (int i = 1; i <= n; ++i)
    {
        cin >> sa[i];
        sa[i] += sa[i - 1];
    }
    for (int i = 1; i <= n; ++i)
    {
        cin >> sb[i];
        sb[i] += sb[i - 1];
    }
    if (sa[n] > sb[n])
    {
        cout << -1;
        return 0;
    }

    ll l = -1, r = n + 1;
    while (r - l > 1)
    {
        ll m = l + (r - l) / 2;
        if (f(m))
            r = m;
        else
            l = m;
    }
    cout << r;
}
