#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>

#define ll long long

using namespace std;


vector<int> vec1, vec2;
int n;


bool check(int mx_k, vector<int> _vec1, vector<int> _vec2)
{
	int j = 0;
	int k = 0;
	int i = 0;
	for (i = 0; i < n; ++i)
	{
		j = max(j, i - mx_k);
		while (j < n && j - i <= mx_k && _vec1[i] > _vec2[j])
		{
			_vec1[i] -= _vec2[j];
			_vec2[j] = 0;
			j++;
		}
		if (_vec1[i] != 0 && (j - i > mx_k || j >= n)) return false;

		if (_vec1[n - 1] == 0)
			return true;

		if (j < n)
		{
			_vec2[j] -= _vec1[i];
			_vec1[i] = 0;
		}
		else
			return false;
	}
	return true;
}

signed main() {

	int s1 = 0, s2 = 0;
	cin >> n;
	vec1.resize(n);
	vec2.resize(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> vec1[i];
		s1 += vec1[i];
	}
	for (int i = 0; i < n; ++i)
	{
		cin >> vec2[i];
		s2 += vec2[i];
	}
	if (s1 > s2)
	{
		cout << -1;
		return 0;
	}

	int L = -1, R = n, O;
	while (R - L > 1)
	{
		O = (L + R) / 2;
		if (check(O, vec1, vec2))
		{
			R = O;
		}
		else
		{
			L = O;
		}
	}
	cout << R;
}
