#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

const int N = 1e5 + 13;
const int INF = 1e9;
const ll LLINF = 1e18;

vector <int> a(1e6), b(1e6);

bool f(int m, int n) {
    deque <int> c, d;
    // cout << "m: " << m << endl;
    for (int i = 0; i < n; ++i) {
        c.push_back(i);
        while (c.front() < i - m) c.pop_front();

        if (!d.empty() && d.front() < i - m) return false;
        while (!d.empty() && b[i] > 0) {
            int k = min(b[i], a[d.front()]);
            a[d.front()] -= k;
            if (a[d.front()] == 0) d.pop_front();
            b[i] -= k;
        }

        while (!c.empty() && a[i] > 0) {
            int k = min(b[c.front()], a[i]);
            b[c.front()] -= k;
            if (b[c.front()] == 0) c.pop_front();
            a[i] -= k;
        }
        if (a[i] > 0) d.push_back(a[i]);
    }
    if (!d.empty()) return false;
    return true;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];

    int l = -1, r = n + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (f(m, n)) r = m;
        else l = m;
        // cout << l << " " << r << endl;
    }
    // cout << l << ' ' << r;
    if (r > n) cout << -1;
    else cout << r;

    return 0;
}

