#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll n;
	cin >> n;
	vector<ll> a(n);
	for (auto& i : a) cin >> i;
	vector<pair<ll, ll>> mml(n);
	vector<pair<ll, ll>> mmr(n);
	mml[0] = { a[0], a[0] };
	mmr[n - 1] = { a[n - 1], a[n - 1] };
	for (int i = 1; i < n; ++i) {
		mml[i] = { max(mml[i - 1].first, a[i]), min(mml[i - 1].second, a[i]) };
		mmr[n - 1 - i] = { max(mmr[n - i].first, a[n - 1 - i]), min(mmr[n - i].second, a[n - 1 - i]) };
	}
	cout << "1.00 ";
	ll min1, min2, max1, max2;
	ld ans;
	for (ll i = 1; i < n; ++i) {
		min1 = mml[i - 1].second;
		min2 = mmr[i].second;
		max1 = mml[i - 1].first;
		max2 = mmr[i].first;
		if (min1 <= min2 && max1 >= max2) {
			ans = ld(1.0) - ld(min1) / ld(min2);
		}
		else if (min1 >= min2 && max1 <= max2) {
			ans = ld(1.0) - ld(max1) / ld(max2);
		}
		else if (max1 >= max2 && min2 <= min1)
			ans = ld(0.0);
		else {
			ans = ld(1.0) - ld(max1) / ld(max2);
		}
		cout << ans << " ";
	}

	return 0;
}