#include <bits/stdc++.h>

using namespace std;

double calc(double t, int prefmx, int prefmn, int sufmx, int sufmn){

    double mn = min(prefmn * 1.0, 1.0 * sufmn * (1.0 - t));
    double mx = max(prefmx * 1.0, 1.0 * sufmx * (1.0 - t));

    return mx - mn;
}

double ternarysearch(int prefmx, int prefmn, int sufmx, int sufmn){

    double l = 0.0, r = 1.0;
    while (abs(r - l) > 0.0000000001){
        double m1 = l + (r - l) / 3.0;
        double m2 = m1 + (r - l) / 3.0;

        double x = calc(m1, prefmx, prefmn, sufmx, sufmn);
        double y = calc(m2, prefmx, prefmn, sufmx, sufmn);
        //cerr << m1 << " " << m2 << " " << x << " " << y << "\n";
        if (x < y) r = m2;
        else l = m1;
    }

    return l;

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n; cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    vector<int> prefmx(n), prefmn(n), sufmx(n), sufmn(n);

    prefmx[0] = a[0];
    prefmn[0] = a[0];
    for (int i = 1; i < n; ++i){
        prefmx[i] = max(prefmx[i-1], a[i]);
        prefmn[i] = min(prefmn[i-1], a[i]);
    }

    sufmx[n-1] = a[n-1];
    sufmn[n-1] = a[n-1];
    for (int i = n-2; i >= 0; --i){
        sufmx[i] = max(sufmx[i+1], a[i]);
        sufmn[i] = min(sufmn[i+1], a[i]);
    }

    vector<double> ans(n);
    for (int i = n-1; i >= 0; --i){
        //cerr << i << "\n";
        if (i == 0) {
            ans[i] = 1.0;
            continue;
        }
        ans[i] = ternarysearch(prefmx[i-1], prefmn[i-1], sufmx[i], sufmn[i]);
    }

    cout.precision(9);
    for (int i = 0; i < n; ++i) cout << fixed << ans[i] << " ";

    return 0;
}
