#include <bits/stdc++.h>

using namespace std;

bool recursion(vector<string>& v, vector<vector<vector<int>>>& idx, vector<int> cur){
    if (cur.size() == 1) return true;
    for (int i = 0; i < 26; ++i){
        map<vector<int>, vector<int>> mp;
        bool flag = true;
        for (auto x : cur){
            if (idx[x][i].empty()){
                flag = false;
                break;
            }
            mp[idx[x][i]].push_back(x);
        }

        if (!flag) continue;
        //cerr << i << "\n";
        for (auto [a, b] : mp){
            if (b.size() == cur.size()) flag = false;
            else flag &= recursion(v, idx, b);
        }
        //cerr << flag << "\n";
        if (flag) return true;
    }

    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int l, n; cin >> l >> n;
    vector<string> v(n);
    for (int i = 0; i < n; ++i){
        cin >> v[i];
    }

    vector<vector<vector<int>>> idx(n, vector<vector<int>>(26));
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < l; ++j){
            idx[i][v[i][j] - 'a'].push_back(j);
        }
    }
    vector<int> cur;
    for (int i = 0; i < n; ++i) cur.push_back(i);
    if (recursion(v, idx, cur)) cout << "YES\n";
    else cout << "NO\n";

    return 0;
}
