#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,sse4,popcnt")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <functional>
#include <unordered_map>
#include <complex>
#include <array>
#include <chrono>
#include <random>
#include <vector>
#include <string>
#include <sstream>
#include <cmath>
#include <cstring>
#include <bitset>
#include <list>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <cassert>

#define sq(x) ((x) * (x))
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errp(x) cerr << "["#x"]  {" << ((x).first) << ", " << ((x).second) << "}\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n"

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template <typename T1, typename T2> inline bool relax(T1& a, const T2& b) {
    return a > b ? a = b, true : false;
}

template <typename T1, typename T2> inline bool strain(T1& a, const T2& b) {
    return a < b ? a = b, true : false;
}

// :::::::::::::::::::::::::::::::

// rusfree8049
// edefegecafy

#define v vector

void solve() {
    ll a, b, c, d, e, f, g;
    cin >> a >> b >> c >> d >> e >> f >> g;
    ll x = e * f * g;
    cout << (a * b * x + c * d * x) << '\n';
}

void solve2() {
    ll n;
    cin >> n;
    v<ll> a(n), b(n);
    for(ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for(ll i = 0; i < n; ++i) {
        cin >> b[i];
    }
    ll pos = 0;
    v<ll> s(n);
    v<ll> prefa(n + 1);
    partial_sum(a.begin(), a.end(), prefa.begin() + 1);
    v<ll> prefb(n + 1);
    partial_sum(b.begin(), b.end(), prefb.begin() + 1);
//    v<ll>
    ll res = 0;
    for(ll i = 0; i < n; ++i) {
        ll c = a[i];
//        while(pos < i && )
        while(c != 0 && pos < n) {
            if(s[pos] == b[pos]) {
                ++pos;
            } else {
                ll ma = min(b[pos] - s[pos], c);
                c -= ma;
                s[pos] += ma;
            }
        }
        if(pos > n) {
            cout << -1;
            return;
        }
        res = max(res, abs(pos - i));
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);
    
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    
    return 0;
}
