﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <string>
#define endl '\n';
using namespace std;
using ll = long long;
int n;
long long answ = 0;
const int N = 3e5;
long double a[N];
long double mnpref[N];
long double mxpref[N];
long double mnsuff[N];
long double mxsuff[N];
long double f(long double q, int w) {
    long double c = max(mxpref[w - 1], mxsuff[w] * (1 - q));
    long double d = min(mnpref[w - 1], mnsuff[w] * (1 - q));
    return c - d;
}
int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    cout << fixed << setprecision(20);
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    mnpref[1] = a[1];
    mxpref[1] = a[1];
    for (int i = 2; i <= n; i++) {
        mnpref[i] = min(mnpref[i - 1], a[i]);
        mxpref[i] = max(mxpref[i - 1], a[i]);
    }
    mxsuff[n] = a[n];
    mnsuff[n] = a[n];
    for (int i = n - 1; i >= 1; i--) {
        mxsuff[i] = max(mxsuff[i + 1], a[i]);
        mnsuff[i] = min(mnsuff[i + 1], a[i]);
    }
    cout << 1.0 << " ";
    for (int i = 2; i <= n; i++) {
        long double L = 0;
        long double R = 1;
        for(int cur = 0; cur < 75; cur ++){
            long double m1 = L + (R - L) / 3;
            long double m2 = R - (R - L) / 3;
            if (f(m1, i) <  f(m2, i)) {
                R = m2;;
            }
            else {
                L = m1;
            }
        }
        cout << L << " ";
    }
}
