#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <stack>
#include <deque>
#include <string>
#include <numeric>
#include <cmath>
#include <bitset>
#include <set>

using namespace  std;
//#define int long long

typedef long long ll;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

#define all(a) (a).begin(), (a).end()

bool ok(vector<int> arr, vector<int> arr2,int k) {
    int n = arr.size();
    ll sum = 0;
    stack<int> right_free;
    deque<int> left_free;
    rrange(i, n) {
        right_free.push(i);
    }
    range(i, n) {
        if(!right_free.empty()&&right_free.top()==i){
            right_free.pop();
        }

        if(arr2[i]>0){
            left_free.push_back(i);
        }

        while (!left_free.empty() && i - left_free.front() > k) {
            left_free.pop_front();
        }
        while (!left_free.empty() && arr2[i] > 0) {
            int j = left_free.front();
            int t = min(arr[j], arr2[i]);
            arr[j] -= t;
            arr2[i] -= t;
            if (arr[j] == 0) left_free.pop_front();
        }
        while (arr2[i] > 0) {
            bool good_right = !right_free.empty() && abs(right_free.top() - i) <= k;
            if (!good_right){
                return false;
            }
            int j = right_free.top();
            int t = min(arr[j], arr2[i]);
            arr[j] -= t;
            arr2[i] -= t;
            if (arr[j] == 0) right_free.pop();
        }
    }
    return true;
}

signed main() {
    ios::ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin>>n;
    vector<int> arr(n),arr2(n);
    range(i, n) cin >> arr[i];
    ll sum = 0;
    range(i,n) {
        cin>>arr2[i];
        sum += arr2[i] - arr[i];
    }
    if (sum < 0) {
        cout << -1;
        return 0;
    }
    int l = -1; int r = n;
//    l = 1; r = 4;
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (ok(arr2,arr, m)) {
                 r = m;
        } else {
            l = m;
        }
    }
    cout << r << endl;
    return 0;
}

/*4
5 5 5 0
0 5 5 5*/