#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <unordered_set>
#include <cmath>
#include <random>
#include <bitset>
#include <algorithm>

#define int long long
#define double long double


using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> aa(n);
    for (auto &i : aa) {
        cin >> i;
    }
    vector<int> bb(n);
    for (auto &i : bb) {
        cin >> i;
    }
    int suma = accumulate(aa.begin(), aa.end(), 0ll);
    int sumb = accumulate(bb.begin(), bb.end(), 0ll);
    if (suma > sumb) {
        cout << -1;
        return;
    }
    int l = -1, r = n;
    while (l + 1 != r) {
        vector<int> a = aa;
        vector<int> b = bb;
        int m = (l + r) / 2;
        bool flag = true;
        int cur_sum = 0;
        for (int i = 0; i < m + 1; ++i) {
            cur_sum += b[i];
        }
        int j = 0;
        for (int i = 0; i < n; ++i) {
            for (int k = j; k < min(n, i+m+1); ++k) {
                if (a[i] > 0) {
                    int subtr = min(b[k], a[i]);
                    a[i] -= subtr;
                    b[k] -= subtr;
                    j = k;
                } else {
                    break;
                }
            }
            if (a[i] > 0) {
                flag = false;
                break;
            }
            j = max(j, i - m + 1);
        }
        if (flag) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << r;
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(10);
#endif

    solve();
}
