#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <cmath>
#include <utility>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <deque>

#define ll long long

using namespace std;

vector<ll> a, b;
ll n;

bool check(ll m)
{
    vector<ll> a_c = a;
    deque<ll> ls;
    ll j = 0;
    for (ll i = 0; i < n; ++i) {
        ls.push_back(a_c[i]);
        if(size(ls) > m + 1) {
            return false;
        }
        a_c[i] = 0;
        while (size(ls) > 0) {
            ll x = min(b[i] - a_c[i], ls[0]);
            a_c[i] += x;
            ls[0] -= x;
            if (ls[0] == 0) {
                ls.pop_front();
            } else {
                break;
            }
        }
        j = max(j, i + 1);
        while (j < n && j < i + m + 1) {

            ll x = min(b[i] - a_c[i], a_c[j]);
            a_c[i] += x;
            a_c[j] -= x;
            if (a_c[i] == b[i]) {
                break;
            } else {
                j++;
            }
        }
    }
    if (size(ls) == 0)
        return true;
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    a.resize(n); b.resize(n);
    for(ll i = 0; i < n; ++i){
        cin >> a[i];
    }
    for(ll i = 0; i < n; ++i){
        cin >> b[i];
    }
    ll l = -1, r = n + 1;
    while(r - l > 1){
        ll m = (r + l) / 2;
        if (check(m)){
            r = m;
        }
        else{
            l = m;
        }
    }
    if (r > n){
        r = -1;
    }
    cout << r;
}