#pragma GCC target("avx,avx2")
#pragma GCC optimaze("Ofast")
#pragma GCC optimaze("unroll-loops")
#pragma GCC optimaze("fast-math")
#pragma GCC optimaze("no-stack-protector")
#pragma GCC optimaze("unswitch-loops")
#pragma GCC optimaze("rename-registers")

#include<bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define forn(i, n) for(int i = 0; i < int(n); i++)

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    double n, in;
    cin>> n;
    vector<double> input;
    vector<double> min_l;
    vector<double> max_l;
    vector<double> min_r;
    vector<double> max_r;
    double min_in = 1e9+10;
    double max_in = -1;
    for (int i = 0; i < n; i ++){
        cin  >> in;
        input.push_back(in);
        min_in = min(min_in, in);
        max_in = max(max_in, in);
        min_l.push_back(min_in);
        max_l.push_back(max_in);
    }
     min_in = 1e9+10;
    max_in = -1;
     for (int i = n-1; i > -1; i --){
        in = input[i];
        min_in = min(min_in, in);
        max_in = max(max_in, in);
        min_r.push_back(min_in);
        max_r.push_back(max_in);
    }
    vector<double> ans;
    for (int i = 0; i < n; i ++){
        if (i==0){
            ans.push_back(1.0);
        }
        else if (max(max_l[i-1], max_r[n-i-1])==max_l[i-1]){
            if (min(min_l[i-1], min_r[n-i-1])==min_r[n-i-1]){
                ans.push_back(0.0);
            }
            else{
                double res =  1-min_l[i-1]/min_r[n-i-1];
                ans.push_back(res);
            }
        }
        else{
            if (min(min_l[i-1], min_r[n-i-1])==min_r[n-i-1]){
                double res = 1 - max_l[i-1]/max_r[n-i-1];
                ans.push_back(res);
            }
            else{
                double res = max(1-max_l[i-1]/max_r[n-i-1], 1 - min_l[i-1]/min_r[n-i-1]);
                ans.push_back(res);
            }
        }
    }
    for (int i = 0; i < n; i ++){
        cout << ans[i] << " ";
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(20);

//    #ifndef ONLINE_JUDGE
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//    freopen("error.txt", "w", stderr);
//    #endif // ONLINE_JUDGE

    solve();

    return 0;
}
