#pragma GCC target("avx,avx2")
#pragma GCC optimaze("Ofast")
#pragma GCC optimaze("unroll-loops")
#pragma GCC optimaze("fast-math")
#pragma GCC optimaze("no-stack-protector")
#pragma GCC optimaze("unswitch-loops")
#pragma GCC optimaze("rename-registers")

#include<bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define forn(i, n) for(int i = 0; i < int(n); i++)

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ll md = 1e9 + 7;
const ll p = 300 + rnd() % 200;

int get_hash(vector<bool> &arr) {
    ll h = arr[0];
    for(int i = 1; i < arr.size(); i++) {
        h = (h * p % md + ll(arr[i])) % md;
    }
    return h;
}

void solve() {
    int n, l;
    cin >> l >> n;

    vector<string> arr(n);

    forn(i, n) {
        cin >> arr[i];
    }

    bitset<26> uze;

    while(arr.size() > 1) {
        vector<int> cnt(26);

        for(const auto &i : arr) {
            bitset<26> b;

            for(const auto &j : i) {
                b[j-'a'] = 1;
            }

            forn(j, 26) {
                cnt[j] += b[j];
            }
        }

        bitset<26> know;
        forn(i, 26) {
            if (cnt[i] == arr.size() && !uze[i]) {
                know[i] = 1;
                uze[i] = 1;
            }
        }

        if (!know.any()) {
            cout << "NO";
            return;
        }

        map<int, vector<int>> mapa;
        forn(i, arr.size()) {
            vector<bool> used(l);
            forn(j, l) {
                if (!know[arr[i][j] - 'a']) {
                    used[j] = true;
                }
            }

            int h = get_hash(used);
            mapa[h].push_back(i);
        }

        int skok = 0;
        for(const auto &i : mapa) {
            if (i.second.size() > 1) {
                skok++;
            }
        }

        if (skok == 0) {
            cout << "YES";
            return;
        }
        if (skok > 1) {
            cout << "NO";
            return;
        }

        vector<string> temp;
        for(const auto &i : mapa) {
            if (i.second.size() > 1) {
                for(const auto &j : i.second) {
                    temp.push_back(arr[j]);
                }
            }
        }
//        if (arr == temp) {
//            cout << "NO";
//            return;
//        }
        arr = temp;
    }

    cout << "YES";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(20);

    #ifndef ONLINE_JUDGE
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        freopen("error.txt", "w", stderr);
    #endif // ONLINE_JUDGE

    solve();

    return 0;
}
