#include <iostream>
#include <vector>
#include <deque>
#include <numeric>
using namespace std;
vector<int> a;
vector<int> b;

bool check(int m) {
    int n = a.size();
    deque<pair<int, int>> deq;
    for (int i = 0; i < m; ++i) {
        deq.emplace_back(b[i], i);
    }
    for (int i = 0; i < n; ++i) {
        int x=a[i];
        while (!deq.empty() && (deq[0].first == 0 || deq[0].second < i - m)) {
            deq.pop_front();
        }
        if (i + m < n) {
            deq.emplace_back(b[i], i);
        }
        while (x>0 && !deq.empty()){
            if (deq[0].first>x) {
                deq[0].first-=x;
                x=0;
            }else{
                x-=deq[0].first;
                deq[0].first=0;
            }
            deq.pop_front();
        }
        if (x>0){
            return false;
        }
    }
    return true;
}

int main() {
    int n;
    cin >> n;
    a.resize(n);
    b.resize(n);
    for (int _ = 0; _ < n; ++_) {
        cin >> a[_];
    }
    for (int _ = 0; _ < n; ++_) {
        cin >> b[_];
    }
    if (accumulate(a.begin(),a.end(),0)>accumulate(b.begin(),b.end(),0)){
        cout<<-1;
        return 0;
    }
    int l = -1, r = n+1;
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (check(m)){
            r=m;
        }else{
            l=m;
        }
    }
    cout<<r/2;
    return 0;
}
