#include<iostream>
#include<vector>
#include<algorithm>
#include <iomanip>
#include <string>
#include <map>
#include <set>
#include <unordered_map>

#define _CRT_SECURE_NO_WARNINGS

using namespace std;

#define int long long
const int MOD = 998244353;

vector<string> words;
int l, n;

bool solve(vector<string> words, set<char> used = {}) {
	if (words.size() == 1)
		return true;
	// map<char, set<string>> letters;
	vector<vector<string>> letters(30, vector<string>());
	// vector<vector<bool>> was(n, vector<bool>(30, false));
	vector<vector<bool>> was;
	was.resize(n, vector<bool>(26, false));
	char letter = '#';
	for (int i = 0; i < words.size(); i++) {
		if (letter == '#') {
			for (int j = 0; j < words[i].size(); j++) {
				if (!was[i][words[i][j] - 'a']) {
					letters[words[i][j] - 'a'].push_back(words[i]);
					was[i][words[i][j] - 'a'] = true;
					if (letters[words[i][j] - 'a'].size() == words.size() && !used.count(words[i][j])) {
						letter = words[i][j];
						break;
					}
				}
			}
		}
	}
	if (letter == '#')
		return false;

	map<vector<int>, vector<string>> q;
	for (string word : words) {
		vector<int> id;
		for (int i = 0; i < word.size(); i++)
			if (word[i] == letter)
				id.push_back(i);
		q[id].push_back(word);
	}

	bool flag = true;
	auto now = used;
	now.insert(letter);
	for (auto p : q) {
		if (p.second.size() > 1) {
			flag &= solve(p.second, now);
		}
	}
	return flag;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
	cin >> l >> n;
	words.resize(n);
	for (int i = 0; i < n; i++)
		cin >> words[i];
	cout << (solve(words) ? "YES" : "NO");
	return 0;
}