#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pb push_back
#define f first
#define s second
#define mp make_pair
#pragma comment(linker,"/stack:2000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
typedef pair <int,int> pii;
const int MAXN = 1e6 + 5,MAXM = 3e1+5;
int n,m;
struct edge
{
    int leaf;
    int nextx[MAXM];
}g[MAXN];
int sz = 1;
vector <pii> gr[MAXN];
int dp[MAXN];
bool used[MAXN];
void build(string sx)
{
    int v = 0;
    for(size_t fi = 0;fi<sx.size();fi++)
    {
        int now = sx[fi] - 'a';
        if(g[v].nextx[now]==-1)
        {
            for(int si = 0;si<26;si++)
            {
                g[sz].nextx[si] = -1;
            }
            g[v].nextx[now] = sz;
            gr[v].pb(mp(sz,now));
            sz++;
        }
        v = g[v].nextx[now];
    }
    g[v].leaf++;
    dp[v] ++;
}
void dfs(int now)
{
    used[now] = true;
    for(size_t fi = 0;fi<gr[now].size();fi++)
    {
        int next = gr[now][fi].f;
        if(!used[next])
        {
            dfs(next);
            dp[now] += dp[next];
        }
    }
}
int get_res(string sy)
{
    int cnt = 0;
    int v = 0;
    for(size_t fi = 0;fi<sy.size();fi++)
    {
        int now = sy[fi] - 'a';
        if(g[v].nextx[now] == -1)
        {
            int part = 0;
            for(int si = now+1;si<26;si++)
            {
                part += (g[v].nextx[si]!=-1 ? dp[g[v].nextx[si]] : 0);
            }
            cnt += dp[v] - part;
            break;
        }
        for(int si = 0;si<now;si++)
        {
            if(g[v].nextx[si]!=-1)
            {
               cnt+=dp[g[v].nextx[si]];
            }
        }
        cnt+= g[v].leaf;
        v = g[v].nextx[now];

    }
    return cnt;
}
int main()
{
    for(int fi = 0;fi<26;fi++)
    {
        g[0].nextx[fi] = -1;
    }
    cin >> n >> m;
    string mx;
    cin >> mx;
    for(int fi = 1;fi<=n;fi++)
    {
        string sy;
        cin >> sy;
        build(sy);
    }
    dfs(0);
    cout << get_res(mx) << '\n';
    for(int fi = 1;fi<=m;fi++)
    {
        string new_strx = "";
        int pos;
        char x;
        cin >> pos >> x;
        for(size_t si = 0;si<pos-1;si++)
        {
            new_strx += mx[si];
        }
        for(size_t si = pos-1;si<mx.size();si++)
        {
            new_strx += x;
        }
        cout << get_res(new_strx) << '\n';
        mx = new_strx;
    }

}
