#include <iostream>
#include <vector>
#include <iomanip>
using namespace std;

vector<long long> a, gl_mins, gl_maxs, seg_min, seg_max, left_min, left_max;
long long gl_min = 999999999, gl_max = -1;

int main()
{
    long long n;
    cin >> n;
    a.resize(n);
    seg_min.resize(n);
    seg_max.resize(n);
    left_min.resize(n);
    left_max.resize(n);
    for (long long i = 0; i < n; i++)
    {
        cin >> a[i];
        if (i == 0)
        {
            left_min[i] = a[i];
            left_max[i] = a[i];
        }
        else
        {
            left_min[i] = (a[i] < left_min[i - 1] ? a[i] : left_min[i - 1]);
            left_max[i] = (a[i] > left_max[i - 1] ? a[i] : left_max[i - 1]);
        }
        if (a[i] < gl_min)
        {
            gl_min = a[i];
            gl_mins.clear();
            gl_mins.push_back(i);
        }
        else if (a[i] == gl_min)
        {
            gl_mins.push_back(i);
        }
        if (a[i] > gl_max)
        {
            gl_max = a[i];
            gl_maxs.clear();
            gl_maxs.push_back(i);
        }
        else if (a[i] == gl_max)
        {
            gl_maxs.push_back(i);
        }
    }
    seg_min[n - 1] = a[n - 1];
    seg_max[n - 1] = a[n - 1];
    for (long long i = n - 2; i >= 0; i--)
    {
        seg_min[i] = (a[i] < seg_min[i + 1] ? a[i] : seg_min[i + 1]);
        seg_max[i] = (a[i] > seg_max[i + 1] ? a[i] : seg_max[i + 1]);
    }

    /*for (long long i = 0; i < n; i++)
    {
        cout << left_min[i] << ' ';
    }
    cout << endl;
    for (long long i = 0; i < n; i++)
    {
        cout << left_max[i] << ' ';
    }
    cout << endl;
    for (long long i = 0; i < n; i++)
    {
        cout << seg_min[i] << ' ';
    }
    cout << endl;
    for (long long i = 0; i < n; i++)
    {
        cout << seg_max[i] << ' ';
    }
    cout << endl;
    cout << gl_min << ' ' << gl_max << endl;*/

    cout << 1.0 << ' ';
    for (long long k = 1; k < n; k++)
    {
        if (gl_mins.size() > 1)
        {
            if (gl_mins[gl_mins.size() - 1] >= k)
            {
                cout << setprecision(10) << fixed << 0.0 << ' ';
            }
            else
            {
                double del = (1 - (double)left_max[k - 1] / gl_max);
                double res = seg_min[k] * del;
                double dif = (double)left_max[k - 1] - min((double)gl_min, res);
                del = (1 - (double)gl_min / seg_min[k]);
                res = (double)gl_max * del;
                if (dif < max(res, (double)left_max[k - 1]) - gl_min)
                    cout << setprecision(10) << fixed << (1 - (double)left_max[k - 1] / gl_max) << ' ';
                else
                    cout << setprecision(10) << fixed << del << ' ';
            }
        }
        else if (gl_mins[0] >= k && gl_maxs[0] <= k)
        {
            cout << setprecision(10) << fixed << 0.0 << ' ';
        }
        else if (gl_mins[0] < k && gl_maxs[0] < k)
        {
            cout << setprecision(10) << fixed << gl_min / (double)seg_min[k] << ' ';
        }
        else if (gl_mins[0] >= k && gl_maxs[0] >= k)
        {
            cout << setprecision(10) << fixed << (double)left_max[k - 1] / gl_max << ' ';
        }
        else
        {
            double del = (1 - (double)left_max[k - 1] / gl_max);
            double res = seg_min[k] * del;
            double dif = (double)left_max[k - 1] - min((double)gl_min, res);
            del = (1 - (double)gl_min / seg_min[k]);
            res = (double)gl_max * del;
            if (dif < max(res, (double)left_max[k - 1]) - gl_min)
                cout << setprecision(10) << fixed << (1 - (double)left_max[k - 1] / gl_max) << ' ';
            else
                cout << setprecision(10) << fixed << del << ' ';
        }
    }
}
