// VkoshpKostroma.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

//Kostroma

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <stack>

using namespace std;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout << fixed << setprecision(12);
	int n;
	cin >> n;
	vector<int> need(n);
	vector<int> have(n);
	vector<int> old_need(n);
	vector<int> old_have(n);
	long long sn = 0;
	long long sh = 0;
	for (int i = 0; i < n; ++i) {
		cin >> need[i];
		old_need[i] = need[i];
		sn += need[i];
	}
	for (int j = 0; j < n; ++j) {
		cin >> have[j];
		old_have[j] = have[j];
		sh += have[j];
	}
	if (sn > sh) {
		cout << -1;
		return 0;
	}
	int lb = -1;
	int rb = n;
	while (rb - lb > 1) {
		for (int i = 0; i < n; ++i) {
			need[i] = old_need[i];
			have[i] = old_have[i];
		}
		vector<int> no_per(n, 0);
		int m = (rb + lb) / 2;
		int l = 0;
		int r = 0;
		bool fl = true;
		for (int i = 0; i < n; ++i) {
			l = max(i + 1, l);
			r = max(i + 1, r);
			while (l < n && need[l] == 0) {
				l++;
			}
			//cout << i << ' ' << m << ' ' << have[i] << ' ' << need[i] << ' ' << no_per[i] << ' ' << l << ' ' << r << endl;
			if (need[i] < have[i]) {
				while (l < n && l - i <= m && need[i] < have[i]) {
					int add = need[l];
					if (need[i] + add <= have[i]) {
						need[l] = 0;
						need[i] += add;
						l++;
					}
					else {
						need[l] -= have[i] - need[i];
						need[i] = have[i];
						break;
					}
				}
			}
			else {
				while (r < n && r - i <= m && need[i] > have[i]) {
					int add = have[r] - no_per[r];
					if (need[i] - add > have[i]) {
						need[i] -= add;
						no_per[r] = have[r];
						need[r] += add;
						r++;
					}
					else {
						int raz = need[i] - have[i];
						need[i] = have[i];
						need[r] += raz;
						no_per[r] += raz;
						break;
					}
				}
			}
			//cout << i << ' ' << m << ' ' << have[i] << ' ' << need[i] << ' ' << no_per[i] << endl;
			if (need[i] > have[i]) {
				fl = false;
				break;
			}
			
		}
		if (fl) {
			rb = m;
		}
		else {
			lb = m;
		}
	}
	cout << rb;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
