// VkoshpKostroma.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

//Kostroma

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <stack>

using namespace std;

vector<string> bigdata;
int L;
long long cnt = 0;

bool get_ans(vector<int> A, char let, int pos, vector<bool> was) {
	cnt++;
	if (cnt >= 10000000) {
		return false;
	}
	vector<int> in;
	vector<int> out;
	if (A.size() <= 1) {
		return true;
	}
	if (pos == 0) {
		char old = let;
		let = '#';
		for (char ll = 'a'; ll <= 'z'; ++ll) {
			if (was[ll - 'a']) {
				continue;
			}
			bool fl = true;
			for (int i = 0; i < A.size(); ++i) {
				bool fl1 = false;
				for (int j = 0; j < L; ++j) {
					if (bigdata[A[i]][j] == ll) {
						fl1 = true;
						break;
					}
				}
				if (!fl1) {
					fl = false;
					break;
				}
			}
			if (fl) {
				let = ll;
				break;
			}
		}
		//cout << A.size() << ' ' << let << ' ' << pos << endl;
		if (let == '#') {
			return false;
		}
		was[let - 'a'] = true;
	}
	for (int i = 0; i < A.size(); ++i) {
		if (bigdata[A[i]][pos] == let) {
			in.push_back(A[i]);
		}
		else {
			out.push_back(A[i]);
		}
	}
	if (pos == L - 1 && let == 'z') {
		return (get_ans(in, 'a', 0, was) && get_ans(out, 'a', 0, was));
	}
	else if (pos == L - 1) {
		return (get_ans(in, let + 1, 0, was) && get_ans(out, let + 1, 0, was));
	}
	else {
		return (get_ans(in, let, pos + 1, was) && get_ans(out, let, pos + 1, was));
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout << fixed << setprecision(12);
	int n;
	cin >> L;
	cin >> n;
	bigdata.resize(n);
	vector<int> start;
	vector<bool> w(26, false);
	for (int i = 0; i < n; ++i) {
		start.push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		cin >> bigdata[i];
	}
	if (get_ans(start, 'a', 0, w)) {
		cout << "YES";
	}
	else {
		cout << "NO";
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
