#include <iostream>
#include <vector>
#include <algorithm>


//#pragma GCC target("avx")
//#pragma GCC optimize(3)
//#pragma GCC optimize("inline-functions")


#define ll long long
#define ld long double
#define pr pair<ll, ll>
//#define vl vector<ll>
#define all(a) (a.begin(), a.end())

using namespace std;

const ll MAXN = 1e6 + 13;

ll a[MAXN], b[MAXN];
ll zam_a[MAXN], zam_b[MAXN];

bool check(ll m, ll n) {
	ll uk_a = 0;
	ll uk_b = 0;
	for (ll i = 0; i < n; i++) {
		zam_a[i] = a[i];
		zam_b[i] = b[i];
	}
	while (uk_b < n) {
		if (uk_a == n) {
			break;
		}
		if (zam_b[uk_b] == 0) {
			++uk_b;
		}
		if (uk_a - uk_b > m) {
			++uk_b;
		}
		if (uk_b - uk_a > m) {
			return false;
		}
		
		if (zam_b[uk_b] > zam_a[uk_a]) {
			zam_b[uk_b] -= zam_a[uk_a];
			zam_a[uk_a] = 0;
			++uk_a;
		}
		else {
			zam_a[uk_a] -= zam_b[uk_b];
			zam_b[uk_b] = 0;
			++uk_b;
		}
	}
	while (uk_a < n && zam_a[uk_a] == 0) {
		++uk_a;
	}
	if (uk_a == n) {
		return true;
	}
	else {
		return false;
	}
}


//DDDDDDDDDDDDDD
void solve() {
	ll n;
	cin >> n;
	ll summ = 0;
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
		summ += a[i];
	}
	for (ll i = 0; i < n; i++) {
		cin >> b[i];
		summ -= b[i];
	}
	bool flag = true;
	for (ll i = 0; i < n; i++) {
		if (b[i] < a[i]) {
			flag = false;
		}
	}
	if (flag) {
		cout << 0;
		return;
	}
	if (summ > 0) {
		cout << -1;
		return;
	}
	ll l = -1;
	ll r = n;
	while (l < r) {
		ll m = (l + r) / 2;
		// cout << m <<' ' << check(m, n) << endl;
		if (check(m, n)) {
			r = m;
		}
		else {
			l = m + 1;
		}
	}
	cout << l << endl;
}



int main() {
	ios::sync_with_stdio(false);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	ll t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}