// 

#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>


//#pragma GCC target("avx")
//#pragma GCC optimize(3)
//#pragma GCC optimize("inline-functions")



#define ll long long
#define ld long double
#define pr pair<ll, ll>
#define vl vector<ll>
#define all(a) (a.begin(), a.end())

using namespace std;

struct ratio
{
	ll a;
	ll b;

	ratio(ll a, ll b)
	{
		this->a = a;
		this->b = b;
	}

	bool operator==(ratio y)
	{
		return a * y.b == b * y.a;
	}

	bool operator<(const ratio &y) const
	{
		return a * y.b < b * y.a;
	}

	ratio operator+(ll y)
	{
		return ratio(a + y * b, b);
	}

	ratio operator*(ll y)
	{
		return ratio(a * y, b);
	}
};

void solve() {
	cout << fixed << setprecision(10);
	int n;
	cin >> n;

	vector<int> vec(n);

	for (auto& e : vec) cin >> e;

	vector<int> minimums_tail(n);
	vector<int> maximums_tail(n);
	minimums_tail[n - 1] = maximums_tail[n - 1] = vec[n - 1];
	for (int i = n - 2; i >= 0; i--)
	{
		minimums_tail[i] = min(minimums_tail[i + 1], vec[i]);
		maximums_tail[i] = max(maximums_tail[i + 1], vec[i]);
	}

	cout << 1;
	int minimum = 999999999, maximum = 0;
	for (int i = 1; i < n; i++)
	{
		minimum = min(minimum, vec[i-1]);
		maximum = max(maximum, vec[i-1]);
		ll a = minimum, b = maximum, x = maximums_tail[i], y = minimums_tail[i];
		ratio t = ratio(0, 0);
		ratio val = ratio(999999999, 1);
		ratio t1 = max(ratio(a, y), max(ratio(a + b, x + y), ratio(b, x)));
		ratio val1 = t1 * x + (-a);
		if (!(ratio(1, 1) < t1))
		{
			t = t1;
			val = val1;
		}
		ratio t2 = min(min(ratio(1, 1), ratio(a, y)), min(ratio(b, x), ratio(a + b, x + y)));
		ratio val2 = t2 * (-y) + b;
		if (val == val2 && t2 < t || val2 < val)
		{
			t = t2;
			val = val2;
		}
		if (a * x >= b * y && x != y)
		{
			ratio t3 = ratio(b, x);
			ratio val3 = t3 * (x - y);
			if (!(ratio(1, 1) < t3) && (val == val3 && t3 < t || val3 < val)) t = t3;
		}
		else
		{
			ratio t3 = max(ratio(a, y), ratio(b, x));
			ratio val3 = ratio(b - a, 1);
			if (!(ratio(1, 1) < t3) && (val == val3 && t3 < t || val3 < val)) t = t3;
		}
		cout << " " << 1 - (ld)t.a / t.b;
	}
	cout << endl;
}



int main() {
	ios::sync_with_stdio(false);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	ll t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}
