#include <bits/stdc++.h>
using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(obj) obj.begin(), obj.end()
#define pb push_back()
#define fi first
#define se second
#define int long long
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using s64 = long long;

void solve(istream& in, ostream& out) {
    int n, suma = 0, sumb = 0; cin >> n;
    vi a(n), b(n), diff(n);
    forn(i, n) {cin >> a[i]; suma += a[i]; }
    forn(i, n) {cin >> b[i]; sumb += b[i]; }
    if (sumb < suma) {
        cout << "-1\n";
        return;
    }
    forn(i, n) diff[i] = a[i] - b[i];
    int l = -1, r = n;
    while (l+1 != r) {
        int mid = l+(r-l)/2;
        bool ok = true;
        queue<pii> q, waiting;
        forn(i, n) {
            while (!q.empty() && i-q.front().fi > mid) q.pop();
            if (!waiting.empty() && i-waiting.front().fi > mid) { ok = false; break; }

            if (diff[i] <= 0) {
                int cur = -diff[i];
                while (!waiting.empty() && cur > 0) {
                    int kek = min(waiting.front().se, cur);
                    waiting.front().se -= kek;
                    cur -= kek;
                    if (waiting.front().se == 0) waiting.pop();
                }
                int not_free = a[i];
                while (!q.empty() && not_free > 0) {
                    int kek = min(not_free, q.front().se);
                    q.front().se -= kek;
                    not_free -= kek;
                    if (q.front().se == 0) q.pop();
                }
                q.push({i, cur + a[i] - not_free});
                //if (cur > 0) q.push({i, cur});
            } else {
                int cur = diff[i];
                while (!q.empty() && cur > 0) {
                    int kek = min(q.front().se, cur);
                    q.front().se -= kek;
                    cur -= kek;
                    if (q.front().se == 0) q.pop();
                }
                if (cur > 0) {
                    waiting.push({i, cur});
                } else {
                    int not_free = b[i];
                    while (!q.empty() && not_free > 0) {
                        int kek = min(not_free, q.front().se);
                        q.front().se -= kek;
                        not_free -= kek;
                        if (q.front().se == 0) q.pop();
                    }
                    q.push({i, b[i] - not_free});
                }
            }
        }
        if (waiting.empty() && ok) {
            r = mid;
        } else {
            l = mid;
        }
    }
    cout << r << '\n';
}

int32_t main() {
    solve(cin, cout);
    return 0;
    int n;
    cin >> n;
    vector<s64> a(n), b(n);
    s64 suma = 0, sumb = 0;
    for(int i = 0;i < n; i++){
        cin >> a[i];
        suma += a[i];
    }
    for(int i = 0; i < n; i++){
        cin >> b[i];
        sumb += b[i];
    }

    if(suma > sumb){
        cout << "-1\n";
        return 0;
    }

    auto check = [&](int k){
        vector<s64> c(n);
        for(int i = 0; i < n; i++){
            c[i] = a[i] - b[i];
        }

        for(int i = 0; i < n; i++){
            for(int j = 0; j < n; j++){
                if(i != j && abs(i - j) <= k){
                    if(c[i] > 0 && c[j] < 0){
                        s64 d = min(c[i], -c[j]);
                        c[i] -= d;
                        c[j] += d;
                    }
                }
            }
        }

        for(int i = 0; i < n; i++){
            if(c[i] > 0){
                return false;
            }
        }
        return true;
    };

    int l = -1, r = n - 1;
    while(l < r - 1){
        int m = (l + r) / 2;
        if(check(m)){
            r = m;
        }
        else{
            l = m;
        }
    }

    cout << r << "\n";

    return 0;
}
