#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#define all(x) x.begin(), x.end()
#define X first
#define Y second
using namespace std;

bool clear(queue<pair<int, int>>& qa, queue<pair<int, int>>& qb, int i,int x) {
    if (!qa.empty() && i - qa.front().Y > x)
        return 0;
    while (!qb.empty() && i - qb.front().Y > x)
        qb.pop();
    return 1;
}

void upd(queue<pair<int, int>>& qa, queue<pair<int, int>>& qb) {
    while (!qa.empty() && !qb.empty()) {
        if (qa.front().X >= qb.front().X) {
            qa.front().X -= qb.front().X;
            if (qa.front().X == 0)
                qa.pop();
            qb.pop();
        }
        else {
            qb.front().X -= qa.front().X;
            if (qb.front().X == 0)
                qb.pop();
            qa.pop();
        }
    }
}

bool f(vector<int> &a, vector<int> &b, int x) {
    int n = a.size();
    queue<pair<int, int>> qa, qb;
    for (int i = 0; i < n; ++i) {
        bool it = clear(qa, qb, i, x);
        if (!it)
            return 0;
        qa.push({ a[i],i }); qb.push({ b[i],i });
        upd(qa, qb);
    }
    if (!qa.empty())
        return 0;
    return 1;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int& i : a)
        cin >> i;
    for (int& i : b)
        cin >> i;
    long long suma = 0, sumb = 0;
    for (int i : a)
        suma += i;
    for (int i : b)
        sumb += i;
    if (suma > sumb) {
        cout << "-1\n";
        return 0;
    }
    int l = -1, r = n + 1;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        (f(a, b, m) ? r : l) = m;
    }
    cout << r << '\n';
}