#include <bits/stdc++.h>
#define fori for (int i = 0; i < n; ++i)

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

using namespace std;
#ifdef local
bool debug = false;//true;
#else
bool debug = false;
#endif

ll n;
vector <ll> a, b;

bool f(ll k) {
	vector <ll> d(n);
	fori d[i] = a[i];
	int l = 0;
	for (int i = 0; i < n; ++i) {
		while (l < n && i - l > k) {
			l++;
		} 

		while (l < i && d[i] > 0) {
			if (d[l] >= b[l]) {
				l++;
				continue;
			}

			ll dx = min(d[i], b[l] - d[l]);
			d[l] += dx;
			d[i] -= dx;
		}

		if (d[i] > b[i]) {
			if (i == n - 1 || k == 0) {
				return false;
			}

			d[min(i + k, n - 1)] += d[i] - b[i];
			d[i] = b[i];
		}

		if (d[i] > b[i]) {
			// if(debug)cout/* << "R = " << r << endl;
			// if(debug)cout*/ << "I = " << i << endl;
			return false;
		}

		
	}

	// cout << k << ": ";
	// for (int x: d) cout << x << ' ';
	// cout << '\n';

	return true;
}

inline void solve() {
	cin >> n;
	a.resize(n);
	b.resize(n);
	fori cin >> a[i];
	fori cin >> b[i];
	ll s1 = 0, s2 = 0;
	fori {
		s1 += a[i];
		s2 += b[i];
	}
	if (s1 > s2) {
		cout << -1;
		return;
	}
	ll l = -1, r = n-1;
	while (r - l > 1) {
		ll m = (l + r) / 2;
		if(debug)cout << "M = " << m << endl;
		if (f(m)) {
			if(debug)cout << "TRUE" << endl;
			r = m;
		} else {
			if(debug)cout << "FALSE" << endl;
			l = m;
		}
	}
	cout << r;
}

signed main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	
	solve();
}