#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

#define int ll
typedef long long ll;
typedef long double ld;


bool check(vector < int > a, vector < int > b, int l) {
	int j = 0, n = a.size();
	for (int i = 0; i < n; i++) {
		for (; j < i && i - j > l; j++) {}

		for (; j < n && abs(j - i) <= l && a[i] < b[i]; j++) {
			if (a[j] < b[j] || j == i)
				continue;
			if (b[i] - a[i] >= a[j] - b[j]) {
				b[i] -= a[j] - b[j];
				a[j] = b[j];
			}
			else {
				b[j] += b[j] - a[i];
				b[i] = a[i];
				break;
			}
		}

		if (a[i] < b[i])
			return false;
	}
	return true;
}


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	int n;
	cin >> n;

	vector < int > b(n);
	for (int i = 0; i < n; i++)
		cin >> b[i];

	vector < int > a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];

	if (!check(a, b, n)) {
		cout << "-1\n";
		return 0;
	}

	int l = -1, r = n;
	for (; r - l > 1; ) {
		int md = (l + r) / 2;

		if (check(a, b, md))
			r = md;
		else
			l = md;
	}

	cout << r << "\n";

	return 0;
}
/*
4
6 14 70 1
70 3 16 5

1
2
2

1
3
2
*/