#include <bits/stdc++.h>
#pragma comment(linker, "/stack:20000000000")
#pragma GCC optimize("Ofast")
#pragma target("avx,fma")
#pragma target("tune=negative")

using namespace std;

typedef long long ll;

#define F first
#define S second
vector<ll> v;
vector<ll> w, vv, ww;
#define int long long

int check(int m) {
    int n = v.size();
    deque<pair<int, int>> q;
    for (int i = 0; i < n; ++i) {
        int x = v[i];
        while (q.size() && x) {
            auto p = q.front();
            q.pop_front();
            if (x <= p.second) {
                p.second -= x;
                x = 0;
            } else {
                x -= p.second;
                p.second = 0;
            }
            if (p.second > 0) q.push_front(p);
        }
        if (x <= w[i]) w[i] -= x, v[i] = 0;
        else v[i] = x - w[i], w[i] = 0;
        if (w[i] > 0) q.push_back({i, w[i]});
        while (q.size() && q.front().first + m <= i) q.pop_front();
    }
    reverse(v.begin(), v.end());
    reverse(w.begin(), w.end());
    q.clear();
    for (int i = 0; i < n; ++i) {
        int x = v[i];
        while (q.size() && x) {
            auto p = q.front();
            q.pop_front();
            if (x <= p.second) {
                p.second -= x;
                x = 0;
            } else {
                x -= p.second;
                p.second = 0;
            }
            if (p.second > 0) q.push_front(p);
        }
        if (x <= w[i]) w[i] -= x, v[i] = 0;
        else v[i] = x - w[i], w[i] = 0;
        if (w[i] > 0) q.push_back({i, w[i]});
        while (q.size() && q.front().first + m <= i) q.pop_front();
    }
    int ok = 1;
    for (int i = 0; i < n; ++i) if (v[i] > w[i]) ok = 0;
    return ok;
}


signed main() {
    int n;
    cin >> n;
    w.resize(n); v.resize(n);
    for (auto &i: v) cin >> i;
    for (auto &i: w) cin >> i;
    ww = w; vv = v;
    if (accumulate(v.begin(), v.end(), 0LL) > accumulate(w.begin(), w.end(), 0LL)) {
        cout << -1; return 0;
    }

    int l = -1, r = n + 1, m;
    while (l + 1 != r) {
        m = (l + r) / 2;
        (check(m) ? r : l) = m;
        v = vv;
        w = ww;
    }
    if (r == n + 1) cout << -1;
    else cout << r;
}