#include <bits/stdc++.h>
#pragma comment(linker, "/stack:20000000000")
#pragma GCC optimize("Ofast")
#pragma target("avx,fma")
#pragma target("tune=negative")

using namespace std;

typedef long long ll;
typedef long double ld;

#define F first
#define S second

int t[4];
const long double EPS = 1e-9;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n; cin >> n;
    int a1, b1, c1;
    cin >> a1 >> b1 >> c1;
    bool up = a1 < 0, down = a1 > 0;
    vector<tuple<int, int, int> > eq;
    vector<long double > v;
    for (int i = 1, a2, b2, c2; i < n; ++i) {
        cin >> a2 >> b2 >> c2;
        // a1x^2+b1x+c1 = a2x^2+b2x+c2
        // (a1-a2)x^2+(b1-b2)x+(c1-c2)=0
        if (a1 > 0) down = false;
        if (a1 < 0) up = false;
        if (a1 / abs(a1) == a2 / abs(a2)) continue;
        eq.push_back(make_tuple(a2, b2, c2));
        long double a = (a1 - a2), b = (b1 - b2), c = (c1 - c2);
        long double D = 1ll * b * b - 4ll * a * c;
        assert(D > 0);
        long double sq = sqrt(D);
        long double x1 = (-b - sq) / 2.0 / a;
        v.push_back(x1);
    }
    if (up) {
        cout << "0 1000000000000000000" << endl;
    } else if (down) {
        cout << "0 -1000000000000000000" << endl;
    } else {
        long double xm = *max_element(v.begin(), v.end()) + 1e-2, ym = 1e18;
        int sign = a1 / abs(a1);
        if (sign > 0) ym *= -1;
        for (int i = 0; i < eq.size(); ++i) {
            if (sign > 0) {
                ym = max(ym, get<0>(eq[i]) * xm * xm + get<1>(eq[i]) * xm + get<2>(eq[i]));
            } else {
                ym = min(ym, get<0>(eq[i]) * xm * xm + get<1>(eq[i]) * xm + get<2>(eq[i]));
            }
        }
        cout << xm << ' ' << ym << endl;
    }

}