//cpos 3

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <stack>

using namespace std;

typedef long long ll;
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define forIn(v) for (auto tt : v)
#define forInR(v) for (auto &tt : v)
const int inf = 1e9;

void solveI() {
	ll q, w;
	cin >> q >> w;
	vector<string>a(w);
	vector<set<vector<ll>>>m('z' - 'a' + 1);
	vector<ll>aa('z' - 'a' + 1);
	for (auto& i : a) {
		cin >> i;
		vector<vector<ll>>qq('z' - 'a' + 1);
		for (int j = 0; j < q; j++) {
			qq[ll(i[j] - 'a')].push_back(j);
		}
		for (int j = 'a'; j <= 'z'; j++) {
			if (qq[j - 'a'].empty())
				aa[j - 'a'] = 1;
			m[j - 'a'].insert(qq[j - 'a']);
		}
	}

	for (int i = 'a'; i <= 'z'; i++) {
		if (!aa[i - 'a']) {
			if (m[i - 'a'].size() == w) {
				cout << "YES";
			}
		}
	}
	cout << "NO";

}

void solvve() {
	int n, mi = inf, mii = 0, ma = 0, mai = 0;
	cin >> n;
	vector<int>v(n), pm(n), sm(n), s(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
		if (mi > v[i]) {
			mi = v[i];
			mii = i;
		}
		if (ma < v[i]) {
			ma = v[i];
			mai = i;
		}
	}
	pm[0] = v[0];
	sm[n - 1] = v[n - 1];
	s[n - 1] = s[n - 1];
	for (int i = n - 2; i >= 0; i--) {
		sm[i] = min(v[i], sm[i + 1]);
		s[i] = max(v[i], s[i + 1]);
	}
	for (int i = 1; i < n; i++) {
		pm[i] = max(v[i], pm[i - 1]);
	}
	cout << 1 << endl;
	for (int i = 1; i < n; i++) {
		if (i <= mai && i <= mii) {
			double r = 1, l = 0;
			while (r - l > 0.0000000001) {
				double m = (r + l) / 2;
				if (ma - ma * m >= pm[i - 1]){
					l = m;
				}
				else {
					r = m;
				}
			}
			cout << l <<" do min i max"<< endl;
		}
		if (i > mai && i <= mii) {
			cout << 0 << " posle min i do max" << endl;
		}
		if (i > mii) {
			double r = 1, l = 0;
			while (r - l > 0.0000000001) {
				double m = (r + l) / 2;
				if (sm[i] - sm[i] * m >= mi) {
					l = m;
				}
				else {
					r = m;
				}
			}
			cout << l << " ia xz" << endl;
		}
	}
}
vector<ll>v, v1;
bool chk(ll mx) {
	vector<ll>v2 = v, v3 = v1;
	for (int i = 2; i < v2.size(); i++) {
		ll mx, mx1;
		mx = min(v3[i - 2] - v2[i - 2], v2[i]);
		v2[i] -= mx;
		mx1 = min(v3[i - 1] - v2[i - 1], v2[i]);
		v2[i] -= mx1;
		v2[i - 2] += mx;
		v2[i - 1] += mx1;
		if (v2[i] > v3[i]) {
			mx = min(max(v3[i + 1] - v2[i + 1], 0LL), (v2[i] - v3[i]));
			v2[i] -= mx;
			v3[i + 1] += mx;

		}
		if (v2[i] > v3[i]) {
			mx1 = min(max(v3[i + 2] - v2[i + 2], 0LL), (v2[i] - v3[i]));
			v2[i] -= mx1;
			v3[i + 2] += mx1;

		}
		if (v2[i] > v3[i])
			return 0;

	}
	return 1;

}

bool chhh(int n, vector <int> a, vector <int> b, int k, vector <int> p) {
	bool f = 0;
	for (int i = 0; i < n; i++) {
		if (p[min(i + k + 1, n)] - p[max(i - k, 0)] < a[i]) {
			f = 1;
			break;
		}
	}
	return f;
}

int main() {
	int n;
	cin >> n;
	int s1 = 0;
	vector <int> a(n), b(n), p(n + 1);
	int sm = 0;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		s1 += a[i];
	}
	int t = 1;
	for (int i = 0; i < n; i++) {
		cin >> b[i];
		sm += b[i];
		p[t] = sm;
		t++;
	}
	if (s1 > sm) {
		cout << -1;
		return 0;
	}
	int l = -1, r = n, m = 0;
	while (r - l > 1) {
		m = (r + l) / 2;
		if (chhh(n, a, b, m, p)) {
			l = m;
		}
		else {
			r = m;
		}
	}
	cout << r;

	//ll q;
	//cin >> q;
	//vector<ll>a(q);
	//forInR(a)
	//	cin >> tt;
	//vector<ll>b(q);
	//forInR(b)
	//	cin >> tt;

	//vector<ll>prf(q);
	//for (int i = 0; i < q; i++) {
	//	ll df = min(a[i], b[i]);
	//	a[i] -= df;
	//	b[i] -= df;
	//	if (i)
	//		prf[i] = prf[i - 1] + b[i];
	//	else
	//		prf[i] = b[i];
	//}

	//deque<pair<ll, ll>>dq;
	//ll k = 0;
	//for (int i = q - 1; i >= 0; i++) {
	//	dq.push_back({ a[i], i});
	//	while (dq.size()) {
	//		if (dq.front() > )
	//	}
	//}
	/*int a;
	cin >> a;
	vector<int>v(a), f(a), s(a);
	for (int i = 0; i < a; i++) {
		cin >> v[i];
	}
	for (int i = 0; i < a; i++) {
		cin >> f[i];
		s[i] = v[i] - f[i];
	}
	for (int i = 0; i < a; i++) {
		for (int j = 0; j <= i; j++) {

		}
	}*/
}