#include <bits/stdc++.h>

using namespace std;

using ld = long double;

const ld INF = 1e10;

struct S {
	int a, b, c;
};

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n;
	cin >> n;
	vector<S> v(n);
	int ind = 0;
	int cur = 0;
	for(auto& i : v) {
		cin >> i.a >> i.b >> i.c;
		if(std::abs(i.a) > std::abs(v[ind].a) || (std::abs(i.a) == std::abs(v[ind].a) && v[ind].b + v[ind].c < i.b + i.c))
			ind = cur;
		++cur;
	}

	vector<pair<ld, ld>> res;

	for(int i = 0; i < n; ++i) {
		if(i == ind)
			continue;
		ld a = v[ind].a - v[i].a, b = v[ind].b - v[i].b, c = v[ind].c - v[i].c;

		ld d = b * b - 4 * a * c;
		if(d < 0)
			continue;
		d = std::sqrt(d);
		ld x1 = (-b + d) / (2 * a), x2 = (-b - d) / (2 * a);
		if((v[ind].a > 0) ^ (v[i].a > 0))
			res.push_back({x1, x2});
		else
			res.push_back({x2, x1});
	}
	pair<ld, ld> ans = {-INF, INF};
	for(auto p : res)
		if(p.first < p.second) {
			ans.first = std::max(ans.first, p.first);
			ans.second = std::min(ans.second, p.second);
		}
	pair<ld, ld> ans1 = ans, ans2 = ans;
	for(auto p : res)
		if(p.first > p.second) {
			ans1.second = std::min(ans1.second, p.second);
			ans2.first = std::min(ans2.first, p.first);
		}

	if(ans1.first > ans1.second - 1e-8)
		std::swap(ans1, ans2);
	ans = ans2;
	ld x = (ans.first + ans.second) / 2;
	cout << std::fixed << std::setprecision(30) << x << ' ' << v[ind].a * x * x + v[ind].b * x + v[ind].c;

	return 0;
}
