#include <bits/stdc++.h>

#define ll long long
#define int long long
#define ull unsigned long long
#define ALL(c) (c).begin(), (c).end()
#define RALL(c) (c).rbegin(), (c).rend()
#define ios ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

using namespace std;

int n;
vector <int> a, b;

bool ok(int k) {
    vector <int> can = a, tmp = a;
    int i = 0, j = n - 1;
    int l_border = 0, r_border = n - 1;
    bool ok = true;
    while (i <= j && ok) {
        ok = false;
        while (i < n && i <= j) {
            for (int p = max((ll)0, i - k); p < i; ++p) {
                if (tmp[p] >= b[p]) continue;
                int d = min(b[p] - tmp[p], min(can[i], tmp[i]));
                tmp[p] += d;
                tmp[i] -= d;
                can[i] -= d;
                if (d != 0) ok = true;
                if (tmp[i] == 0 || can[i] == 0) break;
            }
            if (tmp[i] > b[i]) break;
            i++;
        }
        if (i == n) break;
        while (j >= 0 && j >= i) {
            for (int p = min(j + k, n - 1); p > j; --p) {
                if (tmp[p] >= b[p]) continue;
                int d = min(b[p] - tmp[p], min(can[j], tmp[j]));
                tmp[p] += d;
                tmp[j] -= d;
                can[j] -= d;
                if (d != 0) ok = true;
                if (tmp[j] == 0 || can[j] == 0) break;
            }
            if (tmp[j] > b[j]) break;
            j--;
        }
    }
    for (int t = 0; t < n; ++t) {
        if (tmp[t] > b[t]) return false;
    }
    return true;
}

signed main() {
    ios;
    cin >> n;
    a.resize(n);
    b.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    int l = -1, r = n + 1;
    while (l < r - 1) {
        int m = (l + r) / 2;
        if (ok(m)) r = m;
        else l = m;
    }
    if (l == n) cout << -1;
    else cout << r;
}
